<?php
/**
 * $Id: RegAppApplyCidrAlloc.php,v 1.9 2004/03/08 01:56:42 yoshi_s Exp $
 * IPv6ɥ쥹֥å꿶楯饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppDBUtil.php");			// DB桼ƥƥ
require_once("RegAppApplyFix.php");			// ǧѥ١饹

//----------------------------------------------------------------------------
// define
//----------------------------------------------------------------------------
define("FREE_CIDR_SEL_MAX", 10);			// 꿶긵ǽͣؿ
define("ALLOC_CIDR_SEL_MAX", 10);			// 꿶ǽͣؿ

// 꿶긵֥åơȥʸ
define("FREE_CIDR_STT_TITLE", "ơ");

/**
 * ̾  RegAppCidrAllocDBUtil
 *   IPv6ɥ쥹֥å꿶DBѤΥ桼ƥƥ饹
 */
class RegAppCidrAllocDBUtil extends RegAppDBUtil
{
	var $fn_col_tbl;			// form name  db̾бơ֥

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppCidrAllocDBUtil
	 *   RegAppCidrAllocDBUtil饹󥹥ȥ饯
	 */
	function RegAppCidrAllocDBUtil()
	{
		$this->fn_col_tbl = array(
			"fn_free_cidr"	=>	"ip_network_number",		// cidr_unallocate_block
		);
	}
}

/**
 * ̾  RegAppApplyCidrAlloc
 *   IPv6ɥ쥹֥å꿶楯饹
 */
class RegAppApplyCidrAlloc
{
	/**
	 * 꿶ϢDB桼ƥƥ
	 */
	var $alloc_util;

	/**
	 * IPv6ɥ쥹֥å꿶楯饹Υǥե
	 */
	var $m_conf_default;

	/**
	 * 󥿥åؿ饹
	 */
	var $m_chk_funcs;

	/**
	 * 꿶ǽʥɥ쥹֥åΥơ
	 */
	var $m_allow_cidr_stt;

	/**
	 * IPv6ɥ쥹꿶̥ץȾarray(ץ̾, conf_obj̾)
	 */
	var $m_cidr_file_if;

	/**
	 * Ʋ̤αѥץ̾,̾󥪥֥̾
	 */
	var $m_cidr_alloc_file;

	/**
	 * Ʋ̤Υȥ
	 */
	var $m_title_tbl;

	/**
	 * DBAPI_IMPLE
	 */
	var $reg_db;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppApplyCidrAlloc
	 *   RegAppApplyCidrAlloc饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function RegAppApplyCidrAlloc($db)
	{
		$this->reg_db = $db;		// DBAPI_IMPLE

		// PERSONϢDB桼ƥƥ
		$this->alloc_util = new RegAppCidrAllocDBUtil();

		// ̾饹
		$this->m_conf_default = array(
			"fn_free_cidr"		=>	new RegAppDispConf("꿶긵֥å", 43),
			"fn_alloc_cidr"		=>	new RegAppDispConf("IPv6ɥ쥹֥å", 43),
		);

		// 󥿥åؿ饹
		$this->m_chk_funcs = array(
			"fn_free_cidr"		=>	new RegAppChkSyntax(
										"chk_ipaddress", null,			// åؿ,ʬѥ᡼
										"C201", "", "",					// 顼(ɬ,Ĺ,)
										1, FREE_CIDR_SEL_MAX, TRUE,		// Ͽ MIN,MAX,ʣܥե饰
										""),							// ʣ顼
			"fn_alloc_cidr"		=>	new RegAppChkSyntax(
										"chk_ipaddress", null,			// åؿ,ʬѥ᡼
										"D001", "D013", "D013",			// 顼(ɬ,Ĺ,)
										1, ALLOC_CIDR_SEL_MAX, TRUE,	// Ͽ MIN,MAX,ʣܥե饰
										"D040"),						// ʣ顼
		);

		// Ʋ̤Υץ̾ȥ桼ƥƥ饹̾Ϣ
		$this->m_cidr_alloc_file = array(
			"DISP_TYPE_OP_FREE_CIDR"	=>	array("RegAppFreeCidrHtml.php", "cidr_info"),
			"DISP_TYPE_OP_ALLOC_CIDR"	=>	array("RegAppAllocCidrHtml.php", "cidr_info"),
			"DISP_TYPE_OP_ALLOC_REVIEW"	=>	array("RegAppReviewCidrHtml.php", "cidr_info"),
		);

		// Ʋ̤Υȥ
		$this->m_title_tbl = array(
			"DISP_TYPE_OP_FREE_CIDR"	=>	"꿶긵֥å",
			"DISP_TYPE_OP_ALLOC_CIDR"	=>	"꿶֥å",
			"DISP_TYPE_OP_ALLOC_REVIEW"	=>	"꿶Ƴǧ",
		);

		// 꿶ǽʥɥ쥹֥åΥơ
		$this->m_allow_cidr_stt = array("returned", "unallocated");
		// IPv6ɥ쥹꿶̥ץȾ
		$this->m_cidr_file_if	= "";
	}

	/**
	 * ؿ̾create_conf_obj
	 *   IPv6ɥ쥹꿶ѤRegAppDispConf[] 
	 * @param  create_fn_keys	string[]		key		(i)
	 * @return  RegAppDispConf[]
	 */
	function create_conf_obj($create_fn_keys)
	{
		$ret_conf = array();
		foreach ($this->m_conf_default as $key => $value)
		{
			if (in_array($key, $create_fn_keys))
			{
				$ret_conf[$key] = $value;
			}
		}
		return $ret_conf;
	}

	/**
	 * ؿ̾get_label_info
	 *   եϲ̤Υ٥ʸ
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ	(i)
	 * @return form name => ʸ Ϣ
	 */
	function get_label_info($for_html=TRUE)
	{
		$label_info = array(
			"fn_free_cidr"		=>	"꿶ǽIPv6ɥ쥹֥å",
			"fn_alloc_cidr"		=>	"Ƽ»ȿ˳꿶IPv6ɥ쥹֥åȾѡ",
		);

		// htmlspecialchars
		if ($for_html)
			$label_info = RegAppFormUtil::conv_array_value_html($label_info);

		return $label_info;
	}

	/**
	 * ؿ̾get_form_example
	 *   եϲ̤ι
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ
	 * @return form name => ʸ Ϣ
	 */
	function get_form_example($for_html=TRUE)
	{
		require("config/RegCnfFormInfo.php");		// եե
		$var_example = array(
			"fn_alloc_cidr"		=>	$cnf_form_example["ip_network_number"],
		);

		// htmlspecialchars
		if ($for_html)
			$var_example = RegAppFormUtil::conv_array_value_html($var_example);

		return $var_example;
	}

	/**
	 * ؿ̾get_cidr_file_if
	 *   ɥ쥹֥å꿶̥ץȾ
	 * @return array(ץ̾, conf_obj̾)
	 */
	function get_cidr_file_if()
	{
		return $this->m_cidr_file_if;
	}

	//-----------------------------------------------------------------------
	// public methods(POSTǡå)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾set_post_cidr_data
	 *   꿶֥åPOSTǡǼ
	 * @param  cidrif_obj	RegAppDispConf[]	̾󥯥饹	(i/o)
	 * @param  set_fn_keys	string[]			Ǽkey			(i)
	 */
	function set_post_cidr_data(&$cidrif_obj, $set_fn_keys)
	{
		if (in_array("fn_free_cidr", $set_fn_keys))
		{
			$cidrif_obj["fn_free_cidr"]->set_post_var("fn_free_cidr");
		}
		if (in_array("fn_alloc_cidr", $set_fn_keys))
		{
			$cidrif_obj["fn_alloc_cidr"]->set_post_var("fn_alloc_cidr");
		}
	}

	/**
	 * ؿ̾set_post_cidr_stt
	 *   POST줿ɥ쥹֥åơ $cidrstt_obj ˥åȤ롣
	 *         cidrif (cidrif_obj["fn_free_cidr"]) ʤ硢ޤ
	 *         ǽʥơͤǤʤϥ顼Ȥ롣
	 * @param  cidrif		RegAppDispConf		꿶긵֥å				(i)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ	(i/o)
	 * @return boolean	TRUEåOKFALSEåNG
	 */
	function set_post_cidr_stt($cidrif, &$cidrstt_obj)
	{
		if (!is_array($cidrif->m_disp_var) || count($cidrif->m_disp_var) < 1)
		{
			return FALSE;
		}

		foreach ($cidrif->m_disp_var as $value)
		{
			$fn_key = strtr($value, ".", "_");
			if (!isset($_POST[$fn_key]) || !in_array($_POST[$fn_key], $this->m_allow_cidr_stt))
			{
				return FALSE;
			}
			$cidrstt_obj[$fn_key] = new RegAppDispConf();
			$cidrstt_obj[$fn_key]->set_post_var($fn_key);
		}

		return TRUE;
	}

	/**
	 * ؿ̾chk_alloc_action_type
	 *   꿶Ƴǧ̤ΥܥϤɽ٤̥פ֤
	 * @param  APPOP_INFO	RegAppApplyOpInfo	ڡɽܾ󥯥饹			(i)
	 * @return DISP_TYPE_OP_ALLOC_CIDR		֥åϲ̤
	 *         DISP_TYPE_OP_FIX_FIX			ǧ
	 *         -1							оʤ
	 */
	function chk_alloc_action_type($APPOP_INFO)
	{
		$fix_btn_nm = $APPOP_INFO->m_op_btn_info["fn_alloc_fix_btn"][0];
		$ret_btn_nm = $APPOP_INFO->m_op_btn_info["fn_allocret_btn"][0];

		if (isset($_POST["fn_alloc_fix_btn"]) && strcmp($_POST["fn_alloc_fix_btn"], $fix_btn_nm) == 0)
		{
			return DISP_TYPE_OP_FIX_FIX;
		}
		if (isset($_POST["fn_allocret_btn"]) && strcmp($_POST["fn_allocret_btn"], $ret_btn_nm) == 0)
		{
			return DISP_TYPE_OP_ALLOC_CIDR;
		}

		return -1;
	}

	//-----------------------------------------------------------------------
	// public methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_cidr_free_syntax
	 *   POSTǡγ꿶긵ɥ쥹֥åͤå
	 * @param  cidrif		RegAppDispConf		꿶긵֥å					(i)
	 * @param  error_str	string[]			顼ɳǼ					(i/o)
	 * @param  hidden_flg	boolean				TRUE:HIDDENåFALSE:INå	(i)
	 * @return åOK1
	 *         ERR_APPOP_IN_SYNTAX		ͥ󥿥åNG(MAXĿOVERΤ)
	 *         ERR_APPOP_HIDDEN_SYNTAX	HIDDENǡ󥿥åNG
	 * @desc   hidden_flg  FALSE ξ硢顼ˤ error_code ˥顼
	 *         (ʣξ礢)Ǽ롣
	 *         hidden_flg  FALSE Ǥ⡢ʸĹʣåΥ顼˴ؤƤ
	 *         ERR_APPOP_HIDDEN_SYNTAX ֤
	 */
	function chk_cidr_free_syntax($cidrif, &$error_str, $hidden_flg)
	{
		// å
		if (count($cidrif->m_disp_var) < 1 ||
			$cidrif->m_disp_var[0] == "" ||
			count($cidrif->m_disp_var) > $this->m_chk_funcs["fn_free_cidr"]->m_max_num)
		{
			if ($hidden_flg)
			{
				return ERR_APPOP_HIDDEN_SYNTAX;
			}
			array_push($error_str, "C203");						// 1Ĥ10Ĥޤǥ顼
			return ERR_APPOP_IN_SYNTAX;
		}
		// 󥿥å(ꥹʤΤǴְ㤤ͭʤ,hiddenǥå)
		if (RegAppFormUtil::call_chk_function($cidrif,
											  $this->m_chk_funcs["fn_free_cidr"],
											  $error_str,
											  TRUE) == FALSE)
		{
			if (!$hidden_flg)
				array_push($error_str, "D000");					// 顼ȯޤ
			return ERR_APPOP_HIDDEN_SYNTAX;
		}
		// ʣå
		if (count($cidrif->m_disp_var) >= 2)
		{
			if (RegIpv6AddressUtil::chk_ipblock_array_overlap($cidrif->m_disp_var))
			{
				if (!$hidden_flg)
					array_push($error_str, "D000");				// 顼ȯޤ
				return ERR_APPOP_HIDDEN_SYNTAX;
			}
		}
		return 1;
	}

	/**
	 * ؿ̾chk_cidr_alloc_syntax
	 *   POSTǡγ꿶Υ󥿥åԤ
	 * @param  cidrif_obj	RegAppDispConf[]	̾󥯥饹						(i/o)
	 * @param  relations	string[]			۲ϢϢ						(i/o)
	 *                                          $relations[俶] = array(俶,俶,...)
	 * @param  error_str	string[]			顼ɳǼ					(i/o)
	 * @param  hidden_flg	boolean				TRUE:HIDDENåFALSE:INå	(i)
	 * @return åOK1
	 *         ERR_APPOP_IN_SYNTAX		ͥ󥿥åNG
	 *         ERR_APPOP_HIDDEN_SYNTAX	HIDDENǡ󥿥åNG
	 * @desc   hidden_flg  FALSE ξ硢顼ˤ error_code ˥顼(ʣ
	 *         礢)Ǽ롣κݡ顼ܤ cidrif_obj  m_error_flg ΩƤ롣
	 *         â꿶긵֥åη顼ܤ ERR_APPOP_HIDDEN_SYNTAX֤Τ
	 *         ǥ顼ϹԤʤ
	 *
	 *         顼ܤ cidrif_obj  m_error_flg ΩƤ
	 *         꿶긵ɥ쥹֥åȳ꿶ͽΥɥ쥹֥åδϢ relations ˥åȤ
	 *         $relations = array("俶1" => array("俶ͽ1", "俶ͽ2", ...),
	 *                            "俶2" => array("俶ͽ1", "俶ͽ2", ...),
	 *                            ...)
	 */
	function chk_cidr_alloc_syntax(&$cidrif_obj, &$relations, &$error_str, $hidden_flg)
	{
		// 꿶֥åMAXĿå
		if (count($cidrif_obj["fn_alloc_cidr"]->m_disp_var) > $this->m_chk_funcs["fn_alloc_cidr"]->m_max_num)
		{
			if ($hidden_flg)
				return ERR_APPOP_HIDDEN_SYNTAX;
			array_push($error_str, "C202");					// 110ĤꤷƤ顼
			return ERR_APPOP_IN_SYNTAX;
		}
		// 󥿥å
		if (RegAppFormUtil::call_chk_function($cidrif_obj["fn_alloc_cidr"],
											  $this->m_chk_funcs["fn_alloc_cidr"],
											  $error_str,
											  $hidden_flg) == FALSE)
		{
			if ($hidden_flg)
				return ERR_APPOP_HIDDEN_SYNTAX;
			return ERR_APPOP_IN_SYNTAX;
		}
		// ɥ쥹ʣå
		if (count($cidrif_obj["fn_alloc_cidr"]->m_disp_var) >= 2)
		{
			if (RegIpv6AddressUtil::chk_ipblock_array_overlap($cidrif_obj["fn_alloc_cidr"]->m_disp_var))
			{
				if ($hidden_flg)
					return ERR_APPOP_HIDDEN_SYNTAX;
				RegAppFormUtil::set_err_data($cidrif_obj["fn_alloc_cidr"],
											 $error_str,
											 $this->m_chk_funcs["fn_alloc_cidr"]->m_err_ex);
				return ERR_APPOP_IN_SYNTAX;
			}
		}

		// ɥ쥹ϰϥå۲طå
		$free_cidr	= array();						// 꿶긵ΰ
		$alloc_cidr	= array();						// 꿶ΰ
		$chk_result = TRUE;							// å
		foreach ($cidrif_obj["fn_alloc_cidr"]->m_disp_var as $alloc)
		{
			// ۲ե饰(俶BLOCK俶BLOCK۲ˤTRUE)
			$included = FALSE;
			foreach ($cidrif_obj["fn_free_cidr"]->m_disp_var as $free)
			{
				if (!is_array($relations[$free]))
				{
					$relations[$free] = array();	// ۲ط
				}

				// 꿶ꥢɥ쥹֥å꿶긵ϰ⤫ݤå
				switch (RegIpv6AddressUtil::chk_ipblock_overlap($alloc, $free))
				{
				case 1:								// Ʊ쥢ɥ쥹
				case 3:								// ϰ⥢ɥ쥹
					$included = TRUE;
					break;

				case 0:								// ʣʤ
				case 2:								// ޤʣ
				case 4:								// 꿶긵礭
					break;

				case -1:							// 顼
				default:							// ¾
					if ($hidden_flg)
						return ERR_APPOP_HIDDEN_SYNTAX;
					array_push($error_str, "D000");
					return ERR_APPOP_IN_SYNTAX;
				}

				if ($included)
				{
					// $relations[俶] = array(俶,俶,...) Ȥ
					array_push($relations[$free], $alloc);
					break;
				}
			}
			if ($included == FALSE)
			{
				// 꿶ͽBLOCK 꿶긵˴ޤޤƤʤ
				if ($hidden_flg)
					return ERR_APPOP_HIDDEN_SYNTAX;
				// ɥ쥹 => 꿶긵ˤʤ 򥻥å
				array_push($error_str, array($alloc, "C204"));
				$chk_result = FALSE;
			}
		}

		if ($chk_result == FALSE)
		{
			$cidrif_obj["fn_alloc_cidr"]->m_error_flg = TRUE;
			return ERR_APPOP_IN_SYNTAX;
		}

		return 1;
	}

	/**
	 * ؿ̾chk_conf_unallocatable
	 *   IPɥ쥹֥åϿԲĤꤵƤʤå
	 *         RegCnfCommon.php  $cnf_unallocatable_block ˽ʣϿԲ
	 * @param  cidr_block	string[]	ɥ쥹֥å	(i)
	 * @param  error_str	string[]	顼ɳǼ			(i/o)
	 * @param  err_set		boolean		顼ɥåȥե饰		(i)
	 * @return boolean		TRUEϿǽFALSEϿԲ(ʣ)
	 * @desc   err_set  TRUEξ硢顼ˤ error_code ˥顼ɤǼ롣
	 */
	function chk_conf_unallocatable($cidr_array, &$error_str, $err_set)
	{
		// config γ꿶Բĥ֥åå
		include("config/RegCnfCommon.php");
		if (is_array($cnf_unallocatable_block) && count($cnf_unallocatable_block) > 0 && is_array($cidr_array))
		{
			$chk_result = TRUE;
			foreach ($cidr_array as $value)
			{
// 2004.03.08 modify >>>
//				$chk_blocks = array();
//				$chk_blocks = array_merge($cnf_unallocatable_block, $value);
				$chk_blocks = is_array($cnf_unallocatable_block) ? $cnf_unallocatable_block : array();
				array_push($chk_blocks, $value);
// 2004.03.08 modify <<<
				if (RegIpv6AddressUtil::chk_ipblock_array_overlap($chk_blocks))
				{
					// ɥ쥹 => 꿶ػꤢ Ͽ
					if ($err_set)
						array_push($error_str, array($value, "C031"));
					$chk_result = FALSE;
				}
			}
			return $chk_result;
		}
		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_unallocate_cidr_list
	 *   꿶ǽʥɥ쥹֥åꥹ(IPɥ쥹,ơ)
	 * @param  cidrif_obj		RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i/o)
	 * @param  cidrstt_obj		RegAppDispConf[]	ɥ쥹֥åơ		(i/o)
	 * @param  error_str		string[]			顼ɾ						(i/o)
	 * @return 1
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_CIDR_SEARCH	꿶ǽ֥å¸ߤʤ
	 * @desc   ORDERϡ
	 *          1.ơ(unallocate, returned ν)
	 *          2.ɥ쥹ֹ
	 *         Ȥ롣
	 *         ̤Τɥ쥹֥åΥɥ쥹 cidrif_obj["fn_free_cidr"] ˡ
	 *         ơ cidrstt_obj["IPɥ쥹"] ˤ줾Ǽ롣
	 */
	function get_unallocate_cidr_list(&$cidrif_obj, &$cidrstt_obj, &$error_str)
	{
		// configγ꿶Բĥ֥åȽʣʤγ꿶ǽ֥å
		include("config/RegCnfCommon.php");
		$where_info = array();
		if(is_array($cnf_unallocatable_block)){
			foreach($cnf_unallocatable_block as $value){
				if(RegIpv6AddressUtil::chk_ipblock($value)){
					array_push($where_info, 
						"NOT ip_network_number <<= cidr '".addslashes($value)."'",
						"NOT ip_network_number >> cidr '".addslashes($value)."'"
					);
				}
			}
		}
		$where_str = count($where_info) ? (" WHERE ".join(" AND ", $where_info)) : "";
		$sql_str = "SELECT ip_network_number, status FROM cidr_unallocate_block" .
				   $where_str .
				   " ORDER BY status DESC, start_sequence_number";
		$db_result = $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)				// 顼
		{
			array_push($error_str, "D200");		// ɥ쥹֥åԥ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)				// 
		{
			array_push($error_str, "C200");		// ɥ쥹֥åϿʤ顼
			return ERR_APPOP_CIDR_SEARCH;
		}

		// ̳Ǽ
		$tmp_addr		= array();
		$cidrstt_obj	= "";
		foreach ($db_result as $value)
		{
			array_push($tmp_addr, $value["ip_network_number"]);
			// array("IPɥ쥹" => RegAppDispConf(), ...) ˥ơǼ
			$fn_key = strtr($value["ip_network_number"], ".", "_");
			$cidrstt_obj[$fn_key] = new RegAppDispConf("", 0, $value["status"]);
		}
		if (count($tmp_addr) < 1)
		{
			array_push($error_str, "C200");		// ɥ쥹֥åϿʤ顼
			return ERR_APPOP_CIDR_SEARCH;
		}

		$cidrif_obj["fn_free_cidr"]->set_disp_var($tmp_addr);

		return 1;
	}

	/**
	 * ؿ̾get_unallocate_cidr_stt
	 *   ꤵ줿ɥ쥹֥åΥơ
	 * @param  cidrif_obj		RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i)
	 * @param  cidrstt_obj		RegAppDispConf[]	ɥ쥹֥åơ		(i/o)
	 * @param  error_str		string[]			顼ɾ		(i/o)
	 * @return 1
	 *         ERR_APPOP_FATAL			fatal顼
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_CIDR_SEARCH	꿶ǽ֥å¸ߤʤ
	 * @desc   ơ cidrstt_obj["IPɥ쥹"] ˳Ǽ롣
	 */
	function get_unallocate_cidr_stt($cidrif_obj, &$cidrstt_obj, &$error_str)
	{
		//--------------------------------------------------------------------
		// cidr_unallocate_block 
		//--------------------------------------------------------------------
		// WHERE
		$where_str = "";		// WHERE(ip_network_number)
		$get_count = 0;			// 
		if (is_array($cidrif_obj["fn_free_cidr"]->m_disp_var))
		{
			foreach ($cidrif_obj["fn_free_cidr"]->m_disp_var as $addr)
			{
				if ($addr != "")
				{
					$where_str .= GetApsString($addr) . ",";
					$get_count++;
				}
			}
			if ($where_str != "")
				$where_str = rtrim($where_str, ",");
		}
		if ($where_str == "")
		{
			return ERR_APPOP_FATAL;
		}
		// (ip_network_number & status)
		$sql_str = "SELECT ip_network_number, status FROM cidr_unallocate_block" .
				   " WHERE ip_network_number IN(" . $where_str . ")" .
				   " ORDER BY status DESC, start_sequence_number";
		$db_result = $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)				// 顼
		{
			array_push($error_str, "D200");		// ɥ쥹֥åԥ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)				// 
		{
			// ɥ쥹 => 꿶ǽǤϤʤ Ͽ
			foreach ($cidrif_obj["fn_free_cidr"]->m_disp_var as $addr)
			{
				if ($addr != "")
					array_push($error_str, array($addr, "C205"));
			}
			return ERR_APPOP_CIDR_SEARCH;
		}

		//--------------------------------------------------------------------
		// ̳Ǽ̥å
		//--------------------------------------------------------------------
		$tmp_addr		= array();
		$cidrstt_obj	= "";
		foreach ($db_result as $value)
		{
			array_push($tmp_addr, $value["ip_network_number"]);
			// array("IPɥ쥹" => RegAppDispConf(), ...) ˥ơǼ
			$fn_key = strtr($value["ip_network_number"], ".", "_");
			$cidrstt_obj[$fn_key] = new RegAppDispConf("", 0, $value["status"]);
		}

		// ץ饤ޥꥭʤΤǡ㤦ϥ顼
		if ($get_count != count($db_result))
		{
			foreach ($cidrif_obj["fn_free_cidr"]->m_disp_var as $addr)
			{
				// ɥ쥹 => 꿶ǽǤϤʤ Ͽ
				if ($addr != "" && !in_array($addr, $tmp_addr))
				{
					array_push($error_str, array($addr, "C205"));
				}
			}
			return ERR_APPOP_CIDR_SEARCH;
		}

		return 1;
	}

	//------------------------------------------------------------------------
	// public methods(̥ѡĺ)
	//------------------------------------------------------------------------
	/**
	 * ؿ̾create_free_cidr_parts
	 *   꿶긵֥åѤHTMLѥǡԤ
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i/o)
	 * @param  title		string				̥ȥ							(i/o)
	 * @param  label_info	string[]			٥								(i/o)
	 * @desc   ץȾ󡢥ȥ򥻥åȤHTML򤹤
	 */
	function create_free_cidr_parts(&$cidrif_obj, &$title, &$label_info)
	{
		$title		= htmlspecialchars(
									$this->m_title_tbl["DISP_TYPE_OP_FREE_CIDR"],
									ENT_QUOTES);
		$label_info = $this->get_label_info();
		$this->m_cidr_file_if = $this->m_cidr_alloc_file["DISP_TYPE_OP_FREE_CIDR"];
		RegAppFormUtil::conv_dispvars_htmlstr($cidrif_obj, array_keys($cidrif_obj));
	}

	/**
	 * ؿ̾create_alloc_cidr_parts
	 *   꿶֥åϲѤHTMLѥǡԤ
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i/o)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ		(i/o)
	 * @param  title		string				̥ȥ			(i/o)
	 * @param  label_info	string[]			٥				(i/o)
	 * @param  form_example	string[]								(i/o)
	 * @desc   ץȾ󡢥ȥ򥻥åȤHTML򤹤
	 */
	function create_alloc_cidr_parts(&$cidrif_obj, &$cidrstt_obj, &$title, &$label_info, &$form_example)
	{
		$title			= htmlspecialchars(
									$this->m_title_tbl["DISP_TYPE_OP_ALLOC_CIDR"],
									ENT_QUOTES);
		$label_info		= $this->get_label_info();
		$form_example	= $this->get_form_example();
		$this->m_cidr_file_if = $this->m_cidr_alloc_file["DISP_TYPE_OP_ALLOC_CIDR"];
		RegAppFormUtil::conv_dispvars_htmlstr($cidrif_obj, array_keys($cidrif_obj));
		RegAppFormUtil::conv_dispvars_htmlstr($cidrstt_obj, array_keys($cidrstt_obj));
	}

	/**
	 * ؿ̾create_review_cidr_parts
	 *   꿶ƳǧѤHTMLѥǡԤ
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i/o)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ		(i/o)
	 * @param  title		string				̥ȥ			(i/o)
	 * @desc   ץȾ󡢥ȥ򥻥åȤHTML򤹤
	 */
	function create_review_cidr_parts(&$cidrif_obj, &$cidrstt_obj, &$title)
	{
		$title			= htmlspecialchars(
									$this->m_title_tbl["DISP_TYPE_OP_ALLOC_REVIEW"],
									ENT_QUOTES);
		$this->m_cidr_file_if = $this->m_cidr_alloc_file["DISP_TYPE_OP_ALLOC_REVIEW"];
		RegAppFormUtil::conv_dispvars_htmlstr($cidrif_obj, array_keys($cidrif_obj));
		RegAppFormUtil::conv_dispvars_htmlstr($cidrstt_obj, array_keys($cidrstt_obj));
	}

	//------------------------------------------------------------------------
	// public methods(HTML)
	//------------------------------------------------------------------------
	/**
	 * ؿ̾print_free_cidr_list
	 *   꿶긵֥åꥹȤHTMLɽ
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ		(i)
	 * @desc   ʲ롣
	 *         1 <select name="fn_free_cidr[]">
	 *         2 <option value="ɥ쥹">ɥ쥹  ơ
	 *         3 </select>
	 */
	function print_free_cidr_list($cidrif_obj, $cidrstt_obj)
	{
		if (!is_array($cidrif_obj["fn_free_cidr"]->m_disp_var) ||
			count($cidrif_obj["fn_free_cidr"]->m_disp_var) < 1)
		{
			return;
		}

		print ("<select name=\"fn_free_cidr[]\" multiple size=\"10\">\n");
		foreach ($cidrif_obj["fn_free_cidr"]->m_disp_var as $addr)
		{
			$stt	= "";
			$fn_key	= strtr($addr, ".", "_");
			if (strcmp($cidrstt_obj[$fn_key]->m_disp_var, "returned") == 0)
			{
				$stt = $cidrstt_obj[$fn_key];
				$stt->conv_value_htmlstr();
				$stt = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . $stt->m_disp_var;
			}
			print ("<option value=\"" . $addr . "\">" . $addr . $stt . "\n");
		}
		print ("</select>\n");
	}

	/**
	 * ؿ̾print_free_cidr_data
	 *   򤷤꿶긵֥åHTMLɽ
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ		(i)
	 * @param  free_bold	boolean				ɥ쥹,ơ<b>ɽե饰	(i)
	 *                      TRUE:ɥ쥹,ơĴɽFALSE:ɥ쥹,ơ̾ɽ
	 * @desc   ٥롢꿶긵֥åơɽ
	 *         <tr></tr>
	 */
	function print_free_cidr_data($cidrif_obj, $cidrstt_obj, $free_bold)
	{
		$disp_cnt = 0;		// ٥ɽѥ
		if (!is_array($cidrif_obj["fn_free_cidr"]->m_disp_var) ||
			count($cidrif_obj["fn_free_cidr"]->m_disp_var) < 1)
		{
			return;		// ɽǡʤ
		}

		if ($free_bold)
		{
			$bold_s = "<b>";
			$bold_e = "</b>";
		}
		else
		{
			$bold_s = "";
			$bold_e = "";
		}

		print ("<tr bgcolor=\"#C0CDFD\">\n");
		print ("<td class=\"tdlisttitle\" width=\"70%\">\n");
		print ($cidrif_obj["fn_free_cidr"]->m_label_str . "\n");
		print ("</td>\n");
		print ("<td class=\"tdlisttitle\" width=\"70%\">\n");
		print (FREE_CIDR_STT_TITLE . "\n");
		print ("</td>\n");
		print ("</tr>\n");

		foreach ($cidrif_obj["fn_free_cidr"]->m_disp_var as $addr)
		{
			$fn_key = strtr($addr, ".", "_");		// ơΥ
			print ("<tr>\n");
			print ("<td class=\"tdlistitem\" bgcolor=\"#FFFFFF\">\n");
			print($bold_s . $addr . $bold_e . "\n");
			print("</td>\n");
			print ("<td class=\"tdlistitem\" bgcolor=\"#FFFFFF\">\n");
			print("<font color=\"black\">" . $bold_s . $cidrstt_obj[$fn_key]->m_disp_var . $bold_e . "</font>\n");
			print("</td>\n");
			print("</tr>\n");
		}
	}

	//-----------------------------------------------------------------------
	// public methods(buttn tag)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_free_cidr_btn
	 *   꿶긵֥å̤ǻѤHTML
	 * @param  appls_obj	RegAppDispConf[]	̾󥯥饹Ϣ()	(i)
	 * @param  appif_obj	RegAppDispConf[]	̾󥯥饹Ϣ()		(i)
	 * @param  APPOP_INFO	RegAppApplyOpInfo	ڡɽܾ󥯥饹			(i)
	 * @param  own_file		string				ǧץ̾(ץ)		(i)
	 * @return HIDDEN TAG
	 */
	function create_free_cidr_btn($appls_conf, $applyif_conf, $APPOP_INFO, $own_file)
	{
		include("RegAppTableStyle.php");
		$base_array = $this->create_base_fm_array($appls_conf, $applyif_conf, TRUE);

		//--------------------------------------------------------------------
		// Ƴǧ̤ǻѤHIDDEN
		//--------------------------------------------------------------------
		// RETURN FORM 
		$ret_btn_str	= $APPOP_INFO->m_op_btn_info["fn_reviewret_btn"][0];
		$ret_btn_name	= "fn_reviewret_btn";
		$ret_fm_key		= $APPOP_INFO->m_op_btn_info["fn_reviewret_btn"][1];
		$ret_fm_action	= $own_file;
		$ret_page_name	= $APPOP_INFO->m_op_btn_info["fn_reviewret_btn"][2];

		//--------------------------------------------------------------------
		// 俶֥åϲ̤ǻѤHIDDEN
		//--------------------------------------------------------------------
		// HIDDEN
		$op_array["fn_app_last_date"]	= $applyif_conf["fn_app_last_date"];
		$op_array["fn_app_memnum"]		= $applyif_conf["fn_app_memnum"];
		$op_array["fn_app_last_date"]->conv_value_htmlstr();
		$op_array["fn_app_memnum"]->conv_value_htmlstr();
		$sel_array = array_merge($base_array, $op_array);
		// SELECT FORM 
		$sel_btn_str	= $APPOP_INFO->m_op_btn_info["fn_sel_conf_btn"][0];
		$sel_btn_name	= "fn_sel_conf_btn";
		$sel_page_name	= $APPOP_INFO->m_op_btn_info["fn_sel_conf_btn"][2];

		//--------------------------------------------------------------------
		// button html
		//--------------------------------------------------------------------
		$btn_tag .= "<table border=\"0\">\n";
		$btn_tag .= "<tr>\n";
		$btn_tag .= "<td class=\"tdnopadd\">\n";

		$btn_tag .= RegAppFormUtil::create_btn_tag(
							array($sel_btn_name	=>	$sel_btn_str),
							$sel_array,
							array_keys($sel_array),
							$sel_page_name
							);

		$btn_tag .= "</form>\n";
		$btn_tag .= "</td>\n";
		$btn_tag .= "<td class=\"tdnopadd\">\n";

		$btn_tag .= RegAppFormUtil::create_form_tag(
							array($ret_fm_key	=>	$ret_fm_action),
							array($ret_btn_name	=>	$ret_btn_str),
							$base_array,
							array_keys($base_array),
							$ret_page_name
							);

		$btn_tag .= "</td>\n";
		$btn_tag .= "</tr>\n";
		$btn_tag .= "</table>\n";

		return $btn_tag;
	}

	/**
	 * ؿ̾create_alloc_cidr_btn
	 *   꿶֥åϲ̤ǻѤHTML
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ		(i)
	 * @param  appls_obj	RegAppDispConf[]	̾󥯥饹Ϣ()	(i)
	 * @param  appif_obj	RegAppDispConf[]	̾󥯥饹Ϣ()		(i)
	 * @param  APPOP_INFO	RegAppApplyOpInfo	ڡɽܾ󥯥饹			(i)
	 * @param  own_file		string				ǧץ̾(ץ)		(i)
	 * @return HIDDEN TAG
	 */
	function create_alloc_cidr_btn($cidrif_obj, $cidrstt_obj,
								   $appls_conf, $applyif_conf,
								   $APPOP_INFO, $own_file)
	{
		include("RegAppTableStyle.php");
		$base_array = $this->create_base_fm_array($appls_conf, $applyif_conf, FALSE);

		//--------------------------------------------------------------------
		// 俶긵֥å̤ǻѤHIDDEN
		//--------------------------------------------------------------------
		// RETURN FORM 
		$ret_btn_str	= $APPOP_INFO->m_op_btn_info["fn_selret_btn"][0];
		$ret_btn_name	= "fn_selret_btn";
		$ret_fm_key		= $APPOP_INFO->m_op_btn_info["fn_selret_btn"][1];
		$ret_fm_action	= $own_file;
		$ret_page_name	= $APPOP_INFO->m_op_btn_info["fn_selret_btn"][2];

		//--------------------------------------------------------------------
		// 俶Ƴǧ̤ǻѤHIDDEN
		//--------------------------------------------------------------------
		// HIDDEN 
		$tmp_array = $this->create_cidr_fm_array($cidrif_obj,
												 array("fn_free_cidr"),
												 $cidrstt_obj);
		$input_array = array_merge($base_array, $tmp_array);
		// SELECT FORM 
		$input_btn_str	 = $APPOP_INFO->m_op_btn_info["fn_alloc_conf_btn"][0];
		$input_btn_name	 = "fn_alloc_conf_btn";
		$input_page_name = $APPOP_INFO->m_op_btn_info["fn_alloc_conf_btn"][2];

		//--------------------------------------------------------------------
		// button html
		//--------------------------------------------------------------------
		$btn_tag .= "<table border=\"0\">\n";
		$btn_tag .= "<tr>\n";
		$btn_tag .= "<td class=\"tdnopadd\">\n";

		$btn_tag .= RegAppFormUtil::create_btn_tag(
							array($input_btn_name	=>	$input_btn_str),
							$input_array,
							array_keys($input_array),
							$input_page_name
							);
		$btn_tag .= "</form>\n";
		$btn_tag .= "</td>\n";
		$btn_tag .= "<td class=\"tdnopadd\">\n";

		$btn_tag .= RegAppFormUtil::create_form_tag(
							array($ret_fm_key	=>	$ret_fm_action),
							array($ret_btn_name	=>	$ret_btn_str),
							$base_array,
							array_keys($base_array),
							$ret_page_name
							);

		$btn_tag .= "</td>\n";
		$btn_tag .= "</tr>\n";
		$btn_tag .= "</table>\n";

		return $btn_tag;
	}

	/**
	 * ؿ̾create_alloc_review_btn
	 *   꿶Ƴǧ̤ǻѤHTML
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ		(i)
	 * @param  appls_obj	RegAppDispConf[]	̾󥯥饹Ϣ()	(i)
	 * @param  appif_obj	RegAppDispConf[]	̾󥯥饹Ϣ()		(i)
	 * @param  APPOP_INFO	RegAppApplyOpInfo	ڡɽܾ󥯥饹			(i)
	 * @param  own_file		string				ǧץ̾(ץ)		(i)
	 * @return HIDDEN TAG
	 */
	function create_alloc_review_btn($cidrif_obj, $cidrstt_obj,
									 $appls_conf, $applyif_conf,
									 $APPOP_INFO, $own_file)
	{
		include("RegAppTableStyle.php");
		//--------------------------------------------------------------------
		// HIDDEN
		//--------------------------------------------------------------------
		$base_array	= $this->create_base_fm_array($appls_conf, $applyif_conf, FALSE);
		$cidr_array	= $this->create_cidr_fm_array($cidrif_obj,
												  array("fn_free_cidr", "fn_alloc_cidr"),
												  $cidrstt_obj);
		$fix_array	= array_merge($base_array, $cidr_array);

		//--------------------------------------------------------------------
		// FORM
		//--------------------------------------------------------------------
		// ̾
		$fm_key			= $APPOP_INFO->m_op_btn_info["fn_alloc_fix_btn"][1];
		$fm_action		= $own_file;
		$page_name		= $APPOP_INFO->m_op_btn_info["fn_alloc_fix_btn"][2];
		// FIX 
		$fix_btn_str	= $APPOP_INFO->m_op_btn_info["fn_alloc_fix_btn"][0];
		$fix_btn_name	= "fn_alloc_fix_btn";
		// RETURN 
		$ret_btn_str	= $APPOP_INFO->m_op_btn_info["fn_allocret_btn"][0];
		$ret_btn_name	= "fn_allocret_btn";

		//--------------------------------------------------------------------
		// button html
		//--------------------------------------------------------------------
		$btn_tag .= "<table border=\"0\">\n";
		$btn_tag .= "<tr>\n";
		$btn_tag .= "<td class=\"tdnopadd\">\n";

		$btn_tag .= RegAppFormUtil::create_form_tag(
							array($fm_key		=>	$fm_action),
							array($fix_btn_name	=>	$fix_btn_str,
								  $ret_btn_name	=>	$ret_btn_str),
							$fix_array,
							array_keys($fix_array),
							$page_name
							);

		$btn_tag .= "</td>\n";
		$btn_tag .= "</tr>\n";
		$btn_tag .= "</table>\n";

		return $btn_tag;
	}

	/**
	 * ؿ̾create_alloc_cidr_errret_btn
	 *   顼ȯ˳꿶֥åϲ̤ܥ
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ		(i)
	 * @param  appls_obj	RegAppDispConf[]	̾󥯥饹Ϣ()	(i)
	 * @param  appif_obj	RegAppDispConf[]	̾󥯥饹Ϣ()		(i)
	 * @param  APPOP_INFO	RegAppApplyOpInfo	ڡɽܾ󥯥饹			(i)
	 * @param  own_file		string				ǧץ̾(ץ)		(i)
	 * @return HIDDEN TAG
	 */
	function create_alloc_cidr_errret_btn($cidrif_obj, $cidrstt_obj,
									 	  $appls_conf, $applyif_conf,
									 	  $APPOP_INFO, $own_file)
	{
		include("RegAppTableStyle.php");
		//--------------------------------------------------------------------
		// HIDDEN
		//--------------------------------------------------------------------
		$base_array	= $this->create_base_fm_array($appls_conf, $applyif_conf, FALSE);
		$cidr_array	= $this->create_cidr_fm_array($cidrif_obj,
												  array("fn_free_cidr", "fn_alloc_cidr"),
												  $cidrstt_obj);
		$ret_array	= array_merge($base_array, $cidr_array);

		//--------------------------------------------------------------------
		// FORM
		//--------------------------------------------------------------------
		$ret_fm_key		= $APPOP_INFO->m_op_btn_info["fn_allocerr_btn"][1];
		$ret_fm_action	= $own_file;
		$ret_page_name	= $APPOP_INFO->m_op_btn_info["fn_allocerr_btn"][2];
		$ret_btn_str	= $APPOP_INFO->m_op_btn_info["fn_allocerr_btn"][0];
		$ret_btn_name	= "fn_allocerr_btn";

		//--------------------------------------------------------------------
		// button html
		//--------------------------------------------------------------------
		$btn_tag  = "<table border=\"0\" class=\"" . $table_style . "\">\n";
		$btn_tag .= "<tr>\n";
		$btn_tag .= "<td valign=\"middle\" align=\"center\">\n";

		$btn_tag .= RegAppFormUtil::create_form_tag(
							array($ret_fm_key	=>	$ret_fm_action),
							array($ret_btn_name	=>	$ret_btn_str),
							$ret_array,
							array_keys($ret_array),
							$ret_page_name
							);

		$btn_tag .= "</td>\n";
		$btn_tag .= "</tr>\n";
		$btn_tag .= "</table>\n";

		return $btn_tag;
	}

	/**
	 * ؿ̾create_free_cidr_errret_btn
	 *   顼ȯ˳꿶긵֥å̤ܥ
	 * @param  appls_obj	RegAppDispConf[]	̾󥯥饹Ϣ()	(i)
	 * @param  appif_obj	RegAppDispConf[]	̾󥯥饹Ϣ()		(i)
	 * @param  APPOP_INFO	RegAppApplyOpInfo	ڡɽܾ󥯥饹			(i)
	 * @param  own_file		string				ǧץ̾(ץ)		(i)
	 * @return HIDDEN TAG
	 */
	function create_free_cidr_errret_btn($appls_conf, $applyif_conf,
									 	 $APPOP_INFO, $own_file, $table_style="white_table")
	{
		include("RegAppTableStyle.php");
		//--------------------------------------------------------------------
		// HIDDEN
		//--------------------------------------------------------------------
		$base_array	= $this->create_base_fm_array($appls_conf, $applyif_conf, FALSE);

		//--------------------------------------------------------------------
		// FORM
		//--------------------------------------------------------------------
		$ret_fm_key		= $APPOP_INFO->m_op_btn_info["fn_selerr_btn"][1];
		$ret_fm_action	= $own_file;
		$ret_page_name	= $APPOP_INFO->m_op_btn_info["fn_selerr_btn"][2];
		$ret_btn_str	= $APPOP_INFO->m_op_btn_info["fn_selerr_btn"][0];
		$ret_btn_name	= "fn_selerr_btn";

		//--------------------------------------------------------------------
		// button html
		//--------------------------------------------------------------------
		$btn_tag  = "<table border=\"0\" class=\"" . $table_style . "\">\n";
		$btn_tag .= "<tr>\n";
		$btn_tag .= "<td valign=\"middle\" align=\"center\">\n";

		$btn_tag .= RegAppFormUtil::create_form_tag(
							array($ret_fm_key	=>	$ret_fm_action),
							array($ret_btn_name	=>	$ret_btn_str),
							$base_array,
							array_keys($base_array),
							$ret_page_name
							);

		$btn_tag .= "</td>\n";
		$btn_tag .= "</tr>\n";
		$btn_tag .= "</table>\n";

		return $btn_tag;
	}

	//-----------------------------------------------------------------------
	// private methods(buttn tag)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_base_fm_array
	 *   Ʋ̤δ HIDDEN RegAppDispConf[] ˤޤȤ
	 * @param  appls_obj	RegAppDispConf[]	̾󥯥饹Ϣ()	(i)
	 * @param  appif_obj	RegAppDispConf[]	̾󥯥饹Ϣ()		(i)
	 * @param  fm_ret_flg	boolean				Ƴǧ̥ե饰				(i)
	 *                      TRUE Ƴǧ(applyif_if acceptid,kindid Τ)
	 *                      FALSE꿶(applyif_if clerkid ʳ)
	 * @return RegAppDispConf[]
	 */
	function create_base_fm_array($appls_conf, $applyif_conf, $fm_ret_flg)
	{
		//----- Ͽ -----//
		if ($fm_ret_flg)
		{
			// Ƴǧ̤Ǥϡֹȼ̤Τ߻
			$if_array["fn_app_acceptid"] = $applyif_conf["fn_app_acceptid"];
			$if_array["fn_app_kindid"]	 = $applyif_conf["fn_app_kindid"];
		}
		else
		{
			// 꿶γƲ̤Ǥϡ̳ô԰ʳ
			foreach ($applyif_conf as $if_key => $if_var)
			{
				if ($if_key == "fn_app_clerkid")
					continue;
				$if_array[$if_key] = $if_var;
			}
		}
		// HTML
		RegAppFormUtil::conv_dispvars_htmlstr($if_array, array_keys($if_array));

		//----- ̾ȿ礷ֵ -----//
		return array_merge($appls_conf, $if_array);
	}

	/**
	 * ؿ̾create_cidr_fm_array
	 *   꿶֥åHIDDEN RegAppDispConf[] ˤޤȤ
	 * @param  cidrif_obj	RegAppDispConf[]	ɥ쥹֥å꿶Ѳ̾	(i)
	 * @param  fn_keys		string[]			cidrif_obj оݤȤʤ륭			(i)
	 * @param  cidrstt_obj	RegAppDispConf[]	ɥ쥹֥åơ		(i)
	 * @return RegAppDispConf[]
	 * @desc   cidrstt_obj  "" ξоݤˤʤ
	 */
	function create_cidr_fm_array($cidrif_obj, $fn_keys, $cidrstt_obj)
	{
		$tmp_array = array();
		// 俶긵CIDR
		if (in_array("fn_free_cidr", $fn_keys))
		{
			$tmp_array["fn_free_cidr"] = $cidrif_obj["fn_free_cidr"];
		}
		// 俶ͽCIDR
		if (in_array("fn_alloc_cidr", $fn_keys))
		{
			$tmp_array["fn_alloc_cidr"] = $cidrif_obj["fn_alloc_cidr"];
		}
		// 俶긵֥åΥơ
		if ($cidrstt_obj != "")
		{
			foreach ($cidrstt_obj as $key => $value)
			{
				$tmp_array[$key] = $value;
			}
		}
		// HTML
		if (count($tmp_array) > 0)
		{
			RegAppFormUtil::conv_dispvars_htmlstr($tmp_array, array_keys($tmp_array));
		}
		else
		{
			$tmp_array = "";
		}
		return $tmp_array;
	}
}
?>
