<?php
/**
 * $Id: RegAppFormNet.php,v 1.19 2004/03/02 10:25:03 wtetsuya Exp $
 */
?>
<?php
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPIWrapper.php");			// DB API IMPLE
require_once("DBAPI_IPNET.php");			// DB API ipnetϢ饹
require_once("RegAppFormUtil.php");			// ե桼ƥƥ饹
require_once("RegAppDateUtil.php");			// մϢ桼ƥƥ饹
require_once("RegIpv6AddressUtil.php");		// IP AddressϢ桼ƥƥ饹
require_once("RegAppApplyDBUtil.php");		// ϢDB桼ƥƥ饹
require_once("RegAppNetDBUtil.php");		// IPNETϢDB桼ƥƥ

//----------------------------------------------------------------------------
// RegNetAddressInfo class
//----------------------------------------------------------------------------
// RegAppFormNet::chk_net_ipaddress_semantics ΰ add_info Ϥ
// ͽIPɥ쥹
//----------------------------------------------------------------------------
class RegNetAddressInfo
{
	var $m_start_num;		// IPɥ쥹֤γֹ
	var $m_end_num;			// IPɥ쥹֤νλֹ
	var $m_cidr_block;		// ƤIPɥ쥹֤°꿶֥å

	/**
	 * ؿ̾RegNetAddressInfo
	 *   RegNetAddressInfo饹󥹥ȥ饯
	 * @param  start	string		IPɥ쥹֤γֹ
	 * @param  end		string		IPɥ쥹֤νλֹ
	 * @param  cidr		string		ƤIPɥ쥹֤°꿶֥å
	 * @desc   cidrϡchk_net_ipaddress_semantics ꤹ
	 */
	function RegNetAddressInfo($start, $end, $cidr="")
	{
		$this->m_start_num	= $start;
		$this->m_end_num	= $end;
		$this->m_cidr_block	= $cidr;
	}
}

//----------------------------------------------------------------------------
// RegAppFormNet class
//----------------------------------------------------------------------------
// IPɥ쥹Ϣο楯饹
//----------------------------------------------------------------------------
class RegAppFormNet
{
	/**
	 * ͥåȥϢ̾饹Υǥե
	 * array(form name => RegAppInputCheck)
	 */
	var $m_conf_default;

	/**
	 * IPNETϢDB桼ƥƥ
	 */
	var $net_util;

	/**
	 * 󥿥åؿ饹
	 * array(form name => RegAppChkSyntax)
	 */
	var $m_chk_funcs;

	/**
	 * 
	 */
	var $m_kind_id;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormNet
	 *   RegAppFormNet饹󥹥ȥ饯
	 * @param  kind_id	string		̡ʵǽID
	 */
	function RegAppFormNet($kind_id)
	{
		//-------------------------------------------------------------------
		// ̡ʵǽID
		//-------------------------------------------------------------------
		$this->m_kind_id = $kind_id;

		//-------------------------------------------------------------------
		// IPNETϢDB桼ƥƥ
		//-------------------------------------------------------------------
		$this->net_util	= new RegAppNetDBUtil();

		//-------------------------------------------------------------------
		// ̾饹
		//-------------------------------------------------------------------
		$this->m_conf_default = array(
			"fn_mem_op_short"	=>	new RegAppDispConf("ȿά", 50),

			"fn_net_ip_address"	=>	new RegAppDispConf("IPͥåȥɥ쥹", 43),
			"fn_net_name"		=>	new RegAppDispConf("ͥåȥ̾", 12),

			"fn_net_orgjp"		=>	new RegAppDispConf("ȿ̾", 256),
			"fn_net_orgen"		=>	new RegAppDispConf("Organization", 256),
			"fn_net_mail"		=>	new RegAppDispConf("Żҥ᡼", 256),		// array
			"fn_net_postal"		=>	new RegAppDispConf("͹ֹ", 10),
			"fn_net_addjp"		=>	new RegAppDispConf("", 256),
			"fn_net_adden"		=>	new RegAppDispConf("Address", 256),
			"fn_net_tec_handle"	=>	new RegAppDispConf("Ǥ/Ϣô", 10),	// array

			"fn_net_init_date"	=>	new RegAppDispConf("Ͽ"),
			"fn_net_last_date"	=>	new RegAppDispConf("ǽ"),

			"fn_net_cidr"		=>	new RegAppDispConf("꿶֥åɥ쥹", 43),

			"fn_net_reason"		=>	new RegAppDispConf("ѹͳ", 1000),
			"fn_net_delete"		=>	new RegAppDispConf("ֵͳ", 1000),
		);

		//-------------------------------------------------------------------
		// 󥿥åؿ饹
		//-------------------------------------------------------------------
		$func_normal = array(
			"fn_mem_op_short"	=>	new RegAppChkSyntax("chk_mem_short", null, "D001", "D007", "D008", 1, 1, FALSE),
			"fn_net_name"		=>	new RegAppChkSyntax("chk_netname", null, "D001", "D038", "D039", 1, 1, FALSE),

			"fn_net_orgjp"		=>	new RegAppChkSyntax("chk_org_jp", null, "D001", "D009", "D010", 1, 1, FALSE),
			"fn_net_orgen"		=>	new RegAppChkSyntax("chk_hankaku_length", array(1,256), "D001", "D009", "D011", 1, 1, FALSE),
			"fn_net_mail"		=>	new RegAppChkSyntax("chk_mailaddress", null, "D001", "D022", "D049", 1, 5, TRUE, "D026"),
			"fn_net_postal"		=>	new RegAppChkSyntax("chk_postalcode", null, "D001", "D017", "D050", 1, 1, FALSE),
			"fn_net_addjp"		=>	new RegAppChkSyntax("chk_address_jp", null, "D001", "D009", "D019", 1, 1, FALSE),
			"fn_net_adden"		=>	new RegAppChkSyntax("chk_address_en", null, "D001", "D009", "D051", 1, 1, FALSE),

			"fn_net_tec_handle"	=>	new RegAppChkSyntax("chk_handle", array(TRUE), "D001", "D033", "D033", 1, 5, TRUE, "D026"),

			"fn_net_init_date"	=>	new RegAppChkSyntax("chk_date_for_db", null, "", "", "", 1, 1, FALSE),

			"fn_net_reason"		=>	new RegAppChkSyntax("chk_changereason", null, "D001", "D044", "", 1, 1, FALSE),
			"fn_net_delete"		=>	new RegAppChkSyntax("chk_deletereason", null, "D001", "D044", "D011", 1, 1, FALSE),
		);

		switch ($this->m_kind_id)
		{
		case "ops0206":			// ƥ桼
		case "ops0208":			// ܻѹ
			// ưϤϥͥåȥɥ쥹
			$func_ex = array(
				//"fn_net_ip_address"	=>	new RegAppChkSyntax("chk_ipaddress", null, "D001", "D013", "D013", 1, 1, TRUE, "D040"),
				"fn_net_ip_address"	=>	new RegAppChkSyntax("chk_ipaddress", null, "D001", "D013", "D013", 1, 1, FALSE),
				"fn_net_last_date"	=>	new RegAppChkSyntax("chk_date_for_db", null, "", "", "", 1, 1, FALSE, "D401"),
			);
			break;
		case "ops0207":			// ֵ
			// ֵѤϥͥåȥɥ쥹ǽʣ(ʣå)
			$func_ex = array(
				"fn_net_ip_address"	=>	new RegAppChkSyntax("chk_ipaddress", null, "D001", "D013", "D013", 1, 10, TRUE, "D040"),
				"fn_net_last_date"	=>	new RegAppChkSyntax("chk_date_for_db", null, "", "", "", 1, 10, TRUE, "", FALSE),
			);
			break;
		default:
			$this->m_kind_id	= "";
			$this->m_chk_funcs	= "";
			return;
		}

		// ĤˤޤȤ
		$this->m_chk_funcs = array_merge($func_normal, $func_ex);
	}

	/**
	 * ؿ̾create_conf_obj
	 *   ͥåȥѤRegAppDispConf[] 
	 * @param  create_fn_keys	string[]		key		(i)
	 * @return  RegAppDispConf[]
	 */
	function create_conf_obj($create_fn_keys)
	{
		$ret_conf = array();
		foreach ($this->m_conf_default as $key => $value)
		{
			if (in_array($key, $create_fn_keys))
			{
				$ret_conf[$key] = $value;
			}
		}
		return $ret_conf;
	}

	/**
	 * ؿ̾get_form_example
	 *   եϲ̤ι
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ
	 * @return form name => ʸ Ϣ
	 */
	function get_form_example($for_html=TRUE)
	{
		require("config/RegCnfFormInfo.php");		// եե
		$var_example = array(
			"fn_net_ip_address"	=>	$cnf_form_example["ip_network_number"],
			"fn_net_name"		=>	$cnf_form_example["net_name"],

			"fn_net_orgjp"		=>	$cnf_form_example["organization_jp"],
			"fn_net_orgen"		=>	$cnf_form_example["organization_en"],
			"fn_net_mail"		=>	$cnf_form_example["mail_address"],
			"fn_net_postal"		=>	$cnf_form_example["postal_code_number"],
			"fn_net_addjp"		=>	$cnf_form_example["address_jp"],
			"fn_net_adden"		=>	$cnf_form_example["address_en"],
			"fn_net_tec_handle"	=>	$cnf_form_example["handle_full"],
			"fn_net_delete"		=>	$cnf_form_example["delete_reason"],
			"fn_net_reason"		=>	$cnf_form_example["change_reason"],
		);

		// htmlspecialchars
		if ($for_html)
			$var_example = RegAppFormUtil::conv_array_value_html($var_example);

		return $var_example;
	}

	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_net_list
	 *   IPNETꥹȤ
	 * @param  mem_num					ȿֹ			(i)
	 * @param  error_str	string[]	顼ɳǼ	(i/o)
	 * @return int	IPɥ쥹array("43.0.0.0/16", "43.1.0.0/16", "43.2.0.0/16"...)
	 *              ERR_APPOP_DB_ACCESS		DB顼
	 *              ERR_APPOP_NET_SEARCH	ͥåȥĤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_net_list($mem_num, &$error_str)
	{
		$sql_str  = "SELECT ip.ip_network_number FROM mdb_meminfo mem, mdb_ipnetinfo ip";
		$sql_str .= " WHERE mem.member_number = " . $mem_num;
		$sql_str .= " AND (mem.member_number =";
		$sql_str .= " (SELECT cidr.member_number FROM cidr_block cidr WHERE ip.cidr_block = cidr.ip_network_number))";
		$sql_str .= " ORDER BY ip.start_sequence_number";

		$db_result = $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			array_push($error_str, "D201");		// Ǥʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			array_push($error_str, "D204");		// ͥåȥʤ顼
			return ERR_APPOP_NET_SEARCH;		// ¸ߤʤ error
		}

		$ret_list = array();
		for ($n = 0; $n < count($db_result); $n++)
		{
			$ret_list[$n] = $db_result[$n]["ip_network_number"];
		}

		return $ret_list;
	}

	/**
	 * ؿ̾get_net_info
	 *   ͥåȥconf_obj  m_disp_var ˳Ǽ
	 * @param  mem_num							ȿֹ				(i)
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹		(i/o)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @param  input_flg	boolean				ϲ̡HIDDEN̥ե饰	(i)
	 * @return int	1
	 *              ERR_APPOP_DB_ACCESS		DB顼
	 *              ERR_APPOP_NET_SEARCH	ͥåȥĤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         IPɥ쥹(conf_obj["fn_net_ip_address"]->m_disp_var)б
	 *         롣
	 *         input_flg TRUE κݡ顼ɡD204(٥դ)
	 *         input_flg FALSEκݡ顼ɡD201D100
	 */
	function get_net_info($mem_num, &$conf_obj, &$error_str, $input_flg)
	{
		$fn_array	= array_keys($conf_obj);				// conf_objΥ
		$fn_array = $this->create_get_net_fnkeys($fn_array);

		// 륫̾ɲ
		$cols = array();
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			array_push($cols, $this->net_util->fn_col_tbl[$fn_array[$fn_cnt]]);
		}

		// DBIPNETʤϾΤߤʤΤǥåʤ
		$reg_db_net	= new DBAPI_IPNET($this->reg_db);
		$net_tbl	= $reg_db_net->get_ipnet_info_ip_and_mem_num(
									$conf_obj["fn_net_ip_address"]->m_disp_var,
									$mem_num,
									$cols);
		if ($net_tbl === NULL)					// 0
		{
			if ($input_flg)
			{
				// ϿƤʤ顼
				array_push($error_str, array($conf_obj["fn_net_ip_address"]->m_label_str, "D204"));
			}
			else
			{
				array_push($error_str, "D201");		// Ǥʤ顼
				array_push($error_str, "D100");		// Ƥ륨顼
			}
			return ERR_APPOP_NET_SEARCH;			// ¸ߤʤ error
		}
		if ($net_tbl === FALSE)						// 
		{
			array_push($error_str, "D201");			// Ǥʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//   conf_obj ˳Ǽ
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			$conf_obj[$fn_array[$fn_cnt]]->set_disp_var($net_tbl[0]->{$this->net_util->fn_col_tbl[$fn_array[$fn_cnt]]});
		}

		return 1;
	}

	//-----------------------------------------------------------------------
	// public methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_net_in_syntax
	 *   POSTǡΥͥåȥ(form input)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         顼ܤ conf_obj  m_error_flg ΩƤ
	 */
	function chk_net_in_syntax(&$conf_obj, $chk_fn_keys, &$error_str)
	{
		$chk_result = TRUE;

		// syntax checkؿƤӽФ
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $chk_fn_keys))
			{
				// input checkƤӽФ
				if (RegAppFormUtil::call_chk_function($conf_obj[$key], $this->m_chk_funcs[$key], $error_str) == FALSE)
				{
					$chk_result = FALSE;
				}
			}
		}

		//-------------------------------------------------------------------
		// IPɥ쥹ɲåå
		//-------------------------------------------------------------------
		// ɥ쥹åоݤǡġ¾Υ顼ˤʤäƤʤ
		if (in_array("fn_net_ip_address", $chk_fn_keys) && $conf_obj["fn_net_ip_address"]->m_error_flg == FALSE)
		{
			//----- ץ饤١ȥɥ쥹å -----//
			if (is_array($conf_obj["fn_net_ip_address"]->m_disp_var))
			{
				foreach ($conf_obj["fn_net_ip_address"]->m_disp_var as $key => $value)
				{
					if (RegIpv6AddressUtil::chk_user_illegal_block($value) === 1)
					{
						// DBϿʤIPv6֥å($conf_user_illegal_block)
						// ϻǤʤ
						array_push($error_str, array($conf_obj["fn_net_ip_address"]->m_disp_var[$key], "D052"));
						$chk_result = FALSE;
					}elseif (RegIpv6AddressUtil::chk_not_user_global_block($value) === 1)
					{
						// 桼ѤǤʤХ륢ɥ쥹֥å
						// ($conf_not_user_global_block)ϻǤʤ
						array_push($error_str, array($conf_obj["fn_net_ip_address"]->m_disp_var[$key], "D053"));
						$chk_result = FALSE;
					}
				}
			}
			else
			{
				if (RegIpv6AddressUtil::chk_user_illegal_block($conf_obj["fn_net_ip_address"]->m_disp_var) === 1)
				{
					// DBϿʤIPv6֥å($conf_user_illegal_block)
					// ϻǤʤ
					array_push($error_str, array($conf_obj["fn_net_ip_address"]->m_disp_var, "D052"));
					$chk_result = FALSE;
				}elseif (RegIpv6AddressUtil::chk_not_user_global_block($conf_obj["fn_net_ip_address"]->m_disp_var) === 1)
				{
					// 桼ѤǤʤХ륢ɥ쥹֥å
					// ($conf_not_user_global_block)ϻǤʤ
					array_push($error_str, array($conf_obj["fn_net_ip_address"]->m_disp_var, "D053"));
					$chk_result = FALSE;
				}
			}

			//----- ֵѤξϽʣå -----//
			if ($chk_result && (strcmp($this->m_kind_id, "ops0207") == 0))
			{
				//----- ʣϤƤϽʣåԤ -----//
				if (count($conf_obj["fn_net_ip_address"]->m_disp_var) >= 2)
				{
					if (RegIpv6AddressUtil::chk_ipblock_array_overlap($conf_obj["fn_net_ip_address"]->m_disp_var))
					{
						// ʣƤ뤿ᡢ顼
						RegAppFormUtil::set_err_data($conf_obj["fn_net_ip_address"],
													 $error_str,
													 $this->m_chk_funcs["fn_net_ip_address"]->m_err_ex);
						$chk_result = FALSE;
					}
				}
			}


		}

		return $chk_result;
	}

	/**
	 * ؿ̾chk_net_hidden_syntax
	 *   POSTǡȿ(hidden)Υ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  chk_fn_keys	string[]			󥿥åԤkey		(i)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   棱ĤǤ⥨顼ˤʤäϸ³Υ󥿥åϹԤʤ
	 */
	function chk_net_hidden_syntax(&$conf_obj, $chk_fn_keys)
	{
		// syntax checkؿƤӽФ
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $chk_fn_keys))
			{
				// hidden checkƤӽФ
				if (RegAppFormUtil::call_chk_function($conf_obj[$key], $this->m_chk_funcs[$key], ($err=array()), TRUE) == FALSE)
				{
					return FALSE;
				}
			}
		}

		// ɥ쥹åоݤξ
		if (in_array("fn_net_ip_address", $chk_fn_keys))
		{
			//----- ֵѤξϽʣå -----//
			if (strcmp($this->m_kind_id, "ops0207") == 0)
			{
				//----- ʣϤƤϽʣåԤ -----//
				if (count($conf_obj["fn_net_ip_address"]->m_disp_var) >= 2)
				{
					if (RegIpv6AddressUtil::chk_ipblock_array_overlap($conf_obj["fn_net_ip_address"]->m_disp_var))
					{
						return FALSE;		// ʣƤ뤿ᥨ顼
					}
				}
			}

		}

		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(ޥƥå)
	//-----------------------------------------------------------------------

	/**
	 * ؿ̾chk_net_ipaddress_semantics
	 *   POSTǡ ΥޥƥåԤ
	 *         꿶֥å۲ˤ뤫¸ͥåȥ/ƿĤȽʣƤʤå롣
	 * @param  mem_num		integer				ȿֹ							(i)
	 * @param  conf_obj		RegAppDispConf		ɥ쥹(["fn_net_ip_address"])		(i)
	 * @param  add_info		RegNetAddressInfo	ͽIPɥ쥹		(i/o)
	 *	åIPɥ쥹б꿶֥å $m_cidr_block ˥åȤ뢨
	 * @param  error_str	string[]		顼ɳǼ							(i/o)
	 * @param  hidden_chk	boolean			hiddenǡåե饰						(i)
	 * @param  apply_no		integer			ֹʻϽƿĤΥåоݤ
	 * @return 1åOK
	 *         ERR_APPOP_FATAL				fatal顼
	 *         ERR_APPOP_DB_ACCESS			DB顼
	 *         ERR_APPOP_NET_UNDER_CIDR		꿶֥å۲ˤʤ
	 *         ERR_APPOP_NET_STATUS			NETWORKȽʣƤ
	 *         ERR_APPOP_NET_APP_STATUS		ƿĿȽʣƤ
	 * @desc   hidden_chk	TRUE ξ硢add_infoʣΥ顼Ǹ³åߤ
	 *                      FALSEξ硢add_infoʣΥ顼Ǥ³å³
	 */
	function chk_net_ipaddress_semantics($mem_num, &$conf_obj, &$add_info, &$error_str, $hidden_chk=FALSE, $apply_no="")
	{
		//-------------------------------------------------------------------
		// $add_infoζå
		//-------------------------------------------------------------------
		if (is_array($add_info))
		{
			if (count($add_info) == 0 || !is_array($conf_obj->m_disp_var) || count($conf_obj->m_disp_var) != count($add_info))
			{
				RegAppFormUtil::set_err_data($conf_obj, $error_str, "D000", FALSE);
				$conf_obj->m_error_flg = TRUE;
				return ERR_APPOP_FATAL;
			}
		}
		else if ($add_info == "")
		{
			RegAppFormUtil::set_err_data($conf_obj, $error_str, "D000", FALSE);
			$conf_obj->m_error_flg = TRUE;
			return ERR_APPOP_FATAL;
		}

		//-------------------------------------------------------------------
		// ȿ˳꿶줿꿶֥å۲ˤ뤫å
		// Ʊˡ꿶֥å ip_network_number 
		//-------------------------------------------------------------------
		$result = $this->chk_net_semantics_incidr($mem_num,
												  $conf_obj,
												  $add_info,
												  $error_str,
												  $hidden_chk);
		if ($result != 1)
		{
			return $result;
		}

		//-------------------------------------------------------------------
		// ƺѥͥåȥȽʣƤʤå
		// 꿶֥å۲ˡʣͥåȥʤå
		//-------------------------------------------------------------------
		$result = $this->chk_net_semantics_network($conf_obj,
												   $add_info,
												   $error_str,
												   $hidden_chk);
		if ($result != 1)
		{
			return $result;
		}

		return 1;
	}

	//-----------------------------------------------------------------------
	// public methods(DPN_CONTENT)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_get_net_fnkeys
	 *   RegAppDispConf[] Υ󤫤 GET_IPNETINFO ɬפΤʤͤ򥫥åȤ
	 * @param  fn_keys		string[]		RegAppDispConfΥ		(i)
	 * @return string		fn_keys  "fn_mem_op_short" "fn_net_ip_address" "fn_net_reason" "fn_net_delete"
	 *                      
	 */
	function create_get_net_fnkeys($fn_array)
	{
		// ȿάΤϳɬפʤ
		$fn_array	= array_filter($fn_array, "delete_not_get_net_callback");
		$tmp_cnt	= 0;
		$ret_array	= array();
		foreach ($fn_array as $value)
		{
			if ($value != "")
			{
				$ret_array[$tmp_cnt] = $value;
				$tmp_cnt++;
			}
		}
		return $ret_array;
	}

	//-----------------------------------------------------------------------
	// private methods(ޥƥå)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_net_semantics_incidr
	 *   ɥ쥹ȿ۲γ꿶֥åˤ뤫ݤå
	 * @param  mem_num		integer			ȿֹ										(i)
	 * @param  conf_obj		RegAppDispConf	ɥ쥹(["fn_net_ip_address"])					(i)
	 * @param  add_info		RegNetAddressInfo	ͽIPɥ쥹				(i/o)
	 *	åIPɥ쥹б꿶֥å $m_cidr_block ˥åȤ뢨
	 * @param  error_str	string[]		顼ɳǼ							(i/o)
	 * @param  hidden_chk	boolean			hiddenǡåե饰						(i)
	 * @return 1åOK
	 *         ERR_APPOP_DB_ACCESS			DB顼
	 *         ERR_APPOP_NET_UNDER_CIDR		꿶֥å۲ˤʤ
	 * @desc   add_info ꤹ硢conf_obj->m_disp_var ƱǤʤ
	 *         ʤʤǥåƱطȤ뤳ȡ
	 * @desc   hidden_chk	TRUE ξ硢add_infoʣΥ顼Ǹ³åߤ
	 *                      FALSEξ硢add_infoʣΥ顼Ǥ³å³
	 */
	function chk_net_semantics_incidr($mem_num, &$conf_obj, &$add_info, &$error_str, $hidden_chk=FALSE)
	{
		$sql_str = "SELECT ip_network_number FROM cidr_block WHERE member_number = " . $mem_num;

		//----- ķϤʣΥɥ쥹Ͽ׵ -----//
		if (is_array($add_info))
		{
			$chk_result = TRUE;
			// ķϤǤʣɥ쥹ϿΤǡģĳƤ
			foreach ($add_info as $key => $value)
			{
				$sub_str = " AND start_sequence_number <= " . GetApsString($value->m_start_num) .
						   " AND " . GetApsString($value->m_end_num) . " <= end_sequence_number";
				$db_result = $this->reg_db->dbapi_query($sql_str . $sub_str);
				if ($db_result === FALSE)					// 顼
				{
					// DB顼¨λ
					RegAppFormUtil::set_err_data($conf_obj, $error_str, "D000", FALSE);
					$conf_obj->m_error_flg = TRUE;
					return ERR_APPOP_DB_ACCESS;
				}
				if ($db_result === NULL)					// 0
				{
					// ֥ɥ쥹 => 꿶ˤʤפ򥨥顼ʸɲ
					array_push($error_str, array($conf_obj->m_disp_var[$key], "D409"));
					$conf_obj->m_error_flg = TRUE;

					if ($hidden_chk)
						return ERR_APPOP_NET_UNDER_CIDR;	// hiddenå¨λ
					else
						$chk_result = FALSE;				// in check ϺǸޤǷ³
				}
				else
				{
					// ɳĤȤƳ꿶֥åǼ
					$add_info[$key]->m_cidr_block = $db_result[0]["ip_network_number"];
				}
			}
			if ($chk_result == FALSE)
			{
				// input checkǥ顼ȯƤϤǽλ
				return ERR_APPOP_NET_UNDER_CIDR;
			}
		}
		//----- ưϤñΥɥ쥹Ͽ׵ -----//
		else
		{
			$sql_str .= " AND start_sequence_number <= " . GetApsString($add_info->m_start_num) .
						" AND " . GetApsString($add_info->m_end_num) . " <= end_sequence_number";
			$db_result = $this->reg_db->dbapi_query($sql_str);
			if ($db_result === FALSE)					// 顼
			{
				RegAppFormUtil::set_err_data($conf_obj, $error_str, "D000", FALSE);
				$conf_obj->m_error_flg = TRUE;
				return ERR_APPOP_DB_ACCESS;
			}
			if ($db_result === NULL)					// 0
			{
				// ֥ɥ쥹 => 꿶ˤʤפ򥨥顼ʸɲ
				array_push($error_str, array($conf_obj->m_disp_var, "D409"));
				$conf_obj->m_error_flg = TRUE;
				return ERR_APPOP_NET_UNDER_CIDR;
			}
			$add_info->m_cidr_block = $db_result[0]["ip_network_number"];
		}

		return 1;
	}

	/**
	 * ؿ̾chk_net_semantics_network
	 *   ɥ쥹󤬳꿶֥å۲NETWORKȽʣƤʤå
	 *         add_info->m_cidr_block ۲ˡadd_info->m_start_numadd_info->m_end_num 
	 *         ɥ쥹ȽʣΤʤȽꡣ
	 * @param  conf_obj		RegAppDispConf	ɥ쥹(["fn_net_ip_address"])					(i)
	 * @param  add_info		RegNetAddressInfo	ͽIPɥ쥹				(i/o)
	 * @param  error_str	string[]		顼ɳǼ							(i/o)
	 * @param  hidden_chk	boolean			hiddenǡåե饰						(i)
	 * @return 1åOK
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_NET_STATUS		NETWORKȽʣƤ
	 * @desc   add_info ꤹ硢conf_obj->m_disp_var ƱǤʤ
	 *         ʤʤǥåƱطȤ뤳ȡ
	 * @desc   hidden_chk	TRUE ξ硢add_infoʣΥ顼Ǹ³åߤ
	 *                      FALSEξ硢add_infoʣΥ顼Ǥ³å³
	 */
	function chk_net_semantics_network(&$conf_obj, &$add_info, &$error_str, $hidden_chk=FALSE)
	{
		$sql_str = "SELECT count(*) FROM mdb_ipnetinfo WHERE";

		//----- ķϤʣΥɥ쥹Ͽ׵ -----//
		if (is_array($add_info))
		{
			if ($hidden_chk)		// hidden check ξϰå
			{
				foreach ($add_info as $key => $value)
				{
					$sql_str .= $this->create_chk_overlap_selstr($value->m_start_num,
																 $value->m_end_num,
																 $value->m_cidr_block);
					$sql_str .= " OR";
				}
				$sql_str = substr($sql_str, 0, -3);			//  " OR" 
				$db_result = $this->reg_db->dbapi_query_count($sql_str);
				if ($db_result === FALSE)					// 顼
				{
					// DB顼¨λ
					RegAppFormUtil::set_err_data($conf_obj, $error_str, "D000", FALSE);
					$conf_obj->m_error_flg = TRUE;
					return ERR_APPOP_DB_ACCESS;
				}
				if ($db_result > 0)							// ʣƤ
				{
					// ϿѶ֤ȽʣƤפ򥨥顼ʸɲ
					array_push($error_str, "D410");
					$conf_obj->m_error_flg = TRUE;
					return ERR_APPOP_NET_STATUS;			// ϿƤ
				}
			}
			else					// input check ξϸ̤˥å
			{
				$chk_result = TRUE;
				foreach ($add_info as $key => $value)
				{
					$sub_str	= $this->create_chk_overlap_selstr($value->m_start_num,
																   $value->m_end_num,
																   $value->m_cidr_block);

					$db_result	= $this->reg_db->dbapi_query_count($sql_str . $sub_str);
					if ($db_result === FALSE)			// 顼
					{
						// DB顼¨λ
						RegAppFormUtil::set_err_data($conf_obj, $error_str, "D000", FALSE);
						$conf_obj->m_error_flg = TRUE;
						return ERR_APPOP_DB_ACCESS;
					}
					if ($db_result > 0)					// ʣƤ
					{
						// ֥ɥ쥹 => ϿѶ֤ȽʣƤפ򥨥顼ʸɲ
						array_push($error_str, array($conf_obj->m_disp_var[$key], "D410"));
						$conf_obj->m_error_flg = TRUE;
						$chk_result = FALSE;
					}
				}
				if ($chk_result == FALSE)
				{
					// input checkǥ顼ȯƤϤǽλ
					return ERR_APPOP_NET_STATUS;		// ϿƤ
				}
			}
		}
		//----- ưϤñΥɥ쥹Ͽ׵ -----//
		else
		{
			$sql_str .= $this->create_chk_overlap_selstr($add_info->m_start_num,
														 $add_info->m_end_num,
														 $add_info->m_cidr_block);
			$db_result = $this->reg_db->dbapi_query_count($sql_str);
			if ($db_result === FALSE)			// 顼
			{
				RegAppFormUtil::set_err_data($conf_obj, $error_str, "D000", FALSE);
				$conf_obj->m_error_flg = TRUE;
				return ERR_APPOP_DB_ACCESS;
			}
			if ($db_result > 0)							// ʣƤ
			{
				// ֥ɥ쥹 => ϿѶ֤ȽʣƤפ򥨥顼ʸɲ
				array_push($error_str, array($conf_obj->m_disp_var, "D410"));
				$conf_obj->m_error_flg = TRUE;
				return ERR_APPOP_NET_STATUS;			// ϿƤ
			}
		}

		return 1;
	}

	/**
	 * ؿ̾create_chk_overlap_selstr
	 *   ɥ쥹󤬳꿶֥å۲NETWORKȽʣƤʤå
	 *         WHERE
	 * @param  start		ͥåȥɥ쥹 start_sequence_number
	 * @param  end			ͥåȥɥ쥹 end_sequence_number
	 * @param  cidr_add		оݤCIDR BLOCK
	 * @return WHERE
	 */
	function create_chk_overlap_selstr($start, $end, $cidr_add)
	{
		$sel_str  = " (cidr_block = " . GetApsString($cidr_add) . " AND";
		$sel_str .= " ((start_sequence_number <= " . GetApsString($start);
		$sel_str .= " AND " . GetApsString($start) . "<= end_sequence_number)";
		$sel_str .= " OR (start_sequence_number <= " . GetApsString($end);
		$sel_str .= " AND " . GetApsString($end) . "<= end_sequence_number)";
		$sel_str .= " OR (" . GetApsString($start) . "< start_sequence_number";
		$sel_str .= " AND end_sequence_number < " . GetApsString($end) . ")))";

		return $sel_str;
	}
}

/**
 * ؿ̾delete_not_get_net_callback
 *   RegAppDispConf[] Υ GET_IPNETINFO ɬפΤʤͤ򥫥åȤ
 * @param  value				(i)
 * @return TRUE "fn_mem_op_short" "fn_net_ip_address" "fn_net_reason" "fn_net_delete"ʳ
 *         FALSE"fn_mem_op_short" "fn_net_ip_address" "fn_net_reason" "fn_net_delete"
 */
function delete_not_get_net_callback($value)
{
	switch ($value)
	{
	case "fn_mem_op_short":
	case "fn_net_ip_address":
	case "fn_net_reason":
	case "fn_net_delete":
		return FALSE;
	default:
		break;
	}
	return TRUE;
}
?>
