<?php
/**
 * $Id: RegAppFormOp.php,v 1.9 2004/02/27 10:04:15 yoshi_s Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("DBAPIWrapper.php");			// DB API IMPLE
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPI_APPLY.php");			// DBAPI_APPLY DBAPI
require_once("DBAPI_DPN.php");				// DPN_CONTENT DBAPI
require_once("RegAppDateUtil.php");			// մϢ楯饹
require_once("RegAppApplyDBUtil.php");		// ϢDB桼ƥƥ饹
require_once("RegIpv6AddressUtil.php");		// IP AddressϢ桼ƥƥ饹

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormOp
{
	//------------------------------------------------------------------------
	// TAKE,UnTAKE
	//------------------------------------------------------------------------
	/**
	 * ؿ̾take_app_form
	 *   ķϿTAKE
	 *         SDB_APPLY_INFO, DPN_CONTENT 򹹿롣
	 * @param  reg_db			DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @param  apply_util		RegAppApplyDBUtil	applyϢDB桼ƥƥ		(i)
	 * @param  appif_obj		RegAppDispConf[]	̾󥯥饹Ϣ()	(i)
	 * @param  allow_stt		string[]			Ĥ륹ơ	(i)
	 * @param  allow_mem_stt	string[]			Ĥȿơ(i)
	 * @param  clerk_id			string				̳ôID					(i)
	 * @param  error_str		string[]			顼ɳǼ			(i/o)
	 * @return RegAppCreateAppAccϿ
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			񥹥ơ顼
	 *         ERR_APPOP_CHANGE			ѹ
	 *         ERR_APPOP_MEM_STATUS		TAKEĤ륹ơˤʤäƤʤȿ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         Ƽ»ȿϿǤϡallow_mem_stt  "" ꤹ뤳
	 */
	function take_app_form($reg_db, $apply_util, $appif_obj, $allow_stt, $allow_mem_stt, $clerk_id, &$error_str)
	{
		$reg_db_apply	= new DBAPI_APPLY($reg_db);			// DBAPI_APPLY object
		$reg_db_dpn		= new DBAPI_DPN($reg_db);			// DBAPI_DPN object

		// DB APIѤ RCV-XXXXXXXX Ѵ
		$app_no = sprintf("RCV-%08d", $appif_obj["fn_app_acceptid"]->m_disp_var);

		// 
		$app_date = RegAppDateUtil::make_current_date_db();
		//-------------------------------------------------------------------
		// SDB_APPLY_INFO Ͽǡ
		//-------------------------------------------------------------------
		if ($allow_mem_stt == "")
		{
			// åѤΣӣѣ̡ʳƼ»ȿϿǤ mdb_meminfo status åס
			$lock_str  = "SELECT status, final_reply FROM sdb_apply_info" .
						" WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
						" AND apply_kind_id = " . GetApsString($appif_obj["fn_app_kindid"]->m_disp_var) .
						" FOR UPDATE";
		}
		else
		{
			// åѤΣӣѣ(SDB_APPLY_INFO,MDB_MEMINFO)
			$lock_str = "SELECT mem.status as mem_stt," .
						" app.status, app.final_reply" .
						" FROM sdb_apply_info app, mdb_meminfo mem" .
						" WHERE mem.member_number = app.member_number" .
						" AND app.accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
						" AND app.apply_kind_id = " . GetApsString($appif_obj["fn_app_kindid"]->m_disp_var) .
						" AND mem.member_number = " . $appif_obj["fn_app_memnum"]->m_disp_var .
						" FOR UPDATE";
		}

		// SDB_APPLY_INFO򹹿륫̾apply_util ̾ǥäƤΤǡľܻ...
		$app_cols = array("clerk_id", "status", "final_reply");

		// SDB_APPLY_INFO Ͽǡ
		$sdb_appinfo_tbl = new SDB_APPLY_INFO(
							$app_no,	// 祭
							"", $clerk_id, "", "", "considering", "",
							"", "", "", "", $app_date);

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽǡ
		//-------------------------------------------------------------------
		$dpn_content_tbl	= $apply_util->create_dpn_data_take(
										$appif_obj["fn_app_acceptid"]->m_disp_var,
										"V6PC",
										$clerk_id,
										$app_date,
										$appif_obj["fn_app_kindid"]->m_disp_var,
										"");

		//-------------------------------------------------------------------
		// DBϿ
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D307");					// TAKEǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO (MDB_MEMINFO) åơǧ
		//-------------------------------------------------------------------
		$db_result = $reg_db->dbapi_query_lock($lock_str);
		if ($db_result === FALSE)							// 顼
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D307");					// TAKEǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D307");					// TAKEǤʤ顼
			return ERR_APPOP_SEARCH;
		}
		// ơå
		if (in_array($db_result[0]["status"], $allow_stt) == FALSE)
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D416");					// TAKEǤʤ顼
			return ERR_APPOP_STATUS;
		}
		if ($allow_mem_stt != "")
		{
			// ȿơå
			if (in_array($db_result[0]["mem_stt"], $allow_mem_stt) == FALSE)
			{
				$reg_db->REGDB_rollback();
				array_push($error_str, "C111");				// normal,stop Τ߲ĥ顼
				return ERR_APPOP_MEM_STATUS;				// ̳¦ϥ顼̤
			}
		}
		// ǽå
		if (strcmp($db_result[0]["final_reply"], $appif_obj["fn_app_last_date"]->m_disp_var) != 0)
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D401");					// Ƥ륨顼
			return ERR_APPOP_CHANGE;
		}

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO
		//-------------------------------------------------------------------
		$result = $reg_db_apply->save_apply_info($sdb_appinfo_tbl, $app_cols);
		if ($result === FALSE || $result == 0)
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D307");					// TAKEǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽ
		//-------------------------------------------------------------------
		$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
		if ($result === FALSE || $result == 0)
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D307");					// TAKEǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		// ߥå
		$reg_db->REGDB_commit();
		return (new RegAppCreateAppAcc($appif_obj["fn_app_acceptid"]->m_disp_var,
									   $dpn_content_tbl->contents,
									   $dpn_content_tbl->subject));
	}

	/**
	 * ؿ̾untake_app_form
	 *   ķϿUnTAKE
	 *         SDB_APPLY_INFO, DPN_CONTENT 򹹿롣
	 * @param  reg_db			DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @param  apply_util		RegAppApplyDBUtil	applyϢDB桼ƥƥ		(i)
	 * @param  appif_obj		RegAppDispConf[]	̾󥯥饹Ϣ()	(i)
	 * @param  allow_stt		string[]			Ĥ륹ơ	(i)
	 * @param  allow_mem_stt	string[]			Ĥȿơ(i)
	 * @param  clerk_id			string				̳ôID					(i)
	 * @param  clerk_level		string				̳ôǧڥ٥			(i)
	 * @param  error_str		string[]			顼ɳǼ			(i/o)
	 * @return RegAppCreateAppAccϿ
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			񥹥ơ顼
	 *         ERR_APPOP_CHANGE			ѹ
	 *         ERR_APPOP_MEM_STATUS		UnTAKEĤ륹ơˤʤäƤʤȿ
	 *         ERR_APPOP_CLERK_ID		̳ô԰㤤
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         Ƽ»ȿϿǤϡallow_mem_stt  "" ꤹ뤳
	 */
	function untake_app_form($reg_db, $apply_util, $appif_obj, $allow_stt, $allow_mem_stt, $clerk_id, $clerk_level, &$error_str)
	{
		$reg_db_apply	= new DBAPI_APPLY($reg_db);			// DBAPI_APPLY object
		$reg_db_dpn		= new DBAPI_DPN($reg_db);			// DBAPI_DPN object

		// DB APIѤ RCV-XXXXXXXX Ѵ
		$app_no = sprintf("RCV-%08d", $appif_obj["fn_app_acceptid"]->m_disp_var);

		// 
		$app_date = RegAppDateUtil::make_current_date_db();
		//-------------------------------------------------------------------
		// SDB_APPLY_INFO Ͽǡ
		//-------------------------------------------------------------------
		if ($allow_mem_stt == "")
		{
			// åѤΣӣѣ̡ʳƼ»ȿϿǤ mdb_meminfo status åס
			$lock_str  = "SELECT status, final_reply, clerk_id FROM sdb_apply_info" .
						" WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
						" AND apply_kind_id = " . GetApsString($appif_obj["fn_app_kindid"]->m_disp_var) .
						" FOR UPDATE";
		}
		else
		{
			// åѤΣӣѣ(SDB_APPLY_INFO,MDB_MEMINFO)
			$lock_str = "SELECT mem.status as mem_stt," .
						" app.status, app.final_reply, app.clerk_id" .
						" FROM sdb_apply_info app, mdb_meminfo mem" .
						" WHERE mem.member_number = app.member_number" .
						" AND app.accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
						" AND app.apply_kind_id = " . GetApsString($appif_obj["fn_app_kindid"]->m_disp_var) .
						" AND mem.member_number = " . $appif_obj["fn_app_memnum"]->m_disp_var .
						" FOR UPDATE";
		}

		// SDB_APPLY_INFO򹹿륫̾apply_util ̾ǥäƤΤǡľܻ...
		$app_cols = array("clerk_id", "status", "final_reply");

		// SDB_APPLY_INFO Ͽǡ
		$sdb_appinfo_tbl = new SDB_APPLY_INFO(
							$app_no,	// 祭
							"", null, "", "", "received", "",
							"", "", "", "", $app_date);

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽǡ
		//-------------------------------------------------------------------
		$dpn_content_tbl	= $apply_util->create_dpn_data_untake(
										$appif_obj["fn_app_acceptid"]->m_disp_var,
										"V6PC",
										$clerk_id,
										$app_date,
										$appif_obj["fn_app_kindid"]->m_disp_var,
										"");

		//-------------------------------------------------------------------
		// DBϿ
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D308");					// UnTAKEǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO åơǧ
		//-------------------------------------------------------------------
		$db_result = $reg_db->dbapi_query_lock($lock_str);
		if ($db_result === FALSE)							// 顼
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D308");					// UnTAKEǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D308");					// UnTAKEǤʤ顼
			return ERR_APPOP_SEARCH;
		}
		// ơå
		if (in_array($db_result[0]["status"], $allow_stt) == FALSE)
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D418");					// UnTAKEǤʤ顼
			return ERR_APPOP_STATUS;
		}
		if ($allow_mem_stt != "")
		{
			// ȿơå
			if (in_array($db_result[0]["mem_stt"], $allow_mem_stt) == FALSE)
			{
				$reg_db->REGDB_rollback();
				array_push($error_str, "C111");				// normal,stop Τ߲ĥ顼
				return ERR_APPOP_MEM_STATUS;				// ̳¦ϥ顼̤
			}
		}
		// ն̳ôԥåʴ԰ʳ㤦Բġ
		if ((strcmp($db_result[0]["clerk_id"], $clerk_id) != 0) && ($clerk_level != 1))
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D417");					// ô԰㤦顼
			return ERR_APPOP_CLERK_ID;
		}
		// ǽå
		if (strcmp($db_result[0]["final_reply"], $appif_obj["fn_app_last_date"]->m_disp_var) != 0)
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D401");					// Ƥ륨顼
			return ERR_APPOP_CHANGE;
		}

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO
		//-------------------------------------------------------------------
		$result = $reg_db_apply->save_apply_info($sdb_appinfo_tbl, $app_cols);
		if ($result === FALSE || $result == 0)
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D308");					// UnTAKEǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽ
		//-------------------------------------------------------------------
		$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
		if ($result === FALSE || $result == 0)
		{
			$reg_db->REGDB_rollback();
			array_push($error_str, "D308");					// UnTAKEǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		// ߥå
		$reg_db->REGDB_commit();
		return (new RegAppCreateAppAcc($appif_obj["fn_app_acceptid"]->m_disp_var,
									   $dpn_content_tbl->contents,
									   $dpn_content_tbl->subject));
	}

	//------------------------------------------------------------------------
	// REJECT,FIX 桼ƥƥ
	//------------------------------------------------------------------------
	/**
	 * ؿ̾get_opmail_to_addr
	 *   ǧѲΥ᡼ TOɥ쥹
	 * @param  reg_db		DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @param  mem_num							ȿֹ			(i)
	 * @param  to_addr		string[]			Υɥ쥹				(i/o)
	 * @return TRUEԡFALSE
	 * @desc   ȿΥɥ쥹򥻥åȤ롣
	 *         ʣϿܤΤᡢarray() Ȥƥǡ롣
	 *         ϿƤʤϡconfig/RegCnfMail.php 
	 *         $cnf_bcc_mailaddress 򥻥åȤ
	 */
	function get_opmail_to_addr($reg_db, $mem_num, &$to_addr)
	{
		$notice_sql	 = "SELECT notice_address FROM mdb_mem_notice_address" .
					   " WHERE member_number = " . $mem_num .
					   " ORDER BY order_no";
		$notice_result = $reg_db->dbapi_query($notice_sql);
		if ($notice_result === FALSE)				// 顼
		{
			return FALSE;
		}

		if ($notice_result === NULL)				// 裱ʤ
		{
			include("config/RegCnfMail.php");		// ᡼ե
			// BCCTOꤹ
			$to_addr = array($cnf_bcc_mailaddress);
		}
		else
		{
			$to_addr = array();
			foreach ($notice_result as $to_parts)
			{
				array_push($to_addr, $to_parts["notice_address"]);
			}
		}

		return TRUE;
	}

	//------------------------------------------------------------------------
	// 
	//------------------------------------------------------------------------
	/**
	 * ؿ̾get_unallocate_cidr_stt
	 *   ꤵ줿IPɥ쥹֥åΥơ
	 *         Ʊˡե꡼סǧ¸ߥåԤ
	 *         ޤcidr_allocated_block cidr_unallocate_block å
	 * @param  reg_db			DBAPI_IMPLE			DBͥȺѤΥ֥		(i)
	 * @param  cidrif			RegAppDispConf		꿶긵֥å			(i)
	 * @param  cidrstt_obj		RegAppDispConf[]	ɥ쥹֥åơ	(i/o)
	 * @param  error_str		string[]			顼ɾ				(i/o)
	 * @return 1
	 *         ERR_APPOP_FATAL			fatal顼
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_CIDR_SEARCH	꿶ǽ֥å¸ߤʤ
	 * @desc   ơ cidrstt_obj["IPɥ쥹"] ˳Ǽ롣
	 *         顼ȯˤ $error_str ˥顼ɤǼ롣
	 *         ȥ󥶥󳫻ϸ˸ƤӽФԤȡ
	 */
	function get_unallocate_cidr_stt($reg_db, $cidrif, &$cidrstt_obj, &$error_str)
	{
		//--------------------------------------------------------------------
		// WHERE
		//--------------------------------------------------------------------
		$where_str	= "";		// WHERE(ip_network_number)
		$seq_str	= "";		// cidr_allocated_block ۲ CIDR뤫ݤγǧ
		$get_count	= 0;		// 
		if (is_array($cidrif->m_disp_var))
		{
			foreach ($cidrif->m_disp_var as $addr)
			{
				if ($addr != "")
				{
					// Ū˹ʹߤԤᡢϡλֹ
					$ip_if = RegIpv6AddressUtil::get_sequence_num($addr);
					if ($ip_if == FALSE)
						return ERR_APPOP_FATAL;
					$seq_str	.= "(al.start_sequence_number <= " . GetApsString($ip_if[0]) . " AND " .
								   GetApsString($ip_if[1]) . " <= al.end_sequence_number) OR ";

					$where_str	.= GetApsString($addr) . ",";
					$get_count++;
				}
			}
			if ($where_str != "" && $seq_str != "")
			{
				//  "," 
				$where_str	= rtrim($where_str, ",");
				//  " OR " ϢѤ " AND()" Ǥ
				$seq_str	= " AND (" . substr($seq_str, 0, -4) . ")";
			}
		}
		if ($where_str == "" || $seq_str == "")
		{
			return ERR_APPOP_FATAL;
		}

		//--------------------------------------------------------------------
		// å
		//--------------------------------------------------------------------
		$sql_str = "SELECT un.ip_network_number, un.status" .
				   " FROM cidr_unallocate_block un, cidr_allocated_block al" .
				   " WHERE (al.start_sequence_number <= un.start_sequence_number" .
				   " AND un.end_sequence_number <= al.end_sequence_number)" .
				   " AND un.ip_network_number IN(" . $where_str . ")" .
				   $seq_str .
				   " ORDER BY un.status DESC, un.start_sequence_number" .
				   " FOR UPDATE";
		$db_result = $reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			array_push($error_str, "D311");					// ǧǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			// ɥ쥹 => 꿶ǽǤϤʤ Ͽ
			foreach ($cidrif->m_disp_var as $addr)
			{
				if ($addr != "")
					array_push($error_str, array($addr, "C205"));
			}
			return ERR_APPOP_CIDR_SEARCH;
		}

		//--------------------------------------------------------------------
		// ̳Ǽ̥å
		//--------------------------------------------------------------------
		$tmp_addr		= array();
		$cidrstt_obj	= "";
		foreach ($db_result as $value)
		{
			array_push($tmp_addr, $value["ip_network_number"]);
			// array("IPɥ쥹" => RegAppDispConf(), ...) ˥ơǼ
			$fn_key = strtr($value["ip_network_number"], ".", "_");
			$cidrstt_obj[$fn_key] = new RegAppDispConf("", 0, $value["status"]);
		}

		// ץ饤ޥꥭʤΤǡ㤦ϥ顼
		if ($get_count != count($db_result))
		{
			foreach ($cidrif->m_disp_var as $addr)
			{
				// ɥ쥹 => 꿶ǽǤϤʤ Ͽ
				if ($addr != "" && !in_array($addr, $tmp_addr))
				{
					array_push($error_str, array($addr, "C205"));
				}
			}
			return ERR_APPOP_CIDR_SEARCH;
		}

		return 1;
	}
}
?>
