<?php
/**
 * $Id: RegAppFormUtil.php,v 1.3 2004/03/02 07:05:34 wtetsuya Exp $
 * RegAppDispConf ΥǡѤơ󥿥åHTMLԤ桼ƥƥ饹
 */
?>
<?php
require_once("RegAppInputCheck.php");			// ϥåؿ
require_once("RegAppDispConf.php");				// ̾饹
require_once("RegAppExtraConf.php");			// źեե󥯥饹

//---------------------------------------------------------------------------
// RegAppChkSyntax
//---------------------------------------------------------------------------
// 󥿥åѤΥ᥽åԤ饹ʹ¤Ρ
//---------------------------------------------------------------------------
class RegAppChkSyntax
{
	var $m_func_name;
	var $m_param_array;
	var $m_err_zero;
	var $m_err_length;
	var $m_err_pattern;
	var $m_min_num;
	var $m_max_num;
	var $m_multi_flg;
	var $m_err_ex;
	var $m_chk_overlap;

	/**
	 * ؿ̾RegAppChkSyntax
	 *   RegAppChkSyntax󥹥ȥ饯
	 * @param  func_name	string	"ؿ̾"			RegAppInputCheck.php method̾
	 * @param  param_array	string	"array"			ؿƤӽФΰm_disp_var ʳˤʤnull
	 * @param  err_zero		string	"Ϥʤerrcode"	ɬܥ顼Ϥ륨顼
	 * @param  err_length	string	"length errcode"	ʸ顼Ϥ륨顼
	 * @param  err_pattern	string	"errcode"		顼Ϥ륨顼
	 * @param  min_num		string	"ɬܸĿ"			ɬܸĿǾ
	 * @param  max_num		string	"Ŀ"			ϸĿ
	 * @param  multi_flg	boolean	"ʣܥե饰"	ʣϿܤξTRUE(ץ꤬ĤǤDBmultiʤTRUE)
	 * @param  err_ex		string	"¾顼"		ʣͤνʣ顼ʤɤǻ(optional)
	 *													chk_extra_syntax : array[0] ե륵顼˻
	 *																	   array[1] ʣե̾顼˻
	 *																	   array[2] ¸ߤʤޤϣ顼˻
	 *													call_chk_function: ʣܤνʣ顼˻
	 * @param  chk_overlap	boolean	ʣåե饰	ʣͤǽʣåԤݤΥե饰(optional)
	 */
	function RegAppChkSyntax($func_name, $param_array,
							 $err_zero, $err_length, $err_pattern,
							 $min_num, $max_num, $multi_flg,
							 $err_ex="", $chk_overlap=TRUE)
	{
		$this->m_func_name		= $func_name;
		$this->m_param_array	= $param_array;
		$this->m_err_zero		= $err_zero;
		$this->m_err_length		= $err_length;
		$this->m_err_pattern	= $err_pattern;
		$this->m_min_num		= $min_num;
		$this->m_max_num		= $max_num;
		$this->m_multi_flg		= $multi_flg;
		$this->m_err_ex			= $err_ex;
		$this->m_chk_overlap	= $chk_overlap;
	}
}

//---------------------------------------------------------------------------
// RegAppFormUtil
//---------------------------------------------------------------------------
// RegAppDispConf,RegAppExtraConf ΥǡѤơPOSTǡ
// FILESǡ󥿥åHTMLԤ桼ƥƥ饹
//---------------------------------------------------------------------------
class RegAppFormUtil
{
	//-----------------------------------------------------------------------
	// public methods(RegAppDispConf,RegAppExtraConf ǡå/Ѵ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾set_post_vars
	 *   POSTǡ conf_obj->m_disp_var ˥åȤ
	 * @param  conf_obj		RegAppDispConf[]	åоݤRegAppDispConf	(i/o)
	 * @param  set_fn_keys	string[]			åȤԤkey					(i)
	 */
	function set_post_vars(&$conf_obj, $set_fn_keys)
	{
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $set_fn_keys))
			{
				$conf_obj[$key]->set_post_var($key);
			}
		}
	}

	/**
	 * ؿ̾set_extra_infos
	 *   ­ǡ extra_info ˥åȤ
	 * @param  extra_info	RegAppExtraConf[]	åоݤRegAppExtraConf	(i/o)
	 */
	function set_extra_infos(&$extra_info)
	{
		foreach ($extra_info as $key => $value)
		{
			$extra_info[$key]->set_file_info($key);
		}
	}

	/**
	 * ؿ̾conv_dispvars_htmlstr
	 *   ѿ m_disp_var HTMLɽ뤿ѴԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹	(i/o)
	 * @param  conv_fn_keys	string[]			åȤԤkey		(i)
	 */
	function conv_dispvars_htmlstr(&$conf_obj, $conv_fn_keys)
	{
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $conv_fn_keys))
			{
				$conf_obj[$key]->conv_value_htmlstr();
			}
		}
	}

	/**
	 * ؿ̾conv_dispvars_htmltag
	 *   conf_obj->m_disp_var INPUTValueȤɽ뤿ѴԤ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹				(i/o)
	 * @param  conv_fn_keys	string[]		åȤԤkey		(i)
	 */
	function conv_dispvars_htmltag(&$conf_obj, $conv_fn_keys)
	{
		foreach ($conf_obj as $key => $value)
		{
			if (in_array($key, $conv_fn_keys))
			{
				$conf_obj[$key]->conv_value_htmltag();
			}
		}
	}

	/**
	 * ؿ̾set_extra_names_htmlstr
	 *   extra_info->m_disp_var INPUTValueȤɽ뤿ѴԤ
	 * @param  extra_info	RegAppExtraConf[]	­󥯥饹				(i/o)
	 */
	function set_extra_names_htmlstr(&$extra_info)
	{
		foreach ($extra_info as $key => $value)
		{
			$extra_info[$key]->m_file_name = $extra_info[$key]->get_name_htmlstr();
		}
	}

	//-----------------------------------------------------------------------
	// public methods(HTML)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_form_tag
	 *   POSTѤsubmitܥȤ߹form html롣
	 *         RegAppDispConfhiddenä뤳Ȥǽ
	 * @param  form_array	string[]			formnameactionϢ		(i)
	 * @param  btn_array	string[]			submitܥnamevalueϢ	(i)
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹				(i)
	 * @param  disp_array	string[]			ե󥯥饹hiddenϤ	(i)
	 *											Υ̾()
	 * @param  pg_array		string[]			fn_page_nameѤvalue			(i)
	 * @param  enctype_str	boolean				TRUE:file uploadFALSE:normal post	(i)
	 * @return string		submitܥ󥿥
	 * @desc   ѥ᡼Ȥ߹碌ǰʲ롣
	 *         1 <form name="$form_arraykey" method="POST" action="$form_arrayvalue">
	 *         2 <input type="submit" name="$btn_arraykey" value="$btn_arrayvalue">
	 *         3 <input type="hidden" name="$disp_array[$n]" value="$conf_obj[$disp_array[$n]]->m_disp_var">
	 *         4 <input type="hidden" name="fn_page_name" value="$pg_arrayvalue">
	 *         5 </form>
	 *         btn_arrayǤİʾξ硢2򷫤֤
	 *         disp_arrayǤİʾξ硢3򷫤֤
	 *         enctype_str==TRUE ξ硢1 enctype="multipart/form-data" ղä
	 *         htmlspecialcharsΥǡꤹ뤳ȡ
	 */
	function create_form_tag($form_array, $btn_array, $conf_obj, $disp_array, $pg_name="", $enctype_str=FALSE)
	{
		$form_tag = "";
		if (is_array($form_array))
		{
			$fm_data	= each($form_array);
			if ($enctype_str == FALSE)
				$form_tag .= "<form name=\"" . $fm_data[0] . "\" method=\"POST\" action=\"" . $fm_data[1] . "\">\n";
			else
				$form_tag .= "<form name=\"" . $fm_data[0] .
							 "\" enctype=\"multipart/form-data\" method=\"POST\" action=\"" .
							 $fm_data[1] . "\">\n";
		}

		$form_tag .= RegAppFormUtil::create_btn_tag($btn_array, $conf_obj, $disp_array, $pg_name);

		if (is_array($form_array))
		{
			$form_tag .= "</form>\n";
		}
		return $form_tag;
	}

	/**
	 * ؿ̾create_btn_tag
	 *   POSTѤsubmitܥ html롣
	 *         RegAppDispConfhiddenä뤳Ȥǽ
	 * @param  btn_array	string[]			submitܥnamevalueϢ	(i)
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹				(i)
	 * @param  disp_array	string[]			ե󥯥饹hiddenϤ	(i)
	 *											Υ̾()
	 * @param  pg_array		string[]			fn_page_nameѤvalue			(i)
	 * @return string		submitܥ󥿥
	 * @desc   ѥ᡼Ȥ߹碌ǰʲ롣
	 *         1 <input type="submit" name="$btn_arraykey" value="$btn_arrayvalue">
	 *         2 <input type="hidden" name="$disp_array[$n]" value="$conf_obj[$disp_array[$n]]->m_disp_var">
	 *         3 <input type="hidden" name="fn_page_name" value="$pg_arrayvalue">
	 *         btn_arrayǤİʾξ硢1򷫤֤
	 *         disp_arrayǤİʾξ硢2򷫤֤
	 *         htmlspecialcharsΥǡꤹ뤳ȡ
	 */
	function create_btn_tag($btn_array, $conf_obj, $disp_array, $pg_name="")
	{
		$btn_tag = "";
		if (is_array($btn_array))
		{
			foreach ($btn_array as $name => $value)
			{
				$btn_tag .= "<input type=\"submit\" name=\"" . $name . "\" value=\"" . $value . "\">\n";
			}
		}
		$btn_tag .= RegAppFormUtil::create_hidden_tag($conf_obj, $disp_array, $pg_name);
		return $btn_tag;
	}

	/**
	 * ؿ̾create_hidden_tag
	 *   RegAppDispConfPOSTѤhidden html롣
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹				(i)
	 * @param  disp_array	string[]			ե󥯥饹hiddenϤ	(i)
	 *											Υ̾()
	 * @param  pg_array		string[]			fn_page_nameѤvalue			(i)
	 * @return string		submitܥ󥿥
	 * @desc   ѥ᡼Ȥ߹碌ǰʲ롣
	 *         1 <input type="hidden" name="$disp_array[$n]" value="$conf_obj[$disp_array[$n]]->m_disp_var">
	 *         2 <input type="hidden" name="fn_page_name" value="$pg_arrayvalue">
	 *         disp_arrayǤİʾξ硢1򷫤֤
	 *         htmlspecialcharsΥǡꤹ뤳ȡ
	 */
	function create_hidden_tag($conf_obj, $disp_array, $pg_name="")
	{
		$hidden_tag = "";
		if (is_array($disp_array))
		{
			for ($dp_cnt = 0; $dp_cnt < count($disp_array); $dp_cnt++)
			{
				if (is_array($conf_obj[$disp_array[$dp_cnt]]->m_disp_var))
				{
					$var_num = count($conf_obj[$disp_array[$dp_cnt]]->m_disp_var);
					for ($var_cnt = 0; $var_cnt < $var_num; $var_cnt++)
					{
						if ($conf_obj[$disp_array[$dp_cnt]]->m_disp_var[$var_cnt] !== "")
						{
							$hidden_tag .= "<input type=\"hidden\" name=\"" .
										$disp_array[$dp_cnt] . "[]" .
										"\" value=\"" .
										$conf_obj[$disp_array[$dp_cnt]]->m_disp_var[$var_cnt]
										. "\">\n";
						}
					}
				}
				else
				{
					if ($conf_obj[$disp_array[$dp_cnt]]->m_disp_var !== "")
					{
						$hidden_tag .= "<input type=\"hidden\" name=\"" .
									$disp_array[$dp_cnt] .
									"\" value=\"" .
									$conf_obj[$disp_array[$dp_cnt]]->m_disp_var . "\">\n";
					}
				}
			}
		}
		if ($pg_name !== "")
		{
			$hidden_tag .= "<input type=\"hidden\" name=\"fn_page_name\" value=\"" . $pg_name . "\">\n";
		}
		return $hidden_tag;
	}

	/**
	 * ؿ̾create_get_link
	 *   RegAppDispConfGETѤURL LINK(ե̾ޤ)롣
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹				(i)
	 * @param  disp_array	string[]			ե󥯥饹GETϤ		(i)
	 *											Υ̾()
	 * @param  link_file	string				Υץ̾			(i)
	 * @return string		GET LINK
	 * @desc   valueͤؤ urlencode ԤhtmlspecialcharsѤξꤹ뤳ȡ
	 */
	function create_get_link($conf_obj, $disp_array, $link_file)
	{
		$get_str .= RegAppFormUtil::create_get_body($conf_obj, $disp_array);
		if ($get_str === "")
		{
			$get_str = $link_file;						// ե̾Τ
		}
		else
		{
			$get_str = $link_file . "?" . $get_str;		// ? Ƿ
		}
		return $get_str;
	}

	/**
	 * ؿ̾create_get_body
	 *   RegAppDispConfGETѤURL LINK(ե̾Ѥ ? ޤޤ)롣
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹				(i)
	 * @param  disp_array	string[]			ե󥯥饹GETϤ		(i)
	 *											Υ̾()
	 * @return string		GET LINK
	 * @desc   valueͤؤ urlencode ԤhtmlspecialcharsѤξꤹ뤳ȡ
	 */
	function create_get_body($conf_obj, $disp_array)
	{
		$get_str = "";
		if (is_array($disp_array))
		{
			for ($dp_cnt = 0; $dp_cnt < count($disp_array); $dp_cnt++)
			{
				if (is_array($conf_obj[$disp_array[$dp_cnt]]->m_disp_var))
				{
					$var_num = count($conf_obj[$disp_array[$dp_cnt]]->m_disp_var);
					for ($var_cnt = 0; $var_cnt < $var_num; $var_cnt++)
					{
						if ($conf_obj[$disp_array[$dp_cnt]]->m_disp_var[$var_cnt] !== "")
						{
							$get_str .= $disp_array[$dp_cnt] . $var_cnt . "=" .
										urlencode($conf_obj[$disp_array[$dp_cnt]]->m_disp_var[$var_cnt]) .
										"&amp;";
						}
					}
				}
				else
				{
					if ($conf_obj[$disp_array[$dp_cnt]]->m_disp_var !== "")
					{
						$get_str .= $disp_array[$dp_cnt] . "=" .
									$conf_obj[$disp_array[$dp_cnt]]->m_disp_var .
									"&amp;";
					}
				}
			}
		}

		if ($get_str !== "")
		{
			return substr($get_str, 0, -5);		//  &amp; ڤΤ
		}
		return $get_str;
	}

	//-----------------------------------------------------------------------
	// public methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾call_chk_function
	 *   ͤΥ󥿥åԤ
	 * @param  conf_obj		RegAppDispConf	ե󥯥饹					(i/o)
	 * @param  chk_func		RegAppChkSyntax	󥿥å				(i)
	 * @param  error_str	string[]		顼ɳǼ				(i/o)
	 * @param  hidden_chk	boolean			hiddenǡåե饰			(i)
	 * @param  put_errlabel	boolean			顼$error_str˥٥̾	(i)
	 *										ɲä뤫ݤ򼨤ե饰
	 * @return boolean		TRUE:åOKFALSE:åNG
	 * @desc   hidden_chk	TRUE ξ硢顼ɡ顼٥ΥåȤϹԤʤ
	 *                      FALSEξ硢顼ɡ顼٥ΥåȤԤ
	 */
	function call_chk_function(&$conf_obj, $chk_func, &$error_str, $hidden_chk=FALSE, $put_errlabel=TRUE)
	{
		if ($chk_func->m_multi_flg == TRUE)
		{
			return RegAppFormUtil::call_chk_function_array($conf_obj, $chk_func, $error_str, $hidden_chk, $put_errlabel);
		}
		return RegAppFormUtil::call_chk_function_single($conf_obj, $chk_func, $error_str, $hidden_chk, $put_errlabel);
	}

	/**
	 * ؿ̾delete_nodata_col
	 *   ʣϲǽܤǡʤǤ
	 * @param  conf_obj		RegAppDispConf	ե󥯥饹					(i)
	 * @return conf_obj		m_disp_var Υǡ RegAppDispConf
	 */
	function delete_nodata_col($conf_obj)
	{
		if (is_array($conf_obj->m_disp_var))
		{
			$tmp = array_filter($conf_obj->m_disp_var, "delete_nodata_col_callback");
			$cnt = 0;
			$conf_obj->m_disp_var = array();
			foreach ($tmp as $value)
			{
				$conf_obj->m_disp_var[$cnt] = $value;
				$cnt++;
			}
		}
		return $conf_obj;
	}

	/**
	 * ؿ̾chk_extra_syntax
	 *   ­Υ󥿥å(ե̾ե륵å)Ԥ
	 * @param  extra_if		RegAppExtraConf	źեե󥯥饹				(i/o)
	 * @param  chk_func		RegAppChkSyntax	󥿥å				(i)
	 * @param  error_str	string[]		顼ɳǼ				(i/o)
	 * @param  put_errlabel	boolean			顼$error_str˥٥̾	(i)
	 *										ɲä뤫ݤ򼨤ե饰
	 * @return boolean		TRUE:åOKFALSE:åNG
	 */
	function chk_extra_syntax(&$extra_if, $chk_func, &$error_str, $put_errlabel=TRUE)
	{
		if ($chk_func->m_func_name == "")
		{
			return TRUE;			// åؿϿƤʤ
		}

		//-------------------------------------------------------------------
		// ɬܥå
		//-------------------------------------------------------------------
		// RegAppExtraConfǤϡm_file_nameξϿ 0
		$file_name = $extra_if->get_file_name();
		if ($file_name === "")
		{
			if ($extra_if->m_min_num > 0)
			{
				RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_zero, $put_errlabel);
				return FALSE;
			}
			return TRUE;						// ɬܰʳ϶äOK
		}

		//-------------------------------------------------------------------
		// ե륵å
		//-------------------------------------------------------------------
		switch ($extra_if->chk_file_size())
		{
		case 1:			// ե륵ϣ
			break;
		case -1:		// ե륵ʲ
			RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_ex[2], $put_errlabel);
			return FALSE;
		case -2:		// ե륵ͣĶ
			RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_ex[0], $put_errlabel);
			return FALSE;
		}

		//-------------------------------------------------------------------
		// ե̾åʣϿܡ
		//-------------------------------------------------------------------
		if ($chk_func->m_multi_flg == TRUE)
		{
			$data_num = 0;
			$correct_datas = array();
			if (is_array($extra_if->m_file_name))
			{
				foreach ($extra_if->m_file_name as $value)
				{
					if ($value == "")
					{
						continue;
					}
					$data_num++;
					// 
					$tmp_param = $chk_func->m_param_array;
					if (is_array($tmp_param))
					{
						array_unshift($tmp_param, $value);		// ͤƬ˳
					}
					else
					{
						$tmp_param = array($value);				// ͤƬ
					}
					// ե̾å
					switch (call_user_func_array($chk_func->m_func_name, $tmp_param))
					{
					case REG_APP_INPUT_CHK_OK:
						array_push($correct_datas, $value);
						break;
					case REG_APP_INPUT_ERR_STRLEN:
						$chk_result = FALSE;
						RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_length, $put_errlabel);
						return FALSE;
					case REG_APP_INPUT_ERR_PATTERN:
					default:
						RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_pattern, $put_errlabel);
						return FALSE;
					}
				}
			}
			// ǡĿɬܰʾ夢뤫å
			if ($data_num < $chk_func->m_min_num)
			{
				RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_zero, $put_errlabel);
				return FALSE;
			}

			// ʣե̾ǡå
			if ((count($correct_datas) > 1) && (count($correct_datas) >= $chk_func->m_min_num))
			{
				$uniques = array_count_values($correct_datas);
				foreach ($uniques as $value)
				{
					if ($value > 1)
					{
						RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_ex[1], $put_errlabel);
						return FALSE;
					}
				}
			}
		}
		//-------------------------------------------------------------------
		// ե̾åñϿܡ
		//-------------------------------------------------------------------
		else
		{
			// 
			$params = $chk_func->m_param_array;
			if (is_array($params))
				array_unshift($params, $extra_if->m_file_name);		// ͤƬ˳
			else
				$params = array($extra_if->m_file_name);			// ͤƬ

			// 󥿥å¹
			switch (call_user_func_array($chk_func->m_func_name, $params))
			{
			case REG_APP_INPUT_CHK_OK:
				break;
			case REG_APP_INPUT_ERR_STRLEN:
				RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_length, $put_errlabel);
				return FALSE;
			case REG_APP_INPUT_ERR_PATTERN:
			default:
				RegAppFormUtil::set_err_data($extra_if, $error_str, $chk_func->m_err_pattern, $put_errlabel);
				return FALSE;
			}
		}

		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(ǡѴ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾conv_array_value_html
	 *   array  value  HTMLɽ뤿ѴԤ
	 * @param  conv_array		string[]	Ѵʸ				(i)
	 * @param  kana_flg			boolean		TRUE:ȾѥʢѴ¹		(i)
	 * @param  max_len			integer		1ʾξ硢ʸڤͤԤ	(i)
	 * @desc   Ⱦѥʢѥʡm_max_len ʸ˥åȡHTML "" '' ̵Ԥ
	 */
	function conv_array_value_html($conv_array, $kana_flg=TRUE, $max_len=0)
	{
		if (!is_array($conv_array))
		{
			return $conv_array;		// ä鲿⤷ʤ
		}

		foreach ($conv_array as $key => $value)
		{
			if ($kana_flg)
			{
				// Ⱦѥʢѥ
				$conv_array[$key] = mb_convert_kana($conv_array[$key]);
			}
			if ($max_len > 0)
			{
				// MAXʸڤͤ
				$conv_array[$key] = mb_substr($conv_array[$key], 0, $max_len);
			}
			// HTML̵
			$conv_array[$key] = htmlspecialchars($conv_array[$key], ENT_QUOTES);
		}

		return $conv_array;
	}

	//-----------------------------------------------------------------------
	// private methods(󥿥å)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾call_chk_function_single
	 *   ͤΥ󥿥åԤ($conf_obj->m_disp_var ñξ)
	 * @param  conf_obj		RegAppDispConf	ե󥯥饹				(i/o)
	 * @param  chk_func		RegAppChkSyntax	󥿥å			(i)
	 * @param  error_str	string[]		顼ɳǼ				(i/o)
	 * @param  hidden_chk	boolean			hiddenǡåե饰			(i)
	 * @param  put_errlabel	boolean			顼$error_str˥٥̾	(i)
	 *										ɲä뤫ݤ򼨤ե饰
	 * @return boolean		TRUE:åOKFALSE:åNG
	 * @desc   hidden_chk	TRUE ξ硢顼ɡ顼٥ΥåȤϹԤʤ
	 *                      FALSEξ硢顼ɡ顼٥ΥåȤԤ
	 */
	function call_chk_function_single(&$conf_obj, $chk_func, &$error_str, $hidden_chk=FALSE, $put_errlabel=TRUE)
	{
		if ($chk_func->m_func_name == "")
		{
			return TRUE;
		}

		// ɬܤǤʸå
		if ($chk_func->m_min_num == 0 && (!isset($conf_obj->m_disp_var) || $conf_obj->m_disp_var === ""))
		{
			return TRUE;		// ɬܤǤϤʤΤTRUE
		}

		// 
		$params = $chk_func->m_param_array;
		if (is_array($params))
		{
			array_unshift($params, &$conf_obj->m_disp_var);		// ͤƬ˳
		}
		else
		{
			$params = array(&$conf_obj->m_disp_var);			// ͤƬ
		}

		// ɬܥå
		if ($chk_func->m_min_num == 1 && $conf_obj->m_disp_var == "")
		{
			if (!$hidden_chk)
				RegAppFormUtil::set_err_data($conf_obj, $error_str, $chk_func->m_err_zero, $put_errlabel);
			return FALSE;
		}
		else
		{
			// 󥿥å¹
			switch (call_user_func_array($chk_func->m_func_name, $params))
			{
			case REG_APP_INPUT_CHK_OK:
				break;
			case REG_APP_INPUT_ERR_STRLEN:
				if (!$hidden_chk)
					RegAppFormUtil::set_err_data($conf_obj, $error_str, $chk_func->m_err_length, $put_errlabel);
				return FALSE;
			case REG_APP_INPUT_ERR_PATTERN:
			default:
				if (!$hidden_chk)
					RegAppFormUtil::set_err_data($conf_obj, $error_str, $chk_func->m_err_pattern, $put_errlabel);
				return FALSE;
			}
		}
		return TRUE;
	}

	/**
	 * ؿ̾call_chk_function_array
	 *   ͤΥ󥿥åԤ($conf_obj->m_disp_var  array ξ)
	 * @param  conf_obj		RegAppDispConf	ե󥯥饹			(i/o)
	 * @param  chk_func		RegAppChkSyntax	󥿥å			(i)
	 * @param  error_str	string[]		顼ɳǼ				(i/o)
	 * @param  hidden_chk	boolean			hiddenǡåե饰			(i)
	 * @param  put_errlabel	boolean			顼$error_str˥٥̾	(i)
	 *										ɲä뤫ݤ򼨤ե饰
	 * @return boolean		TRUE:åOKFALSE:åNG
	 * @desc   hidden_chk	TRUE ξ硢顼ɡ顼٥ΥåȤϹԤʤ
	 *                      FALSEξ硢顼ɡ顼٥ΥåȤԤ
	 */
	function call_chk_function_array(&$conf_obj, $chk_func, &$error_str, $hidden_chk=FALSE, $put_errlabel=TRUE)
	{
		if ($chk_func->m_func_name == "")
		{
			return TRUE;
		}

		// ʣϿǽ && ɬܹ
		if ($chk_func->m_min_num > 0 && (!is_array($conf_obj->m_disp_var) || (count($conf_obj->m_disp_var) < $chk_func->m_min_num)))
		{
			if (!$hidden_chk)
				RegAppFormUtil::set_err_data($conf_obj, $error_str, $chk_func->m_err_zero, $put_errlabel);
			if (is_array($conf_obj->m_disp_var))
				$conf_obj = $tmp_obj = RegAppFormUtil::delete_nodata_col($conf_obj);
			return FALSE;
		}
		else
		{
			$chk_result = TRUE;
			$data_num = 0;
			$correct_datas = array();
			if (is_array($conf_obj->m_disp_var))
			{
				foreach ($conf_obj->m_disp_var as $key => $value)
				{
					if ($value == "")
					{
						continue;
					}
					$data_num++;

					// 
					$tmp_param = $chk_func->m_param_array;
					if (is_array($tmp_param))
					{
						// ͤƬ˳
						array_unshift($tmp_param, &$conf_obj->m_disp_var[$key]);
					}
					else
					{
						// ͤƬ
						$tmp_param = array(&$conf_obj->m_disp_var[$key]);
					}

					switch (call_user_func_array($chk_func->m_func_name, $tmp_param))
					{
					case REG_APP_INPUT_CHK_OK:
						array_push($correct_datas, $conf_obj->m_disp_var[$key]);
						break;
					case REG_APP_INPUT_ERR_STRLEN:
						if ($hidden_chk)
							return FALSE;
						RegAppFormUtil::set_err_data($conf_obj, $error_str, $chk_func->m_err_length, $put_errlabel);
						$chk_result = FALSE;
						break;
					case REG_APP_INPUT_ERR_PATTERN:
					default:
						if ($hidden_chk)
							return FALSE;
						RegAppFormUtil::set_err_data($conf_obj, $error_str, $chk_func->m_err_pattern, $put_errlabel);
						$chk_result = FALSE;
						break;
					}
				}
				$conf_obj = RegAppFormUtil::delete_nodata_col($conf_obj);
			}
			if ($data_num < $chk_func->m_min_num)
			{
				if (!$hidden_chk)
					RegAppFormUtil::set_err_data($conf_obj, $error_str, $chk_func->m_err_zero, $put_errlabel);
				return FALSE;
			}

			// ʣǡå
			if ((count($correct_datas) > 1) && (count($correct_datas) >= $chk_func->m_min_num) && $chk_func->m_chk_overlap)
			{
				$uniques = array_count_values($correct_datas);
				foreach ($uniques as $value)
				{
					if ($value > 1)
					{
						if (!$hidden_chk)
							RegAppFormUtil::set_err_data($conf_obj, $error_str, $chk_func->m_err_ex, $put_errlabel);
						return FALSE;
					}
				}
			}

			return $chk_result;
		}
	}

	/**
	 * ؿ̾set_err_data
	 *   ͤΥ顼򥻥åȤ
	 * @param  set_obj		RegAppDispConf	ե or Extra󥯥饹			(i/o)
	 *						RegAppExtraConf
	 * @param  error_str	string[]		顼ɳǼ				(i/o)
	 * @param  error_code	string			顼						(i)
	 * @param  put_errlabel	boolean			顼$error_str˥٥̾	(i)
	 *										ɲä뤫ݤ򼨤ե饰
	 * @desc   $set_obj->m_error_flg TRUEꡢ$error_str  $error_codeɲä
	 */
	function set_err_data(&$set_obj, &$error_str, $error_code, $put_errlabel=TRUE)
	{
		$set_obj->m_error_flg = TRUE;
		if (!is_array($error_str))
		{
			return;
		}

		if ($put_errlabel)
		{
			if (is_array($error_code))
			{
				foreach ($error_code as $value)
				{
					array_push($error_str, array($set_obj->m_label_str, $value));
				}
			}
			else
			{
				array_push($error_str, array($set_obj->m_label_str, $error_code));
			}
		}
		else
		{
			if (is_array($error_code))
			{
				foreach ($error_code as $value)
				{
					array_push($error_str, $value);
				}
			}
			else
			{
				array_push($error_str, $error_code);
			}
		}
	}
}

/**
 * ؿ̾delete_nodata_col_callback
 *   delete_nodata_col  callbackؿ
 * @param  value				(i)
 * @return TRUEͤꤵƤ硢FALSEͤnullξ
 */
function delete_nodata_col_callback($value)
{
	if ($value !== "")
		return TRUE;
	return FALSE;
}
?>
