<?php
/* $Id: RegAppSendMail.php,v 1.3 2004/02/23 12:09:33 wtetsuya Exp $ */
/*  */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppMailTemplate.php");			// ᡼ƥץ졼ȥ饹
require_once("RegAppInputCheck.php");			// ϥåؿ

/**
 * ؿ̾RegAppSendMail
 *   ᡼ѥ饹(ƥץ졼ȥ᡼)
 *   ɬ newƻѤ뤳ȡ
 */
class RegAppSendMail
{
	//-----------------------------------------------------------------------
	// private fields
	//-----------------------------------------------------------------------
	var $m_to		= "";
	var $m_subject	= "";
	var $m_body		= "";
	var $m_headers	= "";

	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppSendMail
	 *   RegAppSendMail饹󥹥ȥ饯
	 * @desc   ܥ饹λѤϡɬ new ǺƹԤ
	 */
	function RegAppSendMail()
	{
		$this->m_to		 = "";
		$this->m_subject = "";
		$this->m_body	 = "";
		$this->m_headers = "";
	}

	/**
	 * ؿ̾make_template_mail
	 *   ƥץ졼Ȥ˹ä᡼
	 * @param  template_obj	RegAppMailTemplate ֥				(i)
	 * @return int    10եϥ顼-1֥ȥ顼
	 * @desc   ƥƥץ졼Ȥξꤷ RegAppMailTemplate ưȤ뤳
	 */
	function make_template_mail($template_obj)
	{
		if ($template_obj == NULL)
		{
			return -1;			// ֥Ȼʤ
		}

		include("config/RegCnfCommon.php");		// ̥ƥե

		$pathSep = "/";									// ǥ쥯ȥꥻѥ졼
		$path = $cnf_mail_template_path . $pathSep;		// ƥץ졼DIR
		$tmp_file = $template_obj->m_template_file[$template_obj->m_template_id];
	 	if (!isset($tmp_file) || $tmp_file === "")
		{
			return -1;			// ֥ȥ顼
		}

		//----- ƥץ졼ȥեOPEN -----//
		$tpl_file_name = $path . $tmp_file;				// եѥ
		if (!$tpl_fp = @fopen($tpl_file_name, "rb", 1))
		{
			@fclose($tpl_fp);
			return 0;			// ե륨顼
		}

		//----- إå -----//
		$this->m_headers	= $this->get_mail_header($tpl_fp, $this->m_to, $this->m_subject);
		// إå֥ >> ִ͡
		$this->m_headers	= $this->replace_key_to_value(
											$this->m_headers,
											$template_obj->m_template_common_key);

		// ƥץ졼IDθͭ̾
		$org_key_name	= $template_obj->get_org_key_name();

		//----- To,Subject -----//
		$this->m_to		 = $this->replace_key_to_value(
											$this->m_to,
											$template_obj->$org_key_name);
		$this->m_subject = $this->replace_key_to_value(
											$this->m_subject,
											$template_obj->$org_key_name);

		//----- body -----//
		$this->m_body	= $this->get_mail_body($tpl_fp);
		$this->m_body	= $this->replace_key_to_value(
											$this->m_body,
											$template_obj->$org_key_name);

		@fclose($tpl_fp);
		return 1;			// ｪλ
	}

	/*
	 * ؿ̾send_template_mail
	 *   make_template_mail Ǻ(饹ѿ to,subject,body,headers)ǥ᡼
	 * @return boolean	TRUEFALSE
	 * @desc   to,subjectξʤ᡼꤬ONξΤ߼¹Ԥ롣
	 */
	function send_template_mail()
	{
		if ($this->m_to == "" || $this->m_subject == "")
		{
			return FALSE;
		}
		return $this->send_mail($this->m_to, $this->m_subject, $this->m_body, $this->m_headers);
	}

	/*
	 * ؿ̾send_mail
	 *   ꤵ줿ǥ᡼롣TOʾʤ
	 * @param  send_to			string	᡼륢ɥ쥹(ʣ ", "ڤȤ뤳)	(i)
	 * @param  send_subject		string	ɽ											(i)
	 * @param  send_body		string	ʸ											(i)
	 * @param  send_headers		string	ɲåإå										(i)
	 * @return boolean	TRUEFALSE
	 * @desc   ᡼꤬ONξΤ߼¹Ԥ롣
	 */
	function send_mail($send_to, $send_subject, $send_body, $send_headers)
	{
		// TOɥ쥹å
		$real_to_addr = $this->chk_to_address($send_to);
		if ($real_to_addr == FALSE)
		{
			// ǥХå⡼ɻΤdisplay
			include("config/RegCnfDebug.php");
			if ($cnf_sys_debug_flg)
			{
				$send_to		= htmlspecialchars($send_to, ENT_QUOTES);
				$send_headers	= htmlspecialchars($send_headers, ENT_QUOTES);
				$send_subject	= htmlspecialchars($send_subject, ENT_QUOTES);
				$send_body		= htmlspecialchars($send_body, ENT_QUOTES);
				$g_force_v6pc_debug_item = "TO : ʤᡢǤޤ\n" .
										   "TO : " . $send_to . "<br>\n" .
										   "Header : " . $send_headers . "<br>\n" .
										   "Subject : " . $send_subject . "<br>\n" .
										   "BODY :<br>\n" .
										   $send_body . "<br>\n";
				include("RegForcePrintDebugMsg.php");
			}
			return FALSE;			// To
		}

		// ᡼꤬ONξΤ߼¹Ԥ롣
		include("config/RegCnfMail.php");
		if ($cnf_mail_send_all)
		{
			// ʸɤѴ
			mb_language("ja");
			// 󥳡ѴԤäƥ᡼
			return mb_send_mail($real_to_addr, $send_subject, $send_body, $send_headers);
		}
		else
		{
			// ǥХå⡼ɻΤdisplay
			include("config/RegCnfDebug.php");
			if ($cnf_sys_debug_flg)
			{
				$real_to_addr	= htmlspecialchars($real_to_addr, ENT_QUOTES);
				$send_headers	= htmlspecialchars($send_headers, ENT_QUOTES);
				$send_subject	= htmlspecialchars($send_subject, ENT_QUOTES);
				$send_body		= htmlspecialchars($send_body, ENT_QUOTES);
				$g_force_v6pc_debug_item = "NOT MAIL SEND ALL OPTION ON<br>\n" .
										   "TO : " . $real_to_addr . "<br>\n" .
										   "Header : " . $send_headers . "<br>\n" .
										   "Subject : " . $send_subject . "<br>\n" .
										   "BODY :<br>\n" .
										   $send_body . "<br>\n";
				include("RegForcePrintDebugMsg.php");
			}
		}
		return TRUE;
	}

	/*
	 * ؿ̾chk_to_address
	 *   ꤵ줿 "," ڤΥɥ쥹顢᡼륢ɥ쥹ΤߤѴ
	 * @param  to_address	string	᡼륢ɥ쥹(ʣ ", "ڤȤ뤳)		(i)
	 * @return string,FALSE		ѴTONG(ɥ쥹ʤ)
	 * @desc   ñξ϶ڤʤֵѤ
	 */
	function chk_to_address($to_address)
	{
		$to_addr_array	= explode(",", $to_address);		// , ˳Ǽ
		$comp_addr		= array();							// 異ɥ쥹Ǽ
		if (is_array($to_addr_array))
		{
			// ɥ쥹˥եޥåȥå
			foreach($to_addr_array as $num => $to_addr)
			{
				if (chk_mailaddress(trim($to_addr)))		// in RegAppInputCheck.php
				{
					array_push($comp_addr, trim($to_addr));		// ɥ쥹ɲ
				}
			}
			// 異ɥ쥹ǧ
			if (count($comp_addr) > 1)
			{
				return implode(", ", $comp_addr);		// ʣ", "ڤ
			}
			elseif (count($comp_addr) == 1)
			{
				return $comp_addr[0];					// ñλϤΤޤ
			}
		}
		return FALSE;			// ɥ쥹ʤ
	}

	//-----------------------------------------------------------------------
	// private methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_mail_header
	 *   ᡼ƥץ졼ȥե뤫To,Subject,إåФ
	 * @param  fp						ƥץ졼ȥեݥ	(i)
	 * @param  mail_to		string		To								(i/o)
	 * @param  mail_subject	string		Subject							(i/o)
	 * @return string   إåʸ
	 * @desc   ᡼ƥץ졼ȤβԤΤߤιԤޤǸԤ
	 */
	function get_mail_header($fp, &$mail_to, &$mail_subject)
	{
		$tmp	= "";
		$header	= "";
		while (!feof($fp))
		{
			$tmp = fgets($fp, 4096);			// 1ɤ߹
			$tmp_key = substr($tmp, 0, 8);		// Ƭ8ʸ

			//----- "Date"ξ -----//
			if (strncasecmp($tmp_key, "date:", 5) == 0)
			{
				continue;		// إåɲäʤ
			}
			//----- "To"ξ -----//
			else if (strncasecmp($tmp_key, "to:", 3) == 0)
			{
				$mail_to = trim(substr($tmp, 3));
				continue;		// إåɲäʤ
			}
			//----- "Subject"ξ -----//
			else if (strncasecmp($tmp_key, "Subject:", 8) == 0)
			{
				$mail_subject = trim(substr($tmp, 8));
				continue;		// إåɲäʤ
			}
			else
			{
				//----- ԤΤߤξ -----//
				$tmp_key = trim($tmp);
				if ($tmp_key == "")
				{
					break;		// إåʬλ
				}
				else
				{
					$header .= $tmp;	// إåɲ
				}
			}
		}
		return trim($header);		// ƬΥ֥󥯺
	}

	/**
	 * ؿ̾get_mail_body
	 *   ᡼ƥץ졼ȥե뤫᡼ʸФ
	 * @param  fp						ƥץ졼ȥեݥ	(i)
	 * @return string   bodyʸ
	 */
	function get_mail_body($fp)
	{
		$body = "";

		while (!feof($fp))
		{
			$body .= fgets($fp, 4096);
		}
		return trim($body);
	}

	/**
	 * ؿ̾replace_key_to_value
	 *   ʸ󤫤template_key򸡺ꤵ줿ǡִ
	 * @param  replace_str		string		To						(i)
	 * @param  template			string[]	ִʸϢ		(i)
	 * @return string   ִʸ
	 * @desc    template ˤϡkey  ִʸ ȤΥϥåꤹ뤳
	 */
	function replace_key_to_value($replace_str, $template)
	{
		if (is_array($template))
		{
			foreach ($template as $key => $value)
			{
				$replace_str = ereg_replace($key, $value, $replace_str);
			}
		}
		return $replace_str;
	}
}
?>
