<?php
/**
 * $Id: ins_memls_class.php,v 1.4 2004/02/27 09:05:11 wtetsuya Exp $
 * mdb_meminfo ꥹ(ID&Password)Υ١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("RegAppDateUtil.php");			// վ桼ƥƥ
require_once("DBAPIWrapper.php");			// DB API
require_once("DBAPI_MEMBER.php");			// DB API memberϢ饹
require_once("RegAppFormUtil.php");			// ܥ饹
require_once("RegAppMemDBUtil.php");		// memberϢDB桼ƥƥ
?>

<?php
/**
 * ̾  ins_memls_class
 *   
 */
class ins_memls_class
{
	var $reg_db;				// DBAPI_IMPLE
	var $reg_db_mem;			// DBAPI_MEMBER
	var $mem_util;				// memberϢDB桼ƥƥ

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾ins_memls_class
	 *   ins_memls_class饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function ins_memls_class($db)
	{
		$this->reg_db = $db;
		$this->reg_db_mem	= new DBAPI_MEMBER($this->reg_db);
		$this->mem_util		= new RegAppMemDBUtil();
	}

	//-----------------------------------------------------------------------
	// public methods(select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_mem_list
	 *   ȿ member_short_name,organization_en,status ꥹȤ
	 * @param  error_str	string[]		顼ɳǼ		(i/o)
	 * @param  list_type	string			ꥹȥ(def=fv_normal)	(i)
	 *										("fv_normal"stop or normal"fv_full"allotherall)
	 * @param  limit		int									(i)
	 *										(default="")
	 * @param  offset		int				ϥǥå(0)		(i)
	 *										(default="")
	 * @return MDB_MEMINFO[]	ȿ¤Τ
	 *         FALSE			
	 * @desc   Ǥ MDB_MEMINFO arrayȤʤ롣
	 *         顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_mem_list(&$error_str, $list_type="fv_normal", $limit="", $offset="")
	{
		// DBȿ
		if (strcmp($list_type, "fv_normal") == 0)	// normalstopȿΤ
		{
			$mem_tbl = $this->reg_db_mem->search_member_info(
									"status = 'normal' or status = 'stop'",
									array("member_short_name", "organization_en", "status"),
									$limit, $offset);
		}
		else										// deleteޤƳ
		{
			$mem_tbl = $this->reg_db_mem->get_member_info(
									"*",
									array("member_short_name", "organization_en", "status"),
									$limit, $offset);
		}

		if ($mem_tbl === NULL)							// 0
		{
			if (strcmp($list_type, "fv_normal") == 0)
				array_push($error_str, "C116");			// Ͽʤ顼
			else
				array_push($error_str, "D207");			// Ǥʤ顼
			return FALSE;
		}
		if ($mem_tbl === FALSE)							// 
		{
			array_push($error_str, "D207");				// Ǥʤ顼
			return FALSE;
		}
		return $mem_tbl;
	}

	/**
	 * ؿ̾get_mem_count
	 *   Ŭ礹ȿϿ
	 * @param  error_str	string[]		顼ɳǼ		(i/o)
	 * @param  list_type	string			ꥹȥ(def=fv_normal)	(i)
	 *										("fv_normal"stop or normal"fv_full"allotherall)
	 * @return int			ȿ
	 *         FALSE		
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         Ǥ⥨顼ȤϤʤƤӽФ¦ȽǤ뤳ȡ
	 */
	function get_mem_count(&$error_str, $list_type="fv_normal")
	{
		if (strcmp($list_type, "fv_normal") == 0)	// normalstopȿΤ
		{
			$count = $this->reg_db_mem->count_member_info(
							"status = 'normal' or status = 'stop'");
		}
		else										// deleteޤƳ
		{
			$count = $this->reg_db_mem->count_member_info();
		}

		if ($count === FALSE)
		{
			array_push($error_str, "D207");		// Ǥʤ顼
			return FALSE;
		}
		return $count;
	}

	/**
	 * ؿ̾get_mem_info
	 *   ȿconf_obj  m_disp_var ˳Ǽ
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @param  fn_array		string[]			̾	(i)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return boolean	TRUEFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ȿά(conf_obj["fn_mem_op_short"]->m_disp_var)б
	 *         롣fn_array ˤ conf_obj Υ̾ꤹ뤳ȡ
	 *
	 *         ex)CSI  organization  ơ
	 *         $conf_obj["fn_mem_op_short"]->m_disp_var = "CSI";
	 *         get_mem_info($conf_obj, array("fn_mem_op_orgen", "fn_mem_stt"), $err)
	 *
	 *         ξϥ顼Ȥ롣
	 */
	function get_mem_info(&$conf_obj, $fn_array, &$error_str)
	{
		if (!is_array($fn_array))
		{
			return FALSE;
		}

		$cols = array();
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			array_push($cols, $this->mem_util->fn_col_tbl[$fn_array[$fn_cnt]]);
		}

		// DBȿ
		$mem_tbl = $this->reg_db_mem->get_member_info(
								$conf_obj["fn_mem_op_short"]->m_disp_var,
								$cols);
		if ($mem_tbl === NULL)					// 0
		{
			array_push($error_str, "D207");		// Ǥʤ顼
			return FALSE;
		}
		if ($mem_tbl === FALSE)					// 
		{
			array_push($error_str, "D207");		// Ǥʤ顼
			return FALSE;
		}

		//   conf_obj ˳Ǽ
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			$conf_obj[$fn_array[$fn_cnt]]->set_disp_var($mem_tbl[0]->{$this->mem_util->fn_col_tbl[$fn_array[$fn_cnt]]});
		}

		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(update)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾init_mem_passwd
	 *   ȿΥѥɤ
	 * @param  mem_short	string			ȿά					(i)
	 * @param  lastupdate	date data		ǧ̤ǳǽ(i)
	 * @param  error_str	string[]		顼ɳǼ		(i/o)
	 * @return boolean	string(new password)FALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         lastupdate  ľκǽ󤬰פʤϥ顼Ȥ롣
	 */
	function init_mem_passwd($mem_short, $lastupdate, &$error_str)
	{
		$new_pass	= $this->mem_util->make_mem_password($mem_short);		// HTMLɽ
		$db_pass	= md5($new_pass);							// DBǼ

		// ȥ󥶥󳫻(?)
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "C115");		// Ǥʤ顼
			return FALSE;
		}

		//----- åơåȿֹ,ǽ -----//
		$sql_str  = "SELECT member_number,last_update_date FROM mdb_meminfo WHERE" .
					" member_short_name = " . GetApsString($mem_short) .
					" AND status = 'normal' FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			// ΥѥǤ̾ѤΤ߽ǽ
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C115");					// Ǥʤ顼
			return FALSE;
		}
		if ($db_result === NULL)							// 
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C112");					// normalǤ٤
			return FALSE;
		}
		if (strcmp($lastupdate, $db_result[0]["last_update_date"]) !== 0)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D401");					// Ƥ륨顼
			return FALSE;
		}

		$result = $this->reg_db_mem->save_member_passwd($mem_short, $db_pass);
		if ($result === FALSE || $result != 1)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C115");		// Ǥʤ顼
			return FALSE;
		}

		// ߥå
		$this->reg_db->REGDB_commit();
		return $new_pass;
	}

	/**
	 * ؿ̾chg_mem_status
	 *   ȿΥơѹ
	 * @param  mem_short	string			ȿά					(i)
	 * @param  lastupdate	date data		ǧ̤ǳǽ(i)
	 * @param  chg_status	string			ѹΥơ			(i)
	 * @param  clerk_id		string									(i)
	 * @param  error_str	string[]		顼ɳǼ		(i/o)
	 * @return new_passwd(string)FALSE(===ǥå뤳)
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ߲ξϿѥɤȯԤͤȤ롣
	 */
	function chg_mem_status($mem_short, $lastupdate, $chg_status, $clerk_id, &$error_str)
	{
		if ($clerk_id === null || $mem_short === null || $chg_status === null)
		{
			array_push($error_str, "C114");		// Ǥʤ顼
			return FALSE;
		}
		if ($clerk_id === "" || $mem_short === "" || $chg_status === "")
		{
			array_push($error_str, "C114");		// Ǥʤ顼
			return FALSE;
		}

		//-------------------------------------------------------------------
		// ѹơǧ
		//-------------------------------------------------------------------
		$now_status	= "";				// ߤ٤ơ
		$new_passwd	= "";				// ȯԥѥ
		$db_pass	= "";				// DBǼѥ
		if (strcmp($chg_status, "normal") == 0)
		{
			$now_status = "stop";		// stopʳnormalˤǤʤ
			// stop to normal ξϿȯԤ
			$new_passwd	= $this->mem_util->make_mem_password($mem_short);		// HTMLɽ
			$db_pass	= md5($new_passwd);							// DBǼ
		}
		else if (strcmp($chg_status, "stop") == 0)
		{
			$now_status = "normal";		// normalʳstopˤǤʤ
		}
		else
		{
			array_push($error_str, "C114");		// Ǥʤ顼
			return FALSE;
		}

		$last_date	= RegAppDateUtil::make_current_date_db();	// 
		//-------------------------------------------------------------------
		// DB
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "C114");		// Ǥʤ顼
			return FALSE;
		}

		//----- åơåȿֹ -----//
		$sql_str  = "SELECT member_number, last_update_date FROM mdb_meminfo WHERE" .
					" member_short_name = " . GetApsString($mem_short) . " AND" .
					" status = " . GetApsString($now_status) . 
					" FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C114");					// ơѹ
			return FALSE;
		}
		if ($db_result === NULL)							// 
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			if (strcmp($now_status, "normal") == 0)
				array_push($error_str, "C112");				// normalǤ٤
			else
				array_push($error_str, "C113");				// stopǤ٤
			return FALSE;
		}
		if (strcmp($lastupdate, $db_result[0]["last_update_date"]) !== 0)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D401");					// Ƥ륨顼
			return FALSE;
		}

		$tmp_memnum	= $db_result[0]["member_number"];		// ȿֹǼ

		//----- ȿơѹ -----//
		$sql_str  = "UPDATE mdb_meminfo SET" .
					" status = " . GetApsString($chg_status) . "," .
					" last_update_date = " . GetApsString($last_date) .
					" WHERE member_number = " . $tmp_memnum;
		$db_result = $this->reg_db->dbapi_query_update($sql_str);
		if ($db_result === FALSE || $db_result != 1)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C114");					// Ǥʤ顼
			return FALSE;
		}

		//----- ҥȥɲ -----//
		$sql_str = $this->mem_util->create_insert_str(
						array("member_number", "status", "update_person", "update_date", "accept_id", "operation_id"),
						array($tmp_memnum, $chg_status, $clerk_id, $last_date, "", "ins0301"),
						array(FALSE, TRUE, TRUE, TRUE, TRUE, TRUE));
		$sql_str = "INSERT INTO MDB_MEM_UPDATE_HISTORY" . $sql_str;
		$db_result = $this->reg_db->dbapi_query_insert($sql_str);
		if ($db_result === FALSE || $db_result != 1)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C114");			// Ǥʤ顼
			return FALSE;
		}

		//----- ȿѥԽ -----//
		if (strcmp($now_status, "normal") == 0)
		{
			// normal to stop ξϥꥢ
			$result = $this->reg_db_mem->save_member_passwd($mem_short, null);
			if ($result === FALSE || $result != 1)
			{
				// Хå
				$this->reg_db->REGDB_rollback();
				array_push($error_str, "C114");		// Ǥʤ顼
				return FALSE;
			}
		}
		else
		{
			$result = $this->reg_db_mem->save_member_passwd($mem_short, $db_pass);
			if ($result === FALSE || $result != 1)
			{
				// Хå
				$this->reg_db->REGDB_rollback();
				array_push($error_str, "C114");		// Ǥʤ顼
				return FALSE;
			}
		}

		// ߥå
		$this->reg_db->REGDB_commit();
		return $new_passwd;
	}

	//-----------------------------------------------------------------------
	// public methods(form_syntax)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_memshort_syntax
	 *   ȿάΤʸå
	 * @param  
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 */
	function chk_memshort_syntax($mem_short)
	{
		switch (chk_mem_short($mem_short))
		{
		case REG_APP_INPUT_CHK_OK:				// åOK
			break;
		case REG_APP_INPUT_ERR_STRLEN:			// ʸ顼
		case REG_APP_INPUT_ERR_PATTERN:			// 顼
		default:
			return FALSE;
		}
		return TRUE;
	}

	/**
	 * ؿ̾chk_form_syntax
	 *   POSTǡΥ󥿥åԤ
	 *         ȿά,organization,ǽ ʸåԤ
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 */
	function chk_form_syntax($conf_obj)
	{
		if ($this->chk_memshort_syntax($conf_obj["fn_mem_op_short"]->m_disp_var) == FALSE)
		{
			return FALSE;
		}

		switch (chk_hankaku_length($conf_obj["fn_mem_op_orgen"]->m_disp_var, 1, 256))
		{
		case REG_APP_INPUT_CHK_OK:				// åOK
			break;
		case REG_APP_INPUT_ERR_STRLEN:			// ʸ顼
		case REG_APP_INPUT_ERR_PATTERN:			// 顼
		default:
			return FALSE;
		}

		if (chk_date_for_db($conf_obj["fn_mem_last_date"]->m_disp_var) !== REG_APP_INPUT_CHK_OK)
		{
			return FALSE;
		}

		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾set_paging_data
	 *   ins_0301.php ѤGETѥ᡼RegAppDispConf˥åȤ롣
	 *         POSTǡ򸵤˾(fn_list_typefn_cur_page)Ԥ
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @desc   ins_0301.php ̤ݤɬפȤʤǡ
	 */
	function set_paging_data(&$conf_obj)
	{
		//----- ꥹɽ(normal or full) -----//
		if ((isset($_POST["fn_list_type"])) && (strcmp($_POST["fn_list_type"], "fv_full") == 0))
		{
			$conf_obj["fn_list_type"]->set_post_var("fn_list_type");
		}
		else
		{
			$conf_obj["fn_list_type"]->set_disp_var("fv_normal");
		}

		//----- ߥڡֹ -----//
		if (isset($_POST["fn_cur_page"]))
		{
			$conf_obj["fn_cur_page"]->set_post_var("fn_cur_page");
			if ((ereg("^[0-9]+$", $conf_obj["fn_cur_page"]->m_disp_var) == FALSE) || ($conf_obj["fn_cur_page"]->m_disp_var < 1))
				$conf_obj["fn_cur_page"]->set_disp_var(1);
			else
				$conf_obj["fn_cur_page"]->set_disp_var((int)$conf_obj["fn_cur_page"]->m_disp_var);
		}
		else
		{
			$conf_obj["fn_cur_page"]->set_disp_var(1);
		}

		//----- ڡƥ -----//
		include("config/RegCnfCommon.php");		// ̥ƥե
		if (isset($_POST["fn_item_num"]))
		{
			$conf_obj["fn_item_num"]->set_post_var("fn_item_num");
			if ((ereg("^[0-9]+$", $conf_obj["fn_item_num"]->m_disp_var) == FALSE) || ($conf_obj["fn_item_num"]->m_disp_var < 1))
				$conf_obj["fn_item_num"]->set_disp_var($cnf_mem_idpass_list);
			else
				$conf_obj["fn_item_num"]->set_disp_var((int)$conf_obj["fn_item_num"]->m_disp_var);
		}
		else
		{
			$conf_obj["fn_item_num"]->set_disp_var($cnf_mem_idpass_list);
		}
	}

	/**
	 * ؿ̾create_err_retbtn
	 *   顼ȯ ins_0301chg.php 뤿Υܥ󥿥롣(hiddenդ)
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹		(i)
	 * @param  btn_name		string			ܥname				(i)
	 * @return string ʸ
	 */
	function create_err_retbtn($conf_obj, $btn_name)
	{
		include("RegAppTableStyle.php");
		// button html(顼)
		$btn_tag  = "<table border=\"0\" class=\"";
		$btn_tag .= $table_style . "\">\n";
		$btn_tag .= "<tr>\n";
		$btn_tag .= "<td valign=\"middle\" align=\"center\">\n";
		$btn_tag .= RegAppFormUtil::create_form_tag(
								array("ins_0301chg_ret"	=>	"./ins_0301chg.php"),
								array($btn_name			=>	""),
								$conf_obj,
								array("fn_mem_op_short", "fn_list_type", "fn_cur_page", "fn_item_num"),
								"fv_err_return"
								);
		$btn_tag .= "</td>\n";
		$btn_tag .= "</tr>\n";
		$btn_tag .= "</table>\n";

		return $btn_tag;
	}
}
?>
