<?php
/**
 * $Id: APP_MDB_Select.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
 */

/*
 * ؿ: DBAPI_Query
 * : Ϳ줿SQL쥸ȥDB򸡺Ʒ̤֤
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $sql  SQL
 * @return string  SQL
*/
function DBAPI_Query($con, $sql)
{
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  if($check->is_error)
  {
    return $check;
  }
  $numrows = pg_numrows($result);
  if($numrows > 0)
  {
    $resultArray = array();
    //SQLμ¹Է̤οʲ¹
    for ($i = 0; $i < $numrows; $i++)
    {
      //SQLμ¹Է̤ԥեåƷ̤
      $resultArray[] = pg_fetch_array($result, $i, PGSQL_ASSOC);
    }
  }
  else
  {
    $resultArray = null;
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $resultArray);
}

/**
 * ؿDBAPI_Query_Count
 * Ϳ줿SQL쥸ȥDBcount(*)Ʒ̤֤
 * @param resource $con DBؤΥͥ꥽
 * @param string $sql SQL
 * @return ϿDB_RESULT_INFOԡNULLϿDB_RESULT_INFO
 */
function DBAPI_Query_Count($con, $sql)
{
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)
  {
    return $check;
  }
  //̤֤
  $row = pg_fetch_array($result,0,PGSQL_ASSOC);
  return new DB_RESULT_INFO(false, null, $row[count]);
}

/**
 * ؿDBAPI_Query_Update
 * Ϳ줿SQL쥸ȥDBupdateƷ̤֤
 * @param resource $con DBؤΥͥ꥽
 * @param string $sql SQL
 * @return ϿDB_RESULT_INFOԡNULLϿDB_RESULT_INFO
 */
function DBAPI_Query_Update($con, $sql)
{
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorUpdateSome($con, $result, __FILE__, __LINE__);
  if($check->is_error)
  {
    return $check;
  }
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);
}

/**
 * ؿDBAPI_Query_Insert
 * Ϳ줿SQL쥸ȥDBinsertƷ̤֤
 * @param resource $con DBؤΥͥ꥽
 * @param string $sql SQL
 * @return ϿDB_RESULT_INFOԡNULLϿDB_RESULT_INFO
 */
function DBAPI_Query_Insert($con, $sql)
{
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
  if($check->is_error)
  {
    return $check;
  }
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);
}

/**
 * ؿDBAPI_Query_Delete
 * Ϳ줿SQL쥸ȥDBdeleteƷ̤֤
 * @param resource $con DBؤΥͥ꥽
 * @param string $sql SQL
 * @return ϿDB_RESULT_INFOԡNULLϿDB_RESULT_INFO
 */
function DBAPI_Query_Delete($con, $sql)
{
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorDeleteSome($con, $result, __FILE__, __LINE__);
  if($check->is_error)
  {
    return $check;
  }
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);
}

/**
 * ؿDBAPI_Query_Lock
 * SELECT FOR UPDATEʸLOCK TABLEʸ¹Ԥ
 * @param resource $con DBؤΥͥ꥽
 * @param string $sql SQL
 * @param integer $time åԤ»()
 * @return falseԡnull꡼̤
 */
function DBAPI_Query_Lock($con, $sql, $time)
{
  $result = Reg_sql($con, $sql, $time);
  if(gettype($result) == "object" && $result->db_result_info == LOCK_TIME_OVER)
  {
    return new DB_RESULT_INFO(true, new DB_ERROR_INFO(__FILE__, __LINE__, GetErrorCode(pg_errormessage($con)), pg_errormessage($con)), false);
  }
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  if($check->is_error)
  {
    return $check;
  }
  $numrows = pg_numrows($result);
  if($numrows > 0)
  {
    $resultArray = array();
    //SQLμ¹Է̤οʲ¹
    for ($i = 0; $i < $numrows; $i++)
    {
      //SQLμ¹Է̤ԥեåƷ̤
      $resultArray[] = pg_fetch_array($result, $i, PGSQL_ASSOC);
    }
  }
  else
  {
    $resultArray = null;
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $resultArray);
}

?>
