<?php
//$Id: CANCEL_TOOL.php,v 1.3 2004/02/19 14:15:33 wtetsuya Exp $

require_once("cancel.php");

class CANCEL_TOOL extends DBAPI_BASE
{
	/**
	 * ؿCANCEL_TOOL
	 * 󥹥ȥ饯
	 * @param$dbDBAPI_IMPL
	 * @returnCANCEL_TOOL
	 */
	function CANCEL_TOOL($db="")
	{
		if($db == "")
		{
			$db = DBAPI::connect();
		}
		foreach(get_object_vars($db) as $key => $value)
		{
			$this->$key = $value;
		}
		return $this;
	}
	
	/**
	 * ؿget_inside_app_list
	 * γƼ»ȿNo̤ʿĿ򸡺(SELECT FOR UPDATEϤʤ)
	 * @param$member_numberȿֹ(Ҥи˻Ѥ)
	 * @param$accept_idNo(Ҥи˻Ѥ)
	 * @returnSDB_APPLY_INFO¤
	 */
	function get_inside_app_list($member_number="", $accept_id="")
	{
		if($this->profile_log)
		{
			$this->_pre_func("GetInsideAppList");
		}
		$debugParam = array($member_number, $accept_id);
		$this->_debug_log("GetInsideAppList", $debugParam);
		$this->result = GetInsideAppList($this->con, $member_number, $accept_id);
		$ret = $this->_dbapi_return("GetInsideAppList", $debugParam);
		if($this->profile_log)
		{
			$this->_post_func("GetInsideAppList");
		}
		return $ret;
	}
	
	/**
	 * ؿget_inside_app_list_lock
	 * γƼ»ȿNo̤ʿĿ򸡺(SELECT FOR UPDATE)
	 * @param$member_numberȿֹ(Ҥи˻Ѥ)
	 * @param$accept_idNo(Ҥи˻Ѥ)
	 * @returnSDB_APPLY_INFO¤
	 */
	function get_inside_app_list_lock($member_number="", $accept_id="")
	{
		if($this->profile_log)
		{
			$this->_pre_func("GetInsideAppListLock");
		}
		$debugParam = array($member_number, $accept_id);
		$this->_debug_log("GetInsideAppListLock", $debugParam);
		$this->result = GetInsideAppListLock($this->con, $member_number, $accept_id);
		$ret = $this->_dbapi_return("GetInsideAppListLock", $debugParam);
		if($this->profile_log)
		{
			$this->_post_func("GetInsideAppListLock");
		}
		return $ret;
	}
	
	/**
	 * ؿpackage_reject_app
	 * Ѳ
	 * @param$applyinfoSELECT FOR UPDATEѤߤSDB_APPLY_INFO¤Τ
	 * @param$clerk_idDB˽񤭹ôԤID
	 * @param$dateDB˽񤭹
	 * @param$noteDB˽񤭹NOTE
	 * @returnfalseDB顼ȯƽλ/ॢȤˤå
	 *          -1PERSONSELECT
	 *          -4SDB_APPLY_INFOι
	 */
	function package_reject_app($applyinfo, $clerk_id, $date="", $note="")
	{
		if($this->profile_log)
		{
			$this->_pre_func("PackageRejectApp");
		}
		$debugParam = array($applyinfo, $clerk_id);
		$this->_debug_log("PackageRejectApp", $debugParam);
		$this->result = PackageRejectApp($this->con, $applyinfo, $clerk_id, $date, $note);
		$ret = $this->_dbapi_return("PackageRejectApp", $debugParam);
		if($this->profile_log)
		{
			$this->_post_func("PackageRejectApp");
		}
		return $ret;
	}
	
	/**
	 * ؿreject_app
	 * Ѳ
	 * @param$applyinfoSELECT FOR UPDATEѤߤSDB_APPLY_INFO¤
	 * @param$clerk_idDB˽񤭹ôԤID
	 * @param$dateDB˽񤭹
	 * @param$noteDB˽񤭹NOTE
	 * @returnfalseDB顼ȯƽλ/ॢȤˤå
	 *          -1PERSONSELECT
	 *          -4SDB_APPLY_INFOι
	 */
	function reject_app($applyinfo, $clerk_id, $date="", $note="")
	{
		if($this->profile_log)
		{
			$this->_pre_func("RejectApp");
		}
		$debugParam = array($applyinfo, $clerk_id);
		$this->_debug_log("RejectApp", $debugParam);
		$this->result = RejectApp($this->con, $applyinfo, $clerk_id, $date, $note);
		$ret = $this->_dbapi_return("RejectApp", $debugParam);
		if($this->profile_log)
		{
			$this->_post_func("RejectApp");
		}
		return $ret;
	}
	
	/**
	 * ؿpackage_cancel_app
	 * 겼
	 * @param$applyinfoSELECT FOR UPDATEѤߤSDB_APPLY_INFO¤Τ
	 * @param$settlement_idDB˽񤭹settlement_id(겼MEMοԾŻҥ᡼)
	 * @param$dateDB˽񤭹
	 * @param$noteDB˽񤭹NOTE
	 * @returnfalseDB顼ȯƽλ/ॢȤˤå
	 *          -1PERSONSELECT
	 *          -4SDB_APPLY_INFOι
	 */
	function package_cancel_app($applyinfo, $settlement_id, $date="", $note="")
	{
		if($this->profile_log)
		{
			$this->_pre_func("PackageCancelApp");
		}
		$debugParam = array($applyinfo, $settlement_id);
		$this->_debug_log("PackageCancelApp", $debugParam);
		$this->result = PackageCancelApp($this->con, $applyinfo, $settlement_id, $date, $note);
		$ret = $this->_dbapi_return("PackageCancelApp", $debugParam);
		if($this->profile_log)
		{
			$this->_post_func("PackageCancelApp");
		}
		return $ret;
	}
	
	/**
	 * ؿcancel_app
	 * 겼
	 * @param$applyinfoSELECT FOR UPDATEѤߤSDB_APPLY_INFO¤
	 * @param$settlement_idDB˽񤭹settlement_id(겼MEMοԾŻҥ᡼)
	 * @param$dateDB˽񤭹
	 * @param$noteDB˽񤭹NOTE
	 * @returnfalseDB顼ȯƽλ/ॢȤˤå
	 *          -1PERSONSELECT
	 *          -4SDB_APPLY_INFOι
	 */
	function cancel_app($applyinfo, $settlement_id, $date="", $note="")
	{
		if($this->profile_log)
		{
			$this->_pre_func("CancelApp");
		}
		$debugParam = array($applyinfo, $settlement_id);
		$this->_debug_log("CancelApp", $debugParam);
		$this->result = CancelApp($this->con, $applyinfo, $settlement_id, $date, $note);
		$ret = $this->_dbapi_return("CancelApp", $debugParam);
		if($this->profile_log)
		{
			$this->_post_func("CancelApp");
		}
		return $ret;
	}
}

?>
