<?php
//$Id: DBAPI_DNS.php,v 1.2 2004/02/12 10:59:11 wtetsuya Exp $
require_once("mdb_common.php");
require_once("mdb_dnsinfo.php");

class DBAPI_DNS extends DBAPI_BASE
{
  /**
  * DBAPI_DNS
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_DNS($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * get_dns_info
  * @desc DNS
  * @param CIDR֥å
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_DNSINFO¤(array)
  */
  function get_dns_info($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "name_server")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,member_number,initial_registration_date,last_update_date,note";
      $sub_selcol = "name_server";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetDNSInfo");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("GetDNSInfo", $debugParam);
    $this->result = GetDNSInfo($this->con, $ip_network_number, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("GetDNSInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetDNSInfo");
    }
    return $ret;
  }
  
  /**
  * get_dns_info_member_short_name
  * @desc ȿάΤDNS
  * @param ȿά
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_DNSINFO¤(array)
  */
  function get_dns_info_member_short_name($member_short_name, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "name_server")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,member_number,initial_registration_date,last_update_date,note";
      $sub_selcol = "name_server";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetDNSInfoByMemberShortName");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("GetDNSInfoByMemberShortName", $debugParam);
    $this->result = GetDNSInfoByMemberShortName($this->con, $member_short_name, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("GetDNSInfoByMemberShortName", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetDNSInfoByMemberShortName");
    }
    return $ret;
  }
  
  /**
  * get_dns_info_ip_and_mem_num
  * @desc CIDR֥åȿֹ椫DNS
  * @param CIDR֥å
  * @param ȿֹ
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_DNSINFO¤(array)
  */
  function get_dns_info_ip_and_mem_num($ipnet, $mem_num, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "name_server")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,member_number,initial_registration_date,last_update_date,note";
      $sub_selcol = "name_server";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetDNSInfoByIPAndMemNum");
    }
    $debugParam = array($ipnet, $mem_num);
    $this->_debug_log("GetDNSInfoByIPAndMemNum", $debugParam);
    $this->result = GetDNSInfoByIPAndMemNum($this->con, $ipnet, $mem_num, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("GetDNSInfoByIPAndMemNum", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetDNSInfoByIPAndMemNum");
    }
    return $ret;
  }
  
  /**
  * count_dns_info
  * @desc ˥ޥåMDB_DNSINFOιԿ
  * @param 
  * @return Կ
  */
  function count_dns_info($condition="")
  {
    if($condition != "")
    {
      $condition = "where " . $condition;
    }
    if($this->profile_log)
    {
      $this->_pre_func("CountDNSInfo");
    }
    $debugParam = array($condition);
    $this->_debug_log("CountDNSInfo", $debugParam);
    $this->result = CountDNSInfo($this->con, $condition);
    $ret = $this->_dbapi_return("CountDNSInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CountDNSInfo");
    }
    return $ret;
  }
  
  /**
  * create_dns_info
  * @desc DNS򿷵
  * @param MDB_DNSINFO¤
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function create_dns_info($dnsinfo, $updateinfo)
  {
    if(!is_array($dnsinfo->name_server)){
      $dnsinfo->name_server = array();
    }
    if($this->profile_log)
    {
      $this->_pre_func("CreateDNSInfo");
    }
    $debugParam = array($dnsinfo, $updateinfo);
    $this->_debug_log("CreateDNSInfo", $debugParam);
    $this->result = CreateDNSInfo($this->con, &$dnsinfo, $updateinfo);
    $ret = $this->_dbapi_return("CreateDNSInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateDNSInfo");
    }
    return $ret;
  }
  
  /**
  * save_dns_info
  * @desc DNS򹹿
  * @param MDB_DNSINFO¤
  * @param MDB_UPDATE_INFO¤
  * @param ¸̾(array)
  * @return true/false
  */
  function save_dns_info($dnsinfo, $updateinfo, $column_array="")
  {
    if(!is_array($dnsinfo->name_server)){
      $dnsinfo->name_server = array();
    }
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "name_server")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,member_number,initial_registration_date,last_update_date,note";
      $sub_selcol = "name_server";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveDNSInfo");
    }
    $debugParam = array($dnsinfo, $updateinfo);
    $this->_debug_log("SaveDNSInfo", $debugParam);
    $this->result = SaveDNSInfo($this->con, $dnsinfo, $updateinfo, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("SaveDNSInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveDNSInfo");
    }
    return $ret;
  }
  
  /**
  * delete_dns_info
  * @desc DNS
  * @param CIDR֥å(xxx.xxx.xxx.xxx/xx)
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function delete_dns_info($ip_network_number, $updateinfo)
  {
    if($this->profile_log)
    {
      $this->_pre_func("DeleteDNSInfo");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("DeleteDNSInfo", $debugParam);
    $this->result = DeleteDNSInfo($this->con, $ip_network_number, $updateinfo);
    $ret = $this->_dbapi_return("DeleteDNSInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DeleteDNSInfo");
    }
    return $ret;
  }
  
  /**
  * delete_dns_info_member_short_name
  * @desc ȿάΤȤDNS
  * @param ȿά
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function delete_dns_info_member_short_name($member_short_name, $updateinfo)
  {
    if($this->profile_log)
    {
      $this->_pre_func("DeleteDNSInfoByMemberShortName");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("DeleteDNSInfoByMemberShortName", $debugParam);
    $this->result = DeleteDNSInfoByMemberShortName($this->con, $member_short_name, $updateinfo);
    $ret = $this->_dbapi_return("DeleteDNSInfoByMemberShortName", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DeleteDNSInfoByMemberShortName");
    }
    return $ret;
  }
  
  /**
  * select_dns_info_history
  * @desc DNSι
  * @param CIDR֥å(xxx.xxx.xxx.xxx/xx)
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_UPDATE_INFO¤(array)
  */
  function select_dns_info_history($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      $selcol = implode(",", $column_array);
    }
    else
    {
      $selcol = "ip_network_number,start_sequence_number,end_sequence_number,update_person,update_date,accept_id,operation_id";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectDNSInfoHistory");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectDNSInfoHistory", $debugParam);
    $this->result = SelectDNSInfoHistory($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectDNSInfoHistory", $debugParam);
    if($this->profile_log){
      $this->_post_func("SelectDNSInfoHistory");
    }
    return $ret;
  }
  
  /**
  * select_dns_info_history_update_date
  * @desc DNSιդȤ˼
  * @param 
  * @param λ
  * @return CIDR֥å(array)
  */
  function select_dns_info_history_update_date($start, $end=null)
  {
    if($this->profile_log)
    {
      $this->_pre_func("SelectDNSInfoHistoryByUpdateDate");
    }
    $debugParam = array($start, $end);
    $this->_debug_log("SelectDNSInfoHistoryByUpdateDate", $debugParam);
    $this->result = SelectDNSInfoHistoryByUpdateDate($this->con, $start, $end);
    $ret = $this->_dbapi_return("SelectDNSInfoHistoryByUpdateDate", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectDNSInfoHistoryByUpdateDate");
    }
    return $ret;
  }
}

?>
