<?php
//$Id: DBAPI_OPS0207.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
require_once("sdb_apply_info.php");
require_once("sdb_form_common.php");
require_once("sequence_number.php");
require_once("sdb_form_ops0207.php");

class DBAPI_OPS0207 extends DBAPI_BASE
{
  /**
  * DBAPI_OPS0207
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_OPS0207($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * get_apply_form_ops0207
  * @desc ֵѿ
  * @param No
  * @param ߤǡΥ̾(array)
  * @return SDB_FORM_OPS0207¤
  */
  function get_apply_form_ops0207($accept_id, $column_array="")
  {
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "ip_network_number")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id";
      $sub_selcol = "ip_network_number";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetApplyForm_OPS0207");
    }
    $debugParam = array($accept_id);
    $this->_debug_log("GetApplyForm_OPS0207", $debugParam);
    $this->result = GetApplyForm_OPS0207($this->con, $accept_id, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("GetApplyForm_OPS0207", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetApplyForm_OPS0207");
    }
    return $ret;
  }
  
  /**
  * create_apply_form_ops0207
  * @desc ֵѿ򿷵
  * @param SDB_APPLY_INFO¤
  * @param SDB_FORM_OPS0207¤
  * @return No
  */
  function create_apply_form_ops0207($apply_info, $ops0207)
  {
    if(!is_array($ops0207->ip_network_number)){
      $ops0207->ip_network_number = array();
    }
    if($this->profile_log)
    {
      $this->_pre_func("CreateApplyForm_OPS0207");
    }
    $debugParam = array($apply_info, &$ops0207);
    $this->_debug_log("CreateApplyForm_OPS0207", $debugParam);
    $this->result = CreateApplyForm_OPS0207($this->con, $apply_info, &$ops0207);
    $ret = $this->_dbapi_return("CreateApplyForm_OPS0207", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateApplyForm_OPS0207");
    }
    return $ret;
  }
  
  /**
  * save_apply_form_ops0207
  * @desc ֵѿ򹹿
  * @param SDB_FORM_OPS0207¤
  * @param ¸̾ȥǡ(array)
  * @return ʤ
  */
  function save_apply_form_ops0207($ops0207, $column_array="")
  {
    if(!is_array($ops0207->ip_network_number)){
      $ops0207->ip_network_number = array();
    }
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "ip_network_number")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id";
      $sub_selcol = "ip_network_number";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveApplyForm_OPS0207");
    }
    $debugParam = array($ops0207);
    $this->_debug_log("SaveApplyForm_OPS0207", $debugParam);
    $this->result = SaveApplyForm_OPS0207($this->con, $ops0207, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("SaveApplyForm_OPS0207", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveApplyForm_OPS0207");
    }
    return $ret;
  }
}

?>
