<?php
//$Id: DBAPI_OPS0208.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
require_once("sdb_apply_info.php");
require_once("sdb_form_common.php");
require_once("sequence_number.php");
require_once("sdb_form_ops0208.php");

class DBAPI_OPS0208 extends DBAPI_BASE
{
  /**
  * DBAPI_OPS0208
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_OPS0208($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * get_apply_form_ops0208
  * @desc NWܻѹ
  * @param No
  * @param ߤǡΥ̾(array)
  * @return SDB_FORM_OPS0208¤
  */
  function get_apply_form_ops0208($accept_id, $column_array="")
  {
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "ip_network_number" || $value == "technical_responsibility" || $value == "mail_address")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,network_name,organization_jp,organization_en,postal_code_number,address_jp,address_en,change_reason";
      $sub_selcol = "ip_network_number,technical_responsibility,mail_address";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetApplyForm_OPS0208");
    }
    $debugParam = array($accept_id);
    $this->_debug_log("GetApplyForm_OPS0208", $debugParam);
    $this->result = GetApplyForm_OPS0208($this->con, $accept_id, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("GetApplyForm_OPS0208", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetApplyForm_OPS0208");
    }
    return $ret;
  }
  
  /**
  * create_apply_form_ops0208
  * @desc NWܻѹ򿷵
  * @param SDB_APPLY_INFO¤
  * @param SDB_FORM_OPS0208¤
  * @return No
  */
  function create_apply_form_ops0208($apply_info, $ops0208)
  {
    if(!is_array($ops0208->ip_network_number)){
      $ops0208->ip_network_number = array();
    }
    if(!is_array($ops0208->mail_address)){
      $ops0208->mail_address = array();
    }
    if(!is_array($ops0208->technical_responsibility)){
      $ops0208->technical_responsibility = array();
    }
    if($this->profile_log)
    {
      $this->_pre_func("CreateApplyForm_OPS0208");
    }
    $debugParam = array($apply_info, &$ops0208);
    $this->_debug_log("CreateApplyForm_OPS0208", $debugParam);
    $this->result = CreateApplyForm_OPS0208($this->con, $apply_info, &$ops0208);
    $ret = $this->_dbapi_return("CreateApplyForm_OPS0208", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateApplyForm_OPS0208");
    }
    return $ret;
  }
  
  /**
  * save_apply_form_ops0208
  * @desc NWܻѹ򹹿
  * @param SDB_FORM_OPS0208¤
  * @param ¸̾ȥǡ(array)
  * @return ʤ
  */
  function save_apply_form_ops0208($ops0208, $column_array="")
  {
    if(!is_array($ops0208->ip_network_number)){
      $ops0208->ip_network_number = array();
    }
    if(!is_array($ops0208->mail_address)){
      $ops0208->mail_address = array();
    }
    if(!is_array($ops0208->technical_responsibility)){
      $ops0208->technical_responsibility = array();
    }
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "ip_network_number" || $value == "technical_responsibility" || $value == "mail_address")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,network_name,organization_jp,organization_en,postal_code_number,address_jp,address_en,change_reason";
      $sub_selcol = "ip_network_number,technical_responsibility,mail_address";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveApplyForm_OPS0208");
    }
    $debugParam = array($ops0208);
    $this->_debug_log("SaveApplyForm_OPS0208", $debugParam);
    $this->result = SaveApplyForm_OPS0208($this->con, $ops0208, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("SaveApplyForm_OPS0208", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveApplyForm_OPS0208");
    }
    return $ret;
  }
}

?>
