<?php
//$Id: DBAPI_SEQ.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
require_once("sequence_number.php");
//require_once("reg_lock.php");
//require_once("reg_sql.php");

class DBAPI_SEQ extends DBAPI_BASE
{
	/**
	* DBAPI_SEQ
	* @desc 󥹥ȥ饯
	* @param DBAPI_IMPL֥
	* @return ʤ
	*/
	function DBAPI_SEQ($db="")
	{
		if($db == "")
    	{
      		$db = DBAPI::connect();
    	}
    	foreach(get_object_vars($db) as $key => $value)
    	{
      		$this->$key = $value;
    	}
    	return $this;
	}
	
	/**
	* seq_getcount
	* @desc ʸбֹ
	* @param ʸ
	* @return ֹ
	*/
	function seq_getcount($key)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("SEQ_GetCount");
        }
        $debugParam = array($key);
        $this->_debug_log("SEQ_GetCount", $debugParam);
        $this->result = SEQ_GetCount($this->con, $key);
        $ret = $this->_dbapi_return("SEQ_GetCount", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("SEQ_GetCount");
        }
        return $ret;
	}
	
	/**
	* getcount_seqrcv
	* @desc ֹбȯID
	* @param No
	* @return ȯID
	*/
	function getcount_seqrcv($accept_id)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("GetCount_SEQRCV");
        }
        $debugParam = array($accept_id);
        $this->_debug_log("GetCount_SEQRCV", $debugParam);
        $this->result = GetCount_SEQRCV($this->con, $key);
        $ret = $this->_dbapi_return("GetCount_SEQRCV", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("GetCount_SEQRCV");
        }
        return $ret;
	}
	
	/**
	* seq_inccount
	* @desc ʸбֹ+1ơ֤ͤ
	* @param ʸ
	* @return +1ֹ
	* @descδؿSELECT FOR UPDATEƤǤ롣ΥåॢȤ򵯤Ȥϡ
	* LOCK_TIME_OVER(-5)äƤΤǡɬפ˱Ƥcatch뤳
	*/
    function seq_inccount($key)
	{
        if($this->profile_log)
        {
        	$this->_pre_func("SEQ_IncCount");
        }
        $debugParam = array($key);
        $this->_debug_log("SEQ_IncCount", $debugParam);
        $this->result = SEQ_IncCount($this->con, $key);
        $ret = $this->_dbapi_return("SEQ_IncCount", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("SEQ_IncCount");
        }
        return $ret;
    }
    
	/**
	* inccount_seqrcv
	* @desc NoбȯID򥤥󥯥Ȥ
	* @param No
	* @return ȯID
	* @descδؿSELECT FOR UPDATEƤǤ롣ΥåॢȤ򵯤Ȥϡ
	* LOCK_TIME_OVER(-5)äƤΤǡɬפ˱Ƥcatch뤳
	*/
	function inccount_seqrcv($accept_id)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("IncCount_SEQRCV");
        }
        $debugParam = array($accept_id);
        $this->_debug_log("IncCount_SEQRCV", $debugParam);
        $this->result = IncCount_SEQRCV($this->con, $key);
        $ret = $this->_dbapi_return("IncCount_SEQRCV", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("IncCount_SEQRCV");
        }
        return $ret;
	}
	
	/**
	* seq_setcount
	* @desc ʸбֹ򥻥åȤ
	* @param ʸ
	* @param ֹ
	* @return true/false
	* @descδؿSELECT FOR UPDATEƤǤ롣ΥåॢȤ򵯤Ȥϡ
	* LOCK_TIME_OVER(-5)äƤΤǡɬפ˱Ƥcatch뤳
	*/
	function seq_setcount($key, $value)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("SEQ_SetCount");
        }
        $debugParam = array($key, $value);
        $this->_debug_log("SEQ_SetCount", $debugParam);
        $this->result = SEQ_SetCount($this->con, $key, $value);
        $ret = $this->_dbapi_return("SEQ_SetCount", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("SEQ_SetCount");
        }
        return $ret;
	}
	
	/**
	* setcount_seqrcv
	* @desc NoбȯID򥻥åȤ
	* @param No
	* @param ȯID
	* @return true/false
	* @descδؿSELECT FOR UPDATEƤǤ롣ΥåॢȤ򵯤Ȥϡ
	* LOCK_TIME_OVER(-5)äƤΤǡɬפ˱Ƥcatch뤳
	*/
	function setcount_seqrcv($accept_id, $id)
	{
		if($this->profile_log)
        {
        	$this->_pre_func("SetCount_SEQRCV");
        }
        $debugParam = array($accept_id, $id);
        $this->_debug_log("SetCount_SEQRCV", $debugParam);
        $this->result = SetCount_SEQRCV($this->con, $key, $value);
        $ret = $this->_dbapi_return("SetCount_SEQRCV", $debugParam);
        if($this->profile_log)
        {
        	$this->_post_func("SetCount_SEQRCV");
        }
        return $ret;
	}
}

?>
