<?php
//$Id: sdb_clerk_info.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $

/*
 * ؿ: SelectClerkInfo
 * : ̳ôԾ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $clerk_id  ôID
 * @param  string  $selcol  ߤǡΥ̾
 * @param  string  $ext  ղþ(OFFSETLIMIT)
 * @return SDB_CLERK_INFO[]  ̳ôԾ¤Τ 
*/
function SelectClerkInfo ($con, $clerk_id, $selcol, $ext){
  //SQLʸκ : ɽSDB_CLERK_INFO θ
  if($clerk_id == "*"){
    $sql = "select " . $selcol . " from sdb_clerk_info " . $ext;
  }
  else{
    $sql = "select " . $selcol . " from sdb_clerk_info where clerk_id = ".GetApsString($clerk_id)." ".$ext;
  }
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;  
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $sdb_clerk_info_list = array();
    //SQLμ¹Է̤οʲ¹
    for($pi=0; $pi<$numrows; $pi++){
      //SQLμ¹Է̤ԥեåƷ̤
      $row = pg_fetch_array($result, $pi,PGSQL_ASSOC);
      $sdb_clerk_info_list[] = new SDB_CLERK_INFO($row);
    }
  }
  else{
    $sdb_clerk_info_list = null;
  }
  //̤֤
  return new DB_RESULT_INFO(false, null, $sdb_clerk_info_list);
}

/*
 * ؿ: SearchClerkInfo
 * : ̳ôԾ򸡺
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $condition  
 * @param  string  $selcol  ߤǡΥ̾
 * @param  string  $ext  ղþ(OFFSETLIMIT)
 * @return SDB_CLERK_INFO[]  ̳ôԾ¤Τ 
*/
function SearchClerkInfo($con, $condition, $selcol, $ext){
  //SQLʸκɽSDB_CLERK_INFOθ
  $sql = "select " . $selcol . " from sdb_clerk_info where " . $condition . " " . $ext;
  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;  
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $sdb_clerk_info_list = array();
    //SQLμ¹Է̤οʲ¹
    for($pi=0; $pi<$numrows; $pi++){
      //SQLμ¹Է̤ԥեåƷ̤
      $row = pg_fetch_array($result, $pi,PGSQL_ASSOC);
      $sdb_clerk_info_list[] = new SDB_CLERK_INFO($row);
    }
  }
  else{
    $sdb_clerk_info_list = null;
  }
  //̤֤
  return new DB_RESULT_INFO(false, null, $sdb_clerk_info_list);
}

/*
 * ؿ: GetClerkInfo
 * : ̳ôԾ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $clerk_id  ôID
 * @param  string  $selcol  ߤǡΥ̾
 * @param  string  $ext  ղþ(OFFSETLIMIT)
 * @return SDB_CLERK_INFO  ̳ôԾ
*/
function GetClerkInfo($con, $clerk_id, $selcol, $ext){
  //ؿSelectClerkInfoΥ
  $result = SelectClerkInfo ($con, $clerk_id, $selcol, $ext);
  //ؿͤĴ٤ƥ顼ǤХ顼֤
  if($result->is_error) return $result;
  //줿̤0ǤХ顼֤
  if($result->db_result_info == null)
    return new DB_RESULT_INFO(false, null, null);
  //̤֤
  return new DB_RESULT_INFO(false, null, $result->db_result_info);   
}

/*
 * ؿ: GetClerkPasswd
 * : ̳ôԤΥѥɤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $clerk_id  ôID
 * @return string  ôԥѥ
*/
function GetClerkPasswd($con, $clerk_id){
  //SQLʸκ : ɽSDB_CLERK_INFO  θ
  $sql = "select password from sdb_clerk_info  where clerk_id = ".getApsString($clerk_id);
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:Υ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    //SQLμ¹Է̤ԥեåƷ̤
    $row = pg_fetch_array($result, 0,PGSQL_ASSOC);  
    //̤֤
    return new DB_RESULT_INFO(false, null, $row[password]);   
  }
  else{
    return new DB_RESULT_INFO(false, null, null);
  }
}

/*
 * ؿ CountClerkInfo
 *  ̳ôԤιԿ򸡺
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $condition  
 * @return  integer  Կ
*/
function CountClerkInfo($con, $condition){
  //SQLʸκ : ɽSDB_CLERK_INFO θ
  $sql = "select count(*) from sdb_clerk_info " . $condition;
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error) return $check;
  $row = pg_fetch_array($result,0,PGSQL_ASSOC);
  //̤֤
  return new DB_RESULT_INFO(false, null, $row[count]);
}

/*
 * ؿ: CreateClerkInfo
 * : ̳ôԾϿ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  SDB_CLERK_INFO  $clerk  ̳ôԾ
 * @param  string  $password  ѥ
 * @return boolean  ݤ
*/
function CreateClerkInfo($con, $clerk, $password){
  //SQLʸκ : ɽSDB_CLERK_INFOؤ
  $sql = "INSERT INTO sdb_clerk_info(SELECT ".GetApsString($clerk->clerk_id).",".GetApsString($password).",".GetApsString($clerk->full_name).",".$clerk->auth_level." WHERE 0=(SELECT COUNT(*) FROM sdb_clerk_info WHERE clerk_id = ".GetApsString($clerk->clerk_id)."))";
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorInsertOneorZeroΥ:꡼Υ顼åԤ
  $check = DoCheckDBErrorInsertOneorZero($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);
}

/*
 * ؿ: DeleteClerkInfo
 * : ô̾ǻꤷ̳ôԾ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $clerk_id  ôID
 * @return boolean  ݤ
*/
function DeleteClerkInfo($con, $clerk_id){
  //SQLʸκ : ɽSDB_CLERK_INFOκ
  $sql = "delete from SDB_CLERK_INFO ". " where clerk_id = ".GetApsString($clerk_id);
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorDeleteSomeΥ:꡼ˤΥ顼åԤ
  $check = DoCheckDBErrorDeleteSome($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);
}

/*
 * ؿ: SaveClerkInfo
 * : ̳ôԾ񤭤
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  SDB_CLERK_INFO  $clerk  ̳ôԾ
 * @return boolean  ݤ
*/
function SaveClerkInfo($con, $clerk, $selcol){
  //SQLʸκ : ɽSDB_CLERK_INFOι
  $sql = "update SDB_CLERK_INFO set full_name = ".GetApsString($clerk->full_name). " where clerk_id = ".GetApsString($clerk->clerk_id);
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorUpdateSomeΥ:꡼Υ顼åԤ
  $check = DoCheckDBErrorUpdateSome($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);    

}

/*
 * ؿ: SaveClerkPasswd
 * : ̳ôԤΥѥɤ¸
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $clerk_id  ôID
 * @param  string  $passwd  ѥ
 * @return boolean  ݤ 
*/
function SaveClerkPasswd($con, $clerk_id, $passwd){
  //SQLʸκ : ɽSDB_CLERK_INFOι
  $sql = "update SDB_CLERK_INFO set  password = ".GetApsString($passwd). " where clerk_id = ".GetApsString($clerk_id);
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorUpdateSomeΥ:꡼Υ顼åԤ
  $check = DoCheckDBErrorUpdateSome($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);  
}
?>
