<?php
/**
 * $Id: RegAppApplyListClass.php,v 1.3 2004/02/27 10:04:15 yoshi_s Exp $
 * ()١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("DBAPI_APPLY.php");
?>
<?php
class RegAppApplyListClass
{
	var $reg_db;				// DBAPI_IMPLE
	var $reg_db_apply;			// DBAPI_APPLY

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppApplyListClass
	 *   RegAppApplyListClass饹󥹥ȥ饯
	 */
	function RegAppApplyListClass($db)
	{
		$this->reg_db = $db;
		$this->reg_db_apply = new DBAPI_APPLY($this->reg_db);
	}

	//-----------------------------------------------------------------------
	// private methods(db select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_apply_list
	 *   Ŭ礹뿽
	 * @param  error_str	string[]	顼ɳǼ				(i)
	 * @param  exe_str		string		,Ⱦ(where,order by)		(i)
	 * @param  mem_flg		boolean		mdb_meminfomember_short_name⸡TRUE
	 * @param  limit		int										(i)
	 *									(default="")						(i)
	 * @param  offset		int			ϥǥå(0)				(i)
	 *									(default="")
	 * @return array	¤Τ
	 *         NULL		(ʤ)
	 *         FALSE	
	 * @desc   Ǥ APPLY_LIST_TBL arrayȤʤ롣
	 *         顼ˤ error_str ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_apply_list(&$error_str, $sel_str, $exe_str, $mem_flg, $limit="", $offset="")
	{
		if ($mem_flg)
		{
			// Ƽ»ȿϿmember_number NULL 뤿ᡢLEFT JOINǸ
			$sqlstr = "SELECT " . $sel_str .
					  " FROM sdb_apply_info app LEFT JOIN mdb_meminfo mem ON app.member_number = mem.member_number" .
					  $exe_str;
		}
		else
		{
			$sqlstr = "SELECT " . $sel_str . " FROM sdb_apply_info app" . $exe_str;
		}

		if ($limit != "" && $offset !== "")
		{
			if ($limit < 0 || $offset < 0)
			{
				array_push($error_str, "D300");		// Ǥʤ顼
				return FALSE;
			}
			$sqlstr .= " LIMIT " . $limit . " OFFSET " . $offset;
		}

		$apply_ls_tbl = $this->reg_db->dbapi_query($sqlstr);
		if ($apply_ls_tbl === FALSE)
		{
			array_push($error_str, "D300");		// Ǥʤ顼
			return FALSE;
		}

		return $apply_ls_tbl;		// ξ⥨顼ȤϤʤ
	}

	/**
	 * ؿ̾get_apply_count
	 *   Ŭ礹뿽
	 * @param  error_str	string[]	顼ɳǼ				(i)
	 * @param  exe_str		string		,Ⱦ(where,order by)		(i)
	 * @param  mem_flg		boolean		mdb_meminfomember_short_name⸡TRUE
	 * @return int			(ʤϣ֤)
	 *         FALSE		
	 */
	function get_apply_count(&$error_str, $exe_str, $mem_flg)
	{
		if ($mem_flg)
		{
			// Ƽ»ȿϿmember_number NULL 뤿ᡢLEFT JOINǸ
			$sqlstr = "SELECT count(*) FROM sdb_apply_info app LEFT JOIN mdb_meminfo mem ON app.member_number = mem.member_number" .
					  $exe_str;
		}
		else
		{
			$sqlstr = "SELECT count(*) FROM sdb_apply_info app" . $exe_str;
		}
		$count = $this->reg_db->dbapi_query_count($sqlstr);
		if ($count === FALSE)
		{
			array_push($error_str, "D300");		// Ǥʤ顼
			return FALSE;
		}

		return $count;				// ξ⥨顼ȤϤʤ
	}
}
?>
