<?php
/**
 * $Id: RegAppCidrList.php,v 1.10 2004/03/05 08:13:33 wtetsuya Exp $
 * 꿶֥åѥ١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppPagingUtil.php");
require_once("REGClass.php");				// DBѹ¤Υ饹
require("config/RegCnfCommon.php");			// ̥ƥե
require_once("DBAPIWrapper.php");			// DB API

//------------------------------------------------------------------------
// defines
//------------------------------------------------------------------------
define("CIDRLS_TYPE_MEMBER", 1);			// ȿ¦꿶ɽ(ops0503)
define("CIDRLS_TYPE_CLERK", 2);				// ̳¦꿶ɽ(ins0107)
// for future
define("GET_TYPE_SORT", 0);					// GET󥯺סʥѡ
define("GET_TYPE_INFO", 1);					// GET󥯺סʾѡ
?>

<?php
/**
 * ̾  RegAppCidrList
 *   
 */
class RegAppCidrList
{
	//------------------------------------------------------------------------
	// ѿ
	//------------------------------------------------------------------------
	//--- CIDRꥹȾ ---//
	var $reg_db;						// DBAPI_IMPLE
	var $m_cidr_list_tbl;				// 꿶֥åꥹ
	var $m_list_type;					// ꥹȥ(CIDRLS_TYPE_MEMBER,CIDRLS_TYPE_CLERK)

	//--- HTML ---//
	var $m_pg_link_file;				// ڡ󥰥󥯤ॸ
	var $m_ret_link_file;				// 
	var $m_ret_link_str;				// ʸ
	var $m_err_code_array;				// 顼
	var $m_table_style;					// ơ֥륹

	//--- ڡ,Ѿ ---//
	var $m_all_item;					// ƥ
	var $m_cur_page;					// ߥڡ
	var $m_item_num;					// ڡΥƥ
	var $m_disp_item;					// ɽѤHTML٥̾Ϣ
	var $m_disp_able;					// ɽܼ
	var $m_sort_able;					// ȼ̡ʵĤ륽Ⱦ
	var $m_sort_def;					// ȥǥեȥƥ
	var $m_sort_info;					// ȴ_a or _d դǼ
	var $m_sort_col;					// ȹܤ GET value  DB̾Ϣ
	var $m_paging_link;					// ڡѣȣԣͣ
	var $m_sort_link;					// ѣȣԣͣ
	var	$m_ls_colwidth;					// ꥹȣ
	var	$m_page_util;					// ڡ󥰥桼ƥƥ


	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppCidrList
	 *   RegAppCidrList饹󥹥ȥ饯
	 * @param  $db				DBAPI_IMPLE(connectѤǤ뤳)
	 * @param  $pg_link_file	ڡ󥰲Υ
	 * @param  $link_file		
	 * @param  $link_str		󥯤Σȣԣͣɽʸ
	 * @param  $list_type		ꥹȥ(CIDRLS_TYPE_MEMBER, CIDRLS_TYPE_CLERK)
	 */
	function RegAppCidrList($db, $pg_link_file, $ret_link_file, $ret_link_str, $list_type)
	{
		$this->reg_db = $db;

		$this->m_pg_link_file	= $pg_link_file;
		$this->m_ret_link_file	= $ret_link_file;
		$this->m_ret_link_str	= $ret_link_str;
		include("RegAppTableStyle.php");
		$this->m_table_style	= $table_style;
		$this->m_list_type		= $list_type;
		$this->m_cidr_list_tbl	= array();
		$this->init_cidrls_info();
		$this->m_err_code_array	= array();
	}

	//------------------------------------------------------------------------
	// ɽ
	//------------------------------------------------------------------------
	/**
	 * ؿ̾init_cidrls_info
	 *   ڡ󥰡Ⱦɽ
	 */
	function init_cidrls_info()
	{
		global $cnf_cidr_block_list;

		//-------------------------------------------------------------------
		// ڡ󥰾
		//-------------------------------------------------------------------
		$this->m_all_item		= 0;
		$this->m_cur_page		= 1;
		$this->m_item_num		= $cnf_cidr_block_list;
		$this->m_paging_link	= "";
		$this->m_page_util		= null;

		//-------------------------------------------------------------------
		// Ⱦ
		//-------------------------------------------------------------------
		switch ($this->m_list_type)
		{
		//--- ȿ¦꿶ɽ(ops0503) ---//
		case CIDRLS_TYPE_MEMBER:
			// ɽ̽
			$this->m_disp_able = array(
								"fv_srt_mem",			// ȿά
								"fv_srt_cidr",			// IPͥåȥɥ쥹
								"fv_srt_allocdate",		// 꿶
								);

			// ɽܤHTML٥̾Ϣ
			$this->m_disp_item = array(
						"fv_srt_mem"		=>	"ȿά",
						"fv_srt_cidr"		=>	"ͥåȥɥ쥹",
						"fv_srt_allocdate"	=>	"꿶",
						);

			// ȼ̡ʵĤ륽Ⱦ˽
			$this->m_sort_able = array(
								"fv_srt_cidr",			// IPͥåȥɥ쥹
								"fv_srt_allocdate",		// 꿶
								);

			// ȹ,ɽܤ POST,GET value  DB̾Ϣ
			$this->m_sort_col = array(
						"fv_srt_cidr"		=>	"cidr.start_sequence_number",
						"fv_srt_allocdate"	=>	"cidr.initial_registration_date",
						);

			// ȾΥǥե͡IPͥåȥɥ쥹
			$this->m_sort_def		= "fv_srt_cidr";
			$this->m_sort_info		= $this->m_sort_def . "_a";
			// ȥ
			$this->m_sort_link		= array();

			// ꥹȣ
			$this->m_ls_colwidth	= array(
											"30",			// ȿά
											"45",			// IPͥåȥɥ쥹
											"25",			// 꿶
											);
			break;

		//--- ̳¦꿶ɽ(ins0107) ---//
		case CIDRLS_TYPE_CLERK:
			// ɽ̽
			$this->m_disp_able = array(
								"fv_srt_mem",			// ȿά
								"fv_srt_cidr",			// IPͥåȥɥ쥹
								"fv_srt_allocdate",		// 꿶
								);

			// ɽܤHTML٥̾Ϣ
			$this->m_disp_item = array(
						"fv_srt_mem"		=>	"ȿά",
						"fv_srt_cidr"		=>	"ͥåȥɥ쥹",
						"fv_srt_allocdate"	=>	"꿶",
						);

			// ȼ̡ʵĤ륽Ⱦ˽
			$this->m_sort_able = array(
								"fv_srt_mem",			// ȿά
								"fv_srt_cidr",			// IPͥåȥɥ쥹
								"fv_srt_allocdate",		// 꿶
								);

			// ȹ,ɽܤ POST,GET value  DB̾Ϣ
			$this->m_sort_col = array(
						"fv_srt_mem"		=>	"mem.member_short_name",
						"fv_srt_cidr"		=>	"cidr.start_sequence_number",
						"fv_srt_allocdate"	=>	"cidr.initial_registration_date",
						);

			// ȾΥǥե͡ȿάΡ
			$this->m_sort_def		= "fv_srt_mem";
			$this->m_sort_info		= $this->m_sort_def . "_a";
			// ȥ
			$this->m_sort_link		= array();

			// ꥹȣ
			$this->m_ls_colwidth	= array(
											"30",			// ȿά
											"45",			// IPͥåȥɥ쥹
											"25",			// 꿶
											);
			break;

		//---  ---//
		default:
			$this->m_disp_able	 = array();
			$this->m_disp_item	 = array();
			$this->m_sort_able	 = array();
			$this->m_sort_col	 = array();
			$this->m_sort_def	 = "";
			$this->m_sort_info	 = "";
			$this->m_sort_link	 = array();
			$this->m_ls_colwidth = array();
			break;
		}
	}

	/**
	 * ؿ̾create_cidrls_info()
	 *   ڡ󥰾ȳ꿶֥å롣
	 *         RegAppCidrListHtml.php includeɬܽ
	 * @param  mem_short	string		ȿά(ȿʬ * ˤ)
	 * @return TRUEλFALSE顼
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 *         RegAppCidrListHtml.php include ɬ¹Ԥ뤳ȡ
	 */
	function create_cidrls_info($mem_short)
	{
		//--------------------------------------------------------------------
		// ڡ󥰾,Ⱦ
		//--------------------------------------------------------------------
		$this->set_paging_data();			// paging GETѥ᡼Ͽ
		$this->set_sort_data();				// sort GETѥ᡼Ͽ
		$this->m_all_item = $this->get_cidr_count($mem_short);	// 
		if ($this->m_all_item === FALSE)
		{
			return FALSE;
		}

		// Ⱦɲ
		$getarray["fn_sort"] = $this->m_sort_info;
		// ڡ󥰥桼ƥƥ饹(all item, item per page, cur page)
		$this->m_page_util = new RegAppPagingUtil(
									(int)($this->m_all_item),
									(int)($this->m_item_num),
									(int)($this->m_cur_page));
		// ڡѤΣȣԣͣ
		$this->m_paging_link = $this->m_page_util->create_page_link(
												$this->m_pg_link_file,
												$getarray,
												$this->m_table_style);
		// ѤΣȣԣͣ
		$this->m_sort_link	 = $this->create_sort_link();

		//--------------------------------------------------------------------
		// 꿶֥å
		//--------------------------------------------------------------------
		$this->m_cidr_list_tbl = $this->get_cidr_list(
											$mem_short,
											$this->m_item_num,
											$this->m_page_util->m_start_item - 1);
		if ($this->m_cidr_list_tbl == FALSE)
		{
			return FALSE;
		}

		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(HTML)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾print_title_table
	 *   꿶֥åΤHTMLơ֥Υȥ(<tr></tr>)HTMLϤ
	 */
	function print_title_table()
	{
		$colnum	= count($this->m_disp_able);	// ܿ
		print ("<tr bgcolor=\"#C0CDFD\">\n");
		//----- ܥȥԽ -----//
		for ($n = 0; $n < $colnum; $n++)
		{
			print ("<td class=\"tdlisttitle\" width=\"" . $this->m_ls_colwidth[$n] ."%\">\n");
			if (in_array($this->m_disp_able[$n], $this->m_sort_able))
			{
				print ("<a href=\"" . $this->m_sort_link[$this->m_disp_able[$n]] . "\">");
			}
			print (htmlspecialchars($this->m_disp_item[$this->m_disp_able[$n]]));
			print ("</a>\n");
			print ("</td>\n");
		}
		print ("</tr>\n");
	}

	/**
	 * ؿ̾print_cidrls_table
	 *   꿶֥åΤHTMLơ֥ι(<tr></tr>)HTMLϤ
	 */
	function print_cidrls_table()
	{
		// ǤƤɬ array ˤʤäƤϤ
		if ($this->m_cidr_list_tbl == null || !is_array($this->m_cidr_list_tbl))
		{
			return;
		}

		for ($n = 0; $n < count($this->m_cidr_list_tbl); $n++)
		{
			print ("<tr>\n");
			print ("<td class=\"tdlistitem\">" .
				   htmlspecialchars($this->m_cidr_list_tbl[$n]["member_short_name"]) .
				   "</td>\n");
			print ("<td class=\"tdlistitem\" bgcolor=\"#FFFFFF\">" .
				   htmlspecialchars($this->m_cidr_list_tbl[$n]["ip_network_number"]) .
				   "</td>\n");
			print ("<td class=\"tdlistitem\" bgcolor=\"#FFFFFF\">" .
				   htmlspecialchars($this->m_cidr_list_tbl[$n]["initial_registration_date"]) .
				   "</td>\n");
			print ("</tr>\n");
		}
	}

	//-----------------------------------------------------------------------
	// public methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_err_code_array
	 *   顼롣
	 * @return 顼(RegAppErrorMessage.php )
	 */
	function get_err_code_array()
	{
		return $this->m_err_code_array;
	}

	/**
	 * ؿ̾set_paging_data
	 *   ߥڡֹ(ɽ٤ڡֹ) m_cur_page Ͽ롣
	 *         ڡΥƥ m_item_num Ͽ롣
	 * @desc   GETϤ줿 "fn_cur_page" "fn_item_num" ͤϿ롣
	 *         GETƤʤ 1$cnf_cidr_block_list 򤽤줾Ͽ
	 *         롣
	 */
	function set_paging_data()
	{
		// ߥڡֹ
		if (isset($_GET["fn_cur_page"]))
		{
			$this->m_cur_page = urldecode($_GET["fn_cur_page"]);
			// å(ͤǤʤ1ڡܤˤ)
			if (ereg("^[0-9]+$", $this->m_cur_page) == FALSE || $this->m_cur_page < 1)
				$this->m_cur_page = 1;
			else
				$this->m_cur_page = (int)$this->m_cur_page;
		}
		else									// ˥塼Υ
		{
			$this->m_cur_page = 1;
		}

		// ڡƥ
		global $cnf_cidr_block_list;
		if (isset($_GET["fn_item_num"]))
		{
			$this->m_item_num = urldecode($_GET["fn_item_num"]);
			// å(ͤǤʤconfͤˤ)
			if (ereg("^[0-9]+$", $this->m_item_num) == FALSE || $this->m_item_num < 1)
				$this->m_item_num = $cnf_cidr_block_list;
			else
				$this->m_item_num = (int)$this->m_item_num;
		}
		else
		{
			$this->m_item_num = $cnf_cidr_block_list;
		}
	}

	/**
	 * ؿ̾set_sort_data
	 *   Ⱦ m_sort_info Ͽ롣
	 * @desc   GETϤ줿 "fn_sort"
	 *         GETƤʤ $this->m_sort_def . "_a" Ͽ롣
	 */
	function set_sort_data()
	{
		if (isset($_GET["fn_sort"]))
		{
			$sort_lf = trim($_GET["fn_sort"]);
			if (in_array(substr($sort_lf, 0, -2), $this->m_sort_able) == FALSE)
			{
				$sort_lf = $this->m_sort_def . "_a";	// Ĥʤdefault
			}
		}
		else
		{
			$sort_lf = $this->m_sort_def . "_a";		// Ĥʤdefault
		}
		$this->m_sort_info = $sort_lf;
	}


	//-----------------------------------------------------------------------
	// private methods(db select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_cidr_list
	 *   ȿγ꿶֥å
	 *         MDB_MEMINFO::member_number, CIDR_BLOCK::ip_network_number,
	 *         CIDR_BLOCK::initial_registration_date,
	 *         MDB_MEMINFO::organization_jp, MDB_MEMINFO::mail_address
	 * @param  mem_short	string	ȿά(ȿʬ * ˤ)
	 * @param  limit		int								(i)
	 *								(default="")
	 * @param  offset		int		ϥǥå(0)			(i)
	 *								(default="")
	 * @return CIDR_LIST_TBL[]		꿶֥å¤Τ
	 *         FALSE				
	 * @desc   Ǥ CIDR_LIST_TBL arrayȤʤ롣
	 *         顼ˤ $this->m_err_code_array ˥顼(ʣξ
	 *         礢)Ǽ롣0Ǥ⥨顼Ȥ
	 */
	function get_cidr_list($mem_short, $limit="", $offset="")
	{
		$sqlstr  = "SELECT cidr.member_number, cidr.ip_network_number, cidr.initial_registration_date, mem.member_short_name";
		$sqlstr .= " FROM cidr_block cidr, mdb_meminfo mem";

		//----- ̳ô(ȿns) -----//
		if (strcmp($mem_short, "*") == 0)
		{
			$sqlstr .= " WHERE (cidr.member_number = mem.member_number) AND (mem.status IN('stop', 'normal', 'deleting'))";
		}
		//----- ȿ(ȿʲns) -----//
		else
		{
			$mem_short = GetApsString($mem_short);		// from common/db/common_function.php
			if (strcmp($mem_short, "null") == 0)
			{
				array_push($this->m_err_code_array, "D200");	// Ǥʤ顼
				return FALSE;
			}
			$sqlstr .= " WHERE (mem.member_short_name = " . $mem_short . ")";
			$sqlstr .= " AND mem.status IN('stop', 'normal', 'deleting')";
			$sqlstr .= " AND (cidr.member_number = mem.member_number)";
		}

		// ȶ
		$sqlstr .= $this->create_order_str();

		if ($limit != "" && $offset !== "")
		{
			if ($limit < 0 || $offset < 0)
			{
				array_push($this->m_err_code_array, "D200");		// Ǥʤ顼
				return FALSE;
			}
			$sqlstr .= " LIMIT " . $limit . " OFFSET " . $offset;
		}

		$cidr_ls_tbl = $this->reg_db->dbapi_query($sqlstr);
		if ($cidr_ls_tbl === NULL)			// 0
		{
			array_push($this->m_err_code_array, "D203");		// 0泌顼
			return FALSE;
		}
		if ($cidr_ls_tbl === FALSE)
		{
			array_push($this->m_err_code_array, "D200");		// Ǥʤ顼
			return FALSE;
		}

		return $cidr_ls_tbl;
	}

	/**
	 * ؿ̾get_cidr_count
	 *   ̾ѡߡȿ˳꿶줿꿶֥åϿ
	 * @param  mem_short	string		ȿά(ȿʬ * ˤ)
	 * @return int			꿶֥å
	 *         FALSE		ԡ0Ǥ⥨顼Ȥ
	 */
	function get_cidr_count($mem_short)
	{
		$sqlstr  = "SELECT count(*) FROM cidr_block cidr, mdb_meminfo mem";

		//----- ̳ô(ȿns) -----//
		if (strcmp($mem_short, "*") == 0)
		{
			$sqlstr .= " WHERE (cidr.member_number = mem.member_number) AND (mem.status IN('stop', 'normal', 'deleting'))";
		}
		//----- ȿ(ȿʲns) -----//
		else
		{
			$mem_short = GetApsString($mem_short);		// from common/db/common_function.php
			if (strcmp($mem_short, "null") == 0)
			{
				array_push($this->m_err_code_array, "D200");	// Ǥʤ顼
				return FALSE;
			}
			$sqlstr .= " WHERE (mem.member_short_name = " . $mem_short . ")";
			$sqlstr .= " AND mem.status IN('stop', 'normal', 'deleting')";
			$sqlstr .= " AND (cidr.member_number = mem.member_number)";
		}

		$count = $this->reg_db->dbapi_query_count($sqlstr);
		if ($count === FALSE)
		{
			array_push($this->m_err_code_array, "D200");		// Ǥʤ顼
			return FALSE;
		}
		else if ($count == 0)
		{
			array_push($this->m_err_code_array, "D203");		// 0泌顼
			return FALSE;
		}

		return $count;
	}

	/**
	 * ؿ̾create_order_str
	 *   Ⱦ(ORDER BY)
	 * @return string	ORDER BY(" ORDER BY"ޤ)
	 */
	function create_order_str()
	{
		$order_str = "";
		if ($this->m_sort_info !== "")
		{
			// ȡ/߽ڤʬ
			$sortif = array();
			if (ereg("^(fv_srt_[a-z]+)_([a|d])$", $this->m_sort_info, $sortif))
			{
				array_shift($sortif);	// ꥸʥƬǤ
			}
			else
			{	// 곰ϥǥե
				$sortif[0] = $this->m_sort_def;
				$sortif[1] = "a";
			}

			// 硦߽
			if ($sortif[1] == "d")
				$sortif[2] = " DESC";
			else
				$sortif[2] = "";

			// IPͥåȥɥ쥹ξϥץ饤ޥʤΤ¾
			if (strcmp($sortif[0], "fv_srt_cidr") == 0)
			{
				$order_str = $this->m_sort_col["fv_srt_cidr"] . $sortif[2];
			}
			// IPͥåȥɥ쥹ʳξϻ͡IPͥåȥɥ쥹ǥ
			else
			{
				$order_str = $this->m_sort_col[$sortif[0]] . $sortif[2] . "," .
							 $this->m_sort_col["fv_srt_cidr"] . $sortif[2];
			}

			if ($order_str !== "")
			{
				$order_str = (" ORDER BY " . $order_str);
			}
		}
		return $order_str;
	}

	//-----------------------------------------------------------------------
	// private methods(HTML)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_sort_link
	 *   ڡ󥰾Ȥ߹GET󥯤롣
	 * @return ʸ(Ⱦ)
	 */
	function create_sort_link()
	{
		$sortlink = array();
		$sort_str = "";
		for ($n = 0; $n < count($this->m_sort_able); $n++)
		{
			// ߤΥȴξ /߽ ž(fv_srt_XX_x _x ߾)
			if (strcmp(substr($this->m_sort_info, 0, -2), $this->m_sort_able[$n]) == 0)
			{
				$sort_str = $this->m_sort_able[$n];
				if (substr($this->m_sort_info, -1) == "a")
				{
					$sort_str .= "_d";
				}
				else
				{
					$sort_str .= "_a";
				}
			}
			else
			{
				$sort_str = $this->m_sort_able[$n] . "_a";
			}

			$sortlink[$this->m_sort_able[$n]]
							= $this->create_get_link(
											$this->m_pg_link_file,
											$this->m_page_util,
											$sort_str,
											GET_TYPE_SORT);
		}
		return $sortlink;
	}

	/**
	 * ؿ̾create_get_link
	 *   ڡ󥰾󡢥ȾȤ߹GET󥯤롣
	 * @param  $link_file	string				ե̾				(i)
	 * @param  $page_util	RegAppPagingUtil	ڡ󥰥桼ƥƥ饹(i)
	 * @param  $sort_lf		string				Ⱦ(fn_sortб)	(i)
	 * @param  $type		int					ѥ᡼				(i)
	 *											GET_TYPE_SORT, GET_TYPE_INFO
	 * @return		GETʸ
	 * @desc		GET_TYPE_SORT ξϸߥڡ򣱤ˤ
	 *				GET_TYPE_INFO ξϸߥڡϿ
	 */
	function create_get_link($link_file, $page_util, $sort_lf, $type=GET_TYPE_SORT)
	{
		//  + ڡ󥰾
		$linkhead = $link_file;
		$linkstr = "";

		if ($page_util != null)		// Ƭ᤹
		{
			switch ($type)
			{
			case GET_TYPE_SORT:
				$linkstr .= "fn_item_num=" . $page_util->m_page_item . "&amp;fn_cur_page=1";
				break;
			case GET_TYPE_INFO:
				$linkstr .= $page_util->create_get_str();
				break;
			default:
				break;
			}
		}

		// Ⱦɲ
		if ($sort_lf !== "")
		{
			if ($linkstr == "")
				$linkstr .= ("fn_sort=" . urlencode(sort_lf));
			else
				$linkstr .= ("&amp;" . "fn_sort=" . urlencode($sort_lf));
		}

		if ($linkstr != "")
		{
			$linkhead = ($linkhead . "?" . $linkstr);
		}
		return $linkhead;
	}
}
?>
