<?php
/**
 * $Id: RegAppDnsInfo.php,v 1.5 2004/02/27 10:54:02 yoshi_s Exp $
 * հDNSɽ(å)
 */
?>
<?php 
//---------------------------------------------------------------------------
// include,require
//---------------------------------------------------------------------------
require_once("RegAppDispConf.php");			// ̾󥯥饹
require_once("RegAppFormDns.php");			// հDNSѥե󥯥饹
require_once("RegAppInputCheck.php");		// ϥåѴؿ

//------------------------------------------------------------------------
// defines
//------------------------------------------------------------------------
define("DNSIF_TYPE_MEMBER", 1);				// ȿ¦հDNSɽ(ops0508)
define("DNSIF_TYPE_CLERK", 2);				// ̳¦հDNSɽ(ins0113)
?>
<?php
/**
 * ̾  RegAppDnsInfo
 *   հDNSɽ̥ӥͥå饹
 */
class RegAppDnsInfo extends RegAppFormDns
{
	//------------------------------------------------------------------------
	// ѿ
	//------------------------------------------------------------------------
	var $reg_db;						// DBAPI_IMPLE
	var $m_list_type;					// ɽ

	//--- HTML ---//
	var $m_ret_link_file;				// 
	var $m_ret_link_str;				// ʸ
	var $m_err_code_array;				// 顼
	var $m_table_style;					// ơ֥륹

	//--- ڡ󥰡Ѿ ---//
	var $m_list_datas;					// GETѥ᡼

	//--- Ѿ ---//
	var $m_search_info;					// ȴ
	var $m_sel_parts_keys;				// GETѥ᡼˳Ǽ
	var $m_app_parts_keys;				// ɽ󥭡̾ɽ󥯥饹ѡ

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppDnsInfo
	 *   RegAppDnsInfo饹󥹥ȥ饯
	 * @param  $db				DBAPI_IMPLE(connectѤǤ뤳)
	 * @param  $ret_link_file	
	 * @param  $ret_link_str	󥯤Σȣԣͣɽʸ
	 * @param  $list_type		ꥹȥ(DNSIF_TYPE_MEMBER, DNSIF_TYPE_CLERK)
	 */
	function RegAppDnsInfo($db,
						   $ret_link_file, $ret_link_str,
						   $list_type)
	{
		parent::RegAppFormDns();

		$this->reg_db			= $db;
		$this->m_list_type		= $list_type;
		$this->m_err_code_array	= array();

		//----- HTML -----//
		$this->m_ret_link_file	= $ret_link_file;
		$this->m_ret_link_str	= $ret_link_str;
		include("RegAppTableStyle.php");
		$this->m_table_style	= $table_style;

		//----- հDNS -----//
		$this->init_dns_info();
	}

	//------------------------------------------------------------------------
	// ɽ
	//------------------------------------------------------------------------
	/**
	 * ؿ̾init_dns_info
	 *   հDNS
	 */
	function init_dns_info()
	{
		//-------------------------------------------------------------------
		// ڡ󥰾󥯤˻ѡ
		//-------------------------------------------------------------------
		// ̤Ϥڡ,Ⱦѡ
		$this->m_list_datas = array(
			"fn_cur_page"	=>	-1,
			"fn_item_num"	=>	-1,
			"fn_sort"		=>	"",
		);

		//-----------------------------------------------------------------------
		// ǧѾ󥯥饹
		//-----------------------------------------------------------------------
		// 
		$this->m_search_info = "";

		// ̤Ϥ븡IPɥ쥹
		$this->m_sel_parts_keys = array("fn_if");

		// հDNS󥢥ƥ७
		$this->m_app_parts_keys = array(
			"fn_mem_op_short",
			"fn_dns_ip_address",
			"fn_dns_ns",
			"fn_dns_init_date",
			"fn_dns_last_date",
		);
	}

	/**
	 * ؿ̾create_dns_info
	 *   հDNS
	 *         RegAppDnsInfoHtml.php includeɬܽ
	 * @param  mem_num		int			ȿֹ(ȿʬоݤȤ -1 ˤ)
	 * @param  mem_short	string		ȿά(ȿʬоݤȤ * ˤ)
	 * @return TRUEλFALSE顼
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 *         RegAppDnsInfoHtml.php include ɬ¹Ԥ뤳ȡ
	 */
	function create_dns_info($mem_num, $mem_short)
	{
		//--------------------------------------------------------------------
		// GETѥ᡼
		//--------------------------------------------------------------------
		$this->set_list_data();				// GETѥ᡼Ͽ
		// GETѥ᡼IPͥåȥɥ쥹
		if ($this->set_search_data() == FALSE)
		{
			return FALSE;
		}

		//--------------------------------------------------------------------
		// ѥ֥Ⱥ
		//--------------------------------------------------------------------
		$this->dns_if_obj	= parent::create_conf_obj($this->m_app_parts_keys);

		//--------------------------------------------------------------------
		// Ͽ, հDNS
		//--------------------------------------------------------------------
		// 糧å
		$this->dns_if_obj["fn_dns_ip_address"]->set_disp_var($this->m_search_info);

		// ̳¦ǽ䴰ȿֹ桢ȿάΤƤ
		switch ($this->m_list_type)
		{
		case DNSIF_TYPE_MEMBER:		// ȿ¦ǽ
			if ($mem_num == -1 || strcmp($mem_short, "*") == 0)
			{
				return FALSE;
			}
			break;

		case DNSIF_TYPE_CLERK:		// ̳¦ǽ
			if ($mem_num == -1 && strcmp($mem_short, "*") == 0)
			{
				// ȿֹ桢ȿάγ
				if ($this->get_mem_info($this->dns_if_obj["fn_dns_ip_address"]->m_disp_var,
										$mem_num,
										$mem_short) == FALSE)
				{
					return FALSE;
				}
			}
			else
			{
				return FALSE;
			}
			break;

		default:
			return FALSE;
		}

		//----- հDNS -----//
		if ($this->get_dns_info($mem_num) == FALSE)
		{
			return FALSE;
		}

		//----- ȿάΥå -----//
		$this->dns_if_obj["fn_mem_op_short"]->set_disp_var($mem_short);
		return TRUE;
	}


	/**
	 * ؿ̾get_mem_info
	 *   հDNSݻȿȿֹȿάΤ
	 * @param  ip_addr		string		IPͥåȥɥ쥹ʸ
	 * @param  mem_num		int			ȿֹǼΰ
	 * @param  mem_short	string		ȿάγǼΰ
	 * @return TRUEFALSE顼
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 */
	function get_mem_info($ip_addr, &$mem_num, &$mem_short)
	{
		if ($this->reg_db == NULL)
			return FALSE;

		// SQL
		$sqlstr  = "SELECT mem.member_number, mem.member_short_name" .
				   " FROM mdb_meminfo mem, mdb_dnsinfo dns" .
				   " WHERE dns.ip_network_number = " . GetApsString($ip_addr) .
				   " AND (mem.status IN('stop', 'normal', 'deleting')) AND (mem.member_number = dns.member_number)";

		// DB䤤碌¹
		$result = $this->reg_db->dbapi_query($sqlstr);

		// 
		if ($result === NULL || $result === FALSE)
		{
			array_push($this->m_err_code_array, "D202");
			return FALSE;
		}
		// ̤ǡġĤˤʤϤ
		if (!is_array($result) || count($result) != 1)
		{
			array_push($this->m_err_code_array, "D202");
			return FALSE;
		}

		// ȿֹ򥻥å
		$mem_short = $result[0]["member_short_name"];
		$mem_num   = $result[0]["member_number"];

		return TRUE;
	}

	/**
	 * ؿ̾get_dns_info
	 *   հDNS
	 * @param  mem_num		int			ȿֹ
	 * @return TRUEFALSE顼
	 * @desc   顼ˤ $this->m_err_code_array ˥顼ɤϿ롣
	 */
	function get_dns_info($mem_num)
	{
		$result = parent::get_dns_info(
								$mem_num,
								$this->dns_if_obj,
								$this->m_err_code_array);
		switch ($result)
		{
		case 1:
			break;
		case ERR_APPOP_DNS_SEARCH:			// DNSʤ
		case ERR_APPOP_DB_ACCESS:			// DB顼
		default:
			return FALSE;
		}

		return TRUE;
	}


	//-----------------------------------------------------------------------
	// public methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_disp_data
	 *   HTMLɽѤβ̾饹֥Ȥ
	 * @return RegAppDispConf֥ȤϢ
	 * @desc   HTML̵ֵѤ
	 */
	function get_disp_data()
	{
		if ($this->dns_if_obj != NULL)
		{
			// HTML̵
			RegAppFormUtil::conv_dispvars_htmlstr($this->dns_if_obj,
												  $this->m_app_parts_keys);
		}
		return $this->dns_if_obj;
	}

	/**
	 * ؿ̾get_err_code_array
	 *   顼롣
	 * @return 顼(RegAppErrorMessage.php )
	 */
	function get_err_code_array()
	{
		return $this->m_err_code_array;
	}

	/**
	 * ؿ̾create_ret_link
	 *   ڡ󥰾󡢥ȾȤ߹GET󥯤롣
	 * @return	GETʸ
	 */
	function create_ret_link()
	{
		//  + ڡ󥰾
		$linkhead = $this->m_ret_link_file;
		$linkstr = "";

		//----- ߥڡ -----//
		if ($this->m_list_datas["fn_cur_page"] != -1)
		{
			$linkstr = ("fn_cur_page=" . urlencode($this->m_list_datas["fn_cur_page"]));
		}
		//----- ڡΥƥ -----//
		if ($this->m_list_datas["fn_item_num"] != -1)
		{
			if ($linkstr == "")
				$linkstr = ("fn_item_num=" . urlencode($this->m_list_datas["fn_item_num"]));
			else
				$linkstr .= ("&amp;" . "fn_item_num=" . urlencode($this->m_list_datas["fn_item_num"]));
		}
		//----- Ⱦ -----//
		if (strcmp($this->m_list_datas["fn_sort"], "") != 0)
		{
			if ($linkstr == "")
				$linkstr = ("fn_sort=" . urlencode($this->m_list_datas["fn_sort"]));
			else
				$linkstr .= ("&amp;" . "fn_sort=" . urlencode($this->m_list_datas["fn_sort"]));
		}

		if ($linkstr != "")
		{
			$linkhead = ($linkhead . "?" . $linkstr);
		}
		return $linkhead;
	}

	/**
	 * ؿ̾set_list_data
	 *   IPɥ쥹̤ ڡ󥰡 Ǽ롣
	 * @desc   GETϤ줿 "fn_cur_page" "fn_item_num" "fn_sort" ͤϿ롣
	 */
	function set_list_data()
	{
		//----- ߥڡֹ -----//
		if (isset($_GET["fn_cur_page"]))
		{
			$this->m_list_datas["fn_cur_page"] = urldecode($_GET["fn_cur_page"]);
			if (ereg("^[0-9]+$", $this->m_list_datas["fn_cur_page"]) == FALSE ||
				$this->m_list_datas["fn_cur_page"] < 1)
			{
				$this->m_list_datas["fn_cur_page"] = -1;
			}
			else
			{
				$this->m_list_datas["fn_cur_page"] = (int)$this->m_list_datas["fn_cur_page"];
			}
		}
		else
		{
			$this->m_list_datas["fn_cur_page"] = -1;
		}

		//----- ڡΥƥ -----//
		if (isset($_GET["fn_item_num"]))
		{
			$this->m_list_datas["fn_item_num"] = urldecode($_GET["fn_item_num"]);
			if (ereg("^[0-9]+$", $this->m_list_datas["fn_item_num"]) == FALSE ||
				$this->m_list_datas["fn_item_num"] < 1)
			{
				$this->m_list_datas["fn_item_num"] = -1;
			}
			else
			{
				$this->m_list_datas["fn_item_num"] = (int)$this->m_list_datas["fn_item_num"];
			}
		}
		else
		{
			$this->m_list_datas["fn_item_num"] = -1;
		}

		//----- ȾȾѱѿΤߤΥå -----//
		if (isset($_GET["fn_sort"]))
		{
			$sort_lf = trim(urldecode($_GET["fn_sort"]));
			if (chk_hankaku($sort_lf) != REG_APP_INPUT_CHK_OK)
			{
				$sort_lf = "";
			}
		}
		else
		{
			$sort_lf = "";
		}
		$this->m_list_datas["fn_sort"] = $sort_lf;
	}

	/**
	 * ؿ̾set_search_data
	 *   հDNS󸡺Ѥ  Ǽ롣
	 * @return TRUE:ǼFALSEǼ
	 * @desc   GETϤ줿 "fn_if" Ǽ롣
	 *         Ǽξ m_search_info ˸郎ϿƤ롣
	 *         Ԥ m_err_code_array ˥顼ǼFALSE֤
	 */
	function set_search_data()
	{
		//----- ߥڡֹ -----//
		if (isset($_GET["fn_if"]))
		{
			$search_lf = trim(urldecode($_GET["fn_if"]));
			switch (chk_ipaddress($search_lf))
			{
			case REG_APP_INPUT_CHK_OK:
				break;

			case REG_APP_INPUT_ERR_PATTERN:
			case REG_APP_INPUT_ERR_STRLEN:
			default:
				// հDNS
				array_push($this->m_err_code_array, "D202");
				return FALSE;
			}
		}
		else
		{
			// հDNS
			array_push($this->m_err_code_array, "D202");
			return FALSE;
		}

		$this->m_search_info = $search_lf;
		return TRUE;
	}
}
?>
