<?php
/**
 * $Id: RegAppFormOps0201.php,v 1.7 2004/02/27 10:04:15 yoshi_s Exp $
 * IPɥ쥹꿶֥åֵѿ(ops0201)Υ桼ƥƥ饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("RegAppFormCidr.php");			// 꿶֥åϢ̾󥯥饹
require_once("RegAppDateUtil.php");			// մϢ桼ƥƥ饹
require_once("DBAPI_OPS0201.php");			// SDB_FORM_OPS0201 DBAPI
require_once("DBAPI_DPN.php");				// DPN_CONTENT DBAPI
require_once("RegAppFormSendMail.php");		// ᡼Υ饹
?>
<?php
//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormOps0201 extends RegAppFormCidr
{
	/**
	 * DBAPI_IMPLE
	 */
	var $reg_db;

	/**
	 * applyϢDB桼ƥƥ
	 */
	var $apply_util;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormOps0201
	 *   RegAppFormOps0201饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function RegAppFormOps0201($db)
	{
		parent::RegAppFormCidr();
		$this->reg_db		= $db;
		$this->apply_util	= new RegAppApplyDBUtil();
	}

	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_cidr_deletable
	 *   ۲NetworkDNSʤɥ쥹֥åݤȽꤹ
	 * @param  mem_num						ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf	̾󥯥饹IPɥ쥹	(i/o)
	 *                      ["fn_cidr_ip_address"]
	 * @return int	1ֵѲǽ֥å
	 *              ERR_APPOP_FATAL			fatal顼
	 *              ERR_APPOP_DB_ACCESS		DB顼
	 *              ERR_APPOP_CIDR_STATUS	۲NET,DNSĤäƤ
	 */
	function chk_cidr_deletable($mem_num, &$conf_obj)
	{
		if (!is_array($conf_obj->m_disp_var) || count($conf_obj->m_disp_var) < 1)
		{
			return ERR_APPOP_FATAL;
		}

		$chk_address = "";
		foreach ($conf_obj->m_disp_var as $value)
		{
			if ($value != "")
				$chk_address .= GetApsString($value) . ",";
		}
		if ($chk_address == "")
		{
			return ERR_APPOP_FATAL;
		}
		$chk_address = rtrim($chk_address, ",");

		$sql_str = 	"SELECT COUNT(*) FROM cidr_block" .
					" WHERE member_number = " . $mem_num .
					" AND ip_network_number IN(" . $chk_address . ")" .
					" AND (" .
					"ip_network_number IN(SELECT ip_network_number FROM mdb_dnsinfo WHERE member_number = " . $mem_num . ")" .
					" OR ip_network_number IN(SELECT cidr_block FROM mdb_ipnetinfo))";
		$db_result = $this->reg_db->dbapi_query_count($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result == 0)
		{
			return 1;									// ֵOK
		}

		return ERR_APPOP_CIDR_STATUS;					// NETĤäƤ
	}

	/**
	 * ؿ̾get_del_cidr_list
	 *   NetworkDNSϿƤʤɥ쥹֥åꥹȤ
	 * @param  mem_num					ȿֹ				(i)
	 * @param  error_str	string[]	顼ɳǼ	(i/o)
	 * @return int	IPɥ쥹array("43.0.0.0/16", "43.1.0.0/16", "43.2.0.0/16"...)
	 *              ERR_APPOP_DB_ACCESS			DB顼
	 *              ERR_APPOP_CIDR_SEARCH		ɥ쥹֥åĤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_del_cidr_list($mem_num, &$error_str)
	{
		$sql_str = 	"SELECT ip_network_number FROM cidr_block" .
					" WHERE member_number = " . $mem_num .
					" AND ip_network_number NOT IN" .
					"(SELECT ip_network_number FROM mdb_dnsinfo WHERE member_number = " . $mem_num . ")" .
					" AND ip_network_number NOT IN(SELECT cidr_block FROM mdb_ipnetinfo)" .
					" ORDER BY start_sequence_number";
		$db_result = $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			array_push($error_str, "D200");		// ɥ쥹֥åǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			array_push($error_str, "D413");		// ֵѲǽCIDRʤ
			array_push($error_str, "D414");		// ֵѾ
			return ERR_APPOP_CIDR_SEARCH;		// ¸ߤʤ error
		}

		$ret_list = array();
		for ($n = 0; $n < count($db_result); $n++)
		{
			$ret_list[$n] = $db_result[$n]["ip_network_number"];
		}

		return $ret_list;
	}

	/**
	 * ؿ̾get_cidr_info_list
	 *   IPɥ쥹бCIDR BLOCKꥹȤRegAppDispConf
	 *         ꥹȤ
	 * @param  mem_num								ȿֹ				(i)
	 * @param  conf_obj			RegAppDispConf		ե󥯥饹		(i/o)
	 *                      	["fn_cidr_ip_address"] Ϥ
	 * @param  error_str		string[]			顼ɳǼ	(i/o)
	 * @param  lock_flg			boolean				åݥե饰		(i)
	 *							TRUEå롢FALSEåʤ
	 * @return RegAppDispConf[]	IPɥ쥹򥭡ˤRegAppDispConfϢϢ
	 *						array("IP" => array("fn_key" => RegAppDispConf,
	 *											"fn_key" => RegAppDispConf, ...),
	 *							  "IP" => array("fn_key" => RegAppDispConf,
	 *											"fn_key" => RegAppDispConf, ...),
	 *								....
	 *							  )
	 *			ERR_APPOP_FATAL				fatal 顼
	 *			ERR_APPOP_DB_ACCESS			DB顼
	 *			ERR_APPOP_CIDR_SEARCH		ɥ쥹֥å󤬸Ĥʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         IPɥ쥹(conf_obj["fn_cidr_ip_address"]->m_disp_var)б
	 *         롣
	 *         $lock_flg TRUEξ硢ɥ쥹֥åоݹԤå롣
	 *         ξ硢ȥ󥶥󳫻ϸ˸ƤӽФԤȡ
	 */
	function get_cidr_info_list($mem_num, &$conf_obj, &$error_str, $lock_flg=FALSE)
	{
		//--------------------------------------------------------------------
		// å
		//--------------------------------------------------------------------
		$get_num = count($conf_obj->m_disp_var);
		if (!is_array($conf_obj->m_disp_var) || $get_num < 1)
		{
			array_push($error_str, "D200");		// Ǥʤ顼
			return ERR_APPOP_FATAL;
		}

		//--------------------------------------------------------------------
		// DBͳ
		//--------------------------------------------------------------------
		//----- WHEREIPͥåȥɥ쥹Ǹ-----//
		$where_str = "";
		foreach ($conf_obj->m_disp_var as $value)
		{
			if ($value != "")
				$where_str .= GetApsString($value) . ",";
		}
		if ($where_str == "")
		{
			array_push($error_str, "D200");		// Ǥʤ顼
			return ERR_APPOP_FATAL;
		}
		$where_str = rtrim($where_str, ",");

		//----- CIDR_BLOCK ξ -----//
		// SELECTʳ
		$fn_array = array("fn_cidr_ip_address", "fn_cidr_last_date");
		$sel_cols = RegAppDBUtil::create_select_str($fn_array,
													$this->cidr_util->fn_col_tbl);

		// SQLʸ
		$sql_str = 	"SELECT " . $sel_cols . " FROM cidr_block" .
					" WHERE member_number = " . $mem_num .
					" AND ip_network_number IN(" . $where_str . ")" .
					" ORDER BY start_sequence_number";
		if ($lock_flg)
		{
			$sql_str = $sql_str . " FOR UPDATE";
			$qurery_method = "dbapi_query_lock";
		}
		else
		{
			$qurery_method = "dbapi_query";
		}

		//--------------------------------------------------------------------
		// CIDR_BLOCK ξ
		//--------------------------------------------------------------------
		$cidr_result = $this->reg_db->$qurery_method($sql_str);
		if ($cidr_result === FALSE)				// 顼
		{
			array_push($error_str, "D200");		// Ǥʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($cidr_result === NULL)				// 
		{
			// IPɥ쥹 => CIDR BLOCKϿƤʤפ򥨥顼ʸɲ
			foreach($conf_obj->m_disp_var as $key => $value)
			{
				array_push($error_str, array($value, "D203"));
			}
			return ERR_APPOP_CIDR_SEARCH;		// ¸ߤʤ error
		}

		// ץ饤ޥꥭʤΤǡۤʤ¸ߤʤ˳
		if ($get_num != count($cidr_result))
		{
			for($res_cnt = 0; $res_cnt < count($cidr_result); $res_cnt++)
			{
				$get_ip[$res_cnt] = $cidr_result[$res_cnt]["ip_network_number"];
			}

			$diff_ip = array_diff($conf_obj->m_disp_var, $get_ip);
			foreach ($diff_ip as $value)
			{
				// IPɥ쥹 => CIDR BLOCKϿƤʤפ򥨥顼ʸɲ
				array_push($error_str, array($value, "D203"));
			}
			return ERR_APPOP_CIDR_SEARCH;		// ¸ߤʤ error
		}

		//--------------------------------------------------------------------
		// Ǽ
		//--------------------------------------------------------------------
		$ret_conf	= array();

		//----- CIDR_BLOCK Ǽ -----//
		foreach ($cidr_result as $cidr_value)
		{
			$ret_conf[$cidr_value["ip_network_number"]] = parent::create_conf_obj($fn_array);
			foreach ($fn_array as $fn)
			{
				$ret_conf[$cidr_value["ip_network_number"]][$fn]->set_disp_var($cidr_value[$this->cidr_util->fn_col_tbl[$fn]]);
			}
		}

		return $ret_conf;
	}

	//-----------------------------------------------------------------------
	// public methods()
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾send_app_ops0201
	 *   IPɥ쥹꿶֥åֵѿ Ф
	 *         SDB_APPLY_INFO,SDB_FORM_OPS0201,DPN_CONTENT,CIDR_BLOCK,CIDR_BLOCK_UPDATE_HISTORY롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹Ϣ		(i)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @param  last_list	date_data[]			ǽϢ			(i)
	 * @return ϿRegAppCreateAppAcc
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_MEM_SEARCH		ȿĤʤ
	 *         ERR_APPOP_CIDR_SEARCH	ɥ쥹֥åĤʤ
	 *         ERR_APPOP_CIDR_CHANGE	ѹƤ
	 *         ERR_APPOP_CIDR_STATUS	۲NETĤäƤ
	 *         ERR_APPOP_FATAL			fatal 顼
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         $last_list ꤵ줿ϥIPɥ쥹ȺǽӤԤ
	 */
	function send_app_ops0201($mem_num, &$conf_obj, &$error_str, $last_list="")
	{
		$reg_db_ops0201	= new DBAPI_OPS0201($this->reg_db);		// DBAPI_OPS0201 object
		$reg_db_dpn		= new DBAPI_DPN($this->reg_db);			// DBAPI_DPN object
		$reg_db_cidr	= new DBAPI_CIDR($this->reg_db);		// DBAPI_CIDR object

		//-------------------------------------------------------------------
		// SDB_FORM_OPS0201 Ͽǡ
		//-------------------------------------------------------------------
		$ops_0201tbl = new SDB_FORM_OPS0201(
				"",
				$conf_obj["fn_cidr_ip_address"]->m_disp_var
		);

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽǡ
		//-------------------------------------------------------------------
		// SDB_FORM_OPS0201Ͽ륭
		$conf_dpn_keys = array("fn_cidr_ip_address");

		// dpn_content ʸǡ(for create_dpn_data_accept_discuss)
		$content_conf_obj = new RegAppDispConfData($conf_dpn_keys, $conf_obj);

		// Ͽֺ
		$app_date = RegAppDateUtil::make_current_date_db();

		//-------------------------------------------------------------------
		// CIDR_BLOCK Ͽǡ
		//-------------------------------------------------------------------
		$mdb_cidr_tbl = array();
		foreach ($conf_obj["fn_cidr_ip_address"]->m_disp_var as $return_block)
		{
			// ֵѥ֥åΥǡ˳Ǽ
			$add_info = RegIpv6AddressUtil::get_sequence_num($return_block);
			$cidr_tbl = new CIDR_BLOCK(
					$return_block,			// IPͥåȥɥ쥹
					$add_info[2],			// ץե
					$app_date,				// Ͽ
					$app_date,				// 
					$mem_num,				// ȿֹ
					""						// note
				);
			array_push($mdb_cidr_tbl, $cidr_tbl);
		}

		//-------------------------------------------------------------------
		// DBȥ󥶥󳫻ϡå
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//----- åơå᡼륢ɥ쥹 -----//
		$sql_str  = "SELECT applicant_mail_address FROM mdb_meminfo WHERE" .
					" member_number = " . $mem_num . " AND" .
					" status = 'normal'" . 
					" FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_MEM_SEARCH;
		}
		// ᡼륢ɥ쥹Ͽ
		$mem_in_mail = $db_result[0]["applicant_mail_address"];

		//-------------------------------------------------------------------
		// CIDRå
		//-------------------------------------------------------------------
		$ret_conf = $this->get_cidr_info_list($mem_num,
											  $conf_obj["fn_cidr_ip_address"],
											  $error_str,
											  TRUE);
		if (!is_array($ret_conf))
		{
			$this->reg_db->REGDB_rollback();
			return $ret_conf;
		}

		//-------------------------------------------------------------------
		// ɥ쥹֥åֵѲݥå
		//-------------------------------------------------------------------
		$chk_result = $this->chk_cidr_deletable($mem_num, $conf_obj["fn_cidr_ip_address"]);
		switch ($chk_result)
		{
		case 1:							// ֵѲǽ
			break;

		case ERR_APPOP_CIDR_STATUS:		// ۲NET,DNSĤäƤ
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D413");					// ۲˻ĤäƤ륨顼
			array_push($error_str, "D414");					// ֵѲǽ
			return $chk_result;

		case ERR_APPOP_FATAL:
		case ERR_APPOP_DB_ACCESS:
		default:
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return $chk_result;

		}

		// ǽǧ
		if ($last_list != "")
		{
			foreach ($last_list as $key => $value)
			{
				// $ret_conf Υ IPɥ쥹
				if (strcmp($ret_conf[$key]["fn_cidr_last_date"]->m_disp_var, $value) != 0)
				{
					$this->reg_db->REGDB_rollback();
					// "ɥ쥹" => Ƥפ򥨥顼ɲ
					array_push($error_str, array($key, "D401"));
					return ERR_APPOP_CIDR_CHANGE;
				}
			}
		}

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO, SDB_FORM_OPS0201 Ͽ
		//-------------------------------------------------------------------
		// SDB_APPLY_INFO Ͽǡ
		$sdb_appinfo_tbl = new SDB_APPLY_INFO(
							"", $app_date, "", "", $mem_num, "", "",
							$mem_in_mail, $app_date, "", "", $app_date);

		$apply_no = $reg_db_ops0201->create_apply_form_ops0201(
												$sdb_appinfo_tbl,
												$ops_0201tbl);
		if ($apply_no === FALSE || $apply_no == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽ
		//-------------------------------------------------------------------
		$dpn_content_tbl = $this->apply_util->create_dpn_data_accept_auto(
										$apply_no,
										"MEM",
										$mem_in_mail,
										$app_date,
										"ops0201",
										$content_conf_obj);
		$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
		if ($result === FALSE || $result == 0)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// CIDR_BLOCK/CIDR_BLOCK_UPDATE_HISTORY 
		//-------------------------------------------------------------------
		$mdb_update_tbl = new MDB_UPDATE_INFO(
							$mem_in_mail,
							$app_date,
							sprintf("RCV-%08d", $apply_no),
							"ops0201");

		$result = $reg_db_cidr->mdb_cidr_delete($mdb_cidr_tbl, $mdb_update_tbl);
		if ($result !== TRUE)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// Х᡼Ρʶ̳ôԸ
		//-------------------------------------------------------------------
		// ̳Υɥ쥹(To) ˻
		include("config/RegCnfMail.php");
		$to_addr = array($cnf_to_mailaddress);
		// ᡼ǡ
		$reg_mail_data	= new RegAppFormMailData(
								$to_addr,
								"ops0201",
								$this->apply_util->m_app_kind_tbl["ops0201"],
								sprintf("RCV-%08d", $apply_no),
								$app_date);
		// Υ᡼
		RegAppFormSendMail::send_form_notice_mail($reg_mail_data, FALSE);

		//-------------------------------------------------------------------
		// ߥå
		//-------------------------------------------------------------------
		$this->reg_db->REGDB_commit();
		return (new RegAppCreateAppAcc($apply_no, $dpn_content_tbl->contents, $dpn_content_tbl->subject));
	}

	/**
	 * ؿ̾get_app_ops0201
	 *   IPɥ쥹꿶֥åֵѿ 
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  allow_stt	string[]			Ĥ륹ơ	(i)
	 * @param  mem_num							ȿֹ						(i)
	 * @return 1
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			Ĥ륹ơˤʤäƤʤ
	 * @desc   ˤϿ­ appfm_objextra_if˥åȤ롣
	 *         Υ֥Ȥؿ뤿ᡢͽɬפϤʤ
	 *         ޤ$appif_obj["fn_app_last_date"]˺ǽǼ롣
	 *         ȿֹ椬ꤵ줿硢sdb_apply_info:member_number򸡺
	 *         ղä롣
	 */
	function get_app_ops0201(&$appif_obj, &$appfm_obj, $allow_stt, $mem_num="")
	{
		//-------------------------------------------------------------------
		// Ͽǡ
		//-------------------------------------------------------------------
		//----- SDB_APPLY_INFO ξ -----//
		// SQLʿΥơȺǽȿάΤ뤿ᡢsdb_apply_info appmdb_meminfo mem ղá
		$ops0201_sql = "SELECT app.status, app.final_reply, mem.member_short_name" .
					   " FROM sdb_apply_info app, mdb_meminfo mem" .
					   " WHERE app.member_number = mem.member_number" .
					   " AND app.accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " AND app.apply_kind_id = " . GetApsString($appif_obj["fn_app_kindid"]->m_disp_var);
		// ȿֹ椬ꤵƤϸղä
		if ($mem_num != "")
		{
			$sel_sql .= " AND app.member_number = " . $mem_num;
		}

		//----- SDB_FORM_IP_NETWORK_NUMBER ξ -----//
		$ipadd_sql	 = "SELECT ip_network_number FROM sdb_form_ip_network_number" .
					   " WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " ORDER BY order_no";


		//-------------------------------------------------------------------
		// SDB_APPLY_INFO ξ
		//-------------------------------------------------------------------
		$ops0201_result = $this->reg_db->dbapi_query($ops0201_sql);
		if ($ops0201_result === FALSE)			// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}
		if ($ops0201_result === NULL)			// 
		{
			return ERR_APPOP_SEARCH;			// ¸ߤʤ error
		}

		//-------------------------------------------------------------------
		// SDB_FORM_IP_NETWORK_NUMBER ξ
		//-------------------------------------------------------------------
		$ipadd_result = $this->reg_db->dbapi_query($ipadd_sql);
		if ($ipadd_result === FALSE)				// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}

		//--------------------------------------------------------------------
		// Ǽ
		//--------------------------------------------------------------------
		// ǽơݤå
		if (in_array($ops0201_result[0]["status"], $allow_stt) == FALSE)
		{
			return ERR_APPOP_STATUS;
		}

		//----- ǼѲ̾Ϣκ -----//
		$conf_array	= array(
				"fn_mem_op_short",
				"fn_cidr_ip_address",
		);
		$appfm_obj = parent::create_conf_obj($conf_array);

		//----- SDB_APPLY_INFO Ǽ -----//
		$appfm_obj["fn_mem_op_short"]->set_disp_var($ops0201_result[0]["member_short_name"]);
		$appif_obj["fn_app_last_date"]->set_disp_var($ops0201_result[0]["final_reply"]);

		//----- SDB_FORM_IP_NETWORK_NUMBER Ǽ -----//
		if ($ipadd_result === NULL)
		{
			$appfm_obj["fn_cidr_ip_address"]->set_disp_var("");
		}
		else
		{
			$appfm_obj["fn_cidr_ip_address"]->m_disp_var = array();
			foreach ($ipadd_result as $value)
			{
				if ($value["ip_network_number"] != "")
					array_push($appfm_obj["fn_cidr_ip_address"]->m_disp_var, $value["ip_network_number"]);
			}
		}

		return 1;
	}
	
	/**
	 * ؿsend_app_ops0201_for_tool
	 * 꿶ֵ(ġ뤫ƤФ)
	 * @param$ip_network_number[]ֵѤ륢ɥ쥹֥åΥͥåȥɥ쥹
	 * @param$mem_num󤹤ȿȿֹ
	 * @param$clerk_idġưôԤID
	 * @param$error_str[]顼ɳǼ
	 * @returnFALSEԡTRUE
	 * @descTRϸƤӽФǳϤƤ
	 */
	function send_app_ops0201_for_tool($ip_network_number, $mem_num, $clerk_id, &$error_str)
	{
		$reg_db_ops0201 = new DBAPI_OPS0201($this->reg_db);
		$reg_db_dpn = new DBAPI_DPN($this->reg_db);
		$reg_db_cidr = new DBAPI_CIDR($this->reg_db);
		
		$conf_obj = array("fn_cidr_ip_address" => new RegAppDispConf("IPͥåȥɥ쥹"));
		$conf_obj["fn_cidr_ip_address"]->m_disp_var = $ip_network_number;
		
		// SDB_FORM_OPS0201Ͽǡ
		$ops_0201tbl = new SDB_FORM_OPS0201("", $conf_obj["fn_cidr_ip_address"]->m_disp_var);
		
		// DPN_CONTENTϿǡ
		$conf_dpn_keys = array("fn_cidr_ip_address");
		
		// dpn_contentʸǡ
		$content_conf_obj = new RegAppDispConfData($conf_dpn_keys, $conf_obj);
		
		// Ͽֺ
		$app_date = RegAppDateUtil::make_current_date_db();
		
		// CIDR_BLOCKϿǡ
		$mdb_cidr_tbl = array();
		foreach($conf_obj["fn_cidr_ip_address"]->m_disp_var as $return_block)
		{
			$add_info = RegIpv6AddressUtil::get_sequence_num($return_block);
			$cidr_tbl = new CIDR_BLOCK($return_block,
									   $add_info[2],
									   $app_date,
									   $app_date,
									   $mem_num,
									   "");
			array_push($mdb_cidr_tbl, $cidr_tbl);
		}
		
		// CIDRå
		$ret_conf = $this->get_cidr_info_list($mem_num, $conf_obj["fn_cidr_ip_address"], $error_str, TRUE);
		if(!is_array($ret_conf))
		{
			return $ret_conf;
		}
		
		// ɥ쥹֥åֵѲݥå
		$chk_result = $this->chk_cidr_deletable($mem_num, $conf_obj["fn_cidr_ip_address"]);
		switch($chk_result)
		{
			case 1:
				break;
			case ERR_APPOP_CIDR_STATUS:
				array_push($error_str, "D413");
				array_push($error_str, "D414");
				return $chk_result;
			case ERR_APPOP_FATAL:
			case ERR_APPOP_DB_ACCESS:
			default:
				array_push($error_str, "D302");
				return FALSE;
		}
		
		// SDB_APPLY_INFOSDB_FORM_OPS0201Ͽ
		$sdb_appinfo_tbl = new SDB_APPLY_INFO("",				//No
											  $app_date,		//
											  "",				//clerk_id
											  "",				//apply_kind_id
											  $mem_num,			//ȿֹ
											  "",				//ơ
											  "",				//settlement_id
											  $clerk_id,		//send_person
											  $app_date,		//settlement_date
											  "",				//charge_flag
											  "",				//note
											  $app_date);		//final_reply
		$apply_no = $reg_db_ops0201->create_apply_form_ops0201($sdb_appinfo_tbl, $ops_0201tbl);
		if($apply_no === FALSE || $apply_no == 0)
		{
			array_push($error_str, "D302");
			return FALSE;
		}
		
		// DPN_CONTENTϿ
		$dpn_content_tbl = $this->apply_util->create_dpn_data_accept_auto($apply_no,
																		  "SYSTEM",
																		  $clerk_id,
																		  $app_date,
																		  "ops0201",
																		  $content_conf_obj);
		$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
		if($result === FALSE || $result == 0)
		{
			array_push($error_str, "D302");
			return FALSE;
		}
		
		// CIDR_BLOCKCIDR_BLOCK_UPDATE_HISTORY
		$mdb_update_tbl = new MDB_UPDATE_INFO($clerk_id,
											  $app_date,
											  sprintf("RCV-%08d", $apply_no),
											  "ins0303");
		$result = $reg_db_cidr->mdb_cidr_delete($mdb_cidr_tbl, $mdb_update_tbl);
		if($result !== TRUE)
		{
			array_push($error_str, "D302");
			return FALSE;
		}

		//-------------------------------------------------------------------
		// Х᡼Ρʶ̳ôԸ
		//-------------------------------------------------------------------
		// ̳Υɥ쥹(To) ˻
		include("config/RegCnfMail.php");
		$to_addr = array($cnf_to_mailaddress);
		// ᡼ǡ
		$reg_mail_data	= new RegAppFormMailData(
								$to_addr,
								"ops0201",
								$this->apply_util->m_app_kind_tbl["ops0201"],
								sprintf("RCV-%08d", $apply_no),
								$app_date);
		// Υ᡼
		RegAppFormSendMail::send_form_notice_mail($reg_mail_data, TRUE);

		return TRUE;
	}
}
?>
