<?php
/**
 * $Id: RegAppFormOps0207.php,v 1.16 2004/03/08 01:29:25 wtetsuya Exp $
 * ƺѤIPɥ쥹ֵѿ(ops0207)Υ桼ƥƥ饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("DBAPI_OPS0207.php");			// SDB_FORM_OPS0207 DBAPI
require_once("DBAPI_DPN.php");				// DPN_CONTENT DBAPI
require_once("DBAPI_REPORT.php");			// RDB DBAPI
require_once("RegAppFormNet.php");			// ͥåȥϢ̾󥯥饹
require("config/RegCnfCommon.php");			// ե
require_once("RegAppFormSendMail.php");
require_once("RegAppReportData.php");
require_once("RegAppWhois.php");
?>
<?php
//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegAppFormOps0207 extends RegAppFormNet
{
	/**
	 * DBAPI_IMPLE
	 */
	var $reg_db;

	/**
	 * applyϢDB桼ƥƥ
	 */
	var $apply_util;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegAppFormOps0207
	 *   RegAppFormOps0207饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function RegAppFormOps0207($db)
	{
		parent::RegAppFormNet("ops0207");
		$this->reg_db		= $db;
		$this->apply_util	= new RegAppApplyDBUtil();
	}

	/**
	 * ؿ̾get_label_info
	 *   եϲ̤ιܲʸ
	 * @param  for_html		boolean		TRUE:htmlspecialcharsѤΥǡ	(i)
	 * @return form name => ʸ Ϣ
	 */
	function get_label_info($for_html=TRUE)
	{
		$label_info = array(
			"fn_net_ip_address"	=>	"ֵѤIPͥåȥɥ쥹Ⱦѡ",
			"fn_net_delete"		=>	"ͥåȥֵѤͳʱѸɽȾѡ",
		);

		// htmlspecialchars
		if ($for_html)
			$label_info = RegAppFormUtil::conv_array_value_html($label_info);

		return $label_info;
	}

	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_net_info_list
	 *   IPɥ쥹бͥåȥꥹȤRegAppDispConf
	 *         ꥹȤ
	 * @param  mem_num								ȿֹ				(i)
	 * @param  conf_obj			RegAppDispConf		ե󥯥饹		(i/o)
	 *                      	["fn_net_ip_address"] Ϥ
	 * @param  error_str		string[]			顼ɳǼ	(i/o)
	 * @param  transaction_f	boolean				ȥ󥶥ե饰	(i)
	 *							TRUE ȥ󥶥¹ԤʽλԤ
	 *							FALSEȥ󥶥¹Ԥʤ
	 *							ؿǥå뤿ᡢFALSE ξϸƤӽФ
	 *							ǥȥ󥶥򳫻ϤƤȡ
	 * @return RegAppDispConf[]	IPɥ쥹򥭡ˤRegAppDispConfϢϢ
	 *						array("IP" => array("fn_key" => RegAppDispConf,
	 *											"fn_key" => RegAppDispConf, ...),
	 *							  "IP" => array("fn_key" => RegAppDispConf,
	 *											"fn_key" => RegAppDispConf, ...),
	 *								....
	 *							  )
	 *			ERR_APPOP_FATAL			fatal 顼
	 *			ERR_APPOP_DB_ACCESS		DB顼
	 *			ERR_APPOP_NET_SEARCH	ͥåȥ󤬸Ĥʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         IPɥ쥹(conf_obj["fn_net_ip_address"]->m_disp_var)б
	 *         롣
	 */
	function get_net_info_list($mem_num, &$conf_obj, &$error_str, $transaction_f=FALSE)
	{
		//--------------------------------------------------------------------
		// å
		//--------------------------------------------------------------------
		$get_num = count($conf_obj->m_disp_var);
		if (!is_array($conf_obj->m_disp_var) || $get_num < 1)
		{
			array_push($error_str, "D201");		// Ǥʤ顼
			$conf_obj->m_error_flg = TRUE;
			return ERR_APPOP_FATAL;
		}

		//--------------------------------------------------------------------
		// DBͳ
		//--------------------------------------------------------------------
		//----- WHEREIPͥåȥɥ쥹Ǹ-----//
		$where_str = "";
		foreach ($conf_obj->m_disp_var as $value)
		{
			if ($value != "")
				$where_str .= GetApsString($value) . ",";
		}
		if ($where_str == "")
		{
			array_push($error_str, "D201");		// Ǥʤ顼
			$conf_obj->m_error_flg = TRUE;
			return ERR_APPOP_FATAL;
		}
		$where_str = rtrim($where_str, ",");

		//----- MDB_IPNETINFO ξ -----//
		// SELECTʳ
		$fn_ipnet_array = array(
				"fn_net_ip_address", "fn_net_name",
				"fn_net_orgjp", "fn_net_orgen",
				"fn_net_postal", "fn_net_addjp", "fn_net_adden",
				"fn_net_last_date",
		);
		$sel_cols = RegAppDBUtil::create_select_str($fn_ipnet_array,
													$this->net_util->fn_col_tbl);

		// SQLʸ
		$ipnet_sql = "SELECT " . $sel_cols . " FROM mdb_ipnetinfo" .
					 " WHERE ip_network_number IN(" . $where_str . ")" .
					 " AND " . $mem_num . " =" .
					 " (SELECT cidr.member_number FROM cidr_block cidr WHERE mdb_ipnetinfo.cidr_block = cidr.ip_network_number)" .
					 " ORDER BY start_sequence_number FOR UPDATE";

		//----- MDB_IPNET_TECHNICAL_RESP ξ -----//
		// SELECTʳ
		$fn_get_array = array("fn_net_ip_address", "fn_net_tec_handle");
		$sel_cols = RegAppDBUtil::create_select_str($fn_get_array,
													$this->net_util->fn_col_tbl);

		// SQLʸ
		$tec_sql = "SELECT " . $sel_cols . " FROM mdb_ipnet_technical_resp" .
				   " WHERE ip_network_number IN(" . $where_str . ")" .
				   " ORDER BY ip_network_number, order_no";

		//----- MDB_IPNET_MAIL_ADDRESS ξ -----//
		// SELECTʳ
		$fn_get_array = array("fn_net_ip_address", "fn_net_mail");
		$sel_cols = RegAppDBUtil::create_select_str($fn_get_array,
													$this->net_util->fn_col_tbl);

		// SQLʸ
		$mail_sql = "SELECT " . $sel_cols . " FROM mdb_ipnet_mail_address" .
					" WHERE ip_network_number IN(" . $where_str . ")" .
					" ORDER BY ip_network_number, order_no";

		//--------------------------------------------------------------------
		// MDB_IPNETINFO ξ
		//--------------------------------------------------------------------
		if ($transaction_f)			// ե饰ΩäƤϥȥ󥶥
		{
			if ($this->reg_db->REGDB_begin() == FALSE)
			{
				array_push($error_str, "D201");		// Ǥʤ顼
				$conf_obj->m_error_flg = TRUE;
				return ERR_APPOP_DB_ACCESS;
			}
		}

		$ipnet_result = $this->reg_db->dbapi_query_lock($ipnet_sql);
		if ($ipnet_result === FALSE)				// 顼
		{
			if ($transaction_f)
				$this->reg_db->REGDB_rollback();
			array_push($error_str, "D201");			// Ǥʤ顼
			$conf_obj->m_error_flg = TRUE;
			return ERR_APPOP_DB_ACCESS;
		}
		if ($ipnet_result === NULL)					// 
		{
			if ($transaction_f)
				$this->reg_db->REGDB_rollback();
			// IPɥ쥹 => ͥåȥϿƤʤפ򥨥顼ʸɲ
			foreach($conf_obj->m_disp_var as $key => $value)
			{
				array_push($error_str, array($value, "D204"));
			}
			$conf_obj->m_error_flg = TRUE;
			return ERR_APPOP_NET_SEARCH;			// ¸ߤʤ error
		}

		// ץ饤ޥꥭʤΤǡۤʤ¸ߤʤ˳
		if ($get_num != count($ipnet_result))
		{
			if ($transaction_f)
				$this->reg_db->REGDB_rollback();
			for($res_cnt = 0; $res_cnt < count($ipnet_result); $res_cnt++)
			{
				$get_ip[$res_cnt] = $ipnet_result[$res_cnt]["ip_network_number"];
			}

			$diff_ip = array_diff($conf_obj->m_disp_var, $get_ip);
			foreach ($diff_ip as $value)
			{
				// IPɥ쥹 => ͥåȥϿƤʤפ򥨥顼ʸɲ
				array_push($error_str, array($value, "D204"));
			}
			$conf_obj->m_error_flg = TRUE;
			return ERR_APPOP_NET_SEARCH;			// ¸ߤʤ error
		}

		//--------------------------------------------------------------------
		// MDB_IPNET_TECHNICAL_RESP ξ
		//--------------------------------------------------------------------
		$tec_result = $this->reg_db->dbapi_query($tec_sql);
		if ($tec_result === FALSE)				// 顼
		{
			if ($transaction_f)
				$this->reg_db->REGDB_rollback();
			array_push($error_str, "D201");		// Ǥʤ顼
			$conf_obj->m_error_flg = TRUE;
			return ERR_APPOP_DB_ACCESS;
		}

		//--------------------------------------------------------------------
		// MDB_IPNET_MAIL_ADDRESS ξ
		//--------------------------------------------------------------------
		$mail_result = $this->reg_db->dbapi_query($mail_sql);
		if ($mail_result === FALSE)				// 顼
		{
			if ($transaction_f)
				$this->reg_db->REGDB_rollback();
			array_push($error_str, "D201");		// Ǥʤ顼
			$conf_obj->m_error_flg = TRUE;
			return ERR_APPOP_DB_ACCESS;
		}

		// ȥ󥶥λ
		if ($transaction_f)
		{
			$this->reg_db->REGDB_commit();
		}

		//--------------------------------------------------------------------
		// Ǽ
		//--------------------------------------------------------------------
		$conf_array	= array(
				"fn_net_ip_address", "fn_net_name",
				"fn_net_orgjp", "fn_net_orgen",
				"fn_net_mail",
				"fn_net_postal", "fn_net_addjp", "fn_net_adden",
				"fn_net_tec_handle",
				"fn_net_last_date",
		);
		$ret_conf	= array();

		//----- MDB_IPNETINFO Ǽ -----//
		foreach ($ipnet_result as $ip_value)
		{
			$ret_conf[$ip_value["ip_network_number"]] = parent::create_conf_obj($conf_array);
			$ret_conf[$ip_value["ip_network_number"]]["fn_net_tec_handle"]->m_disp_var = array();
			$ret_conf[$ip_value["ip_network_number"]]["fn_net_mail"]->m_disp_var = array();
			foreach ($fn_ipnet_array as $fn)
			{
				$ret_conf[$ip_value["ip_network_number"]][$fn]->set_disp_var($ip_value[$this->net_util->fn_col_tbl[$fn]]);
			}
		}

		//----- MDB_IPNET_TECHNICAL_RESP Ǽ -----//
		if ($tec_result === NULL)
		{
			foreach ($ret_conf as $key => $value)
			{
				$ret_conf[$key]["fn_net_tec_handle"]->set_disp_var("");
			}
		}
		else
		{
			foreach ($tec_result as $tec_value)
			{
				if (!isset($ret_conf[$tec_value["ip_network_number"]]))
				{
					array_push($error_str, "D201");		// Ǥʤ顼
					$conf_obj->m_error_flg = TRUE;
					return ERR_APPOP_FATAL;				// 󤬴ְäƤ롩
				}
				array_push($ret_conf[$tec_value["ip_network_number"]]["fn_net_tec_handle"]->m_disp_var,
						   $tec_value["technical_responsibility"]);
			}
		}

		//----- MDB_IPNET_MAIL_ADDRESS Ǽ -----//
		if ($mail_result === NULL)
		{
			foreach ($ret_conf as $key => $value)
			{
				$ret_conf[$key]["fn_net_mail"]->set_disp_var("");
			}
		}
		else
		{
			foreach ($mail_result as $ml_value)
			{
				if (!isset($ret_conf[$ml_value["ip_network_number"]]))
				{
					array_push($error_str, "D201");		// Ǥʤ顼
					$conf_obj->m_error_flg = TRUE;
					return ERR_APPOP_FATAL;				// 󤬴ְäƤ롩
				}
				array_push($ret_conf[$ml_value["ip_network_number"]]["fn_net_mail"]->m_disp_var,
						   $ml_value["mail_address"]);
			}
		}

		return $ret_conf;
	}

	/**
	 * ؿ̾send_app_ops0207
	 *   ƺѤIPɥ쥹ֵѿ Ф
	 *         SDB_APPLY_INFO, SDB_FORM_OPS0207, DPN_CONTENT, MDB_IPNETINFO, MDB_IPNET_UPDATE_HISTORY
	 *         򹹿롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹Ϣ		(i)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @param  last_list	date_data[]			ǽϢ			(i)
	 * @return ϿRegAppCreateAppAcc
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_NET_SEARCH		ͥåȥ󤬸Ĥʤ
	 *         ERR_APPOP_NET_CHANGE		ͥåȥ󤬹Ƥ
	 *         ERR_APPOP_FATAL			fatal 顼
	 *         ERR_APPOP_MEM_SEARCH		ȿĤʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         $last_list ꤵ줿ϥIPɥ쥹ȺǽӤԤ
	 */
	function send_app_ops0207($mem_num, $conf_obj, &$error_str, $last_list="")
	{
		$reg_db_ops0207	= new DBAPI_OPS0207($this->reg_db);		// DBAPI_OPS0207 object
		$reg_db_dpn		= new DBAPI_DPN($this->reg_db);			// DBAPI_DPN object
		$reg_db_net		= new DBAPI_IPNET($this->reg_db);		// DBAPI_IPNET object
		$reg_db_rpt		= new DBAPI_REPORT($this->reg_db);		// DBAPI_REPORT object

		//-------------------------------------------------------------------
		// SDB_FORM_OPS0207 Ͽǡ
		//-------------------------------------------------------------------
		$ops_0207tbl = new SDB_FORM_OPS0207(
				"",
				$conf_obj["fn_net_ip_address"]->m_disp_var
		);

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽǡ
		// ֵѤǤϡͥåȥDPN_CONTENTS˳Ǽ
		//-------------------------------------------------------------------
		// SDB_FORM_OPS0207Ͽ륭
		$conf_dpn_keys = array(
				"fn_net_ip_address",
				"fn_net_name",
				"fn_net_orgjp",
				"fn_net_orgen",
				"fn_net_mail",
				"fn_net_postal",
				"fn_net_addjp",
				"fn_net_adden",
				"fn_net_tec_handle",
				"fn_net_delete",
		);

		// Ͽֺ
		$app_date = RegAppDateUtil::make_current_date_db();

		//-------------------------------------------------------------------
		// DBȥ󥶥󳫻ϡå
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// MEMBER åơå᡼륢ɥ쥹
		//-------------------------------------------------------------------
		$sql_str  = "SELECT applicant_mail_address FROM mdb_meminfo WHERE" .
					" member_number = " . $mem_num . " AND" .
					" status = 'normal'" . 
					" FOR UPDATE";
		$db_result = $this->reg_db->dbapi_query_lock($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");					// ФǤʤ顼
			return ERR_APPOP_MEM_SEARCH;
		}
		// ᡼륢ɥ쥹Ͽ
		$mem_in_mail = $db_result[0]["applicant_mail_address"];

		//-------------------------------------------------------------------
		// IPNET å
		//-------------------------------------------------------------------
		$ret_conf = $this->get_net_info_list($mem_num,
											 $conf_obj["fn_net_ip_address"],
											 $error_str,
											 FALSE);
		if (!is_array($ret_conf))
		{
			$this->reg_db->REGDB_rollback();
			return $ret_conf;
		}

		// ǽǧ
		if ($last_list != "")
		{
			foreach ($last_list as $key => $value)
			{
				// $ret_conf Υ IPɥ쥹
				if (strcmp($ret_conf[$key]["fn_net_last_date"]->m_disp_var, $value) != 0)
				{
					$this->reg_db->REGDB_rollback();
					// "ɥ쥹" => Ƥפ򥨥顼ɲ
					array_push($error_str, array($key, "D401"));
					return ERR_APPOP_NET_CHANGE;
				}
			}
		}

		// dpn_content ʸǡ(for create_dpn_data_accept_discuss)
		// ֵѤͥåȥĿϿ
		// ֵͳɲ
		$tmp_del_conf = new RegAppDispConf("ֵͳ");
		$tmp_del_conf->set_disp_var($conf_obj["fn_net_delete"]->m_disp_var);
		foreach ($ret_conf as $key => $value)
		{
			$value["fn_net_delete"] = $tmp_del_conf;
			$content_conf_tbl[$key] = new RegAppDispConfData($conf_dpn_keys, $value);
		}

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO, SDB_FORM_OPS0207 Ͽ
		//-------------------------------------------------------------------
		$sdb_appinfo_tbl = new SDB_APPLY_INFO(
							"", $app_date, "", "", $mem_num, "", "",
							$mem_in_mail, $app_date, "", "", $app_date);

		$apply_no = $reg_db_ops0207->create_apply_form_ops0207(
												$sdb_appinfo_tbl,
												$ops_0207tbl);
		if ($apply_no === FALSE || $apply_no == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		//-------------------------------------------------------------------
		// DPN_CONTENT Ͽ
		//-------------------------------------------------------------------
		$result_content = "";			// 
		// ͥåȥĤˤĤĤcontentˤϿ
		foreach ($content_conf_tbl as $contents)
		{
			$dpn_content_tbl = $this->apply_util->create_dpn_data_accept_auto(
											$apply_no,
											"MEM",
											$mem_in_mail,
											$app_date,
											"ops0207",
											$contents);
			$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
			if ($result === FALSE || $result == 0)
			{
				$this->reg_db->REGDB_rollback();
				array_push($error_str, "D302");		// ФǤʤ顼
				return ERR_APPOP_DB_ACCESS;
			}
			// acc ̤ǤϢ뤷ɽ
			$result_content .= $dpn_content_tbl->contents . "\n\n";
		}

		//-------------------------------------------------------------------
		// MDB_IPNETINFO/MDB_MEM_UPDATE_HISTORY 
		//-------------------------------------------------------------------
		// ҥȥѥǡ
		$mdb_update_tbl = new MDB_UPDATE_INFO(
							$mem_in_mail,
							$app_date,
							sprintf("RCV-%08d", $apply_no),
							"ops0207");
		// ͥåȥֵѤ
		foreach ($conf_obj["fn_net_ip_address"]->m_disp_var as $del_address)
		{
			$result = $reg_db_net->delete_ipnet_info(
										$del_address, $mdb_update_tbl);
			if ($result === FALSE || $result == 0)
			{
				$this->reg_db->REGDB_rollback();
				array_push($error_str, "D302");		// ФǤʤ顼
				return ERR_APPOP_DB_ACCESS;
			}
		}
		
		//-------------------------------------------------------------------
		// APNICѾϿ
		//-------------------------------------------------------------------
   		include("config/RegCnfCommon.php");
		foreach($ret_conf as $key => $val){
		
			//-------------------------------------------------------------------
			// WhoisԤchangedܤ
			//-------------------------------------------------------------------
			$whois =& new RegAppWhois($cnf_report_whois_server);
			$whois->set_name($val["fn_net_ip_address"]->m_disp_var);
			$whois->execute();
			if($whois->is_error()){
				$this->reg_db->REGDB_rollback();
				array_push($error_str, "D212");		// whois顼
				return ERR_APPOP_DB_ACCESS;
			}
			$wobj =& $whois->get_object("inet6num");
			if(!is_object($wobj) 
			|| !$wobj->is_equal($val["fn_net_ip_address"]->m_disp_var)
			|| !$wobj->is_assigned_non_portable()){
				$this->reg_db->REGDB_rollback();
				array_push($error_str, "D213");		// ̤ƥ顼
				return ERR_APPOP_DB_ACCESS;
			}
			$changed = $wobj->get_item_array("changed");
			array_push($changed, $cnf_report_changed_email." ".date("Ymd"));

			$report_info = new REPORT_INFO(
				"",                                         // report_id
				$apply_no,                                  // accept_id
				$cnf_report_to,                             // report_to    (config)
				"returned",                                 // report_type
				$val["fn_net_ip_address"]->m_disp_var,      // inet6num
				$val["fn_net_name"]->m_disp_var,            // natname
				$cnf_report_country,                        // country      (config)
				$val["fn_net_orgen"]->m_disp_var,           // descr
				$val["fn_net_tec_handle"]->m_disp_var,      // admin_c
				$val["fn_net_tec_handle"]->m_disp_var,      // tech_c
				array(),                                    // rev_srv
				$cnf_report_status,                         // status       (config)
				array(),                                    // remarks
				$val["fn_net_mail"]->m_disp_var,            // notify
				$cnf_report_mnt_by,                         // mnt_by
				array(),                                    // mnt_lower
				array(),                                    // mnt_irt
				$changed,                                   // changed
				$cnf_report_source,                         // source       (config)
				$conf_obj["fn_net_delete"]->m_disp_var,     // delete
				$cnf_report_password                        // password     (config)
			);
			$result = $reg_db_rpt->create_report_returned($report_info);
			if($result === FALSE){
				$this->reg_db->REGDB_rollback();
				array_push($error_str, "D302");		// ФǤʤ顼
				return ERR_APPOP_DB_ACCESS;
			}
		}

		//-------------------------------------------------------------------
		// ᡼Ρʶ̳ôԸ
		//-------------------------------------------------------------------
		$mail_report_info = $reg_db_rpt->get_report($apply_no);
		if($mail_report_info === FALSE){
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		foreach($mail_report_info as $mail_report){
			// ̳Υɥ쥹(To) ˻$cnf_to_mailaddress
			// ѤƤ餽Ѥ configͤѹ
			include("config/RegCnfMail.php");
			$to_addr = array($cnf_to_mailaddress);
			// ᡼ǡ
			$reg_mail_data	= new RegAppFormMailData(
								$to_addr,										// to ɥ쥹
								"ops0207",										// ̻
								$this->apply_util->m_app_kind_tbl["ops0207"],	// ̾
								sprintf("RCV-%08d", $apply_no),					// ֹ
								$app_date);										// 
			// ǡ
			$rpt_obj = new RegAppReportData($mail_report);
			$report_body = $rpt_obj->create_body();
		
			// Υ᡼
			RegAppFormSendMail::send_form_report_mail($report_body, $reg_mail_data, FALSE);
		}
		
		//-------------------------------------------------------------------
		// ߥå
		//-------------------------------------------------------------------
		$this->reg_db->REGDB_commit();
		return (new RegAppCreateAppAcc($apply_no, $result_content, $dpn_content_tbl->subject));
	}

	/**
	 * ؿ̾get_app_ops0207
	 *   ƺѤIPɥ쥹ֵѿ 
	 * @param  appif_obj	RegAppDispConf[]	Ϣ				(i/o)
	 * @param  appfm_obj	RegAppDispConf[]	̾󥯥饹Ϣ			(i/o)
	 * @param  allow_stt	string[]			Ĥ륹ơ	(i)
	 * @param  mem_num							ȿֹ						(i)
	 * @return 1
	 *         ERR_APPOP_DB_ACCESS		DB顼
	 *         ERR_APPOP_SEARCH			񤬸Ĥʤ
	 *         ERR_APPOP_STATUS			Ĥ륹ơˤʤäƤʤ
	 * @desc   ˤϿ­ appfm_objextra_if˥åȤ롣
	 *         Υ֥Ȥؿ뤿ᡢͽɬפϤʤ
	 *         ޤ$appif_obj["fn_app_last_date"]˺ǽǼ롣
	 *         ȿֹ椬ꤵ줿硢sdb_apply_info:member_number򸡺
	 *         ղä롣
	 */
	function get_app_ops0207(&$appif_obj, &$appfm_obj, $allow_stt, $mem_num="")
	{
		//-------------------------------------------------------------------
		// Ͽǡ
		//-------------------------------------------------------------------
		//----- SDB_APPLY_INFO ξ -----//
		// SQLʿΥơȺǽȿάΤ뤿ᡢsdb_apply_info appmdb_meminfo mem ղá
		$ops0207_sql = "SELECT app.status, app.final_reply" .
					   " FROM sdb_apply_info app" .
					   " WHERE app.accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " AND app.apply_kind_id = " . GetApsString($appif_obj["fn_app_kindid"]->m_disp_var);
		// ȿֹ椬ꤵƤϸղä
		if ($mem_num != "")
		{
			$sel_sql .= " AND app.member_number = " . $mem_num;
		}

		//----- SDB_FORM_IP_NETWORK_NUMBER ξ -----//
		$ipadd_sql	 = "SELECT ip_network_number FROM sdb_form_ip_network_number" .
					   " WHERE accept_id = " . $appif_obj["fn_app_acceptid"]->m_disp_var .
					   " ORDER BY order_no";

		//-------------------------------------------------------------------
		// SDB_APPLY_INFO ξ
		//-------------------------------------------------------------------
		$ops0207_result = $this->reg_db->dbapi_query($ops0207_sql);
		if ($ops0207_result === FALSE)			// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}
		if ($ops0207_result === NULL)			// 
		{
			return ERR_APPOP_SEARCH;			// ¸ߤʤ error
		}

		//-------------------------------------------------------------------
		// SDB_FORM_IP_NETWORK_NUMBER ξ
		//-------------------------------------------------------------------
		$ipadd_result = $this->reg_db->dbapi_query($ipadd_sql);
		if ($ipadd_result === FALSE)				// 顼
		{
			return ERR_APPOP_DB_ACCESS;
		}

		//--------------------------------------------------------------------
		// Ǽ
		//--------------------------------------------------------------------
		// ǽơݤå
		if (in_array($ops0207_result[0]["status"], $allow_stt) == FALSE)
		{
			return ERR_APPOP_STATUS;
		}

		//----- ǼѲ̾Ϣκ -----//
		$conf_array	= array(
				"fn_net_ip_address",
		);
		$appfm_obj = parent::create_conf_obj($conf_array);

		//----- SDB_APPLY_INFO Ǽ -----//
		$appif_obj["fn_app_last_date"]->set_disp_var($ops0207_result[0]["final_reply"]);

		//----- SDB_FORM_IP_NETWORK_NUMBER Ǽ -----//
		if ($ipadd_result === NULL)
		{
			$appfm_obj["fn_net_ip_address"]->set_disp_var("");
		}
		else
		{
			$appfm_obj["fn_net_ip_address"]->m_disp_var = array();
			foreach ($ipadd_result as $value)
			{
				if ($value["ip_network_number"] != "")
					array_push($appfm_obj["fn_net_ip_address"]->m_disp_var, $value["ip_network_number"]);
			}
		}

		return 1;
	}

	/**
	 * ؿsend_app_ops0207_for_tool
	 * ưֵ(ġ뤫ƤФ)
	 * @param$ip_network_number[]ֵѤ򤹤ͥåȥɥ쥹
	 * @param$mem_num󤹤ȿȿֹ
	 * @param$clerk_idġưôԤID
	 * @param$error_str[]顼ɳǼ
	 * @returnFALSEԡTRUE
	 * @descTRϸƤӽФǳϤƤ
	 */
	function send_app_ops0207_for_tool($ip_network_number, $mem_num, $clerk_id, &$error_str)
	{
		$reg_db_ops0207 = new DBAPI_OPS0207($this->reg_db);
		$reg_db_dpn = new DBAPI_DPN($this->reg_db);
		$reg_db_net = new DBAPI_IPNET($this->reg_db);
		$reg_db_rpt		= new DBAPI_REPORT($this->reg_db);		// DBAPI_REPORT object
		
		$conf_obj = array("fn_net_ip_address" => new RegAppDispConf("IPͥåȥɥ쥹"));
		$conf_obj["fn_net_ip_address"]->m_disp_var = $ip_network_number;
		
		// SDB_FORM_OPS0207Ͽǡ
		$ops_0207_tbl = new SDB_FORM_OPS0207("",
											 $conf_obj["fn_net_ip_address"]->m_disp_var);
		
		// DPN_CONTENTϿǡ
		$conf_dpn_keys = array("fn_net_ip_address",
							   "fn_net_name",
							   "fn_net_orgjp",
							   "fn_net_orgen",
							   "fn_net_mail",
							   "fn_net_postal",
							   "fn_net_addjp",
							   "fn_net_adden",
							   "fn_net_tec_handle");
		
		// Ͽֺ
		$app_date = RegAppDateUtil::make_current_date_db();
		
		// IPNETå
		$ret_conf = $this->get_net_info_list($mem_num, $conf_obj["fn_net_ip_address"], $error_str, FALSE);
		if(!is_array($ret_conf))
		{
			return $ret_conf;
		}
		
		// dpn_contentʸǡ
		// ֵѤͥåȥĿϿ
		foreach($ret_conf as $key => $value)
		{
			$content_conf_tbl[$key] = new RegAppDispConfData($conf_dpn_keys, $value);
		}
		
		// SDB_APPLY_INFOSDB_FORM_OPS0207Ͽ
		$sdb_appinfo_tbl = new SDB_APPLY_INFO("",				//No
											  $app_date,		//
											  "",				//clerk_id
											  "",				//apply_kind_id
											  $mem_num,			//ȿֹ
											  "",				//ơ
											  "",				//settlement_id
											  $clerk_id,		//send_person
											  $app_date,		//settlement_date
											  "",				//charge_flag
											  "",				//note
											  $app_date);		//final_reply
		$apply_no = $reg_db_ops0207->create_apply_form_ops0207($sdb_appinfo_tbl, $ops_0207_tbl);
		if($apply_no === FALSE || $apply_no == 0)
		{
			array_push($error_str, "D302");
			return FALSE;
		}
		
		// DPN_CONTENTϿ
		foreach($content_conf_tbl as $contents)
		{
			$dpn_content_tbl = $this->apply_util->create_dpn_data_accept_auto($apply_no,
																			  "SYSTEM",
																			  $clerk_id,
																			  $app_date,
																			  "ops0207",
																			  $contents);
			$result = $reg_db_dpn->dpn_create_content($dpn_content_tbl);
			if($result === FALSE || $result == 0)
			{
				array_push($error_str, "D302");
				return FALSE;
			}
		}
		
		// MDB_IPNETINFOMDB_IPNET_UPDATE_HISTORY
		$mdb_update_tbl = new MDB_UPDATE_INFO($clerk_id, $app_date, sprintf("RCV-%08d", $apply_no), "ins0303");
		foreach($conf_obj["fn_net_ip_address"]->m_disp_var as $del_address)
		{
			$result = $reg_db_net->delete_ipnet_info($del_address, $mdb_update_tbl);
			if($result === FALSE || $result == 0)
			{
				array_push($error_str, "D302");
				return FALSE;
			}
		}
		
		//-------------------------------------------------------------------
		// APNICѾϿ
		//-------------------------------------------------------------------
		include("config/RegCnfCommon.php");
		foreach($ret_conf as $key => $val){
		
			//-------------------------------------------------------------------
			// WhoisԤchangedܤ
			//-------------------------------------------------------------------
			$changed = array();
			if($cnf_report_whois_mode){
				$whois =& new RegAppWhois($cnf_report_whois_server);
				$whois->set_name($val["fn_net_ip_address"]->m_disp_var);
				$whois->execute();
				if($whois->is_error()){
					$this->reg_db->REGDB_rollback();
				array_push($error_str, "D212");		// whois顼
					return ERR_APPOP_DB_ACCESS;
				}
				$wobj =& $whois->get_object("inet6num");
				if(!is_object($wobj) 
				|| !$wobj->is_equal($val["fn_net_ip_address"]->m_disp_var)
				|| !$wobj->is_assigned_non_portable()){
					$this->reg_db->REGDB_rollback();
					array_push($error_str, "D213");		// ̤ƥ顼
					return ERR_APPOP_DB_ACCESS;
				}
				$changed = $wobj->get_item_array("changed");
				array_push($changed, $cnf_report_changed_email." ".date("Ymd"));
			}

			$report_info = new REPORT_INFO(
				"",                                         // report_id
				$apply_no,                                  // accept_id
				$cnf_report_to,                             // report_to    (config)
				"returned",                                 // report_type
				$val["fn_net_ip_address"]->m_disp_var,      // inet6num
				$val["fn_net_name"]->m_disp_var,            // natname
				$cnf_report_country,                        // country      (config)
				$val["fn_net_orgen"]->m_disp_var,           // descr
				$val["fn_net_tec_handle"]->m_disp_var,      // admin_c
				$val["fn_net_tec_handle"]->m_disp_var,      // tech_c
				array(),                                    // rev_srv
				$cnf_report_status,                         // status       (config)
				array(),                                    // remarks
				$val["fn_net_mail"]->m_disp_var,            // notify
				$cnf_report_mnt_by,                         // mnt_by
				array(),                                    // mnt_lower
				array(),                                    // mnt_irt
				$changed,                                   // changed
				$cnf_report_source,                         // source       (config)
				$cnf_report_delete,                         // delete       (config)
				$cnf_report_password                        // password     (config)
			);
			$result = $reg_db_rpt->create_report_returned($report_info);
			if($result === FALSE){
				$this->reg_db->REGDB_rollback();
				array_push($error_str, "D302");		// ФǤʤ顼
				return ERR_APPOP_DB_ACCESS;
			}
		}

		//-------------------------------------------------------------------
		// ᡼Ρʶ̳ôԸ
		//-------------------------------------------------------------------
		$mail_report_info = $reg_db_rpt->get_report($apply_no);
		if($mail_report_info === FALSE){
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D302");		// ФǤʤ顼
			return ERR_APPOP_DB_ACCESS;
		}

		foreach($mail_report_info as $mail_report){
			// ̳Υɥ쥹(To) ˻$cnf_to_mailaddress
			// ѤƤ餽Ѥ configͤѹ
			include("config/RegCnfMail.php");
			$to_addr = array($cnf_to_mailaddress);
			// ᡼ǡ
			$reg_mail_data	= new RegAppFormMailData(
								$to_addr,										// to ɥ쥹
								"ops0207",										// ̻
								$this->apply_util->m_app_kind_tbl["ops0207"],	// ̾
								sprintf("RCV-%08d", $apply_no),					// ֹ
								$app_date);										// 
			// ǡ
			$rpt_obj = new RegAppReportData($mail_report);
			$report_body = $rpt_obj->create_body();
		
			// Υ᡼
			RegAppFormSendMail::send_form_report_mail($report_body, $reg_mail_data, TRUE);
		}
		return TRUE;
	}
}
?>
