<?php
/**
 * $Id: ins_0402_class.php,v 1.4 2004/02/27 09:05:11 wtetsuya Exp $
 * IPɥ쥹²(ins_0402)ѤΥ桼ƥƥ饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPIWrapper.php");			// DB API
require_once("RegAppInputCheck.php");		// եϥå饹
require_once("RegAppDispConf.php");			// ե󥯥饹
require_once("RegAppFormUtil.php");			// ե桼ƥƥ饹
require_once("RegV6pcLog.php");				// ϥ饹

//----------------------------------------------------------------------------
// define
//----------------------------------------------------------------------------
define("ERR_LIMIT_DB_ACCESS", -1);			// DB顼
define("ERR_LIMIT_MEM_SEARCH", -2);			// ȿĤʤ

/**
 * ̾  ins_0402_class
 *   IPɥ쥹²(ins_0402)桼ƥƥ饹
 *   POST줿ǡѤ롣POSTǡ˸ƤӽФ
 */
class ins_0402_class
{
	var $reg_db;

	//-----------------------------------------------------------------------
	// public methods
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾ins_0402_class
	 *   ins_0402_class󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function ins_0402_class($db)
	{
		$this->reg_db = $db;
	}

	/**
	 * ؿ̾chk_memshort_in_syntax
	 *   POSTǡʥե͡ˤΥ󥿥åԤ
	 *         ȿάΤɬϡʸå
	 * @param  conf_obj		RegAppDispConf	ե󥯥饹				(i/o)
	 *						["fn_mem_op_short"]
	 * @param  error_str	string[]		顼ɳǼ			(i/o)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         conf_obj["fn_mem_op_short"]ꤹ뤳ȡ
	 */
	function chk_memshort_in_syntax(&$conf_obj, &$error_str)
	{
		$chk_result = TRUE;		// Ƚ

		//--------------------------------------------------------------------
		// ȿά POSTǡå
		//--------------------------------------------------------------------
		if ($conf_obj->m_disp_var == "")
		{
			$chk_result = FALSE;			// ɬܹܥ顼
			$conf_obj->m_error_flg = TRUE;	// FORM顼ɽե饰
			array_push($error_str, array($conf_obj->m_label_str, "D001"));
		}
		else
		{
			switch (chk_mem_short($conf_obj->m_disp_var))
			{
			case REG_APP_INPUT_CHK_OK:				// åOK
				break;
			case REG_APP_INPUT_ERR_STRLEN:			// ʸ顼
				$chk_result = FALSE;
				$conf_obj->m_error_flg = TRUE;	// FORM顼ɽե饰
				array_push($error_str, array($conf_obj->m_label_str, "D007"));
				break;
			case REG_APP_INPUT_ERR_PATTERN:			// 顼
			default:
				$chk_result = FALSE;
				$conf_obj->m_error_flg = TRUE;	// FORM顼ɽե饰
				array_push($error_str, array($conf_obj->m_label_str, "D008"));
				break;
			}
		}

		return $chk_result;
	}

	/**
	 * ؿ̾chk_memshort_hidden_syntax
	 *   POSTǡhiddenˤΥ󥿥åԤ
	 *         ȿάΤʸå
	 * @param  mem_short	string			ȿά					(i)
	 * @param  error_str	string[]		顼ɳǼ		(i)
	 * @return boolean	TRUE󥿥åOKFALSE󥿥åNG
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function chk_memshort_hidden_syntax($mem_short, &$error_str)
	{
		switch (chk_mem_short($mem_short))
		{
		case REG_APP_INPUT_CHK_OK:				// åOK
			break;
		case REG_APP_INPUT_ERR_STRLEN:			// ʸ顼
		default:
			return FALSE;
		}
		return TRUE;
	}

	/**
	 * ؿ̾chk_memshort_semantics
	 *   POSTǡʥե͡ˤΥޥƥåԤ
	 *         ȿάΤ¸߲(̾ѡߤΤ줫)å롣
	 *         ̾ѡȿ¸ߤȿֹ
	 *         $mem_num ˳Ǽ롣
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹			(i/o)
	 * @param  error_str	string[]			顼ɳǼ			(i/o)
	 * @return int	10ȿ¸ߤʤ,status error-1DB³顼(¾ fatal error)
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *
	 *         ȿά(conf_obj["fn_mem_op_short"]->m_disp_var)б
	 *         롣fn_array ˤ conf_obj Υ̾ꤹ뤳ȡ
	 */
	function chk_memshort_semantics(&$conf_obj, &$mem_num, &$error_str)
	{
		$sql_str = "SELECT member_number FROM mdb_meminfo WHERE" .
				   " member_short_name = " . GetApsString($conf_obj["fn_mem_op_short"]->m_disp_var) .
				   " AND status IN('normal','stop')";
		$db_result	= $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			array_push($error_str, "D207");		// Ǥʤ顼
			$conf_obj["fn_mem_op_short"]->m_error_flg = TRUE;
			return -1;
		}
		if ($db_result === NULL)							// 
		{
			array_push($error_str, "C020");		// ȿĤʤ顼
			$conf_obj["fn_mem_op_short"]->m_error_flg = TRUE;
			return 0;
		}

		$mem_num = $db_result[0]["member_number"];
		return 1;
	}

	/**
	 * ؿ̾get_ip_limit_info
	 *   IPɥ쥹¤conf_obj->m_disp_var
	 *         ˳Ǽ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return int		1ʤ0ԡ-1
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ξ conf_obj->m_disp_var ˥åȤ
	 */
	function get_ip_limit_info($mem_num, &$conf_obj, &$error_str)
	{
		$v4_res = $this->get_ipv4_limit_info($mem_num, $conf_obj, $error_str);
		if($v4_res < 0){
			return $v4_res;
		}
		$v6_res = $this->get_ipv6_limit_info($mem_num, $conf_obj, $error_str);
		if($v6_res < 0){
			return $v6_res;
		}
		if($v4_res == 0 && $v6_res == 0){
			array_push($error_str,
					   array($conf_obj["fn_mem_op_short"]->m_label_str, "D211"));
			$conf_obj["fn_mem_op_short"]->m_error_flg = TRUE;
			return 0;
		}
		return 1;
	}

	/**
	 * ؿ̾get_ipv4_limit_info
	 *   IPv4ɥ쥹¤conf_obj->m_disp_var
	 *         ˳Ǽ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return int		1ʤ0ԡ-1
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ξ conf_obj->m_disp_var ˥åȤ
	 */
	function get_ipv4_limit_info($mem_num, &$conf_obj, &$error_str)
	{
		// Ƽ»ȿIPɥ쥹³
		$sql_str	= "SELECT ip_network_number FROM sdb_ip_member" .
					  " WHERE member_number = " . $mem_num;
		$db_result	= $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			// ԥ顼
			array_push($error_str, "D210");
			return -1;
		}
		if ($db_result === NULL)							// 
		{
			return 0;
		}

		// IPɥ쥹³Ǽ
		$limit_ls = array();
		foreach ($db_result as $value)
		{
			if ($value["ip_network_number"] != "")
				array_push($limit_ls, $value["ip_network_number"]);
		}
		if (count($limit_ls) < 1)
		{
			return 0;
		}

		$conf_obj["fn_mem_ipv4_limit"]->set_disp_var($limit_ls);
		return 1;
	}

	/**
	 * ؿ̾get_ipv6_limit_info
	 *   IPɥ쥹¤conf_obj->m_disp_var
	 *         ˳Ǽ롣
	 * @param  mem_num							ȿֹ					(i)
	 * @param  conf_obj		RegAppDispConf		ե󥯥饹			(i/o)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return int		1ʤ0ԡ-1
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ξ conf_obj->m_disp_var ˥åȤ
	 */
	function get_ipv6_limit_info($mem_num, &$conf_obj, &$error_str)
	{
		// Ƽ»ȿIPɥ쥹³
		$sql_str	= "SELECT ip_network_number FROM sdb_ipv6_member" .
					  " WHERE member_number = " . $mem_num;
		$db_result	= $this->reg_db->dbapi_query($sql_str);
		if ($db_result === FALSE)							// 顼
		{
			// ԥ顼
			array_push($error_str, "D210");
			return -1;
		}
		if ($db_result === NULL)							// 
		{
			return 0;
		}

		// IPɥ쥹³Ǽ
		$limit_ls = array();
		foreach ($db_result as $value)
		{
			if ($value["ip_network_number"] != "")
				array_push($limit_ls, $value["ip_network_number"]);
		}
		if (count($limit_ls) < 1)
		{
			return 0;
		}

		$conf_obj["fn_mem_ipv6_limit"]->set_disp_var($limit_ls);
		return 1;
	}

	/**
	 * ؿ̾delete_ip_limit
	 *   IPɥ쥹¤Ͽ롣
	 * @param  mem_short	string				ȿά					(i)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return TRUE
	 *         ԡERR_LIMIT_DB_ACCESS		DB顼
	 *               ERR_LIMIT_MEM_SEARCH		normalMEMBERʤ
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function delete_ip_limit($mem_short, &$error_str)
	{
		$lock_sql	= "SELECT member_number FROM mdb_meminfo" .
					  " WHERE member_short_name = " . GetApsString($mem_short) .
					  " AND status IN('normal','stop') FOR UPDATE";

		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D000");					// 顼ȯޤ
			return ERR_LIMIT_DB_ACCESS;
		}
		// mdb_mem_info å
		$db_result = $this->reg_db->dbapi_query_lock($lock_sql);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D000");					// 顼ȯޤ
			return ERR_LIMIT_DB_ACCESS;
		}
		if ($db_result === NULL)							// 
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D210");					// ԥ顼
			return ERR_LIMIT_MEM_SEARCH;
		}

		// IPɥ쥹²
		$mem_num	= $db_result[0]["member_number"];
		if ($mem_num == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D210");					// ԥ顼
			return ERR_LIMIT_MEM_SEARCH;
		}
		
		// IPv4ɥ쥹²
		$db_result = $this->delete_ipv4_limit($mem_num);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D000");					// 顼ȯޤ
			return ERR_LIMIT_DB_ACCESS;
		}

		// IPv6ɥ쥹²
		$db_result = $this->delete_ipv6_limit($mem_num);
		if ($db_result === FALSE)							// 顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D000");					// 顼ȯޤ
			return ERR_LIMIT_DB_ACCESS;
		}

		$this->reg_db->REGDB_commit();
		return TRUE;
	}

	/**
	 * ؿ̾delete_ipv4_limit
	 *   IPv4ɥ쥹¤Ͽ롣
	 * @param  mem_short	string				ȿά					(i)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return TRUE
	 *         ԡFALSE		DB顼
	 */
	function delete_ipv4_limit($mem_num)
	{
		$del_sql	= "DELETE FROM sdb_ip_member WHERE member_number = " . $mem_num;
		return $this->reg_db->dbapi_query_delete($del_sql);
	}

	/**
	 * ؿ̾delete_ipv6_limit
	 *   IPv6ɥ쥹¤Ͽ롣
	 * @param  mem_short	string				ȿά					(i)
	 * @param  error_str	string[]			顼ɳǼ		(i/o)
	 * @return TRUE
	 *         ԡFALSE		DB顼
	 */
	function delete_ipv6_limit($mem_num)
	{
		$del_sql	= "DELETE FROM sdb_ipv6_member WHERE member_number = " . $mem_num;
		return $this->reg_db->dbapi_query_delete($del_sql);
	}

	//-----------------------------------------------------------------------
	// public methods()
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾write_ip_limit_log
	 *   ƤϤ
	 * @param  clerk_id			string			̳ôID		(i)
	 * @param  mem_short		string			ȿά			(i)
	 */
	function write_ip_limit_log($clerk_id, $mem_short)
	{
		RegV6pcLog::info("[ins0402]::[force delete member ip filter]::[client " .
						 getenv("REMOTE_ADDR") . "] user " . $clerk_id .
						 ": member[" . $mem_short . "] all delete");
	}
}
?>
