<?php
/**
 * $Id: ins_alloccidr_class.php,v 1.5 2004/02/27 09:05:11 wtetsuya Exp $
 * 
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("RegIpAddressUtil.php");		// IPɥ쥹桼ƥƥ饹
require_once("RegIpv6AddressUtil.php");		// IPɥ쥹桼ƥƥ饹
require_once("DBAPIWrapper.php");			// DB API
require_once("DBAPI_CIDR.php");				// DB API CIDRϢ饹
require_once("RegAppDateUtil.php");			// վ桼ƥƥ饹
?>

<?php
/**
 * ̾  ins_alloccidr_class
 *   
 */
class ins_alloccidr_class
{
	var $reg_db;				// DBAPI_IMPLE
	var $reg_db_cidr;			// DBAPI_MEMINFO

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾ins_alloccidr_class
	 *   ins_alloccidr_class饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function ins_alloccidr_class($db)
	{
		$this->reg_db = $db;
		$this->reg_db_cidr = new DBAPI_CIDR($this->reg_db);
	}

	//-----------------------------------------------------------------------
	// public methods(select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾chk_block_creatable
	 *   IPɥ쥹֥åϿǽݤå
	 * @param  cidr_block	string	ɥ쥹֥å		(i)
	 * @return 1Ͽǽ0ϿԲ(ʣ)-1DB顼-2ϿԲĥ֥å
	 */
	function chk_block_creatable($cidr_block)
	{
		// config γ꿶Բĥ֥åå
		if ($this->chk_conf_unallocatable($cidr_block) == FALSE)
		{
			return -2;	// ʣξΤԵĤȤ롣
		}
		// DBϿͥå
        $sql_fmt = <<<_END_
SELECT COUNT(*) FROM cidr_allocated_block 
WHERE ip_network_number >>= cidr %s
      OR cidr %s >>= ip_network_number
_END_;
		$sql_str = sprintf($sql_fmt, 
			GetApsString($cidr_block),
			GetApsString($cidr_block)
		);
		$count = $this->reg_db->dbapi_query_count($sql_str);
		if ($count === FALSE)
		{
			return -1;			// DB顼
		}
		if ($count > 0)
		{
			return 0;			// ʣ
		}

		return 1;				// ʣʤ
	}

	//-----------------------------------------------------------------------
	// public methods(select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾register_cidr_block
	 *   ɥ쥹֥åmdb_allocated_block,cidr_unallocate_blockϿ
	 *         ҥȥɲä롣
	 * @param  conf_obj		RegAppDispConf	ե󥯥饹			(i)
	 * @param  clerk_id		string									(i)
	 * @param  error_str	string[]		顼ɳǼ		(i/o)
	 * @return 1Ͽǽ0ϿԲ(ʣ)-1DB顼-2ϿԲĥ֥å
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function register_cidr_block($conf_obj, $clerk_id, &$error_str)
	{
		//-------------------------------------------------------------------
		// Ͽǡ
		//-------------------------------------------------------------------
		// ѾDBǼѴ
		$init_date = RegAppDateUtil::makedate_db_by_form($conf_obj["fn_alloc_date"]->m_disp_var);

		if ($init_date == "")
		{
			return -1;		// 顼
		}
		// ǽ()
		$last_date	= RegAppDateUtil::make_current_date_db();	// 

		// MDBҥȥѹ¤κ
		$history_tbl = new MDB_UPDATE_INFO(
							$clerk_id,
							$last_date,
							null,
							"ins0201_add");

		//-------------------------------------------------------------------
		// ǡǽå
		//-------------------------------------------------------------------
		// config γ꿶Բĥ֥åå
		if ($this->chk_conf_unallocatable($cidr_block) == FALSE)
		{
			array_push($error_str, "C031");		// 꿶ػߥ顼
			return FALSE;
		}

		//-------------------------------------------------------------------
		// DBϿ
		//-------------------------------------------------------------------
		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D206");		// ϿǤʤ顼
			return FALSE;
		}

		$result = $this->reg_db_cidr->create_cidr_allocated_block(
										$conf_obj["fn_alloc_block"]->m_disp_var,
										$init_date,
										$conf_obj["fn_blockfrom"]->m_disp_var,
										"",
										$history_tbl);
		if ($result === FALSE)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D206");		// Ͽԥ顼
			return FALSE;
		}
		if ($result == 0)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C030");		// Ͽѥ顼
			return FALSE;
		}

		$result = $this->reg_db_cidr->create_cidr_unallocate_block(
										$conf_obj["fn_alloc_block"]->m_disp_var,
										$init_date,
										"",
										"unallocated",
										"",
										$history_tbl);
		if ($result === FALSE || $result == 0)		// unallocateΤϿԤϥ顼
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "D206");		// Ͽԥ顼
			return FALSE;
		}

		// ߥå
		$this->reg_db->REGDB_commit();
		return TRUE;
	}

	/**
	 * ؿ̾chk_conf_unallocatable
	 *   IPɥ쥹֥åϿԲĤꤵƤʤå
	 *         RegCnfCommon.php  $cnf_unallocatable_block ˽ʣϿԲ
	 * @param  cidr_block	string	ɥ쥹֥å		(i)
	 * @return boolean		TRUEϿǽFALSEϿԲ(ʣ)
	 */
	function chk_conf_unallocatable($cidr_block)
	{
		// config γ꿶Բĥ֥åå
		include("config/RegCnfCommon.php");
		if (is_array($cnf_unallocatable_block))
		{
			for ($cnt = 0; $cnt < count($cnf_unallocatable_block); $cnt++)
			{
				$result = RegIpv6AddressUtil::chk_ipblock_overlap($cidr_block, $cnf_unallocatable_block[$cnt]);
				if (!($result === 0 || $result === -1))		// Ǥ -1 顼̵롣
				{
					return FALSE;	// ʣξΤԵĤȤ롣
				}
			}
		}
		return TRUE;
	}
}
