<?php
/**
 * $Id: ins_cidr_briefing.php,v 1.3 2004/02/12 12:40:07 wtetsuya Exp $
 * 꿶֥åѾɽѥ١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPIWrapper.php");			// DB API
require_once("DBAPI_CIDR.php");				// DB API
?>

<?php
/**
 * ̾  ins_cidr_briefing
 *   
 */
class ins_cidr_briefing
{
	//------------------------------------------------------------------------
	// ѿ
	//------------------------------------------------------------------------
	//--- DB ---//
	var $reg_db;						// DBAPI_IMPLE
	var $reg_db_cidr;					// DBAPI_CIDR

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾ins_cidr_briefing
	 *   ins_cidr_briefing饹󥹥ȥ饯
	 * @param  $db				DBAPI_IMPLE(connectѤǤ뤳)
	 */
	function ins_cidr_briefing($db)
	{
		$this->reg_db = $db;
		$this->reg_db_cidr = new DBAPI_CIDR($this->reg_db);
	}

	//-----------------------------------------------------------------------
	// public methods(db select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_allocate_count
	 *   ̥쥸ȥ꤫Ѿ줿ɥ쥹֥å
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return int			Ѿ줿ɥ쥹֥å
	 *         FALSE		ԡ0ޤ
	 */
	function get_allocate_count(&$error_str)
	{
		$sql_str	= "SELECT COUNT(*) FROM cidr_allocated_block";
		$db_result	= $this->reg_db->dbapi_query_count($sql_str);
		if($db_result === FALSE)				//DB顼
		{
			array_push($error_str, "D200");		// Ǥʤ顼
			return FALSE;
		}
		if($db_result == 0)						// 0
		{
			array_push($error_str, "D203");		// 0泌顼
			return FALSE;
		}
		return $db_result;
	}

	/**
	 * ؿ̾get_allocate_list
	 *   ̥쥸ȥ꤫Ѿ줿ɥ쥹֥åꥹȤ
	 *         "ip_network_number""block_from" 롣
	 * @param  error_str	string[]		顼ɳǼ		(i/o)
	 * @param  limit		int									(i)
	 *										(default="")
	 * @param  offset		int				ϥǥå(0)		(i)
	 *										(default="")
	 * @return CIDR_ALLOCATED_BLOCK[]	Ѿ֥å¤Τ
	 *         FALSE			
	 * @desc   Ǥ CIDR_ALLOCATED_BLOCK arrayȤʤ롣
	 *         顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_allocate_list(&$error_str, $limit="", $offset="")
	{
		// CIDR_ALLOCATED_BLOCK "ip_network_number", "block_from" 
		$alloc_tbl = $this->reg_db_cidr->get_cidr_allocated_block(
						"*",
						array("ip_network_number", "block_from"),
						$limit, $offset);
		if ($alloc_tbl === FALSE)
		{
			array_push($error_str, "D200");		// Ǥʤ顼
			return FALSE;
		}
		if ($alloc_tbl === NULL)				// 0
		{
			array_push($error_str, "D203");		// 0泌顼
			return FALSE;
		}

		return $alloc_tbl;
	}

	/**
	 * ؿ̾get_briefing_list
	 *   ꤵ줿ɥ쥹ϰϤ˴ޤޤ륢ɥ쥹֥åѾְ
	 * @param  alloc_block	string		̥쥸ȥ꤫ΰѾ֥å	(i)
	 * @param  error_str	string[]	顼ɳǼ				(i/o)
	 * @return BRIEFING_LIST_TBL[]	Ѿְ¤Τ
	 *         FALSE			
	 * @desc   Ǥ BRIEFING_LIST_TBL arrayȤʤ롣
	 *         顼ˤ $this->m_err_code_array ˥顼(ʣξ
	 *         礢)Ǽ롣
	 *         BRIEFING_LIST_TBL = array ("ip_network_number" => "",
	 *                                    "status"            => "")
	 */
	function get_briefing_list($alloc_block, &$error_str)
	{
		// CIDR_BLOCK  $alloc_block ϰ ip_network_number 
		$cidr_tbl =
			$this->reg_db_cidr->select_included_cidr_block(
								$alloc_block, array("ip_network_number"));
		if ($cidr_tbl === FALSE)
		{
			array_push($error_str, "D200");			// Ǥʤ顼
			return FALSE;
		}

		// CIDR_UNALLOCATE_BLOCK  $alloc_block ϰ ip_network_number,status 
		$unalloc_tbl = 
			$this->reg_db_cidr->select_included_cidr_unallocate_block(
									$alloc_block, array("ip_network_number", "status"));
		if ($unalloc_tbl === FALSE)
		{
			array_push($error_str, "D200");		// Ǥʤ顼
			return FALSE;
		}
		if ($unalloc_tbl === NULL && $cidr_tbl === NULL)		// 0
		{
			array_push($error_str, "D203");		// 0泌顼
			return FALSE;
		}

		// 꿶֥åCIDR_BLOCKˤꥹȤϿ
		$briefing_ls = array();
		for ($cnt = 0; $cnt < count($cidr_tbl); $cnt++)
		{
			$tmp_array = array(
						"ip_network_number"	=>	$cidr_tbl[$cnt]->ip_network_number,
						"status"			=>	"allocate");	// allocateϿ
			array_push($briefing_ls, $tmp_array);
		}

		// ̤꿶ꡢֵѥ֥åCIDR_UNALLOCATE_BLOCKˤꥹȤϿ
		for ($cnt = 0; $cnt < count($unalloc_tbl); $cnt++)
		{
			$tmp_array = array(
						"ip_network_number"	=>	$unalloc_tbl[$cnt]->ip_network_number,
						"status"			=>	$unalloc_tbl[$cnt]->status);
			array_push($briefing_ls, $tmp_array);
		}

		return $briefing_ls;
	}
}
