<?php
/**
 * $Id: ins_clerk_class.php,v 1.2 2004/02/27 09:05:11 wtetsuya Exp $
 * sdb_clerk_info ѤΥ١饹
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("DBAPIWrapper.php");			// DB API
require_once("DBAPI_CLERK.php");			// DB API clerkϢ饹
require_once("RegAppClerkDBUtil.php");		// clerkϢDB桼ƥƥ
require_once("RegAppDispConf.php");			// ̾󥯥饹
?>

<?php
/**
 * ̾  ins_clerk_class
 *   
 */
class ins_clerk_class
{
	var $reg_db;				// DBAPI_IMPLE
	var $reg_db_clerk;			// DBAPI_CLERK
	var $clerk_util;			// clerkϢDB桼ƥƥ

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾ins_clerk_class
	 *   ins_clerk_class饹󥹥ȥ饯
	 * @param  $db		DBAPI_IMPLE
	 */
	function ins_clerk_class($db)
	{
		$this->reg_db = $db;
		$this->reg_db_clerk = new DBAPI_CLERK($this->reg_db);
		$this->clerk_util	= new RegAppClerkDBUtil();
	}

	//-----------------------------------------------------------------------
	// public methods(insert)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾register_clerk_info
	 *   ̳ôԤɲä
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return 
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function register_clerk_info($conf_obj, &$error_str)
	{
		// ͣģϿ
		$newpass = md5($conf_obj["fn_clerkpass1"]->m_disp_var);

		// ¥ե饰
		$auth_flg = "0";
		if (strcmp($conf_obj["fn_clerklevel"]->m_disp_var, "fv_clerk_auth") == 0)
		{
			$auth_flg = "1";		// ԤȤϿ
		}

		// ѹ¤κ
		$clerk_tbl = new SDB_CLERK_INFO(
							$conf_obj["fn_clerkid"]->m_disp_var,
							$conf_obj["fn_clerkfull"]->m_disp_var,
							$auth_flg);

		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "D206");		// ϿǤʤ顼
			return FALSE;
		}
		// ôԾϿ
		$result = $this->reg_db_clerk->create_clerk_info($clerk_tbl, $newpass);
		if ($result === FALSE || $result != 1)
		{
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C105");		// ϿǤʤ顼
			return FALSE;
		}
		// ߥå
		$this->reg_db->REGDB_commit();
		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(select)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_clerk_count
	 *   ̳ôԤϿ롣
	 * @param  error_str	string[]		顼ɳǼ	(i/o)
	 * @return int			̳ôԿ
	 *         FALSE		
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         1̤⥨顼Ȥ
	 */
	function get_clerk_count(&$error_str)
	{
		include("config/RegCnfCommon.php");
		$where_str = "";
		if ($cnf_built_in_account != "")
		{
			$where_str = " WHERE clerk_id != " . GetApsString($cnf_built_in_account);
		}

		// DB̳ôԿ
		$sql_str	= "SELECT COUNT(*) FROM sdb_clerk_info" . $where_str;
		$db_result	= $this->reg_db->dbapi_query_count($sql_str);
		if($db_result === FALSE)						//DB顼
		{
			array_push($error_str, "C100");		// Ǥʤ顼
			return FALSE;
		}
		return $db_result;
	}

	/**
	 * ؿ̾get_clerk_list
	 *   Ƥζ̳ôԤ clerk_id,full_name,auth_level 
	 * @param  error_str	string[]		顼ɳǼ		(i/o)
	 * @param  limit		int									(i)
	 *										(default="")
	 * @param  offset		int				ϥǥå(0)		(i)
	 *										(default="")
	 * @return db_result	̳ôԾDBͤ
	 *         FALSE		
	 * @desc   Ǥ SDB_CLERK_INFO arrayȤʤ롣
	 *         顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function get_clerk_list(&$error_str, $limit="", $offset="")
	{
		// offset0̤ξϥӥȥ󥢥ȤΤߤξarray()֤
		// ̾ϸƤӽФʤǰΤåƤ
		if ($offset < 0)
		{
			$clerk_tbl = array();
			return $clerk_tbl;
		}

		include("config/RegCnfCommon.php");
		$where_str = "";
		if ($cnf_built_in_account != "")
		{
			$where_str = " WHERE clerk_id != " . GetApsString($cnf_built_in_account);
		}
		$sql_str	= "SELECT clerk_id, full_name, auth_level FROM sdb_clerk_info" . $where_str;
		if ($limit != "")
		{
			$sql_str .= " LIMIT " . $limit;
		}
		if ($offset != "")
		{
			$sql_str .= " OFFSET " . $offset;
		}

		$clerk_tbl	= $this->reg_db->dbapi_query($sql_str);
		if ($clerk_tbl === FALSE)
		{
			array_push($error_str, "C100");		// Ǥʤ顼
			return FALSE;
		}
		if ($clerk_tbl === NULL)
		{
			$clerk_tbl = array();
		}
		return $clerk_tbl;
	}

	/**
	 * ؿ̾get_clerk_info
	 *   ̳ôԾconf_obj  m_disp_var ˳Ǽ
	 * @param  conf_obj		RegAppDispConf[]	ե󥯥饹	(i/o)
	 * @param  fn_array		string[]			̾	(i)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return boolean	TRUEFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ôID(conf_obj["fn_clerkid"]->m_disp_var)б
	 *         롣fn_array ˤ conf_obj Υ̾ꤹ뤳ȡ
	 *
	 *         ex)wtetsuya  full_name  auth_level
	 *         $conf_obj["fn_clerkid"]->m_disp_var = "wtetsuya";
	 *         get_clerk_info($conf_obj, array("fn_clerkfull", "fn_clerklevel"), $err)
	 */
	function get_clerk_info(&$conf_obj, $fn_array, &$error_str)
	{
		if (!is_array($fn_array))
		{
			return FALSE;
		}

		$cols = array();
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			array_push($cols, $this->clerk_util->fn_col_tbl[$fn_array[$fn_cnt]]);
		}

		// ǥե͡ࡢ¾
		$clerk_tbl = $this->reg_db_clerk->get_clerk_info(
								$conf_obj["fn_clerkid"]->m_disp_var,
								$cols);
		if ($clerk_tbl === NULL)
		{
			array_push($error_str, "C100");		// Ǥʤ顼
			array_push($error_str, "D100");		// ǽꥨ顼
			return FALSE;
		}
		if ($clerk_tbl === FALSE)
		{
			array_push($error_str, "C100");		// Ǥʤ顼
			return FALSE;
		}

		//   conf_obj ˳Ǽ
		for ($fn_cnt = 0; $fn_cnt < count($fn_array); $fn_cnt++)
		{
			$conf_obj[$fn_array[$fn_cnt]]->set_disp_var($clerk_tbl[0]->{$this->clerk_util->fn_col_tbl[$fn_array[$fn_cnt]]});
		}

		return TRUE;
	}

	/**
	 * ؿ̾get_clerk_pass
	 *   ̳ôԤθߥѥɤ
	 * @param  clerk_id		string			̳ôԣɣ			(i)
	 * @return stringѥ()FALSE
	 */
	function get_clerk_pass($clerk_id)
	{
		$result = $this->reg_db_clerk->get_clerk_passwd($clerk_id);
		// ³顼⣰ NULLˤʤ뤬ǰΤFALSEå
		if ($result === FALSE || $result === NULL)	// ³ or 0
		{
			return FALSE;
		}
		return $result;
	}

	//-----------------------------------------------------------------------
	// public methods(update)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾save_clerk_fullname
	 *   ̳ôԤΥե͡򹹿
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹		(i)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return boolean	TRUEFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ̳ôԣɣ(["fn_clerkid"])ȥե͡(["fn_clerkfull"])
	 *         ꤷ RegAppDispConf ˻ꤹ뤳ȡ
	 */
	function save_clerk_fullname($conf_obj, &$error_str)
	{
		// ѹ¤κ
		$clerk_tbl = new SDB_CLERK_INFO(
							$conf_obj["fn_clerkid"]->m_disp_var,
							$conf_obj["fn_clerkfull"]->m_disp_var,
							"");

		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "C103");		// Ǥʤ顼
			return FALSE;
		}

		// ե͡򹹿
		$result = $this->reg_db_clerk->save_clerk_info(
									$clerk_tbl,
									array("full_name"));
		if ($result === FALSE || $result != 1)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C103");		// Ǥʤ顼
			return FALSE;
		}
		// ߥå(͡)
		$this->reg_db->REGDB_commit();
		return TRUE;
	}

	/**
	 * ؿ̾save_clerk_pass
	 *   ̳ôԤΥѥɤѹ
	 * @param  conf_obj		RegAppDispConf[]	̾󥯥饹		(i)
	 * @param  error_str	string[]			顼ɳǼ	(i/o)
	 * @return boolean	TRUEFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 *         ̳ôԣɣ(["fn_clerkid"])ȿѥ(["fn_clerkpass1"])
	 *         ꤷ RegAppDispConf ˻ꤹ뤳ȡ
	 */
	function save_clerk_pass($conf_obj, &$error_str)
	{
		// ͣģ
		$newpass = md5($conf_obj["fn_clerkpass1"]->m_disp_var);

		// ȥ󥶥󳫻
		if ($this->reg_db->REGDB_begin() == FALSE)
		{
			array_push($error_str, "C103");		// Ǥʤ顼
			return FALSE;
		}

		// ѥɤ򹹿
		$result = $this->reg_db_clerk->save_clerk_passwd(
									$conf_obj["fn_clerkid"]->m_disp_var,
									$newpass);
		if ($result === FALSE || $result != 1)
		{
			// Хå
			$this->reg_db->REGDB_rollback();
			array_push($error_str, "C103");		// Ǥʤ顼
			return FALSE;
		}
		// ߥå(͡)
		$this->reg_db->REGDB_commit();
		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(delete)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾delete_clerk_info
	 *   ̳ôԤ
	 * @param  clerk_id		string			̳ôID			(i)
	 * @param  error_str	string[]		顼ɳǼ	(i/o)
	 * @return boolean	TRUEFALSE
	 * @desc   顼ˤ error_code ˥顼(ʣξ礢)Ǽ롣
	 */
	function delete_clerk_info($clerk_id, &$error_str)
	{
		// Ƕ̳ôԤκԤ(åƤ)
		if ($this->reg_db_clerk->delete_clerk_info($clerk_id) == FALSE)
		{
			array_push($error_str, "C102");
			return FALSE;
		}
		return TRUE;
	}

	//-----------------------------------------------------------------------
	// public methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾set_paging_data
	 *   ins_0401.php ѤPOST,GETѥ᡼RegAppDispConf˥åȤ롣
	 *         POST,GETǡ򸵤˾(fn_cur_page,fn_item_num)Ԥ
	 * @param  paging_conf		RegAppDispConf[]	ե󥯥饹	(i/o)
	 *												ؿǽԤ
	 * @desc   ins_0401.php ̤ݤɬפȤʤǡ
	 */
	function set_paging_data(&$paging_conf)
	{
		include("config/RegCnfCommon.php");		// ̥ƥե

		// ǧѾ󥯥饹
		$paging_conf = array(
			"fn_cur_page"	=>	new RegAppDispConf(),	// ߥڡֹ
			"fn_item_num"	=>	new RegAppDispConf(),	// ڡΥƥ
		);

		if (strtoupper($_SERVER["REQUEST_METHOD"]) == "POST")
		{
			$in_data	= $_POST;
			$set_func	= "set_post_var";
		}
		else
		{
			$in_data	= $_GET;
			$set_func	= "set_get_var";
		}

		//----- ߥڡֹ -----//
		if (isset($in_data["fn_cur_page"]))
		{
			$paging_conf["fn_cur_page"]->$set_func("fn_cur_page");
			if ((ereg("^[0-9]+$", $paging_conf["fn_cur_page"]->m_disp_var) == FALSE) || ($paging_conf["fn_cur_page"]->m_disp_var < 1))
				$paging_conf["fn_cur_page"]->set_disp_var(1);
			else
				$paging_conf["fn_cur_page"]->set_disp_var((int)$paging_conf["fn_cur_page"]->m_disp_var);
		}
		else
		{
			$paging_conf["fn_cur_page"]->set_disp_var(1);
		}

		//----- ڡƥ -----//
		if (isset($in_data["fn_item_num"]))
		{
			$paging_conf["fn_item_num"]->$set_func("fn_item_num");
			if ((ereg("^[0-9]+$", $paging_conf["fn_item_num"]->m_disp_var) == FALSE) || ($paging_conf["fn_item_num"]->m_disp_var < 1))
				$paging_conf["fn_item_num"]->set_disp_var($cnf_clerk_list);
			else
				$paging_conf["fn_item_num"]->set_disp_var((int)$paging_conf["fn_item_num"]->m_disp_var);
		}
		else
		{
			$paging_conf["fn_item_num"]->set_disp_var($cnf_clerk_list);
		}
	}

	/**
	 * ؿ̾create_clerkls_get_link
	 *   ôɲáѤGET LINK롣
	 * @param  paging_conf		RegAppDispConf[]	ڡ󥰾	(i)
	 * @param  link_file		string				ץ̾	(i)
	 * @return GET LINK
	 */
	function create_clerkls_get_link($paging_conf, $link_file)
	{
		$get_link = "";
		if ($paging_conf["fn_item_num"]->m_disp_var != "")
		{
			$get_link = "fn_item_num=" . urlencode($paging_conf["fn_item_num"]->m_disp_var);
		}
		if ($paging_conf["fn_cur_page"]->m_disp_var != "")
		{
			if ($get_link == "")
			{
				$get_link = "fn_cur_page=" . urlencode($paging_conf["fn_cur_page"]->m_disp_var);
			}
			else
			{
				$get_link .= "&amp;fn_cur_page=" . urlencode($paging_conf["fn_cur_page"]->m_disp_var);
			}
		}

		if ($get_link == "")
		{
			$get_link = $link_file;
		}
		else
		{
			$get_link = $link_file . "?" . $get_link;
		}
		return $get_link;
	}

	/**
	 * ؿ̾create_clerkls_hidden
	 *   ôɲáѤhidden롣
	 * @param  paging_conf		RegAppDispConf[]	ڡ󥰾	(i)
	 * @return HIDDEN
	 */
	function create_clerkls_hidden($paging_conf)
	{
		$post_str = "";
		if ($paging_conf["fn_item_num"]->m_disp_var != "")
		{
			$paging_conf["fn_item_num"]->conv_value_htmlstr();
			$post_str .= "<input type=\"hidden\" name=\"fn_item_num\" value=\"" . $paging_conf["fn_item_num"]->m_disp_var . "\">\n";
		}
		if ($paging_conf["fn_cur_page"]->m_disp_var != "")
		{
			$paging_conf["fn_cur_page"]->conv_value_htmlstr();
			$post_str .= "<input type=\"hidden\" name=\"fn_cur_page\" value=\"" . $paging_conf["fn_cur_page"]->m_disp_var . "\">\n";
		}
		return $post_str;
	}
}
