<?php
//$Id: DBAPI_APPLY.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
require_once("mdb_common.php");
require_once("sdb_apply_info.php");

class DBAPI_APPLY extends DBAPI_BASE
{
  /**
  * DBAPI_APPLY
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_APPLY($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * get_apply_info
  * @desc 
  * @param No
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return SDB_APPLY_INFO¤(array)
  */
  function get_apply_info($accept_id, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,apply_date,clerk_id,apply_kind_id,member_number,status,settlement_id,send_person,settlement_date,charge_flag,note,final_reply";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetApplyInfo");
    }
    $debugParam = array($accept_id);
    $this->_debug_log("GetApplyInfo", $debugParam);
    $this->result = GetApplyInfo($this->con, $accept_id, $selcol, $ext);
    $ret = $this->_dbapi_return("GetApplyInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetApplyInfo");
    }
    return $ret;
  }
  
  /**
  * search_apply_info
  * @desc ˥ޥå뿽
  * @param (stringǻ)
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return SDB_APPLY_INFO¤(array)
  */
  function search_apply_info($condition, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,apply_date,clerk_id,apply_kind_id,member_number,status,settlement_id,send_person,settlement_date,charge_flag,note,final_reply";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SearchApplyInfo");
    }
    $debugParam = array($condition);
    $this->_debug_log("SearchApplyInfo", $debugParam);
    $this->result = SearchApplyInfo($this->con, $condition, $selcol, $ext);
    $ret = $this->_dbapi_return("SearchApplyInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SearchApplyInfo");
    }
    return $ret;
  }
  
  /**
  * count_apply_info
  * @desc ˥ޥåSDB_APPLY_INFOιԿ֤
  * @param 
  * @return Կ
  */
  function count_apply_info($condition="")
  {
    if($condition != "")
    {
      $condition = "where " . $condition;
    }
    if($this->profile_log)
    {
      $this->_pre_func("CountApplyInfo");
    }
    $debugParam = array($condition);
    $this->_debug_log("CountApplyInfo", $debugParam);
    $this->result = CountApplyInfo($this->con, $condition);
    $ret = $this->_dbapi_return("CountApplyInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CountApplyInfo");
    }
    return $ret;
  }
  
  /**
  * create_apply_info
  * @desc 򿷵
  * @param SDB_APPLY_INFO¤
  * @return true/false
  */
  function create_apply_info($sdb_apply_info)
  {
    if($this->profile_log)
    {
      $this->_pre_func("CreateApplyInfo");
    }
    $debugParam = array($sdb_apply_info);
    $this->_debug_log("CreateApplyInfo", $debugParam);
    $this->result = CreateApplyInfo($this->con, &$sdb_apply_info);
    $ret = $this->_dbapi_return("CreateApplyInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateApplyInfo");
    }
    return $ret;
  }
  
  /**
  * save_apply_info
  * @desc 򹹿
  * @param SDB_APPLY_INFO¤
  * @param ¸̾ȥǡ(array)
  * @return true/false
  */
  function save_apply_info($sdb_apply_info, $column_array="")
  {
    $selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        $selcol .= $value . ",";
      }
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "accept_id,apply_date,clerk_id,apply_kind_id,member_number,status,settlement_id,send_person,settlement_date,charge_flag,note,final_reply";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveApplyInfo");
    }
    $debugParam = array($sdb_apply_info);
    $this->_debug_log("SaveApplyInfo", $debugParam);
    $this->result = SaveApplyInfo($this->con, $sdb_apply_info, $selcol);
    $ret = $this->_dbapi_return("SaveApplyInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveApplyInfo");
    }
    return $ret;
  }
}

?>
