<?php
//$Id: DBAPI_IPNET.php,v 1.4 2004/02/27 10:32:21 wtetsuya Exp $
require_once("mdb_common.php");
require_once("mdb_ipnetinfo.php");

class DBAPI_IPNET extends DBAPI_BASE
{
  /**
  * DBAPI_IPNET
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_IPNET($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }
  
  /**
  * ؿmdb_ipnet_update
  * ƿĿǧȤƤMDBΥ쥳ɤ
  * @param$formǧƿĿ
  * @param$updateinfoMDB_UPDATE_INFO¤
  * @param$dateƻ(Ǥ)
  * @param$noteΡ(Ǥ)
  * @returntrueｪλ
  *          falseDB顼ȯ
  *          NO_COLUMN_SELECT(-1)SELECTʤˤǤʤä
  *          NO_RECORD_DELETE(-2)DELETEDELETEǤʤä
  *          NO_RECORD_INSERT(-3)INSERTINSERTǤʤä
  */
  function mdb_ipnet_update($form, $updateinfo, $date="", $note="")
  {
    if($this->profile_log)
    {
      $this->_pre_func("MDBIPNETUpdate");
    }
    $debugParam = array($form, $updateinfo);
    $this->_debug_log("MDBIPNETUpdate", $debugParam);
    $this->result = MDBIPNETUpdate($this->con, $form, $updateinfo, $date, $note);
    $ret = $this->_dbapi_return("MDBIPNETUpdate", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("MDBIPNETUpdate");
    }
    return $ret;
  }
  
  /**
  * get_ipnet_info
  * @desc IPNET
  * @param IPɥ쥹
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_IPNETINFO¤(array)
  */
  function get_ipnet_info($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "mail_address" || $value == "technical_responsibility")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,network_name,cidr_block,organization_jp,organization_en,postal_code_number,address_jp,address_en,initial_registration_date,last_update_date,note";
      $sub_selcol = "mail_address,technical_responsibility";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetIPNETInfo");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("GetIPNETInfo", $debugParam);
    $this->result = GetIPNETInfo($this->con, $ip_network_number, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("GetIPNETInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetIPNETInfo");
    }
    return $ret;
  }
  
  /**
  * get_ipnet_info_member_short_name
  * @desc ȿάΤIPNET
  * @param ȿά
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_IPNETINFO¤(array)
  */
  function get_ipnet_info_member_short_name($member_short_name, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "mail_address" || $value == "technical_responsibility")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= "net." . $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "net.ip_network_number,net.network_name,net.cidr_block,net.organization_jp,net.organization_en,net.postal_code_number,net.address_jp,net.address_en,net.initial_registration_date,net.last_update_date,net.note";
      $sub_selcol = "mail_address,technical_responsibility";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetIPNETInfoByMemberShortName");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("GetIPNETInfoByMemberShortName", $debugParam);
    $this->result = GetIPNETInfoByMemberShortName($this->con, $member_short_name, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("GetIPNETInfoByMemberShortName", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetIPNETInfoByMemberShortName");
    }
    return $ret;
  }
  
  /**
  * get_ipnet_info_ip_and_mem_num
  * @desc IPɥ쥹ȿֹ椫IPNET
  * @param IPɥ쥹
  * @param ȿֹ
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_IPNETINFO¤(array)
  */
  function get_ipnet_info_ip_and_mem_num($ipnet, $mem_num, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "mail_address" || $value == "technical_responsibility")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= "net." . $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "net.ip_network_number,net.network_name,net.cidr_block,net.organization_jp,net.organization_en,net.postal_code_number,net.address_jp,net.address_en,net.initial_registration_date,net.last_update_date,net.note";
      $sub_selcol = "mail_address,technical_responsibility";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetIPNETInfoByIPAndMemNum");
    }
    $debugParam = array($ipnet, $mem_num);
    $this->_debug_log("GetIPNETInfoByIPAndMemNum", $debugParam);
    $this->result = GetIPNETInfoByIPAndMemNum($this->con, $ipnet, $mem_num, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("GetIPNETInfoByIPAndMemNum", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetIPNETInfoByIPAndMemNum");
    }
    return $ret;
  }
  
  /**
  * count_ipnet_info
  * @desc ˥ޥåMDB_IPNETINFOιԿ
  * @param 
  * @return Կ
  */
  function count_ipnet_info($condition="")
  {
    if($condition != "")
    {
      $condition = "where " . $condition;
    }
    if($this->profile_log)
    {
      $this->_pre_func("CountIPNETInfo");
    }
    $debugParam = array($condition);
    $this->_debug_log("CountIPNETInfo", $debugParam);
    $this->result = CountIPNETInfo($this->con, $condition);
    $ret = $this->_dbapi_return("CountIPNETInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CountIPNETInfo");
    }
    return $ret;
  }
  
  /**
  * create_ipnet_info
  * @desc IPNET򿷵
  * @param MDB_IPNETINFO¤
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function create_ipnet_info($ipnetinfo, $updateinfo)
  {
    if(!is_array($ipnetinfo->technical_responsibility)){
      $ipnetinfo->technical_responsibility = array();
    }
    if(!is_array($ipnetinfo->mail_address)){
      $ipnetinfo->mail_address = array();
    }
    if($this->profile_log)
    {
      $this->_pre_func("CreateIPNETInfo");
    }
    $debugParam = array($ipnetinfo, $updateinfo);
    $this->_debug_log("CreateIPNETInfo", $debugParam);
    $this->result = CreateIPNETInfo($this->con, &$ipnetinfo, $updateinfo);
    $ret = $this->_dbapi_return("CreateIPNETInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateIPNETInfo");
    }
    return $ret;
  }
  
  /**
  * save_ipnet_info
  * @desc IPNET򹹿
  * @param MDB_IPNETINFO¤
  * @param MDB_UPDATE_INFO¤
  * @param ¸̾(array)
  * @return true/false
  */
  function save_ipnet_info($ipnetinfo, $updateinfo, $column_array="")
  {
    if(!is_array($ipnetinfo->technical_responsibility)){
      $ipnetinfo->technical_responsibility = array();
    }
    if(!is_array($ipnetinfo->mail_address)){
      $ipnetinfo->mail_address = array();
    }
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "mail_address" || $value == "technical_responsibility")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,network_name,cidr_block,organization_jp,organization_en,postal_code_number,address_jp,address_en,initial_registration_date,last_update_date,note";
      $sub_selcol = "mail_address,technical_responsibility";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveIPNETInfo");
    }
    $debugParam = array($ipnetinfo, $updateinfo);
    $this->_debug_log("SaveIPNETInfo", $debugParam);
    $this->result = SaveIPNETInfo($this->con, $ipnetinfo, $updateinfo, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("SaveIPNETInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveIPNETInfo");
    }
    return $ret;
  }
  
  /**
  * delete_ipnet_info
  * @desc IPNET
  * @param CIDR֥å(xxx.xxx.xxx.xxx/xx)
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function delete_ipnet_info($ip_network_number, $updateinfo)
  {
    if($this->profile_log)
    {
      $this->_pre_func("DeleteIPNETInfo");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("DeleteIPNETInfo", $debugParam);
    $this->result = DeleteIPNETInfo($this->con, $ip_network_number, $updateinfo);
    $ret = $this->_dbapi_return("DeleteIPNETInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DeleteIPNETInfo");
    }
    return $ret;
  }
  
  /**
  * delete_ipnet_info_member_short_name
  * @desc ȿάΤȤIPNET
  * @param ȿά
  * @param MDB_UPDATE_INFO¤
  * @return true/false
  */
  function delete_ipnet_info_member_short_name($member_short_name, $updateinfo)
  {
    if($this->profile_log)
    {
      $this->_pre_func("DeleteIPNETInfoByMemberShortName");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("DeleteIPNETInfoByMemberShortName", $debugParam);
    $this->result = DeleteIPNETInfoByMemberShortName($this->con, $member_short_name, $updateinfo);
    $ret = $this->_dbapi_return("DeleteIPNETInfoByMemberShortName", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("DeleteIPNETInfoByMemberShortName");
    }
    return $ret;
  }
  
  /**
  * select_ipnet_info_history
  * @desc IPNETι
  * @param CIDR֥å(xxx.xxx.xxx.xxx/xx)
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_UPDATE_INFO¤(array)
  */
  function select_ipnet_info_history($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      $selcol = implode(",", $column_array);
    }
    else
    {
      $selcol = "ip_network_number,start_sequence_number,end_sequence_number,update_person,update_date,accept_id,operation_id";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIPNETInfoHistory");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIPNETInfoHistory", $debugParam);
    $this->result = SelectIPNETInfoHistory($this->con, $ip_network_number, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectIPNETInfoHistory", $debugParam);
    if($this->profile_log){
      $this->_post_func("SelectIPNETInfoHistory");
    }
    return $ret;
  }
  
  /**
  * select_ipnet_info_history_update_date
  * @desc IPNETιդȤ˼
  * @param 
  * @param λ
  * @return CIDR֥å(array)
  */
  function select_ipnet_info_history_update_date($start, $end=null)
  {
    if($this->profile_log)
    {
      $this->_pre_func("SelectIPNETInfoHistoryByUpdateDate");
    }
    $debugParam = array($start, $end);
    $this->_debug_log("SelectIPNETInfoHistoryByUpdateDate", $debugParam);
    $this->result = SelectIPNETInfoHistoryByUpdateDate($this->con, $start, $end);
    $ret = $this->_dbapi_return("SelectIPNETInfoHistoryByUpdateDate", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIPNETInfoHistoryByUpdateDate");
    }
    return $ret;
  }
  
  /**
  * select_included_ipnet_info
  * @desc ϥɥ쥹˴ޤޤƤIPNET
  * @param CIDR֥å(xxx.xxx.xxx.xxx/xx)
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_IPNETINFO¤(array)
  */
  function select_included_ipnet_info($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "mail_address" || $value == "technical_responsibility")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,network_name,cidr_block,organization_jp,organization_en,postal_code_number,address_jp,address_en,initial_registration_date,last_update_date,note";
      $sub_selcol = "mail_address,technical_responsibility";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludedIPNETInfo");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIncludedIPNETInfo", $debugParam);
    $this->result = SelectIncludedIPNETInfo($this->con, $ip_network_number, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("SelectIncludedIPNETInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIncludedIPNETInfo");
    }
    return $ret;
  }
  
  /**
  * select_include_ipnet_info
  * @desc ϥɥ쥹ޤIPNET
  * @param CIDR֥å(xxx.xxx.xxx.xxx/xx)
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_IPNETINFO¤
  */
  function select_include_ipnet_info($ip_network_number, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "mail_address" || $value == "technical_responsibility")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "ip_network_number,network_name,cidr_block,organization_jp,organization_en,postal_code_number,address_jp,address_en,initial_registration_date,last_update_date,note";
      $sub_selcol = "mail_address,technical_responsibility";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectIncludeIPNETInfo");
    }
    $debugParam = array($ip_network_number);
    $this->_debug_log("SelectIncludeIPNETInfo", $debugParam);
    $this->result = SelectIncludeIPNETInfo($this->con, $ip_network_number, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("SelectIncludeIPNETInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectIncludeIPNETInfo");
    }
    return $ret;
  }
}

?>
