<?php
//$Id: DBAPI_MEMBER.php,v 1.5 2004/02/27 10:32:21 wtetsuya Exp $
require_once("mdb_common.php");
require_once("sequence_number.php");
require_once("mdb_mem.php");
require_once("sdb_member_info.php");

class DBAPI_MEMBER extends DBAPI_BASE
{
  /**
  * DBAPI_MEMBER
  * @desc 󥹥ȥ饯
  * @param DBAPI_IMPL֥
  * @return ʤ
  */
  function DBAPI_MEMBER($db="")
  {
    if($db == "")
    {
      $db = DBAPI::connect();
    }
    foreach(get_object_vars($db) as $key => $value)
    {
      $this->$key = $value;
    }
    return $this;
  }

  /**
  * ؿmdb_mem_update
  * Ƽ»ȿϿǧȤƼ»ȿκ̤꿶cidr֥åƼ»ȿ˳꿶
  * @param$formǧƼ»ȿϿ(SDB_FORM_OPR0102)
  * @param$cidrƼ»ȿ˳꿶cidr
  * @param$updateinfoMDB_UPDATE_INFO¤
  * @param$member_numberƼ»ȿȿֹ(ץ¦Ǽ)
  * @param$passwordƼ»ȿΥѥ
  * @param$date꿶(Ǥ)
  * @param$noteΡ(Ǥ)
  * @returntrueｪλ
  *          falseDB顼ȯ
  *          NO_COLUMN_SELECT(-1)SELECTʤˤǤʤä
  *          NO_RECORD_DELETE(-2)DELETEDELETEǤʤä
  *          NO_RECORD_INSERT(-3)INSERTINSERTǤʤä
  */
  function mdb_mem_update($form, $cidr, $updateinfo, $member_number, $password, $date="", $note="")
  {
    if($this->profile_log)
    {
      $this->_pre_func("MDBMEMUpdate");
    }
    $debugParam = array($form, $cidr, $updateinfo);
    $this->_debug_log("MDBMEMUpdate", $debugParam);
    $this->result = MDBMEMUpdate($this->con, $form, $cidr, $updateinfo, $member_number, $password, $date, $note);
    $ret = $this->_dbapi_return("MDBMEMUpdate", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("MDBMEMUpdate");
    }
    return $ret;
  }

  /**
  * get_member_passwd
  * @desc Ƽ»ȿѥɤ
  * @param ȿά
  * @return ѥ
  */
  function get_member_passwd($member_short_name)
  {
    if($this->profile_log)
    {
      $this->_pre_func("GetMemberPasswd");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("GetMemberPasswd", $debugParam);
    $this->result = GetMemberPasswd($this->con, $member_short_name);
    $ret = $this->_dbapi_return("GetMemberPasswd", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetMemberPasswd");
    }
    return $ret;
  }

  /**
  * save_member_passwd
  * @desc Ƽ»ȿѥɤ¸
  * @param ȿά
  * @param ѥ
  * @return
  */
  function save_member_passwd($member_short_name, $passwd)
  {
    if($this->profile_log)
    {
      $this->_pre_func("SaveMemberPasswd");
    }
    $debugParam = array($member_short_name, $passwd);
    $this->_debug_log("SaveMemberPasswd", $debugParam);
    $this->result = SaveMemberPasswd($this->con, $member_short_name, $passwd);
    $ret = $this->_dbapi_return("SaveMemberPasswd", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveMemberPasswd");
    }
    return $ret;
  }

  /**
  * get_member_info
  * @desc Ƽ»ȿ
  * @param ȿά
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_MEMINFO¤(array)
  */
  function get_member_info($member_short_name, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "notice_address")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "member_number,member_short_name,representative,applicant_mail_address,applicant_postal_code_number,applicant_address_jp,applicant_address_en,applicant_member_tel_number,applicant_member_fax_number,organization_jp,organization_en,mail_address,postal_code_number,address_jp,address_en,member_tel_number,member_fax_number,initial_registration_date,last_update_date,status,note";
      $sub_selcol = "notice_address";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("GetMEMInfo");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("GetMEMInfo", $debugParam);
    $this->result = GetMEMInfo($this->con, $member_short_name, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("GetMEMInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetMEMInfo");
    }
    return $ret;
  }

  /**
  * search_member_info
  * @desc ˥ޥåƼ»ȿ򸡺
  * @param (stringǻ)
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_MEMINFO¤(array)
  */
  function search_member_info($condition, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $sub_selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "notice_address")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "member_number,member_short_name,representative,applicant_mail_address,applicant_postal_code_number,applicant_address_jp,applicant_address_en,applicant_member_tel_number,applicant_member_fax_number,organization_jp,organization_en,mail_address,postal_code_number,address_jp,address_en,member_tel_number,member_fax_number,initial_registration_date,last_update_date,status,note";
      $sub_selcol = "notice_address";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SearchMEMInfo");
    }
    $debugParam = array($condition);
    $this->_debug_log("SearchMEMInfo", $debugParam);
    $this->result = SearchMEMInfo($this->con, $condition, $selcol, $sub_selcol, $ext);
    $ret = $this->_dbapi_return("SearchMEMInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SearchMEMInfo");
    }
    return $ret;
  }

  /**
  * count_member_info
  * @desc ˥ޥåԿ
  * @param 
  * @return Կ
  */
  function count_member_info($condition="")
  {
    if($condition != "")
    {
      $condition = "where " . $condition;
    }
    if($this->profile_log)
    {
      $this->_pre_func("CountMEMInfo");
    }
    $debugParam = array($condition);
    $this->_debug_log("CountMEMInfo", $debugParam);
    $this->result = CountMEMInfo($this->con, $condition);
    $ret = $this->_dbapi_return("CountMEMInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CountMEMInfo");
    }
    return $ret;
  }

  /**
  * create_member_info
  * @desc Ƽ»ȿ򿷵
  * @param MDB_MEMINFO¤
  * @param MDB_UPDATE_INFO¤
  * @param ѥ
  * @return true or false
  */
  function create_member_info(&$meminfo, $update_info, $password)
  {
    if(!is_array($meminfo->notice_address)){
      $meminfo->notice_address = array();
    }
    if($this->profile_log)
    {
      $this->_pre_func("CreateMEMInfo");
    }
    $debugParam = array($meminfo, $update_info);
    $this->_debug_log("CreateMEMInfo", $debugParam);
    $this->result = CreateMEMInfo($this->con, &$meminfo, $update_info, $password);
    $ret = $this->_dbapi_return("CreateMEMInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("CreateMEMInfo");
    }
    return $ret;
  }

  /**
  * save_member_info
  * @desc Ƽ»ȿ򹹿
  * @param MDB_MEMINFO¤
  * @param MDB_UPDATE_INFO¤
  * @param ¸̾ȥǡ(array)
  * @return true or false
  */
  function save_member_info($meminfo, $update_info, $column_array="")
  {
    if(!is_array($meminfo->notice_address)){
      $meminfo->notice_address = array();
    }
    $selcol = "";
    $sub_selcol = "";
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      foreach($column_array as $key => $value)
      {
        if($value == "notice_address")
        {
          $sub_selcol .= $value . ",";
        }
        else
        {
          $selcol .= $value . ",";
        }
      }
      $sub_selcol = rtrim($sub_selcol, "\x2c");
      $selcol = rtrim($selcol, "\x2c");
    }
    else
    {
      $selcol = "member_number,member_short_name,representative,applicant_mail_address,applicant_postal_code_number,applicant_address_jp,applicant_address_en,applicant_member_tel_number,applicant_member_fax_number,organization_jp,organization_en,mail_address,postal_code_number,address_jp,address_en,member_tel_number,member_fax_number,initial_registration_date,last_update_date,status,note";
      $sub_selcol = "notice_address";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SaveMEMInfo");
    }
    $debugParam = array($meminfo, $updateinfo);
    $this->_debug_log("SaveMEMInfo", $debugParam);
    $this->result = SaveMEMInfo($this->con, $meminfo, $update_info, $selcol, $sub_selcol);
    $ret = $this->_dbapi_return("SaveMEMInfo", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SaveMEMInfo");
    }
    return $ret;
  }

  /**
  * select_member_info_history
  * @desc Ƽ»ȿι
  * @param ȿά
  * @param ߤǡΥ̾(array)
  * @param LIMIT(1)
  * @param OFFSET(0)
  * @return MDB_MEM_UPDATE_HISTORY¤(array)
  */
  function select_member_info_history($member_short_name, $column_array="", $limit="", $offset="")
  {
    $selcol = "";
    $ext = "";
    //̾б
    if((is_array($column_array) == true) && (count($column_array) >= 1))
    {
      $selcol = implode(",", $column_array);
    }
    else
    {
      $selcol = "member_number,organization_jp,organization_en,status,update_person,update_date,accept_id,operation_id";
    }
    //OFFSETLIMITб
    if($limit != "" && $limit >= 1)  //LIMITλꤢ
    {
      $ext .= " LIMIT $limit ";
    }
    if($offset != "" && $offset >= 0)  //OFFSETλꤢ
    {
      $ext .= " OFFSET $offset ";
    }
    if($this->profile_log)
    {
      $this->_pre_func("SelectMEMInfoHistory");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("SelectMEMInfoHistory", $debugParam);
    $this->result = SelectMEMInfoHistory($this->con, $member_short_name, $selcol, $ext);
    $ret = $this->_dbapi_return("SelectMEMInfoHistory", $debugParam);
    if($this->profile_log){
      $this->_post_func("SelectMEMInfoHistory");
    }
    return $ret;
  }

  /**
  * select_member_info_history_update_date
  * @desc Ƽ»ȿιդȤ˼
  * @param 
  * @param λ
  * @return ȿֹ(array)
  */
  function select_member_info_history_update_date($start, $end=null)
  {
    if($this->profile_log)
    {
      $this->_pre_func("SelectMEMInfoInfoHistoryByUpdateDate");
    }
    $debugParam = array($start, $end);
    $this->_debug_log("SelectMEMInfoHistoryByUpdateDate", $debugParam);
    $this->result = SelectMEMInfoHistoryByUpdateDate($this->con, $start, $end);
    $ret = $this->_dbapi_return("SelectMEMInfoHistoryByUpdateDate", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("SelectMEMInfoHistoryByUpdateDate");
    }
    return $ret;
  }

  /**
  * get_member_short_name_by_member_number
  * @desc ȿֹ椫ȿάΤ
  * @param ȿֹ
  * @retrun ȿά
  */
  function get_member_short_name_by_member_number($member_number)
  {
    if($this->profile_log)
    {
      $this->_pre_func("GetMemberShortNameByMemberNumber");
    }
    $debugParam = array($member_number);
    $this->_debug_log("GetMemberShortNameByMemberNumber", $debugParam);
    $this->result = GetMemberShortNameByMemberNumber($this->con, $member_number);
    $ret = $this->_dbapi_return("GetMemberShortNameByMemberNumber", $debugParam);
    if($this->profile_log){
      $this->_post_func("GetMemberShortNameByMemberNumber");
    }
    return $ret;
  }

  /**
  * get_member_number_by_member_short_name
  * @desc ȿάΤȿֹ
  * @param ȿά
  * @retrun ȿֹ
  */
  function get_member_number_by_member_short_name($member_short_name)
  {
    if($this->profile_log)
    {
      $this->_pre_func("GetMemberNumberByMemberShortName");
    }
    $debugParam = array($member_short_name);
    $this->_debug_log("GetMemberNumberByMemberShortName", $debugParam);
    $this->result = GetMemberNumberByMemberShortName($this->con, $member_short_name);
    $ret = $this->_dbapi_return("GetMemberNumberByMemberShortName", $debugParam);
    if($this->profile_log)
    {
      $this->_post_func("GetMemberNumberByMemberShortName");
    }
    return $ret;
  }
}

?>
