<?php
/**
 $Id: mdb_common.php,v 1.1.1.1 2004/01/13 09:17:25 yoshi_s Exp $
*/

/*
 * ؿ: DBAPI_insert_MDB
 * : Ϳ줿եɤͤϢ򡢻ꤷơ֥̾Υơ֥
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $tblname  ơ֥̾
 * @param  array  $row  ơ֥
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DBAPI_insert_MDB($con, $tblname, $row, $file, $line){
  $cols = "";
  $vals = "";
  $dm = "";
  foreach ($row as $colname => $entry) {
    if($entry[value] == null){
      $cols .= "$dm$colname";      
      $vals .= "${dm}null";
    } else if(is_array($entry[value])){
      continue;
    } else if(($entry[type] == "integer")||($entry[type] == "int8")||($entry[type] == "int4")){
      $cols .= "$dm$colname";            
      $vals .= "$dm$entry[value]";      
    } else {
      $cols .= "$dm$colname";            
      $vals .= "$dm".GetApsString($entry[value]);
    }
    $dm = ",";    
  }
  //SQLʸκ : ɽ$TBLNAMEؤ
  $sql = "insert into $tblname ($cols) values($vals)";
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorInsertOneorZeroΥ:꡼Υ顼åԤ
  $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);
}

/*
 * ؿ: DBAPI_update_MDB
 * : Ϳ줿ơ֥̾ͤˤäƳԤ򹹿
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $tblname  ơ֥̾
 * @param  string  $pk_name  祭̾
 * @param  string  $pk_type  祭
 * @param  string  $pk_value  祭
 * @param  array  $row  ơ֥
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DBAPI_update_MDB($con, $tblname, $pk_name,$pk_type,$pk_value, $row,$file,$line){
  $cols = "";
  $dm = "";
  foreach ($row as $colname => $entry) {
    if($entry[value] == null){
      $cols .= "$dm$colname = null";
    } else if(($entry[type] == "integer")||($entry[type] == "int8")||($entry[type] == "int4")){
      $cols .= "$dm$colname = $entry[value]";
    } else {
      $cols .= "$dm$colname = ".GetApsString($entry[value]);
    }    
    $dm = ",";
  }
  //SQLʸκ : ɽ$TBLNAMEι
  if(($pk_type == "integer")||($pk_type == "int8")||($entry[type] == "int4"))
    $sql = "update $tblname set $cols where $pk_name = $pk_value";
  else 
    $sql = "update $tblname set $cols where $pk_name = ".GetApsString($pk_value)."";
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);  
  //ؿDoCheckDBErrorUpdateSomeΥ:꡼Υ顼åԤ
  $check = DoCheckDBErrorUpdateSome($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info);
}

/*
 * ؿ: DBAPI_delete_MDB
 * : Ϳ줿ơ֥̾ͤˤäƳԤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $tblname  ơ֥̾
 * @param  string  $pk_name  祭̾
 * @param  string  $pk_type  祭
 * @param  string  $pk_value  祭
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DBAPI_delete_MDB($con, $tblname, $pk_name, $pk_type,$pk_value,$file,$line){
  //SQLʸκ : ɽ$TBLNAMEκ
  if(($pk_type == "integer")||($$pk_type == "int8")||($entry[type] == "int4"))
    $sql = "delete from $tblname where $pk_name = $pk_value";    
  else 
    $sql = "delete from $tblname where $pk_name =".GetApsString($pk_value)."";
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorDeleteSomeΥ:꡼ˤpg_exec֤ͤΥ顼åԤ
  $check = DoCheckDBErrorDeleteSome($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info); 
}

/*
 * ؿ: DBAPI_delete_MDB_where
 * : Ϳ줿ơ֥̾whereˤäƳԤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $tblname  ơ֥̾
 * @param  string  $where  SQLwhere
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DBAPI_delete_MDB_where($con, $tblname, $where,$file,$line){
  //SQLʸκ : ɽ$TBLNAMEκ  
  $sql = "delete from $tblname";
  if(($where != null)&&($where != "")) $sql = $sql." where ".$where;
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorDeleteSomeΥ:꡼ˤpg_exec֤ͤΥ顼åԤ
  $check = DoCheckDBErrorDeleteSome($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $check->db_result_info); 
}

/*
 * ؿ: DBAPI_select_MDB
 * : Ϳ줿ơ֥̾ͤˤäƳԤ򡢥եɤͤϢ֤
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $tblname  ơ֥̾
 * @param  string  $pk_name  祭̾
 * @param  string  $pk_type  祭
 * @param  string  $pk_value  祭
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return array  եɤͤϢ
*/
function DBAPI_select_MDB($con, $tblname, $pk_name, $pk_type, $pk_value,$file,$line){
  //SQLʸκ : ɽ$TBLNAME θ  
  if(($entry[type] == "integer")||($entry[type] == "int8")||($entry[type] == "int4"))
    $sql = "select * from $tblname where $pk_name = $pk_value";
  else 
    $sql = "select * from p$tblname where $pk_name = ".GetApsString($pk_value)."";
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $resultArray = Array();
    //SQLμ¹Է̤οʲ¹  
    for ($i = 0; $i < $numrows; $i++){
      //SQLμ¹Է̤ԥեåƷ̤
      $resultArray[] = pg_fetch_array($result, $i, PGSQL_ASSOC);
    }
  }
  else{
    $resultArray = null;
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $resultArray);
}

/*
 * ؿ: DBAPI_select_MDB_where
 * : Ϳ줿ơ֥̾whereˤäƳԤ򡢥եɤͤϢ֤
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $tblname  ơ֥̾
 * @param  array  $columns  ֹ
 * @param  string  $where  SQLwhere
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return array  եɤͤϢ
*/
function DBAPI_select_MDB_where($con, $tblname, $columns,$where,$file,$line){
  //SQLʸκ : ɽ$TBLNAME θ    
  for($i=0;$i<count($columns);$i++){
    $target .= "$dm$columns[$i]";
    $dm = ",";
  }  
  $sql = "select $target from $tblname";
  if(($where != null)&&($where != "")) $sql = $sql." where ".$where;
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $resultArray = Array();
    for ($i = 0; $i < $numrows; $i++){
      //SQLμ¹Է̤ԥեåƷ̤
      $resultArray[] = pg_fetch_array($result, $i, PGSQL_ASSOC);
    }
  }
  else{
    $resultArray = null;
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $resultArray);
}

/*
 * ؿ: DBAPI_select_MDB_ARRAY
 * : Ϳ줿ơ֥̾ͤˤäƳԤ֤ͤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $tblname  ơ֥̾
 * @param  string  $pk_name  祭̾
 * @param  string  $pk_type  祭
 * @param  string  $pk_value  祭
 * @param  string  $row_name  °̾
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return array  ͤ
*/
function DBAPI_select_MDB_ARRAY($con, $tblname, $pk_name,$pk_type, $pk_value,$row_name ,$file,$line){
  //SQLʸκ : ɽ$TBLNAME θ  
  if(($pk_type == "integer")||($pk_type == "int8")||($entry[type] == "int4"))
    $sql = "select * from $tblname where $pk_name = $pk_value order by order_no";
  else 
    $sql = "select * from $tblname where $pk_name = ".GetApsString($pk_value)." order by order_no";
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  else{
    //SQLμ¹Է̤οʲ¹
    $numrows = pg_numrows($result);
    if($numrows > 0){
      $array	= array();
      for($i=0;$i<$numrows;$i++){
        //SQLμ¹Է̤ԥեåƷ̤
        $result_row = pg_fetch_array($result, $i,PGSQL_ASSOC);
        $array[] = $result_row[$row_name];
      }
    }
    else{
      $array	= null;
    }
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $array);
}

/*
 * ؿ: DBAPI_select_MDB_ARRAY_BYSQL
 * : Ϳ줿SQLˤäƳԤ򡢥եɤͤϢ֤
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $sql  SQL
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return array  ͤ
*/
function DBAPI_select_MDB_ARRAY_BYSQL($con, $sql,$file,$line){
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  else{
    $numrows = pg_numrows($result);
    if($numrows > 0){
      $array	= array();
      //SQLμ¹Է̤οʲ¹
      for($i=0;$i<$numrows;$i++){
        //SQLμ¹Է̤ԥեåƷ̤
        $result_row = pg_fetch_array($result, $i);
        $array[] = $result_row[0];
      }
    }
    else{
      $array	= null;
    }
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $array);  
}

/*
 * ؿ: DBAPI_insert_MDB_ARRAY
 * : ͤ򡢻ꤷơ֥̾Υơ֥
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $tblname  ơ֥̾
 * @param  string  $pk_name  祭̾
 * @param  string  $pk_type  祭
 * @param  string  $pk_value  祭
 * @param  string  $row_name  °̾
 * @param  string  $row_type  °
 * @param  array  $array  ͤ
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return boolean  ݤ
*/
function DBAPI_insert_MDB_ARRAY($con, $tblname, $pk_name, $pk_type, $pk_value,$row_name,$row_type, $array,$file,$line){
    if (count($array)> 0){
      $i = 1;
      //ꤵ줿ؿDBAPI_insert_MDBΤΰزù
      foreach ($array as $acol){
	$row = array($pk_name => array(type =>$pk_type, value=>$pk_value),
		     $row_name => array(type =>$row_type, value=>$acol),
		     "order_no" => array(type =>"integer", value=>$i++));
	//ؿDBAPI_insert_MDBΥ
	$result = DBAPI_insert_MDB($con, $tblname, $row,$file,$line);
        //ؿͤĴ٤ƥ顼ǤХ顼֤
        if($result->is_error) return $result;
      }
    } else {
      //̤֤
      return new DB_RESULT_INFO(false, null, $array); 
    }
}

/*
 * ؿ: SelectUPDATE_INFO_HISTORY
 * : Ϳ줿SQL˽ƥҥȥɽ򸡺¤Τ˳Ǽ֤
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $sql  SQL
 * @param  string  $file  ե̾
 * @param  integer  $line  ץ೺ֹ
 * @return MDB_UPDATE_INFO[]  
*/
function SelectUPDATE_INFO_HISTORY($con,$sql,$file,$line){
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $resultArray = Array();
    for ($i = 0; $i < $numrows; $i++){
      //SQLμ¹Է̤ԥեåƷ̤
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      //̤򥯥饹MDB_UPDATE_INFO˳Ǽ
      $resultArray[] = new MDB_UPDATE_INFO($row);
    }
  }
  else{
    $resultArray = null;
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $resultArray);  
}

/*
 * ؿ: SelectUPDATE_INFO_HISTORYByUpdateDate
 * : Ϳ줿ҥȥɽȡǽꡢ祭֤
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $table  ơ֥̾
 * @param  string  $pk  祭
 * @param  string  $start  
 * @param  string  $end  λ
 * @return string[]  祭
*/
function SelectUPDATE_INFO_HISTORYByUpdateDate($con,$table,$pk,$start,$end){
  if(($end == "")||($end == null)) 
    //SQLʸκ : ɽ$TABLE θ
    $sql = "select distinct $pk from $table where update_date >=  ".GetApsString($start);
  else
    $sql = "select distinct $pk from $table where update_date >= ".GetApsString($start)." and update_date < ".GetApsString($end);
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:֤ͤΥ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $resultArray = Array();
    for ($i = 0; $i < $numrows; $i++){
      //SQLμ¹Է̤ԥեåƷ̤
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      $resultArray[] = $row[$pk];
    }
  }
  else{
    $resultArray = null;
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $resultArray);    
}

/*
 * ؿ: GetMemberShortNameByMemberNumber
 * : IPȼֹ椫IPȼάΤ
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  integer  $member_number  IPȼֹ
 * @return string  IPȼά
*/
function GetMemberShortNameByMemberNumber($con, $member_number){
  $ret = null;
  //SQLʸκ : ɽMDB_MEMINFO θ
  $sql = "select member_short_name from mdb_meminfo where member_number = ".$member_number;
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:Υ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;  
  //SQLμ¹Է̤ԥեåƷ̤
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $row = pg_fetch_row($result, 0);
    $ret = $row[0];
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $ret);  
}
/*
 * ؿ: GetMemberNumberByMemberShortName
 * : IPȼάΤIPȼNo
 * @param  resource  $con  DBؤΥͥ꥽
 * @param  string  $member_short_name  IPȼά
 * @return integer  IPȼֹ
*/
function GetMemberNumberByMemberShortName($con, $member_short_name){
  $ret = null;
  //SQLʸκ : ɽMDB_MEMINFO θ
  $sql = "select member_number from mdb_meminfo where member_short_name = ".GetApsString($member_short_name);
  //ؿregdb_execΥ:SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //ؿDoCheckDBErrorSelectΥ:Υ顼åԤ
  $check = DoCheckDBErrorSelect($con, $result,__FILE__,__LINE__);
  //åؿͤĴ٤ƥ顼ǤХ顼֤
  if($check->is_error) return $check;  
  //SQLμ¹Է̤ԥեåƷ̤
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $row = pg_fetch_row($result, 0);
    $ret = $row[0];
  }
  pg_freeresult($result);
  //̤֤
  return new DB_RESULT_INFO(false, null, $ret);  
}

?>
