<?php
//$Id: mdb_dnsinfo.php,v 1.6 2004/02/27 10:32:21 wtetsuya Exp $

/**
* GetDNSInfo
* @desc DNS򸡺
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  CIDR֥å
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $sub_selcol  ߤǡΥ̾(֥ơ֥)
* @param  string  $ext  ղþ(OFFSETLIMIT)
* @return MDB_DNSINFO¤(array)
*/
function GetDNSInfo($con, $ip_network_number, $selcol, $sub_selcol, $ext)
{
  //ؿSelectDNSInfoΥ
  $dns_list_result = SelectDNSInfo($con, $ip_network_number, $selcol, $sub_selcol, $ext);
  //͸
  if($dns_list_result->is_error)  return $dns_list_result;  //顼
  if($dns_list_result->db_result_info == null)  //0
  {
    return new DB_RESULT_INFO(false, null, null);
  }
  return new DB_RESULT_INFO(false, null, $dns_list_result->db_result_info);  //
}

/**
* GetDNSInfoByMemberShortName
* @desc ȿάΤȤDNS򸡺
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $member_short_name  ȿά
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $sub_selcol  ߤǡΥ̾(֥ơ֥)
* @param  string  $ext  ղþ(OFFSETLIMIT)
* @return MDB_DNSINFO¤(array)
*/
function GetDNSInfoByMemberShortName($con, $member_short_name, $selcol, $sub_selcol, $ext)
{
  //ؿSelectDNSInfoByMemberShortNameΥ
  $dns_list_result = SelectDNSInfoByMemberShortName($con, $member_short_name, $selcol, $sub_selcol, $ext);
  //͸
  if($dns_list_result->is_error)  return $dns_list_result;  //顼
  if($dns_list_result->db_result_info == null)  //0
  {
    return new DB_RESULT_INFO(false, null, null);
  }
  return new DB_RESULT_INFO(false, null, $dns_list_result->db_result_info);  //
}

/**
* GetDNSInfoByIPAndMemNum
* @desc CIDR֥åȿֹ椫DNS򸡺
* @param resource $con DBͥ꥽
* @param string $ipnet CIDR֥å
* @param integer $mem_num ȿֹ
* @param string $selcol ߤǡΥ̾
* @param string $sub_selcol ߤǡΥ̾(֥ơ֥)
* @param string $ext ղþ(OFFSETLIMIT)
*/
function GetDNSInfoByIPAndMemNum($con, $ipnet, $mem_num, $selcol, $sub_selcol, $ext)
{
  //ؿSelectDNSInfoByIPAndMemNumΥ
  $dns_list_result = SelectDNSInfoByIPAndMemNum($con, $ipnet, $mem_num, $selcol, $sub_selcol, $ext);
  //͸
  if($dns_list_result->is_error)  return $dns_list_result;  //顼
  if($dns_list_result->db_result_info == null)  //0
  {
    return new DB_RESULT_INFO(false, null, null);
  }
  return new DB_RESULT_INFO(false, null, $dns_list_result->db_result_info);  //
}

/**
* SelectDNSInfo
* @desc DNS򸡺
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  CIDR֥å
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $sub_selcol  ߤǡΥ̾(֥ơ֥)
* @param  string  $ext  ղþ(OFFSETLIMIT)
* @return MDB_DNSINFO¤(array)
*/
function SelectDNSInfo($con, $ip_network_number, $selcol, $sub_selcol, $ext)
{
  //SQLʸκɽMDB_DNSINFOθ
  if($selcol != "")  //MDB_DNSINFO٤쥳ɤ
  {
    if($ip_network_number == "*")
    {
      $sql = "SELECT ip_network_number,".$selcol." FROM mdb_dnsinfo ORDER BY start_sequence_number".$ext;
    }
    else
    {
      $sql = "SELECT ip_network_number,".$selcol." FROM mdb_dnsinfo WHERE ip_network_number = ".GetApsString($ip_network_number). " ORDER BY start_sequence_number".$ext;
    }
  }
  else  //֥ơ֥뤫Τ߼٤쥳ɤ(MDB_DNSINFOϳθΤ߹Ԥ)
  {
    if($ip_network_number == "*")
    {
      $sql = "SELECT ip_network_number FROM mdb_dnsinfo ORDER By start_sequence_number".$ext;
    }
    else
    {
      $sql = "SELECT ip_network_number FROM mdb_dnsinfo WHERE ip_network_number = ".GetApsString($ip_network_number)." ORDER BY start_sequence_number".$ext;
    }
  }
  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //͸
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $mdb_dnsinfo = array();
    //SQLμ¹Է̤οʲ¹
    for($pi=0; $pi<$numrows; $pi++)
    {
      //SQLμ¹Է̤1ԥեåƷ̤
      $row = pg_fetch_array($result, $pi, PGSQL_ASSOC);
      if($sub_selcol != "")
      {
        if(substr_count($sub_selcol, "name_server") >= 1)
        {
          //ؿDBAPI_select_MDB_ARRAYΥ롧ɽMDB_DNS_NAME_SERVER鸡
	  $db_dns_result = DBAPI_select_MDB_ARRAY($con, "mdb_dns_name_server", "ip_network_number", "text", $row[ip_network_number], "name_server", __FILE__, __LINE__);
	  //͸
	  if($db_dns_result->is_error)  return $db_dns_result;
	  $row['name_server'] = $db_dns_result->db_result_info;  //
        }
      }
      array_push($mdb_dnsinfo, new MDB_DNSINFO($row));
    }
  }
  else{
    $mdb_dnsinfo = null;
  }
  return new DB_RESULT_INFO(false, null, $mdb_dnsinfo);  //
}

/**
* SelectDNSInfoByMemberShortName
* @desc ȿάΤȤDNS򸡺
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $member_short_name  ȿά
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $sub_selcol  ߤǡΥ̾(֥ơ֥)
* @param  string  $ext  ղþ(OFFSETLIMIT)
* @return MDB_DNSINFO¤(array)
*/
function SelectDNSInfoByMemberShortName($con, $member_short_name, $selcol, $sub_selcol, $ext)
{
  //ȿά΢ȿֹ
  $result = GetMemberNumberByMemberShortName($con, $member_short_name);
  if($result->is_error)  return $result;
  $member_number = $result->db_result_info;
  if($member_number === null){
    return new DB_RESULT_INFO(false, null, null);
  }
  //SQLʸκɽMDB_DNSINFOθ
  if($selcol != "")  //MDB_DNSINFO٤쥳ɤ
  {
    $sql = "SELECT ip_network_number,".$selcol." FROM mdb_dnsinfo WHERE member_number = ".$member_number." ORDER BY member_number".$ext;
  }
  else  //֥ơ֥뤫Τ߼٤쥳ɤ(MDB_DNSINFOϳθΤ߹Ԥ)
  {
    $sql = "SELECT ip_network_number FROM mdb_dnsinfo WHERE member_number = ".$member_number." ORDER By member_number".$ext;
  }
  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //͸
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $mdb_dnsinfo = array();
    //SQLμ¹Է̤οʲ¹
    for($pi=0; $pi<$numrows; $pi++)
    {
      //SQLμ¹Է̤1ԥեåƷ̤
      $row = pg_fetch_array($result, $pi, PGSQL_ASSOC);
      if($sub_selcol != "")
      {
        if(substr_count($sub_selcol, "name_server") >= 1)
        {
          //ؿDBAPI_select_MDB_ARRAYΥ롧ɽMDB_DNS_NAME_SERVER鸡
	  $db_dns_result = DBAPI_select_MDB_ARRAY($con, "mdb_dns_name_server", "ip_network_number", "text", $row[ip_network_number], "name_server", __FILE__, __LINE__);
	  //͸
	  if($db_dns_result->is_error)  return $db_dns_result;
	  $row['name_server'] = $db_dns_result->db_result_info;  //
        }
      }
      array_push($mdb_dnsinfo, new MDB_DNSINFO($row));
    }
  }
  else{
    $mdb_dnsinfo = null;
  }
  return new DB_RESULT_INFO(false, null, $mdb_dnsinfo);  //
}

/**
* SelectDNSInfoByIPAndMemNum
* @desc CIDR֥åȿֹ椫DNS򸡺
* @param resource $con DBͥ꥽
* @param string $ipnet CIDR֥å
* @param integer $mem_num ȿֹ
* @param string $selcol ߤǡΥ̾
* @param string $sub_selcol ߤǡΥ̾(֥ơ֥)
* @param string $ext ղþ(OFFSETLIMIT)
*/
function SelectDNSInfoByIPAndMemNum($con, $ipnet, $mem_num, $selcol, $sub_selcol, $ext)
{
  //SQLʸκɽMDB_DNSINFOθ
  if($selcol != "")  //MDB_DNSINFO٤쥳ɤ
  {
    $sql = "SELECT ip_network_number,".$selcol." FROM mdb_dnsinfo WHERE member_number = ".$mem_num." AND ip_network_number = ".GetApsString($ipnet)." ORDER BY start_sequence_number".$ext;
  }
  else  //֥ơ֥뤫Τ߼٤쥳ɤ(MDB_DNSINFOϳθΤ߹Ԥ)
  {
    $sql = "SELECT ip_network_number FROM mdb_dnsinfo WHERE member_number = ".$mem_num." AND ip_network_number = ".GetApsString($ipnet)." ORDER By start_sequence_number".$ext;
  }
  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  //͸
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $mdb_dnsinfo = array();
    //SQLμ¹Է̤οʲ¹
    for($pi=0; $pi<$numrows; $pi++)
    {
      //SQLμ¹Է̤1ԥեåƷ̤
      $row = pg_fetch_array($result, $pi, PGSQL_ASSOC);
      if($sub_selcol != "")
      {
        if(substr_count($sub_selcol, "name_server") >= 1)
        {
          //ؿDBAPI_select_MDB_ARRAYΥ롧ɽMDB_DNS_NAME_SERVER鸡
	  $db_dns_result = DBAPI_select_MDB_ARRAY($con, "mdb_dns_name_server", "ip_network_number", "text", $row[ip_network_number], "name_server", __FILE__, __LINE__);
	  //͸
	  if($db_dns_result->is_error)  return $db_dns_result;
	  $row['name_server'] = $db_dns_result->db_result_info;  //
        }
      }
      array_push($mdb_dnsinfo, new MDB_DNSINFO($row));
    }
  }
  else{
    $mdb_dnsinfo = null;
  }
  return new DB_RESULT_INFO(false, null, $mdb_dnsinfo);  //
}

/**
* CountDNSInfo
* @desc ˥ޥåDNSθĿ֤
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $condition  
* @return  integer  Ŀ
*/
function CountDNSInfo($con, $condition)
{
  //SQLʸκɽMDB_DNSINFOθ
  $sql = "SELECT COUNT(*) FROM mdb_dnsinfo ".$condition;
  //ؿregdb_execΥ롧SQL¹ԤƷ̤
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  if($check->is_error)  return $check;
  $row = pg_fetch_array($result,0,PGSQL_ASSOC);
  return new DB_RESULT_INFO(false, null, $row[count]);  //
}

/**
* CreateDNSInfo
* @desc DNS
* @param  resource  $con  DBؤΥͥ꥽
* @param  object  $dnsinfo  MDB_DNSINFO¤
* @param  object  $updateinfo  MDB_UPDATE_INFO¤
* @return true/false
*/
function CreateDNSInfo($con, $dnsinfo, $updateinfo)
{
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($dnsinfo->last_update_date == ""){
    $dnsinfo->last_update_date = $now;
  }
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //member_numbernullϵʤ
  if($dnsinfo->member_number === null){
    return new DB_RESULT_INFO(false, null, 0);
  }
  //IPɥ쥹ɽ饹ȥ󥹡ɥ󥹤Ȥ
  $block_range = RegIpv6AddressUtil::get_sequence_num($dnsinfo->ip_network_number);
  $dnsinfo->start_sequence_number = $block_range[0];
  $dnsinfo->end_sequence_number = $block_range[1];
  $dnsinfo->prefix_length = $block_range[2];
  //ؿDBAPI_insert_MDBΥ롧ɽMDB_DNSINFO˹Ԥ
  $result = DBAPI_insert_MDB($con, "mdb_dnsinfo", DBAPI_table_map_to_array_MDB_DNSINFO($dnsinfo), __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  //ؿDBAPI_subtable_insert_MDB_DNSINFOΥ롧ɽMDB_DNS_NAME_SERVER˹Ԥ
  $result = DBAPI_subtable_insert_MDB_DNSINFO($con, $dnsinfo->ip_network_number, $dnsinfo, __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  //ؿDBAPI_insert_MDBΥ롧ɽMDB_DNS_UPDATE_HISTORY˹Ԥ
  $result = DBAPI_insert_MDB($con, "mdb_dns_update_history", DBAPI_table_map_to_array_MDB_DNS_UPDATE_HISTORY($dnsinfo->ip_network_number, $dnsinfo->start_sequence_number, $dnsinfo->end_sequence_number, $updateinfo), __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  return new DB_RESULT_INFO(false, null, true);  //
}

/**
* DBAPI_table_map_to_array_MDB_DNSINFO
* @desc ֥MDB_DNSINFOȥơ֥MDB_DNSINFOбɽ֤
* @param  object  MDB_DNSINFO¤
* @return  array  ơ֥̾°Ф
*/
function DBAPI_table_map_to_array_MDB_DNSINFO($dnsinfo)
{
  $now  = date("Y-m-d H:i:s T");
  if($dnsinfo->initial_registration_date == "")
  {
    $dnsinfo->initial_registration_date = $now;
  }
  return array(
  ip_network_number => array(type => "cidr", value => $dnsinfo->ip_network_number),
  member_number => array(type => "integer", value => $dnsinfo->member_number),
  initial_registration_date => array(type => "timestamp", value => $dnsinfo->initial_registration_date),
  last_update_date => array(type => "timestamp", value => $dnsinfo->last_update_date),
  note => array(type => "text", value => $dnsinfo->note),
  prefix_length => array(type => "integer", value => $dnsinfo->prefix_length),
  start_sequence_number => array(type => "text", value => $dnsinfo->start_sequence_number),
  end_sequence_number => array(type => "text", value => $dnsinfo->end_sequence_number)
  );
}

/**
* DBAPI_subtable_insert_MDB_DNSINFO
* @desc DNSΥ֥ơ֥˹Ԥ
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $pk_value  祭
* @param  object  $dnsinfo  DNS¤
* @param  string  $file  ե̾
* @param  integer  $line  ץ೺ֹ
* @param  string  $sub_selcol  ¸̾
* @return  boolean  true/false
*/
function DBAPI_subtable_insert_MDB_DNSINFO($con, $pk_value, &$dnsinfo, $file, $line, $sub_selcol="")
{
  if($sub_selcol == "")
  {
    $sub_selcol = "name_server";
  }
  //ؿDBAPI_insert_MDB_ARRAYΥ롧ɽMDB_DNS_NAME_SERVER˹Ԥ
  if((substr_count($sub_selcol, "name_server") >= 1) && (count($dnsinfo->name_server) >= 1))
  {
    $result = DBAPI_insert_MDB_ARRAY($con, "mdb_dns_name_server", "ip_network_number", "text", $pk_value, "name_server", "text", $dnsinfo->name_server, $file, $line);
    //͸
    if($result->is_error)  return $result;
  }
  return new DB_RESULT_INFO(false, null, true);  //
}

/**
* DBAPI_table_map_to_array_MDB_DNS_UPDATE_HISTORY
* @desc ֥MDB_DNS_UPDATE_HISTORYȥơ֥MDB_DNS_UPDATE_HISTORYбɽ֤
* @param  text  $ip_network_number  CIDR֥å
* @param  text  $start_sequence_number
* @param  text  $end_sequence_number
* @param  object  MDB_UPDATE_INFO¤
* @return  array  ơ֥̾°Ф
*/
function DBAPI_table_map_to_array_MDB_DNS_UPDATE_HISTORY($ip_network_number, $start_sequence_number, $end_sequence_number, $updateinfo)
{
  return array(
  ip_network_number => array(type => "cidr", value =>$ip_network_number ),
  start_sequence_number => array(type => "text", value =>$start_sequence_number ),
  end_sequence_number => array(type => "text", value =>$end_sequence_number ),     
  update_person => array(type => "text", value =>$updateinfo->update_person),
  update_date   => array(type => "timestamp", value =>$updateinfo->update_date),
  accept_id => array(type => "text", value => $updateinfo->accept_id),
  operation_id     => array(type => "text", value => $updateinfo->operation_id)
  );
}

/**
* SaveDNSInfo
* @desc DNS򹹿
* @param  resource  $con  DBؤΥͥϥɥ
* @param  object  MDB_DNSINFO¤
* @param  object  MDB_UPDATE_INFO¤
* @param  string  ¸̾
* @param  string  ¸̾(֥ơ֥)
* @return true/false
*/
function SaveDNSInfo($con, $dnsinfo, $updateinfo, $selcol, $sub_selcol)
{
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($dnsinfo->last_update_date == ""){
    $dnsinfo->last_update_date = $now;
  }
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //IPɥ쥹ɽ饹ȥ󥹡ɥ󥹤Ȥ
  $block_range = RegIpv6AddressUtil::get_sequence_num($dnsinfo->ip_network_number);
  $dnsinfo->start_sequence_number = $block_range[0];
  $dnsinfo->end_sequence_number = $block_range[1];
  $dnsinfo->prefix_length = $block_range[2];
  //ؿDBAPI_update_MDBΥ롧MDB_DNSINFOγԤ򹹿
  if($selcol != "")
  {
    $data = DBAPI_table_map_to_array_MDB_DNSINFO($dnsinfo);
    foreach(explode(",", $selcol) as $key => $value)
    {
      $data_conv[$value] = $data[$value];
    }
    if(in_array("last_update_date", array_keys($data_conv)) == false){
      $data_conv[last_update_date] = array(type => "timestamp", value => $dnsinfo->last_update_date);
    }
    $result = DBAPI_update_MDB($con, "mdb_dnsinfo", "ip_network_number", "text", $dnsinfo->ip_network_number, $data_conv, __FILE__, __LINE__);
    //͸
    if($result->is_error)  return $result;
  }
  if($sub_selcol != "")
  {
    //Ԥκ
    $result = DBAPI_subtable_delete_MDB_DNSINFO($con, $dnsinfo->ip_network_number, __FILE__, __LINE__);
    //͸
    if($result->is_error)  return $result;
    //줫
    $result = DBAPI_subtable_insert_MDB_DNSINFO($con, $dnsinfo->ip_network_number, $dnsinfo, __FILE__, __LINE__, $sub_selcol);
    //͸
    if($result->is_error)  return $result;
  }
  //κ
  $result = DBAPI_insert_MDB($con, "mdb_dns_update_history", DBAPI_table_map_to_array_MDB_DNS_UPDATE_HISTORY($dnsinfo->ip_network_number, $dnsinfo->start_sequence_number, $dnsinfo->end_sequence_number, $updateinfo), __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  return new DB_RESULT_INFO(false, null, true);  //
}

/**
* DBAPI_subtable_delete_MDB_DNSINFO
* @desc DNSΥ֥ơ֥ιԤ
* @param  resource  $con  DBؤΥͥ꥽
* @param  text  $ip_network_number  CIDR֥å
* @param  string  $file  ե̾
* @param  string  $line  ץ೺ֹ
* @return  true/false
*/
function DBAPI_subtable_delete_MDB_DNSINFO($con, $ip_network_number, $file, $line)
{
  $result = DBAPI_delete_MDB($con, "mdb_dns_name_server", "ip_network_number", "text", $ip_network_number, $file, $line);
  //͸
  if($result->is_error)  return $result;
  return new DB_RESULT_INFO(false, null, true);  //
}

/**
* DeleteDNSInfo
* @desc DNS
* @param  resource  $con  DBؤΥͥϥɥ
* @param  string  $ip_network_number  CIDR֥å
* @param  object  $updateinfo  MDB_UPDATE_INFO¤
* @return true/false
*/
function DeleteDNSInfo($con, $ip_network_number, $updateinfo)
{
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //IPɥ쥹ɽ饹ȥ󥹡ɥ󥹤Ȥ
  $block_range = RegIpv6AddressUtil::get_sequence_num($ip_network_number);
  $start_sequence_number = $block_range[0];
  $end_sequence_number = $block_range[1];
  //֥ơ֥κ
  $result = DBAPI_subtable_delete_MDB_DNSINFO($con, $ip_network_number, __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  //Τκ
  $result = DBAPI_delete_MDB($con, "mdb_dnsinfo", "ip_network_number", "text", $ip_network_number, __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  //Ԥ0ԤäȤϥ顼
  if($result->db_result_info == 0)
  {
    return new DB_RESULT_INFO(false, null, 0);
  }
  //κ
  $result = DBAPI_insert_MDB($con, "mdb_dns_update_history", DBAPI_table_map_to_array_MDB_DNS_UPDATE_HISTORY($ip_network_number, $start_sequence_number, $end_sequence_number, $updateinfo), __FILE__, __LINE__);
  //͸
  if($result->is_error)  return $result;
  return new DB_RESULT_INFO(false, null, true);  //
}

/**
* DeleteDNSInfoByMemberShortName
* @desc ȿάΤȤDNS
* @param  resource  $con  DBؤΥͥϥɥ
* @param  string  $member_short_name  ȿά
* @param  object  $updateinfo  MDB_UPDATE_INFO¤
* @return true/false
*/
function DeleteDNSInfoByMemberShortName($con, $member_short_name, $updateinfo)
{
  //ƥǹ
  $now = date("Y-m-d H:i:s T");
  if($updateinfo->update_date == ""){
    $updateinfo->update_date = $now;
  }
  //ȿά΢ȿֹ
  $result = GetMemberNumberByMemberShortName($con, $member_short_name);
  if($result->is_error)  return $result;
  $member_number = $result->db_result_info;
  if($member_number === null){
    return new DB_RESULT_INFO(false, null, 0);
  }
  //ȿά΢IPNET
  $sql = "SELECT ip_network_number FROM mdb_dnsinfo WHERE member_number = ". $member_number;
  $result = regdb_exec($con, $sql);
  $check = DoCheckDBErrorSelect($con, $result, __FILE__, __LINE__);
  //͸
  if($check->is_error)  return $check;
  $numrows = pg_numrows($result);
  if($numrows > 0){
    $ipnet = array();
    for($i=0; $i<$numrows; $i++)
    {
      $row = pg_fetch_array($result, $i, PGSQL_ASSOC);
      array_push($ipnet, GetApsString($row['ip_network_number']));
    }
    //֥ơ֥κ
    $sql = "DELETE FROM mdb_dns_name_server WHERE ip_network_number IN (" .implode(",", $ipnet). ")";
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorDeleteSome($con, $result, __FILE__, __LINE__);
    //͸
    if($check->is_error)  return $check;
    //Τκ
    $sql = "DELETE FROM mdb_dnsinfo WHERE member_number = " . $member_number;
    $result = regdb_exec($con, $sql);
    $check = DoCheckDBErrorDeleteSome($con, $result, __FILE__, __LINE__);
    //͸
    if($check->is_error)  return $check;
    if($check->db_result_info <= 0)
    {
      return new DB_RESULT_INFO(false, null, $check->db_result_info);
    }
    //κ
    foreach($ipnet as $key => $value)
    {
      $value_quote = $value;
      $value = str_replace("'", "", $value);
      //IPɥ쥹ɽ饹ȥ󥹡ɥ󥹤Ȥ
      $block_range = RegIpv6AddressUtil::get_sequence_num($value);
      $start_sequence_number = $block_range[0];
      $end_sequence_number = $block_range[1];
      $sql = "INSERT INTO mdb_dns_update_history(ip_network_number,start_sequence_number,end_sequence_number,update_person,update_date,accept_id,operation_id) VALUES($value_quote, $start_sequence_number, $end_sequence_number, ".GetApsString($updateinfo->update_person).",".GetApsString($updateinfo->update_date).",".GetApsString($updateinfo->accept_id).",".GetApsString($updateinfo->operation_id).")";
      $result = regdb_exec($con, $sql);
      $check = DoCheckDBErrorInsertOneorZero($con, $result, __FILE__, __LINE__);
      //͸
      if($check->is_error) return $check;
      return new DB_RESULT_INFO(false, null, $check->db_result_info);  //
    }
  }
  else{
    return new DB_RESULT_INFO(false, null, 0);
  }
}

/**
* SelectDNSInfoHistory
* @desc DNSι򸡺
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $ip_network_number  CIDR֥å
* @param  string  $selcol  ߤǡΥ̾
* @param  string  $ext  ղþ(OFFSETLIMIT)
* @return MDB_DNS_UPDATE_HISTORY¤(array)
*/
function SelectDNSInfoHistory($con, $ip_network_number, $selcol, $ext)
{
  return SelectUPDATE_INFO_HISTORY($con, "SELECT ".$selcol." FROM mdb_dns_update_history h WHERE ".GetApsString($ip_network_number)." = h.ip_network_number ORDER BY update_date".$ext, __FILE__, __LINE__);
}

/**
* SelectDNSInfoHistoryByUpdateDate
* @desc Ƚλδ֤ˤ빹CIDR֥åΥꥹȤ֤
* @param  resource  $con  DBؤΥͥ꥽
* @param  string  $start  
* @param  string  $end  λ
* @return CIDR֥åꥹ(array)
*/
function SelectDNSInfoHistoryByUpdateDate($con, $start, $end)
{
  return SelectUPDATE_INFO_HISTORYByUpdateDate($con, "mdb_dns_update_history", "ip_network_number", $start, $end);
}

?>
