<?php
/**
 * $Id: RegIPrev.php,v 1.1 2004/03/08 13:25:40 yoshi_s Exp $
 */
?>
<?php
//----------------------------------------------------------------------------
// include,require
//----------------------------------------------------------------------------
require_once("DBAPIWrapper.php");			// DB API IMPLE
require_once("REGClass.php");				// DBѹ¤Υ饹
require_once("RegIPrevMsg.php");			// DNSžå
require_once("RegIPrevConf.php");			// config饹
require_once("RegIPrevNSInfo.php");			// NS饹
require_once("RegIPrevOutPut.php");			// DNSե饹
require_once("RegIPrevUpdate.php");			// DNSե빹饹
require_once("RegIPrevUpload.php");			// DNSեž饹

//----------------------------------------------------------------------------
// define
//----------------------------------------------------------------------------
define("MOD_BLOCK_SIZE", 4);				// IP֥åʬ
define("IP_BLOCK_MAX_DIGIT", 32);			// IP֥å
define("IP_PREFIX_MIN_NUM", 1);				// IPץեåǾ
define("IP_PREFIX_MAX_NUM", 128);			// IPץեå

//----------------------------------------------------------------------------
// class
//----------------------------------------------------------------------------
class RegIPrev
{
	//-----------------------------------------------------------------------
	// ѿ
	//-----------------------------------------------------------------------
	/**
	 * DBAPI_IMPLE
	 */
	var $reg_db;

	/**
	 * zoneꥹDB
	 */
	var $m_zone_list_db;

	/**
	 * NSꥹDB
	 */
	var $m_ns_list_db;

	/**
	 * zoneꥹfile
	 */
	var $m_zone_list_file;

	/**
	 * NSꥹfile
	 */
	var $m_ns_list_file;

	/**
	 * åꥹ
	 */
	var $m_iprev_msg;

	/**
	 * åϿʸ
	 */
	var $m_log_msg;

	/**
	 * configåϿʸ
	 */
	var $m_conf_msg;

	/**
	 * file outputåϿʸ
	 */
	var $m_out_msg;

	/**
	 * file updateåϿʸ
	 */
	var $m_update_msg;

	/**
	 * file uploadνåϿʸ
	 */
	var $m_reload_msg;

	/**
	 * iniեǡ
	 */
	var $m_iprev_conf;

	/**
	 * debug ե饰
	 */
	var $m_debug_flag;

	//-----------------------------------------------------------------------
	// public methods(󥹥ȥ饯/)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾RegIPrev
	 *   RegIPrev饹󥹥ȥ饯
	 * @param  $db			DBAPI_IMPLE						(i)
	 * @param  $debug_flag	ǥХåե饰(def=FALSE)	 	(i)
	 */
	function RegIPrev($db, $debug_flag=FALSE)
	{
		$this->reg_db			= $db;
		$this->m_zone_list_db	= array();			// zoneꥹȡDB
		$this->m_ns_list_db		= array();			// nsꥹȡDB

		$this->m_zone_list_file	= array();			// zoneꥹȡfile
		$this->m_ns_list_file	= array();			// nsꥹȡfile

		$this->m_debug_flag		= $debug_flag;		// ǥХåե饰

		global $g_iprev_msg;
		$this->m_iprev_msg		= $g_iprev_msg;		// å
		$this->m_log_msg		= "";
		$this->m_conf_msg		= "";
		$this->m_out_msg		= "";
		$this->m_update_msg		= "";
		$this->m_reload_msg		= "";

		$this->m_iprev_conf		= new RegIPrevConf($this->m_iprev_msg, $this->m_debug_flag);
	}

	//-----------------------------------------------------------------------
	// public methods(config)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_config_data
	 *   iniե뤫ͤɤ߽Ф
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN50	config ե뤬¸ߤʤ
	 *		         IPREV_GEN51	DNS_NOT_OUTPUT_ADDRESS 㤤
	 *               IPREV_GEN52	special add file 㤤
	 *               IPREV_GEN53	special add file ʤ
	 *               IPREV_GEN54	special add zoneipʤ
	 *               IPREV_GEN55	special add zoneip㤤
	 *               IPREV_GEN56	special add dnsipʤ
	 *               IPREV_GEN57	special add dnsip㤤
	 *               IPREV_GEN58	special add dnsipzoneipˤʤ
	 *               IPREV_GEN59	special add nameserver㤤
	 *               IPREV_GEN60	special add nameserverʤ
	 *               IPREV_GEN61	special add dnsip overlap
	 *               IPREV_GEN62	special add zoneip overlap
	 *               IPREV_GEN66	AUTH-NS ͤꤵƤʤ
	 *               IPREV_GEN67	AUTH-NS եޥåȥ顼
	 *               IPREV_GEN99	fatal error
	 */
	function get_config_data()
	{
		$result = $this->m_iprev_conf->get_config_data();
		$this->m_conf_msg .= $this->m_iprev_conf->get_log_msg();
		$this->m_conf_msg .= $this->m_iprev_conf->get_debug_msg();
		return $result;
	}

	/**
	 * ؿ̾init_new_dirctory
	 *   NEWCONF, NEWZONE, DELCONF, DELZONE ǥ쥯ȥ
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN20	
	 */
	function init_new_dirctory()
	{
		$del_dirs = array();
		array_push($del_dirs, $this->m_iprev_conf->m_conf_data[NEWCONF]);
		array_push($del_dirs, $this->m_iprev_conf->m_conf_data[NEWZONE]);
		array_push($del_dirs, $this->m_iprev_conf->m_conf_data[DELCONF]);
		array_push($del_dirs, $this->m_iprev_conf->m_conf_data[DELZONE]);

		for ($n = 0; $n < count($del_dirs); $n++)
		{
			// ǥ쥯ȥ¸ߥå
			$ddh = opendir($del_dirs[$n]);
			if ($ddh == FALSE)
				continue;
			else
				closedir($ddh);

			$cmd_str = sprintf("%s %s",
							   $this->m_iprev_conf->m_conf_data[CMD_RMALL],
							   $del_dirs[$n]);
			$cmd_ret  = 1;
			system($cmd_str, $cmd_ret);
			if ($cmd_ret != 0)
			{
				$this->set_log_msg(IPREV_GEN20, array($del_dirs[$n], ("ret:" . $cmd_ret)));
				return IPREV_GEN20;
			}
//			$this->m_log_msg .= $this->m_iprev_msg[IPREV_GEN21] .
//								" [" . $del_dirs[$n] . "]";
		}

		return IPREV_GEN00;
	}


	//-----------------------------------------------------------------------
	// public methods(DB)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_zone_list_db
	 *   zoneñ̤Ȥʤ̥쥸ȥ꤫γ꿶֥å
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN02	zoneꥹȳԡDB顼
	 *		         IPREV_GEN03	zoneꥹȳ  not error
	 *		         IPREV_GEN10	conf,DB zoneʣ
	 *		         IPREV_GEN99	fatal error
	 * @desc	 $m_zone_list_db ˳Ǽ
	 */
	function get_zone_list_db()
	{
		$this->m_zone_list_db	= array();
		$conf_zone_list			= array();
		$zone_ip_list			= array();

		if ($this->reg_db == NULL)
		{
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		//--------------------------------------------------------------------
		// config ǡå
		//--------------------------------------------------------------------
		if (is_array($this->m_iprev_conf->m_add_zone_list) && count($this->m_iprev_conf->m_add_zone_list) > 0)
		{
			$conf_zone_list = $this->m_iprev_conf->m_add_zone_list;
			// ʣåѤIPȴФ
			for($conf_cnt = 0; $conf_cnt < count($conf_zone_list); $conf_cnt++)
			{
				array_push($zone_ip_list, $conf_zone_list[$conf_cnt][DB_ZONE_IP]);
			}
			$this->m_zone_list_db = $conf_zone_list;
		}

		//--------------------------------------------------------------------
		// DB䤤碌
		//--------------------------------------------------------------------
		// ϿꥹȤIPϸоݤ鳰
		$where_str = "";
		$hide_list = $this->m_iprev_conf->m_hide_list;
		for ($n = 0; $n < count($hide_list); $n++)
		{
			$where_str .= $this->create_not_overlap_selstr(
													$hide_list[$n][0],
													$hide_list[$n][1],
													"zone");
			$where_str .= " AND ";
		}
		if ($where_str != "")
		{
			$where_str = (" WHERE " . substr($where_str, 0, -5));
		}

		// SQL
		$sqlstr  = "SELECT zone.ip_network_number AS " .
				   DB_ZONE_IP .
				   ", zone.prefix_length AS " .
				   DB_ZONE_PREFIX .
				   ", zone.start_sequence_number AS " .
				   DB_ZONE_START .
				   ", zone.end_sequence_number AS " .
				   DB_ZONE_END .
				   " FROM cidr_allocated_block AS zone" .
				   $where_str;
		$sqlstr .= " ORDER BY zone.start_sequence_number";

		// DB䤤碌¹
		$db_result = $this->reg_db->dbapi_query($sqlstr);
		if ($db_result === FALSE)			// 顼
		{
			$this->set_log_msg(IPREV_GEN02, "");
			return IPREV_GEN02;
		}
		if ($db_result === NULL)			// 
		{
			if (count($zone_ip_list) > 0)
			{
				// special add zone ΤߤоݤȤƽλ
				$this->m_zone_list_db = $conf_zone_list;
				return IPREV_GEN00;
			}
			else
			{
				// special add zone ip ʤ
				$this->set_log_msg(IPREV_GEN03, "");
				return IPREV_GEN03;			// 顼ǤϤʤΤ
			}
		}

		//--------------------------------------------------------------------
		// configǡȤνʣå
		//--------------------------------------------------------------------
		if (count($zone_ip_list) > 0)
		{
			// configͤDBͤȽʣå
			// פϵĤ
			for ($db_cnt = 0; $db_cnt < count($db_result); $db_cnt++)
			{
				switch ($this->distinct_ipblock_array($zone_ip_list, $db_result[$db_cnt][DB_ZONE_IP]))
				{
				case 0:			// ʣʤʥꥹȤɲäƷ³
					array_push($zone_ip_list, $db_result[$db_cnt][DB_ZONE_IP]);
					array_push($this->m_zone_list_db, $db_result[$db_cnt]);
					break;
				case 1:			// סʥꥹȤɲä³
					break;
				case 2:			// ʣ
				case 3:			// ʣ
				case 4:			// ʣ
					$this->set_log_msg(IPREV_GEN10, "");
					return IPREV_GEN10;			// confDBʣ

				case -1:		// 顼
				default:
					$this->set_log_msg(IPREV_GEN99, "");
					return IPREV_GEN99;
				}
			}
		}
		else
		{
			// configͤʤΤDBͤΤߤϿ
			$this->m_zone_list_db = $db_result;
		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾get_ns_list_db
	 *   NS쥳ɺñ̤ȤʤհDNSIPɥ쥹֥å
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN04	nsꥹȳԡDB顼
	 *		         IPREV_GEN05	nsꥹȳ  not error
	 *		         IPREV_GEN99	fatal error
	 * @desc	 $m_ns_list_db ˳Ǽ
	 */
	function get_ns_list_db()
	{
		$this->m_ns_list_db = array();

		if ($this->reg_db == NULL)
		{
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		$where_str = "";
		$hide_list = $this->m_iprev_conf->m_hide_list;
		for ($n = 0; $n < count($hide_list); $n++)
		{
			$where_str .= " AND ";
			$where_str .= $this->create_not_overlap_selstr(
													$hide_list[$n][0],
													$hide_list[$n][1],
													"zone");
		}

		// SQL
		$sqlstr  = "SELECT zone.ip_network_number AS " .
				   DB_ZONE_IP .
				   ", zone.prefix_length AS " .
				   DB_ZONE_PREFIX .
				   ", zone.start_sequence_number AS " .
				   DB_ZONE_START .
				   ", zone.end_sequence_number AS " .
				   DB_ZONE_END .
				   ", dns.ip_network_number AS " .
				   DB_DNS_IP .
				   ", dns.prefix_length AS " .
				   DB_DNS_PREFIX .
				   ", dns.start_sequence_number AS " .
				   DB_DNS_START .
				   ", dns.end_sequence_number AS " .
				   DB_DNS_END .
				   " FROM cidr_allocated_block AS zone, mdb_dnsinfo AS dns";
		$sqlstr .= " WHERE zone.start_sequence_number <= dns.start_sequence_number AND zone.end_sequence_number >= dns.end_sequence_number";
		$sqlstr .= $where_str;
		$sqlstr .= " ORDER BY zone.start_sequence_number, dns.start_sequence_number";

		// DB䤤碌¹
		$db_result = $this->reg_db->dbapi_query($sqlstr);
		if ($db_result === FALSE)			// 顼
		{
			$this->set_log_msg(IPREV_GEN04, "");
			return IPREV_GEN04;
		}
		if ($db_result === NULL)			// 
		{
			$this->set_log_msg(IPREV_GEN05, "");
			return IPREV_GEN05;				// 顼ǤϤʤΤ
		}

		$this->m_ns_list_db = $db_result;
		return IPREV_GEN00;
	}

	/**
	 * ؿ̾get_ns_server_list_db
	 *   IPɥ쥹֥åбname server̾
	 * @param	$ip_block	IPɥ쥹֥å			(i)
	 * @param	$ns_list	nameserver̾Ǽ		(i/o)
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN06	nameserverꥹȳԡDB顼
	 *		         IPREV_GEN07	nameserverꥹȳ  ͭʤᡢ顼
	 *		         IPREV_GEN99	fatal error
	 * @desc	ϰ $ns_list ˳Ǽ
	 */
	function get_ns_server_list_db($ip_block, &$ns_list)
	{
		$ns_list = array();

		if ($this->reg_db == NULL)
		{
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		// SQL
		$sqlstr  = "SELECT ns.order_no AS " .
				   DB_NS_NO .
				   ", ns.name_server AS " .
				   DB_NS_NS .
				   " FROM mdb_dns_name_server AS ns, mdb_dnsinfo AS dns";
		$sqlstr .= " WHERE dns.ip_network_number = " . GetApsString($ip_block) . " AND dns.ip_network_number = ns.ip_network_number";
		$sqlstr .= " ORDER BY ns.order_no";
		// DB䤤碌¹
		$db_result = $this->reg_db->dbapi_query($sqlstr);
		if ($db_result === FALSE)			// 顼
		{
			$this->set_log_msg(IPREV_GEN06, "");
			return IPREV_GEN06;
		}
		if ($db_result === NULL)			// 
		{
			$this->set_log_msg(IPREV_GEN07, "");
			return IPREV_GEN07;
		}

		$ns_list = $db_result;
		return IPREV_GEN00;
	}


	//-----------------------------------------------------------------------
	// public methods(եϾ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_zone_list_file
	 *   եñ̤Ȥʤzone
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN99	fatal error
	 * @desc	 $m_zone_list_file ˳Ǽ
	 */
	function get_zone_list_file()
	{
		$this->m_zone_list_file = array();

		if (!is_array($this->m_zone_list_db) || count($this->m_zone_list_db) < 1)
		{
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		$tmp_start	= "";
		$tmp_prefix	= "";
		$cnt = count($this->m_zone_list_db);
		// ե˽񤭹ñ̤ zone ꥹȤ
		for ($n = 0; $n < $cnt; $n++)
		{
			$tmp_start	= $this->m_zone_list_db[$n][DB_ZONE_START];		// IPֹ
			$tmp_prefix	= $this->m_zone_list_db[$n][DB_ZONE_PREFIX];	// prefix
			// ʬ䤬ɬפʾ
			if ($this->is_divide_block($tmp_prefix))
			{
				// ʬ
				$div_info	= $this->get_divide_info($tmp_prefix);
				// ʬ̤zoneꥹȤǼ
				$zone_array	= $this->create_divide_block($tmp_start, $div_info);
				if (!is_array($zone_array) || count($zone_array) < 1)
				{
					$this->m_zone_list_file = array();
					$this->set_log_msg(IPREV_GEN99, "");
					return IPREV_GEN99;
				}
				for ($i = 0; $i < count($zone_array); $i++)
				{
					array_push($this->m_zone_list_file, $zone_array[$i]);
				}
			}
			// ʬɬפʤ
			else
			{
				// zoneǼ
				$zone = $this->create_block($tmp_start, $tmp_prefix);
				array_push($this->m_zone_list_file, $zone);
			}
		}
		return IPREV_GEN00;
	}

	/**
	 * ؿ̾get_ns_list_file_db
	 *   եñ̤ȤʤnsDB
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN06	nameserverꥹȳԡDB顼
	 *		         IPREV_GEN07	nameserverꥹȳ  ͭʤᡢ顼
	 *		         IPREV_GEN08	nsꥹȳ
	 *		         IPREV_GEN09	оzoneʤ
	 *		         IPREV_GEN99	fatal error
	 * @desc	 $m_ns_list_file ˳Ǽ
	 *          ϻ $m_ns_list_file 򥯥ꥢǡϿԤ
	 *			$m_ns_list_file ϡRegIPrevNSInfo֥Ȥ
	 */
	function get_ns_list_file_db()
	{
		$this->m_ns_list_file = array();

		if (!is_array($this->m_ns_list_db))
		{
			$this->set_log_msg(IPREV_GEN99, "");
			return IPREV_GEN99;
		}

		$cnt = count($this->m_ns_list_db);
		if ($cnt < 1)
		{
			$this->set_log_msg(IPREV_GEN08, "");
			return IPREV_GEN08;
		}

		//------ name server ߾ ------//
		for ($main_n = 0; $main_n < $cnt; $main_n++)
		{
			//----------------------------------------------------------------
			// zone 
			//----------------------------------------------------------------
			$tmp_zone_array		= array();
			$write_zone_prefix	= 0;			// ºݤνߥ
			$result = $this->get_ns_list_file_ip(
									$this->m_ns_list_db[$main_n][DB_ZONE_START],
									$this->m_ns_list_db[$main_n][DB_ZONE_PREFIX],
									$write_zone_prefix,
									$tmp_zone_array);
			switch ($result)
			{
			case IPREV_GEN00:
				break;
			case IPREV_GEN99:
			default:
				$this->set_log_msg(IPREV_GEN99, "");
				return IPREV_GEN99;
			}

			//----------------------------------------------------------------
			// ns 
			//----------------------------------------------------------------
			$tmp_ns_array		= array();
			$write_ns_prefix	= 0;			// ºݤνߥ
			$result = $this->get_ns_list_file_ip(
									$this->m_ns_list_db[$main_n][DB_DNS_START],
									$this->m_ns_list_db[$main_n][DB_DNS_PREFIX],
									$write_ns_prefix,
									$tmp_ns_array);
			switch ($result)
			{
			case IPREV_GEN00:
				break;
			case IPREV_GEN99:
			default:
				$this->set_log_msg(IPREV_GEN99, "");
				return IPREV_GEN99;
			}

			//----------------------------------------------------------------
			// name server 
			//----------------------------------------------------------------
			$tmp_name_server_list = array();
			$result = $this->get_ns_server_list_db($this->m_ns_list_db[$main_n][DB_DNS_IP], $tmp_name_server_list);
			switch ($result)
			{
			case IPREV_GEN00:
				break;
			case IPREV_GEN06:
			case IPREV_GEN07:
				$this->set_log_msg($result, "");
				return $result;
			case IPREV_GEN99:
			default:
				$this->set_log_msg(IPREV_GEN99, "");
				return IPREV_GEN99;
			}

			$server_cnt = count($tmp_name_server_list);
			$name_server_list = array();
			for ($n = 0; $n < $server_cnt; $n++)
			{
				$name_server_list[$n] =  $tmp_name_server_list[$n][DB_NS_NS];
			}

			//----------------------------------------------------------------
			// ns 󥻥å
			//----------------------------------------------------------------
			$result = $this->get_ns_list_file_ns(
										$write_zone_prefix,
										$write_ns_prefix,
										$tmp_zone_array,
										$tmp_ns_array,
										$name_server_list,
										$this->m_ns_list_file);
			switch ($result)
			{
			case IPREV_GEN00:
				break;
			case IPREV_GEN09:
			default:
				$this->set_log_msg(IPREV_GEN99, "");
				return IPREV_GEN99;
			}
		}

		return IPREV_GEN00;
	}

	/**
	 * ؿ̾get_ns_list_file_conf
	 *   եñ̤Ȥʤnsconfigǡ
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN07	nameserverꥹȳʥ顼ǤϤʤ
	 *		         IPREV_GEN09	оzoneʤ
	 *		         IPREV_GEN99	fatal error
	 * @desc	 $m_ns_list_file ɲóǼ롣DBξ
	 *			åȤ˸ƤӽФ
	 *			$m_ns_list_file ϡRegIPrevNSInfo֥Ȥ
	 */
	function get_ns_list_file_conf()
	{
		$conf_ns_list	= $this->m_iprev_conf->m_add_ns_list;
		$cnt			= count($conf_ns_list);

		if (!is_array($conf_ns_list) || $cnt == 0)
		{
//			$this->m_log_msg .= $this->m_iprev_msg[IPREV_GEN07];
			return IPREV_GEN07;
		}

		//------ name server ߾ ------//
		for ($main_n = 0; $main_n < $cnt; $main_n++)
		{
			//----------------------------------------------------------------
			// zone 
			//----------------------------------------------------------------
			$tmp_zone_array		= array();
			$write_zone_prefix	= 0;			// ºݤνߥ
			$result = $this->get_ns_list_file_ip(
									$conf_ns_list[$main_n][DB_ZONE_START],
									$conf_ns_list[$main_n][DB_ZONE_PREFIX],
									$write_zone_prefix,
									$tmp_zone_array);
			switch ($result)
			{
			case IPREV_GEN00:
				break;
			case IPREV_GEN99:
			default:
				$this->set_log_msg(IPREV_GEN99, "");
				return IPREV_GEN99;
			}

			//----------------------------------------------------------------
			// ns 
			//----------------------------------------------------------------
			$tmp_ns_array		= array();
			$write_ns_prefix	= 0;			// ºݤνߥ
			$result = $this->get_ns_list_file_ip(
									$conf_ns_list[$main_n][DB_DNS_START],
									$conf_ns_list[$main_n][DB_DNS_PREFIX],
									$write_ns_prefix,
									$tmp_ns_array);
			switch ($result)
			{
			case IPREV_GEN00:
				break;
			case IPREV_GEN99:
			default:
				$this->set_log_msg(IPREV_GEN99, "");
				return IPREV_GEN99;
			}

			//----------------------------------------------------------------
			// name server 
			//----------------------------------------------------------------
			$name_server_list = $conf_ns_list[$main_n][DB_NS_LIST];

			//----------------------------------------------------------------
			// ns 󥻥å
			//----------------------------------------------------------------
			$result = $this->get_ns_list_file_ns(
										$write_zone_prefix,
										$write_ns_prefix,
										$tmp_zone_array,
										$tmp_ns_array,
										$name_server_list,
										$this->m_ns_list_file);
			switch ($result)
			{
			case IPREV_GEN00:
				break;
			case IPREV_GEN09:
			default:
				$this->set_log_msg(IPREV_GEN99, "");
				return IPREV_GEN99;
			}
		}

		return IPREV_GEN00;
	}

	//-----------------------------------------------------------------------
	// public methods(ե)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾output_dns_file
	 *   conf,revե
	 * @param  $is_tmp  0    conf,zone 
	 *                  0ʳtemplate  conf Ȥ
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN03	zoneꥹȳ
	 *		         IPREV_GEN08	nsꥹȳ
	 *		         IPREV_GEN30	conf template file ʤ
	 *		         IPREV_GEN31	conf template copy 
	 *		         IPREV_GEN32	conf open 
	 *		         IPREV_GEN33	conf new dir 
	 *		         IPREV_GEN35	zone open 
	 *		         IPREV_GEN36	zone new dir 
	 *		         IPREV_GEN38	zone new dir ʤ
	 *		         IPREV_GEN39	zone file ʤ
	 *		         IPREV_GEN99	fatal error
	 * @desc	$m_zone_list_file, $m_ns_list_file ξեϤ
	 *			$is_tmp  0 ʳξϥƥץ졼ȥե confե
	 *			ȤzoneϹԤʤ
	 */
	function output_dns_file($is_tmp)
	{
		$iprev_out = new RegIPrevOutPut($this->m_iprev_conf,
										$this->m_iprev_msg,
										$this->m_debug_flag);
		if ($is_tmp)
		{
			$result = $iprev_out->output_conf_temp();
			switch ($result)
			{
			case IPREV_GEN00:		// 
				break;

			case IPREV_GEN30:		// conf template file ʤ
			case IPREV_GEN31:		// conf template copy 
			case IPREV_GEN33:		// conf new dir 
			case IPREV_GEN99:		// fatal error
				$this->m_out_msg .= $iprev_out->get_log_msg();
				$this->m_out_msg .= $iprev_out->get_debug_msg();
				return $result;

			default:
				$this->m_out_msg .= $this->m_iprev_msg[IPREV_GEN99];
				$this->m_out_msg .= $iprev_out->get_debug_msg();
				return IPREV_GEN99;
			}

			$this->m_out_msg .= $iprev_out->get_log_msg();
			$this->m_out_msg .= $iprev_out->get_debug_msg();
			return IPREV_GEN00;
		}

		//----- confե,zoneեإå -----//
		$result = $iprev_out->output_conf_file($this->m_zone_list_file);
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN03:		// zoneꥹȳ
		case IPREV_GEN30:		// conf template file ʤ
		case IPREV_GEN31:		// conf template copy 
		case IPREV_GEN32:		// conf open 
		case IPREV_GEN33:		// conf new dir 
		case IPREV_GEN35:		// zone open 
		case IPREV_GEN36:		// zone new dir 
		case IPREV_GEN99:		// fatal error
			$this->m_out_msg .= $iprev_out->get_log_msg();
			$this->m_out_msg .= $iprev_out->get_debug_msg();
			return $result;

		default:
			$this->m_out_msg .= $this->m_iprev_msg[IPREV_GEN99];
			$this->m_out_msg .= $iprev_out->get_debug_msg();
			return IPREV_GEN99;
		}

		//----- NS쥳ɽ񤭹 -----//
		$result = $iprev_out->output_zone_file($this->m_ns_list_file);
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN08:		// nsꥹȳ
		case IPREV_GEN35:		// zone open 
		case IPREV_GEN38:		// zone new dir ʤ
		case IPREV_GEN39:		// zone file ʤ
		case IPREV_GEN99:		// fatal error
			$this->m_out_msg .= $iprev_out->get_log_msg();
			$this->m_out_msg .= $iprev_out->get_debug_msg();
			return $result;

		default:
			$this->m_out_msg .= $this->m_iprev_msg[IPREV_GEN99];
			$this->m_out_msg .= $iprev_out->get_debug_msg();
			return IPREV_GEN99;
		}

		$this->m_out_msg .= $iprev_out->get_log_msg();
		$this->m_out_msg .= $iprev_out->get_debug_msg();
		return IPREV_GEN00;
	}


	//-----------------------------------------------------------------------
	// public methods(ե빹)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾update_dns_file
	 *   conf/zoneեιå
	 *         ɲåե ȿǤ
	 * @param  $type    оݥ
	 *                  UPDATE_CONF_FILE or UPDATE_ZONE_FILE
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN73	CUR[ZONE|CONF]
	 *               IPREV_GEN74	DEL[ZONE|CONF]
	 *               IPREV_GEN75	CUR[ZONE|CONF]delete
	 *               IPREV_GEN77	NEW[ZONE|CONF]copy
	 *               IPREV_GEN79	diff command 
	 *               IPREV_GEN82	NEW[ZONE|CONF] all copy
	 *               IPREV_GEN99	fatal error
	 * @desc   NEW[ZONE|CONF]  CUR[ZONE|CONF] Ӥ֤˱Ʋ
	 *         Ԥ
	 *            CUR[ZONE|CONF] ˥ԡ
	 *            CUR[ZONE|CONF] ˾񤭥ԡ
	 *            CUR[ZONE|CONF]  DEL[ZONE|CONF] ˰ư
	 *            Ʊ⤷ʤ
	 *         NEW[ZONE|CONF] ¸ߤʤϥ顼ȤCUR[ZONE|CONF] 
	 *         ¸ߤʤϺ롣
	 */
	function update_dns_file()
	{
		$iprev_update = new RegIPrevUpdate($this->m_iprev_conf,
										   $this->m_iprev_msg,
										   $this->m_debug_flag);

		//----- confե빹 -----//
		$result = $iprev_update->update_conf_file();
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN73:		// CURCONF
		case IPREV_GEN74:		// DELCONF
		case IPREV_GEN75:		// CURCONFdelete
		case IPREV_GEN77:		// NEWCONFcopy
		case IPREV_GEN79:		// diff command 
		case IPREV_GEN82:		// NEWCONF all copy
		case IPREV_GEN99:		// fatal error
			$this->m_update_msg	.= $iprev_update->get_log_msg();
			$this->m_update_msg	.= $iprev_update->get_debug_msg();
			return $result;

		default:
			$this->m_update_msg .= $this->m_iprev_msg[IPREV_GEN99];
			$this->m_update_msg	.= $iprev_update->get_debug_msg();
			return IPREV_GEN99;
		}

		//----- zoneե빹 -----//
		$result = $iprev_update->update_zone_file();
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN73:		// CURZONE
		case IPREV_GEN74:		// DELZONE
		case IPREV_GEN75:		// CURZONEdelete
		case IPREV_GEN77:		// NEWZONEcopy
		case IPREV_GEN79:		// diff command 
		case IPREV_GEN82:		// NEWZONE all copy
		case IPREV_GEN99:		// fatal error
			$this->m_update_msg .= $iprev_update->get_log_msg();
			$this->m_update_msg	.= $iprev_update->get_debug_msg();
			return $result;

		default:
			$this->m_update_msg .= $this->m_iprev_msg[IPREV_GEN99];
			$this->m_update_msg	.= $iprev_update->get_debug_msg();
			return IPREV_GEN99;
		}

		$this->m_update_msg .= $iprev_update->get_log_msg();
		$this->m_update_msg	.= $iprev_update->get_debug_msg();
		return IPREV_GEN00;
	}


	//-----------------------------------------------------------------------
	// public methods(named reload)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾reload_rev_named
	 *   dns Ф zone/confեžnamed reload Ԥ
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN40	rsync (db to dns)
	 *		         IPREV_GEN41	rsync (dns to dns zone)
	 *               IPREV_GEN42	rsync (dns to dns conf)
	 *               IPREV_GEN43	named reload 
	 *               IPREV_GEN99	fatal error
	 */
	function reload_rev_named()
	{
		$iprev_reload = new RegIPrevUpload($this->m_iprev_conf,
										   $this->m_iprev_msg,
										   $this->m_debug_flag);

		//----- rsync -----//
		$result = $iprev_reload->upload_dns_file();
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN40:		// rsync (db to dns)
		case IPREV_GEN99:		// fatal error
			$this->m_reload_msg	.= $iprev_reload->get_log_msg();
			$this->m_reload_msg	.= $iprev_reload->get_debug_msg();
			return $result;

		default:
			$this->m_reload_msg .= $this->m_iprev_msg[IPREV_GEN99];
			$this->m_reload_msg	.= $iprev_reload->get_debug_msg();
			return IPREV_GEN99;
		}

		//----- named reload -----//
		$result = $iprev_reload->reload_rev_named();
		switch ($result)
		{
		case IPREV_GEN00:		// 
			break;

		case IPREV_GEN41:		// rsync (dns to dns zone)
		case IPREV_GEN42:		// rsync (dns to dns conf)
		case IPREV_GEN43:		// named reload 
		case IPREV_GEN99:		// fatal error
			$this->m_reload_msg	.= $iprev_reload->get_log_msg();
			$this->m_reload_msg	.= $iprev_reload->get_debug_msg();
			return $result;

		default:
			$this->m_reload_msg .= $this->m_iprev_msg[IPREV_GEN99];
			$this->m_reload_msg	.= $iprev_reload->get_debug_msg();
			return IPREV_GEN99;
		}

		$this->m_reload_msg .= $iprev_reload->get_log_msg();
		$this->m_reload_msg	.= $iprev_reload->get_debug_msg();
		return IPREV_GEN00;
	}


	//-----------------------------------------------------------------------
	// public methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_iprev_msg
	 *   åʸ
	 * @param	$msg_code	å		(i)
	 * @return	åʸ
	 */
	function get_iprev_msg($msg_code)
	{
		return $this->m_iprev_msg[$msg_code];
	}


	//-----------------------------------------------------------------------
	// private methods(get_ns_list_file Ϣ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾get_ns_list_file_ip
	 *   ꤵ줿IPv6ɥ쥹֥å顢zone롣
	 *         ʬ䤬ɬפʾʬԤ
	 * @param	$src_start		IPv6ɥ쥹֥åstart_sequence_number	(i)
	 * @param	$src_prefix		IPv6ɥ쥹֥åPrefix				(i)
	 * @param	$dest_prefix	ʬ Prefix								(i/o)
	 * @param	$dest_array		ʬΥ֥å 						(i/o)
	 *							(array([0]=>x.x.x.x.x..., [1]=>x.x.x.x..., ...)
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN99	fatal error
	 */
	function get_ns_list_file_ip($src_start, $src_prefix, &$dest_prefix, &$dest_array)
	{
		$dest_array		= array();
		$dest_prefix	= 0;			// ºݤνߥ
		$div_info		= NULL;

		// ʬ䤬ɬפʾ
		if ($this->is_divide_block($src_prefix))
		{
			// ʬ
			$div_info	= $this->get_divide_info($src_prefix);
			// ʬ̤ΥꥹȤǼ
			$dest_array	= $this->create_divide_block($src_start, $div_info);
			if (!is_array($dest_array) || count($dest_array) < 1)
			{
				return IPREV_GEN99;
			}
			$dest_prefix = $div_info["div_prefix"];
		}
		else
		{
			array_push($dest_array, $this->create_block($src_start, $src_prefix));
			$dest_prefix = $src_prefix;
		}

		return IPREV_GEN00;
	}


	/**
	 * ؿ̾get_ns_list_file_ns
	 *   zone֥åns֥ånameserver󤫤 RegIPrevNSInfo 
	 * @param	$zone_prefix		zone  Prefix								(i)
	 * @param	$ns_prefix			ns  Prefix								(i)
	 * @param	$zone_array			zone֥å							(i)
	 *								(array([0]=>x.x.x.x.x..., [1]=>x.x.x.x..., ...)
	 * @param	$ns_array			ns֥å								(i)
	 *								(array([0]=>x.x.x.x.x..., [1]=>x.x.x.x..., ...)
	 * @param	$name_server_list	nameserver̾							(i)
	 *								(array([0]=>ns̾, [1]=>ns̾, ...)
	 * @param	$ns_list_file		RegIPrevNSInfoǼ						(i/o)
	 *								(array([0]=>RegIPrevNSInfo, [1]=>RegIPrevNSInfo, ...))
	 * @return IPREV_GEN00
	 *		   ԡIPREV_GEN09	оݤzoneʤ
	 * @desc   $ns_list_file ˤɲýߤԤ
	 */
	function get_ns_list_file_ns($zone_prefix, $ns_prefix, $zone_array, $ns_array, $name_server_list, &$ns_list_file)
	{
		$tmp_ns_info		= NULL;
		//----------------------------------------------------------------
		// ns 󥻥å
		//----------------------------------------------------------------
		// ®٤θơϰϸǤϤʤʸǽԤ
		if ($ns_prefix == $zone_prefix)
		{
			// ξ ʬ䤷zoneΰ "" ʸ ns쥳ɤ񤭹ɬפ
			$zone_cnt	= count($zone_array);
			$ns_cnt		= count($ns_array);
			for ($i = 0; $i < $ns_cnt; $i++)
			{
				for ($n = 0; $n < $zone_cnt; $n++)
				{
					if (strcmp($ns_array[$i], $zone_array[$n]) == 0)
					{
						$tmp_ns_info = new RegIPrevNSInfo();
						$tmp_ns_info->m_zone = $zone_array[$n];			// zone
						array_push($tmp_ns_info->m_block_list, "");		// prefixƱʤΤ "" ˤ
						$tmp_ns_info->m_ns_list = $name_server_list;	// nameserver

						// ns fileϿ
						array_push($ns_list_file, $tmp_ns_info);
						break;
					}
				}
				if ($n == $zone_cnt)
				{
					return IPREV_GEN09;		// оݤzoneʤ
				}
			}
		}
		else
		{
			$tmp_ns_info = new RegIPrevNSInfo();
			$zone_cnt	 = count($zone_array);
			$write_digit = ($ns_prefix - $zone_prefix) / MOD_BLOCK_SIZE;
			$write_digit = $write_digit + $write_digit;			// . ηû
			$check_ns	 = substr($ns_array[0], $write_digit);
			//--- zone å ---//
			for ($n = 0; $n < $zone_cnt; $n++)
			{
				if (strcmp($check_ns, $zone_array[$n]) == 0)
				{
					$tmp_ns_info->m_zone = $zone_array[$n];
					break;
				}
			}
			if ($n == $zone_cnt)
			{
				return IPREV_GEN09;			// оݤzoneʤ
			}

			//--- ns å ---//
			$ns_cnt = count($ns_array);
			for ($n = 0; $n < $ns_cnt; $n++)
			{
				array_push($tmp_ns_info->m_block_list, substr($ns_array[$n], 0, ($write_digit - 1)));
			}

			//--- nameserver å ---//
			$tmp_ns_info->m_ns_list = $name_server_list;	// nameserver

			//--- ns fileϿ ---//
			array_push($ns_list_file, $tmp_ns_info);
		}

		return IPREV_GEN00;
	}

	//-----------------------------------------------------------------------
	// private methods(桼ƥƥ)
	//-----------------------------------------------------------------------
	/**
	 * ؿ̾create_not_overlap_selstr
	 *   ɥ쥹¾NETWORKȽʣƤʤå
	 *         WHERE
	 * @param  $start		ͥåȥɥ쥹 start_sequence_number
	 * @param  $end			ͥåȥɥ쥹 end_sequence_number
	 * @param  $head		
	 * @return WHERE
	 */
	function create_not_overlap_selstr($start, $end, $head)
	{
		if ($head != "")
			$head = ($head . ".");
		$sel_str .= "((" . GetApsString($start) . "<" . $head . "start_sequence_number";
		$sel_str .= " OR " . $head . "end_sequence_number<"  . GetApsString($start) . ")";
		$sel_str .= " AND (" . GetApsString($end) . "<" . $head . "start_sequence_number";
		$sel_str .= " OR " . $head . "end_sequence_number<"  . GetApsString($end) . ")";
		$sel_str .= " AND (" . $head . "start_sequence_number<=" . GetApsString($start);
		$sel_str .= " OR " . GetApsString($end) . "<=" . $head . "end_sequence_number))";
		return $sel_str;
	}

	/**
	 * ؿ̾is_divide_block
	 *   
	 * @param	$prefix		prefix length
	 * @return
	 */
	function is_divide_block($prefix)
	{
		if ($prefix % MOD_BLOCK_SIZE == 0)
			return FALSE;
		else
			return TRUE;
	}

	/**
	 * ؿ̾get_divide_info
	 *   IP֥å zone, ns ˽񤭹ñ̤ʬ䤹ݤξ
	 * @param	$prefix			prefix length
	 * @return	array("div_prefix" => "ʬprefix", "div_num" => "ʬ")
	 */
	function get_divide_info($prefix)
	{
		$div_prefix	= 0;
		$div_num	= 0;

		// prefix / MOD_BLOCK_SIZE ;
		$mod_num = $prefix % MOD_BLOCK_SIZE;
		if ($mod_num == 0)
		{
			return array("div_prefix"	=> $prefix,
						 "div_num"		=> 1);
		}

		// MOD_BLOCK_SIZE - ;
		$tmp_num	= MOD_BLOCK_SIZE - $mod_num;
		$div_num	= pow(2, $tmp_num);			// ʬĿ
		$div_prefix	= $tmp_num + $prefix;		// ʬprefix
		return array("div_prefix"	=> $div_prefix,
					 "div_num"		=> $div_num);
	}

	/**
	 * ؿ̾create_block
	 *   ֥åprefixޤǤ򥳥޶ڤǵž16ʿˤ
	 * @param	$ip_start		zonestart_sequence_numberʥʤ16ʥեɽ
	 * @param	$prefix			prefix length
	 * @return	zone֥å
	 */
	function create_block($ip_start, $prefix)
	{
		$zone_block = "";
		if (strlen($ip_start) != IP_BLOCK_MAX_DIGIT)
			return $zone_block;

		$digit = $prefix / MOD_BLOCK_SIZE;
		for ($n = $digit; $n > 0; $n--)
		{
			$zone_block .= $ip_start[$n - 1] . ".";
		}
		if ($zone_block != "")
			$zone_block = substr($zone_block, 0, -1);

		return $zone_block;
	}

	/**
	 * ؿ̾create_divide_block
	 *   ʬ䤷 ֥åꥹȡprefixޤǤ򥳥޶ڤǵž16ʿˤ
	 * @param	$ip_start		zonestart_sequence_numberʥʤ16ʥեɽ:ʬ
	 * @param	$div_info		array("div_prefix" => "ʬprefix", "div_num" => "ʬ")
	 * @return	zone֥å	array(zone, zone, zone, ...)
	 */
	function create_divide_block($ip_start, $div_info)
	{
		$zone_block = array();

		if (strlen($ip_start) != IP_BLOCK_MAX_DIGIT)
			return $zone_block;

		// ®٤θơۥȿûǤϤʤʸǽԤ
		$start_zone = $this->create_block($ip_start, $div_info["div_prefix"]);
		for ($n = 0; $n < $div_info["div_num"]; $n++)
		{
			$chg_num = base_convert((base_convert($start_zone[0], 16, 10) + $n), 10, 16);
			array_push($zone_block, $chg_num . substr($start_zone, 1));
		}

		return $zone_block;
	}

	/**
	 * ؿ̾ : distinct_ipblock_array
	 *    : IPv6ɥ쥹֥åνʣطȽꤷפΤϼ
	 * @access	public
	 * @param	array	$cidrs	IPv6֥åꥹ		(i/o)
	 * @return	int	Ƚ
     *              -1: 顼
     *              0:  ʣʤ
     *              1:  (Ʊɥ쥹ϰ)
     *              2:  ʣ
     *                  *------*      or       *------*       cidr1
     *                      *------*      *------*            cidr2
     *              3:  cidr1  cidr2 ϰ
     *                      *------*                          cidr1
     *                  *--------------*                      cidr2
     *              4:  cidr2  cidr1 ϰ
     *                  *--------------*                      cidr1
     *                      *------*                          cidr2
	 */
	function distinct_ipblock_array($cidrs, $add_cidr)
	{
		if (!is_array($cidrs))
			return -1;		// 顼

		$cnt = count($cidrs);
		if ($cnt < 1)
			return 0;		// ʣʤ

		if ($cnt == 1)
			return RegIpv6AddressUtil::chk_ipblock_overlap($cidrs[0], $add_cidr);

		for($i = 0; $i < $cnt; $i++)
		{
			$result = RegIpv6AddressUtil::chk_ipblock_overlap($cidrs[$i], $add_cidr);
			if ($result !== 0)
				return $result;			// ʣʴ ޤ
		}
		return 0;						// ʣ̵
	}

	/**
	 * ؿ̾check_prefix
	 *   prefixȤݤȽꤹ
	 * @param	$prefix			prefix length
	 * @return	TRUE or FALSE
	 */
	function check_prefix($prefix)
	{
		if ($prefix < IP_PREFIX_MIN_NUM || $prefix > IP_PREFIX_MAX_NUM)
			return FALSE;
		return TRUE;
	}

	/**
	 * ؿ̾set_log_msg
	 *   åɲä
	 * @param $msg_id	åID
	 * @param $options	ץǡʸ
	 *					åθ [0][1]... ղä
	 */
	function set_log_msg($msg_id, $options="")
	{
		$this->m_log_msg .= $this->m_iprev_msg[$msg_id];
		if (is_array($options))
		{
			for ($n = 0; $n < count($options); $n++)
			{
				if ($options[$n] !== "")
				{
					if (substr($options[$n], -1) == "\n")
						$this->m_log_msg .= " [" . substr($options[$n], 0, -1) . "]";
					else
						$this->m_log_msg .= " [" . $options[$n] . "]";
				}
			}
		}
	}

	/**
	 * ؿ̾get_log_msg
	 *   å
	 * @return å
	 */
	function get_log_msg()
	{
		return $this->m_log_msg;
	}
}
?>
